!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Broadcasts Beltrami field, profiles . . .

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine bc00aa( lvol )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only :

  use numerical, only :

  use fileunits, only : ounit

  use inputlist, only : Wbc00aa, Lgeometry, Nvol, Ni, Nofe, pflux, mu, Lconstraint, Lwrpj, Lfindzero

  use cputiming, only : Tbc00aa

  use allglobal, only : myid, cpus, ncpu, dpflux, Ntz, mn,    &
                        mns, diota, dsflangle,                &
                        nlocaldof,                            &
                        Bomn, Iomn,                           & 
                        DenergyDrz, DanalyticDrz,             &
                        Lhessianallocated,                    &
                        DforcebalDrz, DspectralDrz,           &
                        LforcebalDrz,                         &
                        lBBintegral, lABintegral, lvolume
  
  use pjhamilto, only : Itor, Gpol, spmn

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in) :: lvol
  
  INTEGER             :: llmodnp, io, imn, iRZl
  
  BEGIN(bc00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! recall this routine is inside do ll= .. loop;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  llmodnp = modulo(lvol-1,ncpu) ! identify which node contains data; this must be consistent with above looping / parallelization;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! scalars;

! RlBCAST(beta(1:2,lvol),2,llmodnp)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! profiles;
  
  RlBCAST(mu(lvol),1,llmodnp)
  RlBCAST(pflux(lvol),1,llmodnp)
  RlBCAST(dpflux(lvol),1,llmodnp)
  RlBCAST(lvolume(lvol),1,llmodnp)
  
  if( Lconstraint.gt.0 .and. Lwrpj ) then
   RlBCAST(Itor(lvol,0:1),2,llmodnp)
   RlBCAST(Gpol(lvol,0:1),2,llmodnp)
   RlBCAST(spmn(lvol,0:1,1:mn),2*mn,llmodnp)
  endif
  
  pflux(lvol) = pflux(lvol-1) + dpflux(lvol) ! sum \delta \psi_{poloidal};
  
! transformation to straight-field-line angle on interfaces;
  
  RlBCAST(dsflangle(0,lvol,0:1,1:mns),2*mns,llmodnp)
  RlBCAST(dsflangle(1,lvol,0:1,1:mns),2*mns,llmodnp)
  RlBCAST(dsflangle(2,lvol,0:1,1:mns),2*mns,llmodnp)
  
  RlBCAST(diota(lvol,0:2,0:1),6,llmodnp)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! volume integrals;
  
  RlBCAST(lBBintegral(lvol),1,llmodnp)
  RlBCAST(lABintegral(lvol),1,llmodnp)
  
! the derivatives of the lvol-th energy functional with respect to the inner & outer, interface Fourier harmonics, Rj & Zj;
  
  RlBCAST(   DenergyDrz(lvol,0:1,1:nlocaldof),2*nlocaldof,llmodnp)
  RlBCAST( DanalyticDrz(lvol,0:1,1:nlocaldof),2*nlocaldof,llmodnp)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!                    force-balance and angle-constraints                                            ;
  
  ;RlBCAST(Bomn(lvol,0:1,1:mn),2*mn,llmodnp)
  if( Lgeometry.ge.4 ) then
   RlBCAST(Iomn(lvol    ,1:mn),  mn,llmodnp)
  endif

! the derivatives of force-balance and angle-constraints with respect to interface Fourier harmonics;  

  if( Lhessianallocated ) then
   
   ;RlBCAST( DforcebalDrz(lvol,0:1,1:nlocaldof,0:1,1:mn),2*nlocaldof*2* mn   ,llmodnp)
   ;LlBCAST( LforcebalDrz(lvol    ,1:nlocaldof         ),  nlocaldof         ,llmodnp)
   if( Lgeometry.ge.4 ) then
    RlBCAST( DspectralDrz(lvol,    1:nlocaldof    ,2:mn),  nlocaldof  *(mn-1),llmodnp)
   endif
   
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(bc00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine bc00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
