!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Construction of Bessel function solution of Beltrami field.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \subsubheading{Bessel function solution}

!latex \item Consider a cylinder with minor radius $a$, major radius $R=1$, with given toroidal flux $\psi_t$ and given ``pinch-parameter'' $\mu$, then 
!latex \be B^\z &=& \alpha J_0(\mu r), \\
!latex     B^\t &=& r^{-1} \alpha J_1(\mu r), \ee
!latex where $\alpha=\psi_t \mu / 2 \pi a J_1(\mu a)$.
!latex \item The $q$-profile is $q=B^\z/B^\t$.
!latex \item This solution is the minimum energy solution only for $\mu a < 3.11\dots$ \cite{Taylor_86}.
!latex At this point, a helical state is expected to emerge.

!latex \subsubheading{Cylindrical geometry}

!latex \item In cylindrical geometry, $\sqrt g = r$, the vector potential may be written ${\bf A}=A_\t\nabla\t+A_\z\nabla\z$ where
!latex \be A_\t = \sum_p a_{\t,p} r^{2+p}, \;\;\;
!latex     A_\z = \sum_p a_{\z,p} r^{2+p}.
!latex \ee

!latex \item The magnetic field, ${\bf B}=\nabla\times{\bf A}$, is then
!latex \be B^\r = 0, \;\;\;
!latex     B^\t = \frac{-\partial_r A_\z}{r}  = - \sum_p a_{\z,p} (2+p) r^{p}, \;\;\;
!latex     B^\z = \frac{+\partial_r A_\t}{r}  = + \sum_p a_{\t,p} (2+p) r^{p}.
!latex \ee
!latex \be B_\r = 0, \;\;\;
!latex     B_\t = - \sum_p a_{\z,p} (2+p) r^{p+2}, \;\;\;
!latex     B_\z = + \sum_p a_{\t,p} (2+p) r^{p}.
!latex \ee

!latex \item The energy integrals are given
!latex \be {\bf B} \cdot {\bf B} = \sum_{p,q} \left[a_{\z,p} a_{\z,q} (2+p)(2+q)r^{p+q+2}+a_{\t,p} a_{\t,q} (2+p)(2+q)r^{p+q  }\right] \ee
!latex \be {\bf A} \cdot {\bf B} = \sum_{p,q} a_{\t,p} a_{\z,q} \left[ -r^{2+p}(2+q)r^q + r^{2+q}(2+p)r^p\right] = \sum_{p,q} a_{\t,p} a_{\z,q} r^{2+p+q}(p-q) \ee
!latex \be \int_{\cal V}dv \equiv \int \!\! d\r \int \!\! d\t \int \!\! d\z \;\; r = (2\pi)^2 \int \!\! dr \;\; r\ee
!latex \be F &\equiv& \int_{\cal V}{\bf B} \cdot {\bf B} \;\; dv - \mu \int_{\cal V}{\bf A} \cdot {\bf B} \;\; dv \\
!latex & =    & \sum_{p,q} a_{\z,p} a_{\z,q} (2+p)(2+q) \int\!\!dr \;\; r^{p+q+2+1}
!latex   +      \sum_{p,q} a_{\t,p} a_{\t,q} (2+p)(2+q) \int\!\!dr \;\; r^{p+q  +1}\\
!latex & -\mu & \sum_{p,q} a_{\t,p} a_{\z,q} (  p -  q) \int\!\!dr \;\; r^{p+q+2+1}.
!latex \ee

!latex \be \frac{\partial F}{\partial a_{\t,p}} &=&
!latex \sum_q a_{\z,q} (2+p)(2+q) \left.\frac{r^{p+q+2}}{p+q+2}\right|_{0}^{a} - \mu \sum_q a_{\z,q} (p-q) \left.\frac{r^{2+q+p+2}}{2+q+p+2}\right|_{0}^{a}
!latex \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine be00aa
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only :
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : Wbe00aa
  use cputiming, only : Tbe00aa
  use allglobal, only : ncpu, myid, cpus
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  BEGIN(be00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(be00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine be00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


