!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs tangential field on inner and outer interfaces.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine bt00aa( lvol ) 
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, one, pi2

  use numerical, only : 

  use fileunits, only : ounit, punit

  use inputlist, only : Wbt00aa, ext

  use cputiming, only : Tbt00aa

  use allglobal, only : myid, ncpu, cpus, pi2nfp, interfacelabel, &
                        efmn, ofmn, cfmn, sfmn, isr, trigm, trign, trigwk, &
                        sg, gij, mn, im, in, &
                        doAtmn, doAzmn, &
                        Nt, Nz, Ntz, svol
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in) :: lvol

  INTEGER             :: Lcurv, innout, Ldo
  REAL                :: lss
 !CHARACTER           :: suf*4

  BEGIN(bt00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  write(svol,'(i4.4)')lvol
  open(punit+myid,file="."//trim(ext)//".Btz."//svol,status="unknown",form="unformatted")
  write(punit+myid) Nt, Nz, Ntz

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do innout = 0, 1 ! loop over inner/outer interfaces;
   
   lss = interfacelabel(lvol-1+innout) ! radial coordinate;
   
   if( lvol.eq.1 .and. innout.eq.0 ) then 

    gij(2:3,1,:) = zero

   else

    Lcurv = 1 ; WCALL(bt00aa,co01aa,(lvol, lss, Lcurv, Ntz)) ! will need sg(0,:) and gij(1:6,0,:); note that sg(1:3,:) and gij(1:6,1:3,:) are available as workspace arrays;
    
    Ldo = 0 
    WCALL(bt00aa,sa00aa,(lvol, lss, Ldo)) ! returns radially interpolated Fourier harmonics of vector potential through global doAtmn(0,1,1:mn) & doAzmn(0,1,1:mn);
    
    efmn(1:mn) = - doAzmn(0,1,1:mn) ! doAzmn(1,1:mn) = \partial_s A_z;
    cfmn(1:mn) =   doAtmn(0,1,1:mn) ! doAtmn(1,1:mn) = \partial_s A_z;
    
    ofmn(1:mn) = zero ; sfmn(1:mn) = zero
    call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, gij(2,1,:), gij(3,1,:), isr, trigm, trign, trigwk )
    
    gij(2,1,:) = gij(2,1,:) / sg(0,:) ! B^\t;
    gij(3,1,:) = gij(3,1,:) / sg(0,:) ! B^\z;

   endif

   write(punit+myid) gij(2,1,:)
   write(punit+myid) gij(3,1,:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  enddo ! end of do innout = 0, 1;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  close(punit+myid)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(bt00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine bt00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
