!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Theoretical foundation, an introduction to the geometry and numerics, and compilation instructions.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} 
!latex \tableofcontents
!latex \subsection{multi-region, relaxed MHD}
!latex The Stepped Pressure Equilibrium Code, SPEC, seeks numerical solutions to macroscopic force balance between the pressure and the magnetic field in arbitrary,
!latex non-axisymmetric toroidal configurations, with fields of arbitrary topology.
!latex Generally, non-axisymmetric toroidal magnetic fields are non-integrable.
!latex Accordingly, SPEC does not assume that the magnetic field is everywhere tangential to a set of continously nested magnetic surfaces.
!latex
!latex The most elegant approaches for computing MHD equilibria begin with an energy principle.
!latex Our equilibrium model, which we call multi-region, relaxed MHD \cite{DHMMH_08,HDHM_11},
!latex is based on a constrained energy principle that combines ideal MHD and Taylor relaxation theory \cite{Taylor_74}
!latex and is consistent with KAM theory \cite{Kolmogorov_54,Arnold_63,Moser_62}.
!latex Where the constraints of ideal MHD are applied, topological variations in the magnetic field are prohibited.
!latex Where these constraints are not applied, we assume, as did Taylor, that a weakly resistive plasma will relax to minimize the plasma energy
!latex subject to the constraint of conserved helicity.
!latex In these relaxed regions, reconnection phenomena are allowed, so that magnetic islands and field-line chaos may form.
!latex However, some flux surfaces with particularly irrational rotational-transform are expected to survive, and it is at these locations where pressure gradients are allowed.
!latex
!latex Consider a plasma region \cite{DHMMH_08} comprised of a set of \mbox{$N$} nested annular regions,
!latex which are separated by a discrete set of toroidal interfaces, \mbox{${\cal I}_l$}.
!latex We insist that the fields are tangential to the interfaces.
!latex In each volume, \mbox{${\cal V}_l$}, bounded by the \mbox{${\cal I}_{l-1}$} and \mbox{${\cal I}_l$} interfaces,
!latex the plasma energy, \mbox{$U_l$}, the global-helicity, \mbox{$H_l$}, and the mass/entropy, \mbox{$M_l$}, are given by the integrals:
!latex \be U_l = \int_{{\cal V}_l} \left( \frac{p}{\gamma-1} + \frac{B^2}{2\mu_0} \right) dv, \;\;\;\;\;\;\;\;
!latex     H_l = \int_{{\cal V}_l} {\bf A} \cdot {\bf B} \; dv, \;\;\;\;\;\;\;\;
!latex     M_l = \int_{{\cal V}_l} p^{1/\gamma} \; dv, \ee
!latex where \mbox{${\bf B}=\nabla \times {\bf A}$}.
!latex The pressure, \mbox{$p$}, is a scalar function of position.
!latex The equilibrium states that we seek minimize the total plasma energy, subject to the constraints of conserved helicity and conserved mass/entropy in each annular region.
!latex The functional we seek to extremize is $F = \sum_l F_l$
!latex where $F_l\equiv \left( U_l - \mu_l H_l/2 - \nu_l M_l \right)$,
!latex where \mbox{$\mu_l$} and \mbox{$\nu_l$} are Lagrange multipliers (and are constant over each volume).
!latex
!latex We allow for arbitrary variations in (i) the pressure in each volume, $\delta p$, (ii) the magnetic field in each volume, \mbox{$\delta {\bf A}$},
!latex and (iii) the geometry of the interfaces, $\boldxi$;
!latex except that we assume the magnetic field remains tangential to the interfaces.
!latex At the interfaces, and only at the interfaces, the variation in the geometry and fields are constrained according to $\delta {\bf A} = \boldxi \times {\bf B}$.
!latex
!latex The first variation in $F_l$ is given
!latex \be \delta F_l = \int_{{\cal V}_l} \! \left(\frac{1}{\gamma-1} - \frac{\nu_l p^{1/\gamma}}{\gamma p}\right) \delta p \; dv \;\;
!latex                + \;\;\int_{{\cal V}_l} \! \left( \frac{\nabla \times {\bf B}}{\mu_0}-\mu_l {\bf B} \right) \cdot \delta {\bf A} \; dv \;\;\;\;
!latex                + \;\;\int_{\partial {\cal V}_l} \! \left( \frac{p}{\gamma-1} - \nu_l p^{1/\gamma} - \frac{B^2}{2\mu_0} \right) \boldxi \cdot {\bf n} \; ds
!latex \ee
!latex 
!latex The Euler--Lagrange equations show that plasma states that extremize $F$ satisfy the following:
!latex (i) in each annulus the pressure obeys \mbox{$\nu_l p^{1/\gamma}=\gamma p /(\gamma-1)$}, i.e. the pressure is constant.
!latex (ii) in each annulus, the magnetic field is a linear, force-free ``Beltrami'' field given by \mbox{$\nabla \times {\bf B}_l = \mu_l {\bf B}_l$};
!latex and, by using the Euler--Lagrange equation for the pressure,
!latex (iii) the {\em total} pressure is continuous across the ideal interfaces, \mbox{$[[p+B^2/2]]=0$}.
!latex
!latex Nontrivial pressure profiles are supported by the ideal interfaces, across which a pressure discontinuity is allowed
!latex provided there is a compensating discontinuity in the tangential field.
!latex The equilibrium solutions are topologically-constrained but partially-relaxed {\em stepped-pressure} states that we call multi-region, relaxed MHD equilibria.
!latex (Topological constraints on magnetic reconnection have been observed in a similar context \cite{YHW_10}.)
!latex An analysis of the force-balance condition, \mbox{$[[p+B^2/2]]=0$}, shows that, generally, in order for an interface to support pressure,
!latex it must have irrational rotational-transform \cite{MHDvN_10}.
!latex
!latex At first, the restriction to stepped-pressure profiles seems artificial.
!latex However, an equilibrium state with a nontrivial, {\em continuous} pressure that satisfies \mbox{${\bf B}\cdot\nabla p =0$}
!latex with a nonintegrable (partially chaotic) magnetic field {\em must} have an {\em uncountable} infinity of discontinuities in the pressure gradient.
!latex Standard numerical discretizations, e.g. finite differences, for constructing solutions to $\nabla p = {\bf j}\times{\bf B}$ with continuous, nontrivial pressure profiles
!latex and nonintegrable fields will not produce reliable convergence, as the solution being approximated has structure on all scales.
!latex
!latex In contrast, the multi-region relaxed MHD approach described above is based on an energy integral.
!latex This only requires that the pressure be an integrable function and does not require differentiability.
!latex Specifying the profiles discretely, rather than continuously, is a practical means of retaining some control over the pressure and transform profiles
!latex while making minimal assumptions regarding the topology of the field: 
!latex it is only assumed that at least some flux surfaces exist, and that pressure gradients coincide with flux surfaces with strongly irrational transform.
!latex A strong motivation for adopting this model is that Bruno \& Laurence \cite{Bruno_Laurence_96} have proved that, under certain conditions,
!latex 3D stepped-pressure equilibria exist, thus putting the MRXMHD model on a strong mathematical foundation.
!latex Arbitrarily many interfaces may be included, so any pressure profile may be approximated arbitrarily closely.
!latex
!latex A fixed-boundary equilibrium is defined by (i) the shape of the outer boundary,
!latex (ii) the pressure as a function of toroidal flux, e.g. \mbox{$p(\psi_t)=p_l$} for \mbox{$\psi_t \in [\psi_{t,l-1},\psi_{t,l}]$},
!latex and (iii) the rotational-transform of the interfaces.
!latex An initial ``guess'' for the geometry of the internal interfaces is required.
!latex SPEC uses a Fourier represenation in the poloidal and toroidal angles, and a high-order polynomial finite element basis functions in the radial coordinate
!latex to describe the magnetic vector potential.
!latex Differentiating the constrained energy functional with respect to the numerical degrees of freedom in the vector potential
!latex gives rise to a set of sparse linear equations that define the Beltrami fields in each volume,
!latex and the construction of Beltrami fields is trivially distributed over multiple cpus.
!latex Standard numerical methods, e.g. multi-dimensional Newton's method, are then used to vary the internal interface geometry
!latex in order to locate an extremum of the constrained energy functional, i.e. to solve for force balance across the interfaces.

!latex \subsubsection{some additional mathematical details}
!latex The functional we seek to extremize is
!latex \be F = \sum_{l=1}^{N_V} \left( U_l - \mu_l H_l/2 - \nu_l M_l \right), \label{eq:constrainedenergyfunctional}
!latex \ee
!latex where \mbox{$\mu_l$} and \mbox{$\nu_l$} are Lagrange multipliers (and are constant over each volume, \mbox{${\cal V}_l$}).
!latex The first variation in the plasma energy,
!latex allowing variations in the pressure, \mbox{$\delta p$}, the field, \mbox{$\delta {\bf A}$}, and interface geometry, \mbox{$\boldxi$}, is given
!latex \be \delta U_l & = & \int_{{\cal V}_l} \left( \frac{\delta p}{\gamma-1} + \frac{{\bf B}\cdot \nabla \times \delta {\bf A}}{\mu_0} \right) dv
!latex                  +   \int_{\partial {\cal V}_l} \left( \frac{p}{\gamma-1} + \frac{B^2}{2\mu_0} \right) ({\bf n}\cdot \boldxi ) \; ds, \ee
!latex Using the identity $\nabla \cdot ({\bf A} \times {\bf B})={\bf B} \cdot \nabla \times {\bf A}-{\bf A} \cdot \nabla \times {\bf B}$ and integrating by parts we obtain
!latex \be \delta U_l   =   \int_{{\cal V}_l} \left( \frac{\delta p}{\gamma-1} + \frac{\delta {\bf A}\cdot \nabla \times {\bf B}}{\mu_0} \right) dv
!latex                  +   \int_{\partial {\cal V}_l} \left( \frac{p}{\gamma-1} + \frac{B^2}{2\mu_0} \right) ({\bf n}\cdot \boldxi) \; ds
!latex                  +   \int_{\partial {\cal V}_l} \frac{{\bf n}\cdot \delta {\bf A}\times{\bf B}}{\mu_0} \; ds. \ee
!latex The interfaces are assumed to be ideal, so in the surface integrals we make use of 
!latex Faraday's law \mbox{$\partial_t {\bf B}=\nabla\times{\bf E}$} and the
!latex ideal Ohm's law \mbox{${\bf E}+{\bf v}\times{\bf B}=0$} to obtain the expression $\delta {\bf A} = \boldxi \times {\bf B}$.
!latex The variation in the plasma energy becomes
!latex \be \delta U_l = \int_{{\cal V}_l} \left( \frac{\delta p}{\gamma-1} + \frac{\delta {\bf A}\cdot \nabla \times {\bf B}}{\mu_0} \right) dv
!latex                + \int_{\partial {\cal V}_l} \left( \frac{p}{\gamma-1} - \frac{B^2}{2\mu_0} \right) ({\bf n}\cdot \boldxi ) \; ds. \ee
!latex A similar analysis shows that the first variation in the helicity is
!latex \be \delta H_l & = & 2 \int_{{\cal V}_l} {\bf B} \cdot \delta {\bf A} \; dv.
!latex \ee
!latex The variation in the plasma mass is
!latex \be \delta M_l &=& \int_{{\cal V}_l} \frac{p^{1/\gamma}}{\gamma p} \delta p\;dv+\int_{\partial {\cal V}_l} p^{1/\gamma} ({\bf n}\cdot \boldxi ) \; ds. \nonumber \ee

!latex Only the variations in the geometry normal to the interfaces, \mbox{$({\bf n}\cdot \boldxi)$}, are relevant: 
!latex tangential variations do not alter the energy functional.
!latex To constrain the tangential degrees of freedom, additional constraints derived from minimizing the spectral width are included.

!latex \subsection{Description of geometry and numerical methods}

!latex The code can operate in Cartesian, cylindrical or toroidal geometry.
!latex In each case, stellarator symmetry may or may not be enforced (under construction).
!latex The vector potential is descretized using finite-elements in the radial direction, and Fourier harmonics in the poloidal and toroidal angles.
!latex \subsubsection{Cartesian, cylindrical, or toroidal geometry}
!latex The code uses $(\s,\t,\z)$ as the internal coordinates, which may represent Cartesian, cylindrical or toroidal coordinates as follows.
!latex \begin{enumerate}
!latex \item[0.] For Cartesian, we identify
!latex ${\bf x} = \t \; \hat {\bf i} + \z \; \hat {\bf j}+ Z(\s,\t,\z) \; \hat {\bf k},
!latex $
!latex where $\hat {\bf i}$, $\hat {\bf j}$ and $\hat {\bf k}$ are the standard Cartesian basis vectors.
!latex \item[1.] For cylindrical, we identify
!latex ${\bf x} = R(\s,\t,\z) \hat {\bf r}+ \z \; \hat {\bf k},
!latex $
!latex where $\hat {\bf r} \equiv \cos \t \;\hat {\bf i} + \sin\t \; \hat {\bf j}$.
!latex \item[2.] For toroidal, we identify
!latex ${\bf x}=R(\s,\t,\z)\hat {\bf R} + Z(\s,\t,\z) \hat {\bf k},
!latex $
!latex where $\hat {\bf R} \equiv \cos \zeta \;{\bf i} + \sin \zeta \;{\bf j}$.
!latex \end{enumerate}
!latex Note that in the toroidal case, the poloidal angle, $\t$, is arbitrary.
!latex
!latex A set of \mbox{$l=1,N_V$} nested, toroidal surfaces is assumed given.
!latex For expedience, we restrict attention to stellarator symmetric devices \cite{Dewar_Hudson_97b} so that the interfaces may be described
!latex \be \begin{array}{ccc} R_l(\theta,\zeta)&=&\sum_{j}R_{l,j}\cos(m_j \t -n_j \z),\\
!latex                        Z_l(\theta,\zeta)&=&\sum_{j}Z_{l,j}\sin(m_j \t -n_j \z). \end{array} \label{eq:stellaratorsymmetricgeometry} \ee
!latex The coordinate functions \mbox{$R(\s,\t,\z)$} and \mbox{$Z(\s,\t,\z)$} take the form
!latex \be \begin{array}{ccc} R(\s,\t,\z)&=&\sum_j R_j(\s)\cos(m_j\theta-n_j\zeta), \\
!latex                        Z(\s,\t,\z)&=&\sum_j Z_j(\s)\sin(m_j\theta-n_j\zeta), \end{array} \ee
!latex where the functions \mbox{$R_j(\s)$}, \mbox{$Z_j(\s)$} are constructed by piecewise-cubic interpolation of the \mbox{$R_{l,j}$} and \mbox{$Z_{l,j}$}.
!latex In the \mbox{$l$}-th annulus, bounded by the \mbox{$(l-1)$}-th and \mbox{$l$}-th interfaces, 
!latex a general covariant representation of the magnetic vector-potential is written
!latex \be {\bf \bar A}_l=\bar A_{s,l} \nabla s + \bar A_{\t,l} \nabla \t + \bar A_{\z,l} \nabla \z. \ee
!latex To this add \mbox{$\nabla g_l(s,\t,\z)$}, where $g_l$ satisfies
!latex \be \begin{array}{ccl} \partial_\s g_l(\s      ,\t,\z) & = & - \bar A_{\s,l}(\s      ,\t,\z)             ,\\
!latex                        \partial_\t g_l(\s_{l-1},\t,\z) & = & - \bar A_{\t,l}(\s_{l-1},\t,\z)+\psi_{t,l-1},\\
!latex                        \partial_\z g_l(\s_{l-1}, 0,\z) & = & - \bar A_{\z,l}(\s_{l-1}, 0,\z)+\psi_{p,l-1},\end{array} \ee
!latex for arbitrary constants \mbox{$\psi_{t,l-1}$}, \mbox{$\psi_{p,l-1}$}, which are the toroidal and poloidal-fluxes on the interior of surface \mbox{$l-1$}.
!latex Then \mbox{${\bf A}_l={\bf \bar A}_l+\nabla g_l$} is given by \mbox{${\bf A}_l=A_{\theta,l}\nabla\t+A_{\zeta,l}\nabla\z$} with
!latex \be \begin{array}{ccc} A_{\theta,l}(\s_{l-1},\t,\z)&=&\psi_{t,l-1}, \\
!latex                        A_{\zeta,l}(\s_{l-1}, 0,\z) &=&\psi_{p,l-1}. \end{array} \label{eq:gauge} \ee
!latex This specifies the gauge.
!latex For stellarator symmetric equilibria, \mbox{$A_{\theta,l}$} and \mbox{$A_{\zeta,l}$} may be represented by cosine series
!latex \be \begin{array}{ccc} A_{\theta,l}(s,\t,\z)=\sum_{j}A_{\theta,l,j}(s)\cos(m_j\t-n_j\z),\\
!latex                        A_{\zeta,l}(s,\t,\z)=\sum_{j}A_{\zeta,l,j}(s)\cos(m_j\t-n_j\z), \end{array} \ee
!latex where \mbox{$A_{\theta,l,j}(s)$} and \mbox{$A_{\zeta,l,j}(s)$} are represented using finite-elements.

!latex \subsection{Compilation instructions} \begin{enumerate}
!latex \item The source is kept under CVS: \verb+>cvs -d /u/shudson/cvs_Spec/ checkout Spec+
!latex \item Compilation is provided by a Makefile: \verb+>make xspec+. Try \verb+>make help+ for compilation options.
!latex \begin{enumerate}
!latex \item The compilation flags are given by \verb+FLAGS+. These may be over-ruled by command line arguments.
!latex \item Compilation flags must be set that convert single precision to double precision, e.g. \verb+make FLAGS="--dbl"+.
!latex \item The NAG library is used and must be correctly linked.
!latex \item To apply a patch: \verb+>patch -p1 < file+
!l!tex \item The free-boundary capability employs \verb+mgrid+. For this, \verb+stellinstall_sanssiesta.zip+ is included.
!l!tex Simply open a new directory, e.g. \verb+>mkdir Stellopt+, unzip, e.g. \verb+>unzip stellinstall_sanssiesta.zip+, and execute \verb+setup+.
!l!tex This will place the required files into \verb+$(HOME)/bin_847/+.
!latex \end{enumerate}

!latex \newpage

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine descrp


end subroutine descrp

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
