!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Evaluates magnetic pressure and helicity volume integrals, and their derivatives with respect to interface geometry.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \subsubheading{The magnetic pressure, $\int_{\cal V} B^2 dv$, and the helicity, $\int_{\cal V} {\bf A}\cdot{\bf B}dv$.}

!latex \item In the annular regions, the volume integrals are given by the following:

!latex \be

!latex & &\intds \ooint \sqrt g \,\, B^\s B^\s g_{\s\s}                                                                                             \nonumber \\

!latex &=&\sumi \sum_{j,k} \intdsl ( -m_j A_{\zeta,l,j} - n_j \At{l,j} )( -m_k \Az{l,k} - n_k \At{l,k} ) \braket{s_j}{{\sqrt g}^{-1} g_{\s\s}}{s_k} \nonumber \\

!latex &=&     m_j \; \Az{l,j,p,i-1+l} \; m_k \; \Az{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}  \braket{s_j}{{\sqrt g}^{-1} g_{\s\s}}{s_k}  \nonumber \\
!latex &+&     m_j \; \Az{l,j,p,i-1+l} \; n_k \; \At{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}  \braket{s_j}{{\sqrt g}^{-1} g_{\s\s}}{s_k}  \nonumber \\
!latex &+&     n_j \; \At{l,j,p,i-1+l} \; m_k \; \Az{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}  \braket{s_j}{{\sqrt g}^{-1} g_{\s\s}}{s_k}  \nonumber \\
!latex &+&     n_j \; \At{l,j,p,i-1+l} \; n_k \; \At{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}  \braket{s_j}{{\sqrt g}^{-1} g_{\s\s}}{s_k}  \nonumber \\

!latex \ee

!latex \be

!latex & &\intds \ooint \sqrt g \,\, B^\s B^\t g_{s\t}                                                                                              \nonumber \\

!latex &=&\sumi \sum_{j,k}\intdsl \,\, ( -m_j \Az{l,j} - n_j \At{l,j} )( - \Az{l,k}' ) \braket{s_j}{{\sqrt g}^{-1} g_{\s\t}}{c_k}                   \nonumber \\

!latex &=&     m_j \Az{l,j,p,i-1+l}       \Az{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}' \braket{s_j}{{\sqrt g}^{-1} g_{\s\t}}{c_k}         \nonumber \\
!latex &+&     n_j \At{l,j,p,i-1+l}       \Az{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}' \braket{s_j}{{\sqrt g}^{-1} g_{\s\t}}{c_k}         \nonumber \\

!latex \ee

!latex \be

!latex & &\intds \ooint \sqrt g \,\, B^\s B^\z g_{\s\z}                                                                                             \nonumber \\

!latex &=&\sumi \sum_{j,k}\intdsl \,\, ( -m_j \Az{l,j} - n_j \At{l,j} )( \At{l,k}' ) \braket{s_j}{{\sqrt g}^{-1} g_{\s\z}}{c_k}                     \nonumber \\

!latex &=& - m_j \Az{l,j,p,i-1+l}       \At{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}' \braket{s_j}{{\sqrt g}^{-1} g_{\s\z}}{c_k}           \nonumber \\
!latex &+& - n_j \At{l,j,p,i-1+l}       \At{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}' \braket{s_j}{{\sqrt g}^{-1} g_{\s\z}}{c_k}           \nonumber \\

!latex \ee

!latex \be

!latex & &\intds \ooint \sqrt g \,\, B^\t B^\t g_{\t\t}                                                                                             \nonumber \\

!latex &=&\sumi\sum_{j,k}\intdsl ( - \Az{l,j}' )( - \Az{l,k}' ) \braket{c_j}{{\sqrt g}^{-1} g_{\t\t}}{c_k}                                          \nonumber \\
!latex &=&         \Az{l,j,p,i-1+l}     \Az{l,k,q,i-1+r} \intdsl \varphi_{l,p}' \varphi_{r,q}' \braket{c_j}{{\sqrt g}^{-1} g_{\t\t}}{c_k}           \nonumber \\

!latex \ee

!latex \be

!latex & &\intds \ooint \sqrt g \,\, B^\t B^\z g_{\t\z}                                                                                             \nonumber \\

!latex &=&\sumi\sum_{j,k}\intdsl \,\, ( - \Az{l,j}' )( \At{l,k}' ) \braket{c_j}{{\sqrt g}^{-1} g_{\t\z}}{c_k}                                       \nonumber \\

!latex &=& -     \Az{l,j,p,i-1+l}       \At{l,k,q,i-1+r} \intdsl \varphi_{l,p}' \varphi_{r,q}' \braket{c_j}{{\sqrt g}^{-1} g_{\t\z}}{c_k}           \nonumber \\

!latex \ee

!latex \be

!latex & &\intds \ooint \sqrt g \,\, B^\z B^\z g_{\z\z}                                                                                             \nonumber \\

!latex &=&\sumi\sum_{j,k}\intdsl ( \At{l,j}' )( \At{l,k}' ) \braket{c_j}{{\sqrt g}^{-1} g_{\z\z}}{c_k}                                              \nonumber \\

!latex &=&         \At{l,j,p,i-1+l}     \At{l,k,q,i-1+r} \intdsl \varphi_{l,p}' \varphi_{r,q}' \braket{c_j}{{\sqrt g}^{-1} g_{\z\z}}{c_k}           \nonumber \\

!latex \ee

!latex \be

!latex & & \intds \ooint \sqrt g \,\, {\bf A} \cdot {\bf B}                                                                                         \nonumber \\

!latex &=& \sumi \intdsl \ooint \left[ -A_\t \partial_s A_\z + A_\z \partial_s A_\t\right]                                                          \nonumber \\

!latex &=&\sumi \sum_{j,k} \intdsl \left[ -\At{l,j} \Az{l,k}^{'} + \Az{l,j} \At{l,k}^{'}\right]\braket{c_j}{1}{c_k}                                 \nonumber \\
!latex &=& -       \At{l,j,p,i-1+l}     \Az{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}' \braket{c_j}{           1           }{c_k}           \nonumber \\
!latex & & +       \Az{l,j,p,i-1+l}     \At{l,k,q,i-1+r} \intdsl \varphi_{l,p}  \varphi_{r,q}' \braket{c_j}{           1           }{c_k}           \nonumber \\

!latex \ee

!latex \item In the innermost volume, there are additional radial factor $s^{m/2}$, but these are incorporated into the 
!latex \verb+igss+, \verb+igst+, \verb+igsz+, \verb+igtt+, \verb+igtz+, \verb+igzz+, and \verb+igoo+.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine fu00aa( lvol, Ldo )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, half, one, two
  use numerical, only : vsmall
  use fileunits, only : ounit
  use inputlist, only : Wfu00aa, gamma, adiabatic, pscale, Ni, Nofe
  use cputiming
  use allglobal, only : myid, cpus, mn, in, im, ijk,                            &
                        dAd, doAt, doAz,                                        & ! vector potential;
                          igss,   igst,   igsz,   igtt,   igtz,   igzz,   igoo, & ! metric integrals;
                        dxigss, dxigst, dxigsz, dxigtt, dxigtz, dxigzz, dxigoo, & ! metric integrals; derivatives;
                        lvolume, dvolume, &
                        lBBintegral, lABintegral,                               & ! volume integrals;
                        dBBintegral, dABintegral                                  ! volume integrals; derivatives;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in) :: lvol, Ldo                                ! selects volume, and derivative;

  INTEGER             :: ideriv, idd(1:2)                         ! selects original or perturbed vector potential;
  INTEGER             :: ii, jj, kk, jk, pp, qq, ll, rr           ! loop variables;
  REAL                :: BsBs, BsBt, BsBz, BtBt, BtBz, BzBz, AABB ! summation terms;

  BEGIN(fu00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  BsBs = zero ; BsBt = zero ; BsBz = zero ; BtBt = zero ; BtBz = zero ; BzBz = zero ! initialize summation terms;
  AABB = zero                                                                       ! initialize summation terms;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do ii = 1, Ni(lvol) ! loop over sub-grid;
   
   do jj = 1, mn ! loop over Fourier modes;
    
    do kk = 1, mn ; jk = ijk(jj,kk) ! loop over Fourier modes;
     
     do pp = 0, Nofe ! loop over derivatives;
      
      do qq = 0, Nofe ! loop over derivatives;
       
       do ll = 0, 1 ! loop over ``left-basis-elements'';
        
        do rr = 0, 1 ! loop over ``right-basis-elements'';
         
         
         
         if( Ldo.eq.0 .and. .not.dAd%L ) then ! construct B.B and A.B; integrals;
          
          BsBs = BsBs + ( + im(jj) * doAz(  0   ,lvol,jj,pp)%s(ii-1+ll) * im(kk) * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          + im(jj) * doAz(  0   ,lvol,jj,pp)%s(ii-1+ll) * in(kk) * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          + in(jj) * doAt(  0   ,lvol,jj,pp)%s(ii-1+ll) * im(kk) * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          + in(jj) * doAt(  0   ,lvol,jj,pp)%s(ii-1+ll) * in(kk) * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) *   igss(ll,pp,rr,qq,jk)%s(ii)
          
          BsBt = BsBt + ( + im(jj) * doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) & 
                          + in(jj) * doAt(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) ) *   igst(ll,pp,rr,qq,jk)%s(ii)
          
          BsBz = BsBz + ( - im(jj) * doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          - in(jj) * doAt(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) *   igsz(ll,pp,rr,qq,jk)%s(ii)

          BtBt = BtBt + ( +          doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) ) *   igtt(ll,pp,rr,qq,jk)%s(ii)
      
          BtBz = BtBz + ( -          doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) *   igtz(ll,pp,rr,qq,jk)%s(ii)
          
          BzBz = BzBz + ( +          doAt(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) *   igzz(ll,pp,rr,qq,jk)%s(ii)
          
          AABB = AABB + ( -          doAt(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          +          doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) *   igoo(ll,pp,rr,qq,jk)%s(ii)

         endif ! end of if( Ldo.eq.0 .and. .not.dAd%L ) ;

         
         if( Ldo.gt.0 .and. .not.dAd%L ) then ! construct B.B and A.B; derivatives wrt (/ mu, dpflux /);

          do ideriv = 1, 2 ! use product rule to differentiate vector potential products;
           
          if( ideriv.eq.1 ) idd(1:2) = (/ Ldo,   0 /)
          if( ideriv.eq.2 ) idd(1:2) = (/   0, Ldo /)
          
          BsBs = BsBs + ( + im(jj) * doAz(idd(1),lvol,jj,pp)%s(ii-1+ll) * im(kk) * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          + im(jj) * doAz(idd(1),lvol,jj,pp)%s(ii-1+ll) * in(kk) * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          + in(jj) * doAt(idd(1),lvol,jj,pp)%s(ii-1+ll) * im(kk) * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          + in(jj) * doAt(idd(1),lvol,jj,pp)%s(ii-1+ll) * in(kk) * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igss(ll,pp,rr,qq,jk)%s(ii)
          
          BsBt = BsBt + ( + im(jj) * doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) & 
                          + in(jj) * doAt(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igst(ll,pp,rr,qq,jk)%s(ii)
          
          BsBz = BsBz + ( - im(jj) * doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          - in(jj) * doAt(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igsz(ll,pp,rr,qq,jk)%s(ii)

          BtBt = BtBt + ( +          doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igtt(ll,pp,rr,qq,jk)%s(ii)
      
          BtBz = BtBz + ( -          doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igtz(ll,pp,rr,qq,jk)%s(ii)
          
          BzBz = BzBz + ( +          doAt(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igzz(ll,pp,rr,qq,jk)%s(ii)
          
          AABB = AABB + ( -          doAt(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          +          doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igoo(ll,pp,rr,qq,jk)%s(ii)

          enddo ! end of do ideriv = 1, 2;

         endif ! end of if( Ldo.gt.0 .and. .not.dAd%L );
         

         if(                     dAd%L ) then ! construct B.B and A.B; derivatives wrt interface Fourier harmonics; 

          do ideriv = 1, 2 ! use product rule to differentiate vector potential products;

          if( ideriv.eq.1 ) idd(1:2) = (/ -1,  0 /)
          if( ideriv.eq.2 ) idd(1:2) = (/  0, -1 /)

          BsBs = BsBs + ( + im(jj) * doAz(idd(1),lvol,jj,pp)%s(ii-1+ll) * im(kk) * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          + im(jj) * doAz(idd(1),lvol,jj,pp)%s(ii-1+ll) * in(kk) * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          + in(jj) * doAt(idd(1),lvol,jj,pp)%s(ii-1+ll) * im(kk) * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          + in(jj) * doAt(idd(1),lvol,jj,pp)%s(ii-1+ll) * in(kk) * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igss(ll,pp,rr,qq,jk)%s(ii)
          
          BsBt = BsBt + ( + im(jj) * doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) & 
                          + in(jj) * doAt(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igst(ll,pp,rr,qq,jk)%s(ii)

          BsBz = BsBz + ( - im(jj) * doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          - in(jj) * doAt(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igsz(ll,pp,rr,qq,jk)%s(ii)
          
          BtBt = BtBt + ( +          doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igtt(ll,pp,rr,qq,jk)%s(ii)
          
          BtBz = BtBz + ( -          doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igtz(ll,pp,rr,qq,jk)%s(ii)
          
          BzBz = BzBz + ( +          doAt(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igzz(ll,pp,rr,qq,jk)%s(ii)
          
          AABB = AABB + ( -          doAt(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAz(idd(2),lvol,kk,qq)%s(ii-1+rr) &
                          +          doAz(idd(1),lvol,jj,pp)%s(ii-1+ll)          * doAt(idd(2),lvol,kk,qq)%s(ii-1+rr) ) *   igoo(ll,pp,rr,qq,jk)%s(ii)

          enddo ! end of do ideriv = 1, 2; 

          BsBs = BsBs + ( + im(jj) * doAz(  0   ,lvol,jj,pp)%s(ii-1+ll) * im(kk) * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          + im(jj) * doAz(  0   ,lvol,jj,pp)%s(ii-1+ll) * in(kk) * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          + in(jj) * doAt(  0   ,lvol,jj,pp)%s(ii-1+ll) * im(kk) * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          + in(jj) * doAt(  0   ,lvol,jj,pp)%s(ii-1+ll) * in(kk) * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) * dxigss(ll,pp,rr,qq,jk)%s(ii) ! variation in metric;
          
          BsBt = BsBt + ( + im(jj) * doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) & 
                          + in(jj) * doAt(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) ) * dxigst(ll,pp,rr,qq,jk)%s(ii) ! variation in metric;

          BsBz = BsBz + ( - im(jj) * doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          - in(jj) * doAt(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) * dxigsz(ll,pp,rr,qq,jk)%s(ii) ! variation in metric;
          
          BtBt = BtBt + ( +          doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) ) * dxigtt(ll,pp,rr,qq,jk)%s(ii) ! variation in metric;
          
          BtBz = BtBz + ( -          doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) * dxigtz(ll,pp,rr,qq,jk)%s(ii) ! variation in metric;
          
          BzBz = BzBz + ( +          doAt(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) * dxigzz(ll,pp,rr,qq,jk)%s(ii) ! variation in metric;
          
          AABB = AABB + ( -          doAt(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAz(  0   ,lvol,kk,qq)%s(ii-1+rr) &
                          +          doAz(  0   ,lvol,jj,pp)%s(ii-1+ll)          * doAt(  0   ,lvol,kk,qq)%s(ii-1+rr) ) * dxigoo(ll,pp,rr,qq,jk)%s(ii) ! variation in metric;

          endif ! end of if (                    dAd%L )


        enddo ! end of do rr;

       enddo ! end of do ll;
         
      enddo ! end of do qq = 0, Nofe
      
     enddo ! end of do pp = 0, Nofe;
     
    enddo ! end of do kk = 1, mn;
    
   enddo ! end of do jj = 1, mn;
   
  enddo ! end of do ii = 1, Ni(lvol);
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The above integrals are returned in
!latex 
!latex \verb+lBBintegral(lvol)=+ $\ds \!\! \int_{\cal V} dv \; {\bf B}\cdot{\bf B}$
!latex
!latex \verb+lABintegral(lvol)=+ $\ds \!\! \int_{\cal V} dv \; {\bf A}\cdot{\bf B}$

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Ldo.eq.0 .and. .not.dAd%L ) then
   lBBintegral(lvol) =  adiabatic(lvol) * pscale * lvolume(lvol)**(one-gamma)/(gamma-one) + ( BsBs + two*BsBt + two*BsBz + BtBt + two*BtBz + BzBz ) * half
   lABintegral(lvol) =   AABB
  endif
  
  if( Ldo.gt.0 .and. .not.dAd%L ) then 
   dBBintegral       =                                                                      ( BsBs + two*BsBt + two*BsBz + BtBt + two*BtBz + BzBz ) * half
   dABintegral       =   AABB
  endif
  
  if(                     dAd%L ) then
   dBBintegral       = - adiabatic(lvol) * pscale * dvolume / lvolume(lvol)**(-gamma)     + ( BsBs + two*BsBt + two*BsBz + BtBt + two*BtBz + BzBz ) * half
   dABintegral       =   AABB
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wfu00aa ) then
   cput = MPI_WTIME() ; write(ounit,'("fu00aa : "f10.2" : lvol="i3" ; pressure, helicity ="3es23.15" ;")')cput-cpus,lvol,lBBintegral(lvol),lABintegral(lvol)
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(fu00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine fu00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \subsubheading{gauge invariant helicity}

!latex \item A gauge invariant form for the helicity is derived as follows.
!latex The change in helicity, $\delta H$, where the helicity is defined $H \equiv \int {\bf A}\cdot{\bf B}\;dv$,
!latex resulting from a change in the gauge, e.g. ${\bf A}^\prime = {\bf A}+\nabla g$, is given by
!latex \be \delta H = \int_{\cal V} \nabla g \cdot {\bf B} \; dv = \int_{\cal V} \nabla \cdot \left( g {\bf B} \right) dv = \int_{\partial {\cal V}} g \; {\bf B} \cdot d{\bf s}.
!latex \ee
!latex \item The gauge function, $g$, is not required to be a single valued function of postion, i.e. $g(\s,\t+2\pi,\z) \ne g(\s,\t,\z)$ and $g(\s,\t,\z+2\pi) \ne g(\s,\t,\z)$.
!latex In contrast, the magnetic field, and Jacobian, are periodic.
!latex \item Using ${\bf B}\cdot {\bf n}=0$ on the ideal interfaces that bound the volume, ${\cal V}$, the expression for the variation in helicity can be reduced to 
!latex \be \delta H &=& \int\!\!\!\int \left[g(\s,\t,2\pi)-g(\s,\t,0)\right]{\bf B}\cdot d{\bf s} + \int\!\!\!\int \left[g(\s,2\pi,\z)-g(\s,0,\z)\right]{\bf B}\cdot d{\bf s},\\
!latex \ee
!latex where the first integral is over the region of the plane $\z=0$ bounded by the adjacent interfaces, and the second integral over the region of the $\t=0$ plane.
!latex 
!latex \item HOW DO THE TERMS INVOLVING $g$ GET PULLED OUT OF THE INTEGRALS?
!latex
!latex Is $g(\s,\t,2\pi)-g(\s,\t,0)=const.$ and $g(\s,2\pi,\z)-g(\s,0,\z)=const.$?
!latex \item If the vector potential is required to be single valued, the representation of the gauge function is restricted to be of the form
!latex \be g = G_\t \; \t + G_\z \; \z + \tilde g(\s,\t,\z)
!latex \ee
!latex where $G_\t$ and $G_\z$ are constants and $\tilde g$ is periodic.
!latex In this case, $g(\s,\t,2\pi)-g(\s,\t,0)=2 \pi G_\z$ and $g(\s,2\pi,\z)-g(\s,0,\z)=2 \pi G_\t$.
!latex \item By identifying the toroidal and poloidal fluxes enclosed between the interfaces, $\delta \psi \equiv \int\!\!\!\int {\bf B}\cdot d{\bf s}$,
!latex we obtain
!latex \be \delta H = 2 \pi G_\z \; \delta \psi_t + 2 \pi G_\t \; \delta \psi_p.
!latex \ee
!latex \item Some logic missing . . .
!latex \item A gauge invariant form for the helicity is
!latex \be H = \int {\bf A}\cdot{\bf B} \; dv - \delta \psi_p \int_{0}^{2\pi} A_\t(\s_{l-1},\t,\z) d\t - \delta \psi_t \int_{0}^{2\pi} A_\z(\s_{l},\t,\z) d\z,
!latex \ee
!latex where $s_{l-1}$ coincides with the inner interface, and $s_{l}$ coincides with the outer interface.
!latex \item Note that the gauge and boundary conditions employed give $A_\t(\s_{l-1},\t,\z) = \psi_{t,l-1}$ and $A_\z(\s_{l  },\t,\z) = \psi_{p,l}$.
!latex After using $\delta \psi_{t} \equiv \psi_{t,l} - \psi_{t,l-1}$ and $\delta \psi_{p} \equiv \psi_{p,l} - \psi_{p,l-1}$, the final expression for the helicity is
!latex \be H = \int {\bf A}\cdot{\bf B} \; dv + \psi_{t,l} \psi_{p,l} - \psi_{t,l-1} \psi_{p,l-1}.
!latex \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
