!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Describes ongoing and/or planned research activities.

!latex \end{enumerate}

!latex \clearpage

!latex \section{finite-pressure plasma surrounded by a vacuum with a chaotic separatrix}

!latex \subsection{derive equations for Beltrami field with non-zero normal field at outer interface}

!latex \begin{enumerate}

!latex \item Extremize the energy functional 
!latex       \be F \equiv \int_{\cal V} \frac{B^2}{2}\,dv - \frac{\mu}{2} \int_{\cal V} {\bf A}\cdot{\bf B} \,dv,
!latex       \ee
!latex       with respect to variations, $\delta {\bf A}$, in the vector potential, ${\bf B}=\nabla \times {\bf A}$,
!latex       in an annuluar volume bounded by an inner toroidal surface, ${\cal I}_{N-1}$ and an outer toroidal surface, ${\cal I}_N$, under the boundary conditions
!latex       ${\bf B}\cdot {\bf n} = 0$ on ${\cal I}_{N-1}$ and ${\bf B}\cdot {\bf n} = b$ on ${\cal I}_{N}$,
!latex       where $b$ is a user supplied function.
!latex       The `toroidal' and `poloidal' fluxes are also to be constrained.

!latex \item The first variation in $F$ is 
!latex       \be \delta F = \int_{{\cal V}} \delta {\bf A} \cdot \left( \nabla \times {\bf B} - \mu {\bf B}\right) \, dv
!latex                    + \int_{\partial {\cal V}} \delta {\bf A} \times {\bf B}\cdot d{\bf s}
!latex                    - \frac{\mu}{2}\int_{\partial {\cal V}} \delta {\bf A} \times {\bf A}\cdot d{\bf s}.
!latex       \ee
!latex \item If the outer boundary is not a flux surface, how are the toroidal and poloidal fluxes defined?
!latex \item Are there any constraints on $b \equiv {\bf B}\cdot {\bf n}$?
!latex       Note that $0 = \int \nabla \cdot {\bf B} \, dv = \int {\bf B} \cdot d{\bf s} = \int {\bf B} \cdot \nabla s \sqrt g \, d\t \, d\z$.
!latex \item Constrain the variations in $\delta {\bf A}$ to (i) constrain the toroidal and poloidal fluxes, and (ii) preserve the boundary conditions on ${\bf B}\cdot{\bf n}$;
!latex       and simplify the surface integrals.
!latex \item Does this theoretical approach lead to a simple, robust method for constructing Beltrami fields, $\nabla \times {\bf B} = \mu {\bf B}$?
!latex \item For $\mu=0$, this method should produce vacuum fields. How does this method compare (in terms of accuracy, robustness and speed) to alternative methods
!latex       of solving Laplace's equation?
!latex \item Implement this method into SPEC and perform convergence tests that demonstrate that the solutions are accurately being computed.
!latex       (This has mostly been completed; see figures below.)

!latex \end{enumerate}

!latex \subsection{construct `toy-model' of plasma-vacuum equilibrium}

!latex \begin{enumerate}

!latex \item Provide an outer boundary to SPEC that approximates the size and shape of the DIIID inner wall, for example.
!latex \item Modify SPEC so that the Beltrami field in the outermost volume is constrained to be a vacuum field.
!latex \item Determine normal field on outer boundary that results in a separatrix in outermost volume,
!latex       and adjust this normal field so that the plasma-vacuum equilibrium is surrounded by a DIIID-like separatrix.
!latex \item Apply a perturbation to the normal field so that the region near the separatrix becomes chaotic.
!latex \item If the external field is provided, can an application of the virtual casing method \cite{ Shafranov_Zakharov_72} be used
!latex       to construct a true `free-boundary' equilibrium?
!latex \item What is the primary effect of the perturbation field. Is it to ergodize the vacuum region or to force islands in the plasma interior?
!latex \item To what extent do the ideal interfaces (required to support pressure gradients) create a shielding effect?

!latex \end{enumerate}

!latex \subsection{illustrate hetero-clinic tangle}

!latex \begin{enumerate}

!latex \item By locating fixed points, trace out the unstable manifold \cite{RRE_03} associated with the chaotic separatrix.
!latex \item Examine the effect of the unstable manifold on the plasma-vacuum interface.
!latex \item Is there a simple characterization of the unstable manifold (e.g. area and location of primary `lobes')
!latex       that is relevant for understanding the deformation of the plasma-vacuum interface?
!latex \item Vary the rotational-transform, $\iotabar$, on the plasma-vacuum interface.
!latex       Are there certain `resonant' values of the edge-$\iotabar$ that, for a given perturbed normal field
!latex       result in a `large' unstable manifold and ergodization of the vacuum region?

!latex \end{enumerate}

!latex \subsection{illustrate cantori in vacuum region}

!latex \begin{enumerate}

!latex \item By constructing \cite{Hudson_06a} minimizing, high-order, periodic field lines, illustrate the most effective cantori in the vacuum region.
!latex \item Show how the cantori and the unstable manifold interact.
!latex \item Compute field-line flux through cantori. Show how the field line flux varies with edge-$\iotabar$.

!latex \end{enumerate}

!latex \subsection{solve the anisotropic heat diffusion equation in chaotic vacuum region}

!latex \begin{enumerate}

!latex \item The numerical routines for solving the anisotropic heat diffusion equation have already been constructed \cite{Hudson_Breslau_08}
!latex       and should be easily implemented into SPEC.
!latex \item Compute heat flux on wall.
!latex \item Can any qualitative comparisons with experimental results be derived (e.g. heat flux on divertor plates).
!latex \item If an appropriate free-boundary problem is solved, can quantitative comparisons and/or predictions be made?

!latex \end{enumerate}

!latex \subsection{implementation of more realistic physics model in `vacuum' region}

!latex \begin{enumerate}

!latex \item Perhaps the assumption that the plasma is surrounded by a vacuum is too simple,
!latex       and perhaps instead there are plasma currents and various non-ideal effects that are important in this region.
!latex \item Derive a tractable set of equations that capture the relevant physical effects in this region.
!latex \item Implement a numerical solution method.

!latex \end{enumerate}

!latex \subsection{initial results}

!latex \begin{enumerate}

!latex \item Much of the numerical work has already been done, and an example calculation is shown in \Fig{plasmavacuumseparatrix}.
!latex \item \Fig{RadialConvergence} confirms that the vacuum field with non-zero normal field in the outermost boundary is converged with respect to radial resolution.
!latex \item \Fig{FourierConvergence} confirms that the equilibrium geometry is converged with respect to the Fourier resolution.

!latex \inserttwofigure{M=05.N=00.d=2e-2.poin.c.000.ps}{M=05.N=01.d=2e-2.poin.c.000.ps}
!latex {Finite pressure plasma equilibrium surrounded by a vacuum field with separatrix:
!latex the outermost boundary is considered to be the `wall' of an experimental device on which a non-zero normal field is imposed that results in separatrix;
!latex in the outermost volume, the field satisfies $\nabla \times {\bf B}=0$;
!latex in the other volumes the field satisfies $\nabla \times {\bf B} = \mu {\bf B}$;
!latex there are several interior interfaces (shown with thick, black lines) which support pressure discontinuities;
!latex the left figure shows an axisymmetric calculation, and the right figure includes a small non-axisymmetric normal field at the wall which results in an ergodic field.
!latex }{plasmavacuumseparatrix}

!latex \insertdblfigure{curlconvergence.ps}
!latex {Radial resolution convergence study: the resolution of the radial sub-grid in the outermost volume,
!latex the vacuum region with non-zero normal field at the wall, is increased and the error in $\nabla \times {\bf B}=0$ is computed;
!latex the expected error scaling for piecewise cubic and piecewise quintic radial basis functions are obtained.}{RadialConvergence}

!latex \insertsglfigure{M=10.N=06.Ni=04.p=1.d=1e-3.MN.ps}
!latex {Fourier resolution convergence study: the quantity $\Delta$ measures the difference between the geometry of a finite Fourier resolution SPEC equilibrium
!latex and a reference, high resolution SPEC equilibrium.}{FourierConvergence}

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine future ! this is just a dummy routine; the listed variables are required for the macros;

  use fileunits, only : ounit

  use inputlist, only : Wfuture

  use cputiming, only : Tfuture

  use allglobal, only : myid, cpus

  LOCALS

  BEGIN(future)

  RETURN(future)

end subroutine future

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
