!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Returns ``force'' vector and its derivative with respect to geometry.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine fv00aa( Ngdof, force, Lderiv )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero

  use numerical, only : logtolerance ! this is just a small number to avoid underflow when taking logarithms;

  use fileunits, only : ounit

  use inputlist, only : Wfv00aa, Lgeometry, Nvol, forceerr, Energy

  use cputiming, only : Tfv00aa
  
  use allglobal, only : ncpu, myid, cpus,                               &
                        mn, Bomn, Iomn, mBomn, mIomn,                   &
                        DforcebalDrz, DspectralDrz,                     &
                        nlocaldof, mlocaldof,                           &
                        hessian, Lhessianallocated
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER, intent(in)  :: Ngdof               ! dimension;
  REAL,    intent(out) :: force(1:Ngdof)      ! force;
  LOGICAL, intent(in)  :: Lderiv              ! indicates whether derivatives are to be calculated;
  
  INTEGER              :: lvol, ivol, imn, irz, jvol, jmn, jrz, ilocaldof, jlocaldof, totaldof, totaldoc
  
  BEGIN(fv00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  forceerr = zero ! initialize summation; must be outside do ivol = 1, Nvol loop;
  
  if( Lderiv ) then
   
   FATALMESS(fv00aa,.not.Lhessianallocated,error)
   
   hessian(1:Ngdof,1:Ngdof) = zero ! initialize summation; must be outside do ivol = 1, Nvol loop;

  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do ivol = 1, Nvol-1 ! loop over interior interfaces;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \subsubheading{construction of force vector}
   
!latex \item The force vector, ${\bf f}$, is defined
!latex \be f_{l,j} \equiv [[p+B^2/2]]_{l,j}.
!latex \ee
!latex \item If spectral constraints are required, i.e. if \verb+Lgeometry.ge.4+, then the force vector includes
!latex \be f_{l,j} \equiv \left(R_\t X + Z_\t Y \right)_{l,j}.
!latex \ee
   
   totaldoc = (ivol-1) * mlocaldof ! reset incrementally advanced constraint counter;
   
   do imn = 1, mn ! loop over constraint Fourier harmonics;
    
!   if( imask(imn).le.0 ) cycle ! this is not a selected constraint;
    
    if(                      imn.ge.1 ) then ; totaldoc = totaldoc + 1 ; force( totaldoc ) = Bomn(ivol+1,0,imn) - Bomn(ivol,1,imn) ! force-imbalance constraint; pressure;
    endif
    if( Lgeometry.ge.4 .and. imn.gt.1 ) then ; totaldoc = totaldoc + 1 ; force( totaldoc ) = Iomn(ivol    ,imn)                    ! force-imbalance constraint; spectral;
    endif
    
   enddo ! end of do imn = 1, mn;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \subsubheading{quantitative measure of force-imbalance}

!latex \item The internal varible, $|f|\equiv$\verb+forceerr+, is constructed:
!latex \be |f| \equiv \frac{1}{E} \sum_l \frac{1}{J} \sum_j \left| f_{l,j}  \right|,
!latex \ee
!latex where the summation is over the interior interfaces, i.e. $l=1,$ \verb+Nvol+$-1$, and $J\equiv$ \verb+mn+ is the number of Fourier harmonics,
!latex \verb!mn=Ntor+1+Mpol*(2*Ntor+1)!.
!latex \item Note that this quantity is normalized to the total energy, $E$, as defined
!latex \be E = \sum_l \int_{{\cal V}_l} \left( \frac{p}{\gamma-1}+\frac{B^2}{2} \right)dv.
!latex \ee
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   forceerr = forceerr + sum( abs( Bomn(ivol+1,0,1:mn)-Bomn(ivol,1,1:mn) ) )                    ! the normalization wrt total energy, E, comes below;
!  forceerr = forceerr + sum( abs( Bomn(ivol+1,0,1:mn)-Bomn(ivol,1,1:mn) ) ) / sum(imask(1:mn)) ! the normalization wrt total energy, E, comes below;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   if( Lderiv ) then ! construct hessian;
    
!latex \subsubheading{construction of Hessian}
    
!latex \item The Hessian, $\nabla {\bf f}$, is constructed as the derivative of the force, ${\bf f}$,
!latex with respect to the Fourier harmonics, $R_{l,j}$ and $Z_{l,j}$, that describe the geometry of the $l$-th interface.  
    
    totaldoc = (ivol-1) * mlocaldof ! reset incrementally advanced constraint counter; take care with nlocaldof and mlocaldof;
    
    do imn = 1, mn ! loop over constraint Fourier harmonics;
     
!    if( imask(imn).le.0 ) cycle ! this is not a selected constraint;
     
     if(                      imn.ge.1 ) then ; totaldoc = totaldoc + 1 ! force-imbalance constraint; pressure; construct derivatives;
      
      FATALMESS(fv00aa,totaldoc.lt.    1,force-imbalance pressure constraint: needs attention)
      FATALMESS(fv00aa,totaldoc.gt.Ngdof,force-imbalance pressure constraint; needs attention)
      
      do jvol = ivol-1, ivol+1 ! consider block tridiagonal structure of hessian;
       
       if( jvol.eq.   0 ) cycle ! no dependence on coordinate axis;
       if( jvol.eq.Nvol ) cycle ! no dependence on fixed outer boundary;
       
       ilocaldof = 0 ! local degree-of-freedom counter;
       jlocaldof = 0 ! local degree-of-freedom counter;
       
       do jmn = 1, mn ! loop over degree-of-freedom Fourier harmonics;
        
        do jrz = 0, 1 ! loop over R, Z;
         
         if( jmn.eq.1 .and. jrz.eq.1 ) cycle ! no dependence on Z_{m=0,n=0} sin( m \t - n \z);
         
         if( jrz.eq.1 .and. Lgeometry.le.3 ) cycle ! no dependence on Z;
         
         ilocaldof = ilocaldof + 1 ! this counter comes before mask;
         
!        if( imask(jmn).le.0 ) cycle ! this is not a selected degree of freedom;
         
         jlocaldof = jlocaldof + 1 ! this counter comes after  mask;
         
         totaldof = ( jvol - 1 ) * mlocaldof + jlocaldof
         
         FATALMESS(fv00aa,totaldof.lt.    1,force-imbalance pressure constraint: needs attention)
         FATALMESS(fv00aa,totaldof.gt.Ngdof,force-imbalance pressure constraint: needs attention)
         
         if( jvol.eq.ivol-1 ) hessian( totaldoc, totaldof ) =                                              - DforcebalDrz( ivol  , 0, ilocaldof, 1, imn )
         if( jvol.eq.ivol   ) hessian( totaldoc, totaldof ) = DforcebalDrz( ivol+1, 0, ilocaldof, 0, imn ) - DforcebalDrz( ivol  , 1, ilocaldof, 1, imn )
         if( jvol.eq.ivol+1 ) hessian( totaldoc, totaldof ) = DforcebalDrz( ivol+1, 1, ilocaldof, 0, imn )
         

         

        enddo ! end of do jrz;
        
       enddo ! end of do jmn;
       
      enddo ! end of do jvol;
      
     endif ! end of if(                      imn.ge.1 );
     
     if( Lgeometry.ge.4 .and. imn.gt.1 ) then ; totaldoc = totaldoc + 1 ! force-imbalance constraint; spectral; construct derivatives;
      
      FATALMESS(fv00aa,totaldoc.lt.    1,force-imbalance spectral constraint: needs attention)
      FATALMESS(fv00aa,totaldoc.gt.Ngdof,force-imbalance spectral constraint: needs attention)
      
      do jvol = ivol  , ivol   ! spectral constraints are not tri-diagonal but are local to interface; this loop is included for similarity with above;
       
       if( jvol.eq.   0 ) cycle ! no dependence on coordinate axis;
       if( jvol.eq.Nvol ) cycle ! no dependence on fixed outer boundary;
       
       ilocaldof = 0
       jlocaldof = 0
       
       do jmn = 1, mn ! loop over degree-of-freedom Fourier harmonics;
        
        do jrz = 0, 1 ! loop over R, Z;
         
         if( jmn.eq.1 .and. jrz.eq.1 ) cycle ! no dependence on Z_{m=0,n=0} sin( m \t - n \z);
         
         if( jrz.eq.1 .and. Lgeometry.le.3 ) cycle ! no dependence on Z;
         
         ilocaldof = ilocaldof + 1
         
!        if( imask(jmn).le.0 ) cycle ! this is not a selected degree of freedom;
         
         jlocaldof = jlocaldof + 1
         
         totaldof = ( jvol - 1 ) * mlocaldof + jlocaldof
         
         FATALMESS(fv00aa,totaldof.lt.    1,force-imbalance spectral constraint: needs attention)
         FATALMESS(fv00aa,totaldof.gt.Ngdof,force-imbalance spectral constraint: needs attention)
         
         if( jvol.eq.ivol   ) hessian( totaldoc, totaldof ) = DspectralDrz( ivol  ,    ilocaldof,    imn )
         
        enddo ! end of do jrz;
        
       enddo ! end of do jmn;
       
      enddo ! end of do jvol;
      
     endif ! end of if( Lgeometry.ge.4 .and. imn.gt.1 );
     
    enddo ! end of do imn;
    
   endif ! end of if( Lderiv );
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  enddo ! end of do ivol;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! diagnostics;
  
  forceerr = forceerr / Energy ! normalize measure of force-imbalance to total energy;
  
! NORMALIZATION FACTOR 1/mn IS INCORRECT IS MASK IS APPLIED;
  
  do lvol = 1, Nvol-1
                        mBomn(lvol) = log10( max( sqrt(sum((Bomn(lvol+1,0,1:mn)-Bomn(lvol,1,1:mn))**2)/ mn   ), logtolerance ) )
   if( Lgeometry.ge.4 ) mIomn(lvol) = log10( max( sqrt(sum((Iomn(lvol  ,  2:mn)                  )**2)/(mn-1)), logtolerance ) )
  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(fv00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine fv00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
