!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Packs, and unpacks, geometrical degrees of freedom.

!latex \item A factor of $\psi_t^{m/2}$ is now included.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine gf00aa( Ngdof, xx, Nvol, mn, iRbc, iZbs, packorunpack )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, half, one

  use numerical, only :

  use fileunits, only : ounit

  use inputlist, only : Wgf00aa, Lgeometry

  use cputiming, only : Tgf00aa

  use allglobal, only : ncpu, myid, cpus, im, nlocaldof, nflux
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in)    :: Ngdof, Nvol, mn
  REAL                   :: xx(1:Ngdof), iRbc(1:Nvol-1,1:mn), iZbs(1:Nvol-1,1:mn)
  CHARACTER              :: packorunpack

  INTEGER                :: lvol, imn, irz, totaldof
  REAL                   :: lfactor

  BEGIN(gf00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  totaldof = 0
  
  do lvol = 1, Nvol-1 ! loop over internal interfaces;
   
   do imn = 1, mn ! loop over Fourier harmonics;
    
!   if( imask(imn).le.0 ) cycle ! not a geometrical degree of freedom;
    
    lfactor = nflux(lvol)**(im(imn)*half) ! radial normalization factor;
    
    do irz = 0, 1 ! loop over R & Z;

     if( imn.eq.1 .and. irz.eq.1 ) cycle
     if( irz.eq.1 .and. Lgeometry.le.3 ) cycle
     
     totaldof = totaldof + 1
     
     select case( packorunpack )
      
     case( 'P' ) !   pack vector of unknowns;
      
      if( irz.eq.0 ) xx(totaldof) = iRbc(lvol,imn) / lfactor
      if( irz.eq.1 ) xx(totaldof) = iZbs(lvol,imn) / lfactor
      
     case( 'U' ) ! unpack vector of unknowns;
      
      if( irz.eq.0 ) iRbc(lvol,imn) = xx(totaldof) * lfactor
      if( irz.eq.1 ) iZbs(lvol,imn) = xx(totaldof) * lfactor
      
     case default
      
      FATALMESS(gf00aa,.true.,invalid packorunpack)
      
     end select
     
    enddo ! end of do irz;

   enddo ! end of do imn;
   
  enddo ! end of do lvol;
   
  FATALMESS(gf00aa,totaldof.ne.Ngdof,counting error)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(gf00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine gf00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


