!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Compute eigenvalues and eigenvectors of derivative matrix.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine he01aa( Ngdof, position )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, half, one, two

  use numerical, only : sqrtmachprec

  use fileunits, only : ounit, hunit, dunit

  use inputlist, only : Whe01aa, ext, Nvol, LHessian, LHevalues, LHevectors, Lgeometry, Lvacuum

  use cputiming, only : The01aa

  use allglobal, only : myid, cpus, mn, im, in,                                            &
                               nlocaldof, mlocaldof,                                       &
                        svol, NBdof,                                                       &
                        Nt, Nz, Ntz, gij, sg, dxsg, dxgij,                                 &
                        cfmn, sfmn, efmn, ofmn, ijreal, ijimag, trigwk, trigm, trign, isr, &
                        lBBintegral, dBBintegral, dAd, DenergyDrz, DanalyticDrz,           &
                        nlocaldof, DforcebalDrz, DspectralDrz, LforcebalDrz,               &
                        hessian, Lhessianallocated,                                        &
                        Lcoordinatesingularity, Louterboundarynormal
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER, intent(in)  :: Ngdof
  REAL   , intent(in)  :: position(1:Ngdof) ! internal geometrical degrees of freedom;
  
  LOGICAL              :: Lderiv                                                                                 ! for parallel / series construction of Hessian;
  INTEGER              :: lvol, jvol, ivol, innout, imn, irz, jmn, jrz, totaldoc, totaldof, ilocaldof, jlocaldof ! for parallel / series construction of Hessian;
  
  REAL                 :: force(1:Ngdof)
  REAL                 :: xtemp(1:Ngdof), ftemp(1:Ngdof), rvector(1:Ngdof), deriv
  
  REAL, allocatable    :: oBBintegral(:) ! original integral;
  
  INTEGER              :: Lwork, LDA, Ldvi, Ldvr, if02ebf
  REAL                 :: evalr(1:Ngdof), evali(1:Ngdof), evecr(1:Ngdof,1:Ngdof), eveci(1:Ngdof,1:Ngdof), work(1:4*Ngdof) ! for construction of evalues/evectors;
  CHARACTER            :: JOB
  
! INTEGER              :: iev, jev, M1, M2, irank(1:Ngdof), ifail ! for construction of evalues/evectors;
! CHARACTER            :: order
  
  BEGIN(he01aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RALLOCATE( DforcebalDrz,( 1:Nvol, 0:1, 1:nlocaldof, 0:1, 1:mn )) ! derivatives of BB                   wrt geometry;
  LALLOCATE( LforcebalDrz,( 1:Nvol,      1:nlocaldof            ))
  if( Lgeometry.ge.4 ) then                                    
  RALLOCATE( DspectralDrz,( 1:Nvol,      1:nlocaldof,      2:mn )) ! derivatives of spectral constraints wrt geometry;
  endif
  RALLOCATE(hessian,(1:Ngdof,1:Ngdof))
  Lhessianallocated = .true.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{construction of Hessian matrix} \begin{enumerate}

!latex \item The routine \verb+fc02aa+ is used to compute the derivatives, with respect to interface geometry,
!latex       of the force imbalance harmonics, $[[p+B^2/2]]_{j}$, which may be considered to be the ``physical'' constraints,
!latex       and if \verb+Lgeometry.ge.4+ then also the derivatives of the ``artificial'' spectral constraints, $I_j \equiv (R_\t X + Z_\t Y)_j$.

!latex \item The input variable \verb+Lconstraint+ determines whether the derivatives are taken at 
!latex       \begin{enumerate}
!latex       \item \verb+Lconstraint.eq.0+ : fixed $\mu$ and $\delta \psi_p$, 
!latex       \item \verb+Lconstraint.eq.1+ : fixed interface transform, or 
!latex       \item \verb+Lconstraint.eq.2+ : fixed helicity, ${\cal K}$, and $\delta \psi_p$.
!latex       \end{enumerate}
  
!latex \item If \verb+Lgradient.eq.1+, the derivative-matrix is constructed by \verb+fc02aa+,
!latex       which employs matrix-perturbation theory to construct the required derivatives and assumes fixed $\mu$ and $\delta \psi_p$.  

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  Lderiv = .true.
  WCALL(he01aa,fc02aa,( Ngdof, position(1:Ngdof), force(1:Ngdof), Lderiv ))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item If \verb+LHessian.eq.T+, then the derivative-matrix is constructed (here in \verb+he01aa+) using finite differences {\em in series}.
!latex       Again, \verb+Lconstraint+ determines whether the derivatives with respect to the $R_j$ and $Z_j$ are taken at
!latex       fixed $\mu$ and $\delta \psi_p$, fixed interface transform, or fixed helicity and $\delta \psi_p$.
!latex       This matrix should be identical to that produced by \verb+fc01aa+.
!latex \item The matrix produced by \verb+fc01aa/he01aa+ with \verb+Lconstraint=0+ should be {\em almost} identical to that produced by \verb+fc02aa+.
!latex       Small errors will arise due to the finite-accuracy of the finite-difference approximation used in \verb+fc01aa/he01aa+.
!latex       If \verb+Lconstraint.ne.0+, then small discrepancies between the matrix produced by \verb+fc01aa/he01aa+ and that produced by \verb+fc02aa+ will arise
!latex       because $\mu$ and $\delta \psi_p$ may not be held constant.
  
  if( LHessian ) then ! only then is DenergyDrz(lvol,innout,ilocaldof) computed by fc02aa/fu00aa;
   
   RALLOCATE(oBBintegral,(1:Nvol))
   oBBintegral(1:Nvol) = lBBintegral(1:Nvol) ! lBBintegral was set in above call to fc02aa;
   
   totaldof = 0
   
   do lvol = 1, Nvol ! loop over volumes;
    
    if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ; Lcoordinatesingularity = .false. ! either Cartesian geometry or annular volume; used elsewhere;
    else                                                         ; Lcoordinatesingularity = .true.
    endif
    
    if( Lvacuum.ne.0 .and. lvol.eq.Nvol                   ) then ; Louterboundarynormal   = .true.
    else                                                         ; Louterboundarynormal   = .false.
    endif
    
    do innout = 0, 1 ! inner and outer interfaces;
     
     if( lvol.eq.1    .and. innout.eq.0 ) cycle ! skip coordinate axis / fixed inner boundary;
     if( lvol.eq.Nvol .and. innout.eq.1 ) cycle ! skip                   fixed outer boundary;
     
     ilocaldof = 0

     jlocaldof = 0
     
     do imn = 1, mn ! loop over Fourier harmonics = geometrical degrees of freedom;
     
      do irz = 0, 1 ! loop over R, Z;
       
       if( imn.eq.1 .and. irz.eq.1 ) cycle ! this is not a degree of freedom; no dependence on Z_{m,n} \sin( m\t - n\z ) for m=0, n=0;
       
       if( irz.eq.1 .and. Lgeometry.le.3 ) cycle ! no dependence on Z;
       
       ilocaldof = ilocaldof + 1
       
!      if( imask(imn).le.0 ) cycle ! this is not a selected degree of freedom; 

       jlocaldof = jlocaldof + 1

       totaldof = (lvol-2+innout) * mlocaldof + jlocaldof
       
       xtemp(1:Ngdof) = position(1:Ngdof) ! reset geometry to original;
       
       xtemp(totaldof) = position(totaldof) + sqrtmachprec ! perturb geometry;
       
       Lderiv = .false.
       WCALL(he01aa,fc02aa,( Ngdof, xtemp(1:Ngdof), ftemp(1:Ngdof), Lderiv ))
       
       deriv = ( lBBintegral(lvol) - oBBintegral(lvol) ) / sqrtmachprec
       
       write(ounit,1002)myid,lvol,innout,imn,irz,totaldof,deriv,DenergyDrz(lvol,innout,ilocaldof),DanalyticDrz(lvol,innout,ilocaldof),&
                        deriv-DenergyDrz(lvol,innout,ilocaldof),deriv-DanalyticDrz(lvol,innout,ilocaldof)
       
      enddo ! end of do irz;
      
     enddo ! end of do imn;
     
    enddo ! end of if innout;
    
   enddo ! end of do lvol;
   
1002 format("he01aa : "10x" : myid="i3" ; lvol="i3" ; innout="i2" ; imn="i2" ; irz="i3" ; totaldof="i4" ; est.="f15.5" ; DenergyDrz="f15.5" ; Danalytic="f15.5" ; err="2f15.5" ;")
   
   DEALLOCATE(oBBintegral)
   
  endif ! end of if( LHessian );
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( LHessian ) then
   
   totaldof = 0 ! geometrical degree-of-freedom counter; labels derivative;
   
   do jvol = 1, Nvol-1 ! loop over internal interfaces;
    
    do jmn = 1, mn ! loop over Fourier harmonics degrees of freedom;
     
     do jrz = 0, 1 ! loop over R,Z degrees of freedom;
      
      if( jmn.eq.1 .and. jrz.eq.1 ) cycle ! this is not a degree of freedom; no dependence on Z_{m,n} for m=0, n=0;
      
      if( jrz.eq.1 .and. Lgeometry.le.3 ) cycle ! this is not a degree of freedom; no dependence on Z;
      
!     if( imask(jmn).le.0 ) cycle ! this is not a selected degree of freedom; this could come earlier, but is included here for consistency with other routines;
      
      totaldof = totaldof + 1
      
      xtemp(1:Ngdof) = position(1:Ngdof) ! reset geometry to original;
      
      xtemp(totaldof) = position(totaldof) + sqrtmachprec ! perturb geometry;
      
      Lderiv = .false.
      WCALL(he01aa,fc02aa,( Ngdof, xtemp(1:Ngdof), ftemp(1:Ngdof), Lderiv ))
      
      rvector(1:Ngdof) = ( ftemp(1:Ngdof) - force(1:Ngdof) ) / sqrtmachprec ! derivatives of constraints wrt degree-of-freedom;
      
      totaldoc = 0
      
      do ivol = 1, Nvol-1
       
       do imn = 1, mn
        
!       if( imask(imn).le.0 ) cycle ! this is not a selected degree of freedom; 
        
        do irz = 0, 1 ! loop over R,Z degrees of freedom;
         
         if( imn.eq.1 .and. irz.eq.1 ) cycle ! this is not a constraint; I_{m,n} for m=0, n=0 is irrelevant;
         
         if( irz.eq.1 .and. Lgeometry.le.3 ) cycle ! this is not a constraint; no spectral constraints;
         
         totaldoc = totaldoc + 1
         
         FATALMESS(he01aa,totaldoc.lt.    1,needs attention)
         FATALMESS(he01aa,totaldoc.gt.Ngdof,needs attention)
         
         write(ounit,1001)jvol,jmn,jrz,totaldof,ivol,imn,irz,totaldoc,rvector(totaldoc),hessian(totaldoc,totaldof),abs( rvector(totaldoc)-hessian(totaldoc,totaldof) )
         
        enddo ! end of do jrz;
        
       enddo ! end of do jmn;
       
      enddo ! end of do jvol;
      
1001  format("he01aa : " 10x " : jvol="i4" jmn="i4" jrz="i2" jdof="i6" ivol="i4" imn="i4" irz="i2" idoc="i6" estimate="f15.7" hessian="f15.7" err="f15.7" ;")
      
     enddo ! end of do irz;
     
    enddo ! end of do imn;
    
   enddo ! end of do jvol;
   
  endif ! end of if( LHessian );
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \end{enumerate} \subsubsection{construction of eigenvalues and eigenvectors} \begin{enumerate}
  
!latex \item If \verb+LHevalues.eq.T+ then the eigenvalues of the Hessian are computed using the NAG routine \verb+F02EBF+.
!latex \item If \verb+LHevectors.eq.T+ then the eigenvalues {\em and} the eigenvectors of the Hessian are computed.
  
!latex \item Note that if \verb+Lgeometry.ge.4+, then the derivative-matrix also contains information regarding how the ``artificial'' spectral constraints vary with geometry; 
!latex       so, the eigenvalues and eigenvectors are not purely ``physical''.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( myid.eq.0 .and. ( LHevalues .or. LHevectors ) ) then
   
   if( myid.eq.0 ) then ; cput = MPI_WTIME() ; write(ounit,'("he01aa : "f10.2" : LHevalues="L2" , LHevectors="L2" ;")')cput-cpus,LHevalues,LHevectors
   endif
   
   evalr(1:Ngdof) = zero ; evecr(1:Ngdof,1:Ngdof) = zero
   evali(1:Ngdof) = zero ; eveci(1:Ngdof,1:Ngdof) = zero
   
   if( LHevectors ) then ; JOB='V' ; Ldvr = Ngdof ; Ldvi = Ngdof
   else                  ; JOB='N' ; Ldvr =  1    ; Ldvi =  1
   endif
   
   if02ebf = 1 ; LDA = Ngdof ; Lwork = 4*Ngdof
   call F02EBF( JOB, Ngdof, hessian(1:Ngdof,1:Ngdof), LDA, evalr, evali, evecr(1:Ldvr,1:Ngdof), Ldvr, eveci(1:Ldvi,1:Ngdof), Ldvi, work(1:Lwork), Lwork, if02ebf )
   
   cput = MPI_WTIME()
   select case( if02ebf )
   case( 0 )    ; write(ounit,'("he01aa : "f10.2" : if02ebf="i2" ; success ;      ")')cput-cpus,if02ebf
   case( 1 )    ; write(ounit,'("he01aa : "f10.2" : if02ebf="i2" ; input error ;  ")')cput-cpus,if02ebf
   case( 2 )    ; write(ounit,'("he01aa : "f10.2" : if02ebf="i2" ; QR failed ;    ")')cput-cpus,if02ebf
   case default ; write(ounit,'("he01aa : "f10.2" : if02ebf="i2" ; illegal ifail ;")')cput-cpus,if02ebf
   end select
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  DEALLOCATE(DforcebalDrz)
  DEALLOCATE(LforcebalDrz)
  if( Lgeometry.ge.4 ) then
  DEALLOCATE(DspectralDrz)
  endif
  DEALLOCATE(hessian)
  Lhessianallocated = .false.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!    work(1:Ngdof) = sqrt( evalr(1:Ngdof)**2 + evali(1:Ngdof)**2 ) ; M1 = 1 ; M2 = Ngdof ; order = 'D' ; ifail = 0
!    
!    call M01DAF( work(1:Ngdof), M1, M2, order, irank(1:Ngdof), ifail ) ! rank by magnitude of eigenvalue
!    
!       write(ounit,'("he01aa : "f10.2" :                               "      )')cput-cpus
!    
!    do iev = 1, Ngdof
!     do jev = 1, Ngdof
!      if( irank(jev).eq.iev ) then
!       write(ounit,'("he01aa : "f10.2" : "i3" : evalr="es10.2" ; evecr="99f8.4)')cput-cpus,iev,evalr(jev),evecr(1:Ngdof,jev)
!       write(ounit,'("he01aa : "f10.2" : "i3" : evali="es10.2" ; eveci="99f8.4)')cput-cpus,iev,evali(jev),eveci(1:Ngdof,jev)
!       write(ounit,'("he01aa : "f10.2" :                               "      )')cput-cpus
!       exit
!      endif
!     enddo
!    enddo
 
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The eigenvalues and eigenvectors (if required) are written to the file \verb+.ext.GF.ev+ as follows:
!latex \begin{verbatim}
!latex open(hunit,file="."//trim(ext)//".GF.ev",status="unknown",form="unformatted")
!latex write(hunit)Ngdof,Ldvr,Ldvi        ! integers; if only the eigenvalues were computed then Ldvr=Ldvi=1;
!latex write(hunit)evalr(1:Ngdof)         ! reals   ; real      part of eigenvalues;
!latex write(hunit)evali(1:Ngdof)         ! reals   ; imaginary part of eigenvalues; 
!latex write(hunit)evecr(1:Ngdof,1:Ngdof) ! reals   ; real      part of eigenvalues; only if Ldvr=Ngdof;
!latex write(hunit)eveci(1:Ngdof,1:Ngdof) ! reals   ; imaginary part of eigenvalues; only if Ldvi=Ngdof;
!latex close(hunit)
!latex \end{verbatim}
!latex \item The eigenvectors are saved in columns of \verb+evecr, eveci+, as described by the NAG documentation for \verb+F02EBF+.
   
   open(hunit,file="."//trim(ext)//".GF.ev",status="unknown",form="unformatted")
   write(hunit)Ngdof,Ldvr,Ldvi
   write(hunit)evalr
   write(hunit)evali
   write(hunit)evecr
   write(hunit)eveci
   close(hunit)
   
  endif ! end of if( myid.eq.0 .and. ( LHevalues .or. LHevectors ) )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(he01aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine he01aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
