!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Interpolates interface geometry: redundant;
!latex The interface geometry is given in \verb+iRbc(0:Nvol,1:mn)+ and \verb+iZbs(0:Nvol,1:mn)+, where \verb+iRbc(0,1:mn)+ and \verb+iZbs(0,1:mn)+ is the coordinate axis.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ih00aa(Nvol)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : one
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : Wih00aa
  use cputiming
  use allglobal, only : myid, cpus, mn, im, in, iRbc, iZbs, interfacelabel!, Ric, Zis

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in) :: Nvol ! this is really global, but convenient to include in argument list to avoid allocations;

  INTEGER             :: imn, ie01bef
  REAL                :: expmm, lssm(0:Nvol), rmn(0:Nvol), zmn(0:Nvol)

  BEGIN(ih00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do imn = 1,mn ! the extrapolation of each harmonic is performed separately;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!   select case( Lsinterp )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item \verb+Lsinterp.eq.0+, 
!latex \begin{itemize}
!latex \item the coordinates are constructed by a piecewise linear interpolation of the interface harmonics.
!latex \item The coordinate Jacobian is discontinuous at the interfaces; but, as the Beltrami fields in each volume are constructed independently,
!latex a discontinuous Jacobian does not cause any problems.
!latex \end{itemize}

!  case(0)
!  
!    Ric(0:Nvol  ,0,imn) =   iRbc(0:Nvol  ,imn)
!    Zis(0:Nvol  ,0,imn) =   iZbs(0:Nvol  ,imn)
!
!    Ric(0:Nvol-1,1,imn) = ( iRbc(1:Nvol  ,imn) - iRbc(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) ) ! linear derivatives;
!    Zis(0:Nvol-1,1,imn) = ( iZbs(1:Nvol  ,imn) - iZbs(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) ) ! linear derivatives;
!
!    Ric(1:Nvol  ,1,imn) = ( iRbc(1:Nvol  ,imn) - iRbc(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) ) ! linear derivatives;
!    Zis(1:Nvol  ,1,imn) = ( iZbs(1:Nvol  ,imn) - iZbs(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) ) ! linear derivatives;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
!latex \item \verb+Lsinterp.eq.1+, 
!latex \begin{itemize}
!latex \item the coordinates are constructed by a piecewise cubic interpolation of the interface harmonics, provided by the NAG routine \verb+E01BEF+.
!latex \end{itemize}

!   case(1)
!
!    Ric(0:Nvol,0,imn) = iRbc(0:Nvol,imn)
!    Zis(0:Nvol,0,imn) = iZbs(0:Nvol,imn)
!
!    ie01bef=1 ; call E01BEF( Nvol+1 , interfacelabel(0:Nvol) , Ric(0:Nvol,0,imn) , Ric(0:Nvol,1,imn) , ie01bef ) 
!    FATALMESS(ih00aa,ie01bef.ne.0,error interpolating Ric coordinate harmonics using NAG routine E01BEF)
!    
!    ie01bef=1 ; call E01BEF( Nvol+1 , interfacelabel(0:Nvol) , Zis(0:Nvol,0,imn) , Zis(0:Nvol,1,imn) , ie01bef )
!    FATALMESS(ih00aa,ie01bef.ne.0,error interpolating Zis coordinate harmonics using NAG routine E01BEF)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item \verb+Lsinterp.eq.2+, 
!latex \begin{itemize}
!latex \item the coordinates are constructed by a piecewise cubic interpolation of the interface harmonics,
!latex where the first derivatives required for the interpolation are constructed by centered differences
!latex (except at the origin and outermost boundary, where forward and backward differences are used).
!latex \item this should, in most cases, give identical results to the case \verb+Lsinterp=1+.
!latex \end{itemize}

!   case(2)
!    
!    Ric(0:Nvol,0,imn) = iRbc(0:Nvol,imn)
!    Zis(0:Nvol,0,imn) = iZbs(0:Nvol,imn)
!
!    Ric(0       ,1,imn) = ( iRbc(1           ,imn) - iRbc(0           ,imn) ) / ( interfacelabel(1           ) - interfacelabel(0           ) )
!    Ric(1:Nvol-1,1,imn) = ( iRbc(1+1:Nvol-1+1,imn) - iRbc(1-1:Nvol-1-1,imn) ) / ( interfacelabel(1+1:Nvol-1+1) - interfacelabel(1-1:Nvol-1-1) )
!    Ric(  Nvol  ,1,imn) = ( iRbc(    Nvol    ,imn) - iRbc(    Nvol-1  ,imn) ) / ( interfacelabel(    Nvol    ) - interfacelabel(    Nvol-1  ) )
!    
!    Zis(0       ,1,imn) = ( iZbs(1           ,imn) - iZbs(0           ,imn) ) / ( interfacelabel(1           ) - interfacelabel(0           ) )
!    Zis(1:Nvol-1,1,imn) = ( iZbs(1+1:Nvol-1+1,imn) - iZbs(1-1:Nvol-1-1,imn) ) / ( interfacelabel(1+1:Nvol-1+1) - interfacelabel(1-1:Nvol-1-1) )
!    Zis(  Nvol  ,1,imn) = ( iZbs(    Nvol    ,imn) - iZbs(    Nvol-1  ,imn) ) / ( interfacelabel(    Nvol    ) - interfacelabel(    Nvol-1  ) )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
!latex \item \verb+Lsinterp.eq.3+, 
!latex \begin{itemize}
!latex \item the power $r^{m}$ is extracted before the piecewise cubic interpolation of the interface harmonics,
!latex so that the radial dependence of the coordinate Fourier harmonics is $R_j(s) = s^{m/\beta} p(s)$, where $p(s)$ is a polynomial fitted to the interfaces,
!latex i.e. $p(s_i) = R_j(s_i) / s_i^{m/\beta}$, 
!latex and is interpolated (piecewise-cubic) by the NAG routine \verb+E01BEF+, and it is assumed that the radial coordinate, $s$, varies like $s\sim r^\beta$.
!latex \item the $r^m$ factor arises from insisting that the coordinates are regular at the origin, as explained in \verb+ex00aa+.
!latex \item note that constructing a suitable value for $p(0)$ is not trivial; his value is set in \verb+ex00aa+.
!latex \end{itemize}

!   case(3)
!
!    if( im(imn).eq.0 ) then ! additional radial factor is degenerate;
!     
!     Ric(0:Nvol,0,imn) = iRbc(0:Nvol,imn)
!     Zis(0:Nvol,0,imn) = iZbs(0:Nvol,imn)
!     
!    else
!     
!     expmm = im(imn) * one ! NEEDS CLOSE ATTENTION; ERROR;
!
!     lssm(1:Nvol) = interfacelabel(1:Nvol)**expmm
!     
!     Ric(1:Nvol,0,imn) = iRbc(1:Nvol,imn) / lssm(1:Nvol) ! recal that Ric(0,0,imn) was calculated in ex00aa;
!     Zis(1:Nvol,0,imn) = iZbs(1:Nvol,imn) / lssm(1:Nvol) ! recal that Zis(0,0,imn) was calculated in ex00aa;
!
!    endif
!
!    ie01bef=1 ; call E01BEF( Nvol+1 , interfacelabel(0:Nvol) , Ric(0:Nvol,0,imn) , Ric(0:Nvol,1,imn) , ie01bef ) 
!    FATALMESS(ih00aa,ie01bef.ne.0,error establishing interpolation of Ric coordinate harmonics using NAG routine E01BEF)
!    
!    ie01bef=1 ; call E01BEF( Nvol+1 , interfacelabel(0:Nvol) , Zis(0:Nvol,0,imn) , Zis(0:Nvol,1,imn) , ie01bef )
!    FATALMESS(ih00aa,ie01bef.ne.0,error establishing interpolation of Zis coordinate harmonics using NAG routine E01BEF)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item \verb+Lsinterp.eq.4+, 
!latex \begin{itemize}
!latex \item the coordinates are constructed by a piecewise cubic interpolation of the interface harmonics,
!latex where the first derivatives required for the interpolation are constructed by forward differences
!latex (except at the outermost boundary, where backward differences are used).
!latex \item this should, in most cases, give similar results to the case \verb+Lsinterp=1,2+.
!latex \end{itemize}

!   case(4)
!
!    FATALMESS(ih00aa,.true.,this needs to be checked very closely)
!    
!    Ric(0:Nvol  ,0,imn) =   iRbc(0:Nvol  ,imn)
!    Zis(0:Nvol  ,0,imn) =   iZbs(0:Nvol  ,imn)
!    
!    Ric(0:Nvol-1,1,imn) = ( iRbc(1:Nvol  ,imn) - iRbc(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) )
!    Ric(  Nvol  ,1,imn) = ( iRbc(  Nvol  ,imn) - iRbc(  Nvol-1,imn) ) / ( interfacelabel(  Nvol  )-interfacelabel(  Nvol-1) )
!
!    Zis(0:Nvol-1,1,imn) = ( iZbs(1:Nvol  ,imn) - iZbs(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) )
!    Zis(  Nvol  ,1,imn) = ( iZbs(  Nvol  ,imn) - iZbs(  Nvol-1,imn) ) / ( interfacelabel(  Nvol  )-interfacelabel(  Nvol-1) )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item \verb+Lsinterp.eq.5+, 
!latex \begin{itemize}
!latex \item the coordinates are constructed by a piecewise linear interpolation of the interface harmonics,
!latex except in the innermost volume, where
!latex \be R_j(s)=R_{j,1} s^{m_j/2}/s_1^{m_j/2}, \;\;\; Z_j(s)=Z_{j,1} s^{m_j/2}/s_1^{m_j/2}.
!latex \ee
!latex \item this is probably inconsistent with the location of the magnetic axis as computed by \verb+ex00aa+.
!latex \end{itemize}

!   case(5)
!  
!    Ric(0:Nvol  ,0,imn) =   iRbc(0:Nvol  ,imn)
!    Zis(0:Nvol  ,0,imn) =   iZbs(0:Nvol  ,imn)
!
!    Ric(0:Nvol-1,1,imn) = ( iRbc(1:Nvol  ,imn) - iRbc(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) ) ! linear derivatives;
!    Zis(0:Nvol-1,1,imn) = ( iZbs(1:Nvol  ,imn) - iZbs(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) ) ! linear derivatives;
!
!    Ric(1:Nvol  ,1,imn) = ( iRbc(1:Nvol  ,imn) - iRbc(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) ) ! linear derivatives;
!    Zis(1:Nvol  ,1,imn) = ( iZbs(1:Nvol  ,imn) - iZbs(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) ) ! linear derivatives;
    
!    Ric(0:Nvol  ,0,imn) =   iRbc(0:Nvol  ,imn)
!    Zis(0:Nvol  ,0,imn) =   iZbs(0:Nvol  ,imn)
!    
!    Ric(0:Nvol-1,1,imn) = ( iRbc(1:Nvol  ,imn) - iRbc(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) )
!    Ric(  Nvol  ,1,imn) = ( iRbc(  Nvol  ,imn) - iRbc(  Nvol-1,imn) ) / ( interfacelabel(  Nvol  )-interfacelabel(  Nvol-1) )
!
!    Zis(0:Nvol-1,1,imn) = ( iZbs(1:Nvol  ,imn) - iZbs(0:Nvol-1,imn) ) / ( interfacelabel(1:Nvol  )-interfacelabel(0:Nvol-1) )
!    Zis(  Nvol  ,1,imn) = ( iZbs(  Nvol  ,imn) - iZbs(  Nvol-1,imn) ) / ( interfacelabel(  Nvol  )-interfacelabel(  Nvol-1) )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
!   case default
    
!    FATALMESS(ih00aa,.true.,invalid Lsinterp)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
!   end select
   
!   if( Wih00aa ) then
!    cput = MPI_WTIME()
!    write(ounit,'("ih00aa : "f10.2" : myid="i3" ; Ric(1,0,imn), Zis(1,0,imn)="4es13.5" ;")')cput-cpus,myid,iRbc(1,imn),iZbs(1,imn),Ric(1,0,imn),Zis(1,0,imn)
!    pause
!   endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  enddo ! end of do imn=1,mn;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item In all cases, the radial derivatives of the coordinate harmonics are saved in \verb+Ric(0:Nvol,1,1:mn)+ and \verb+Zis(0:Nvol,1,1:mn)+.
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!  if( Wih00aa ) then
!   cput = MPI_WTIME()
!   do imn=1,mn
!    write(ounit,'("ih00aa ; "f10.2" : myid="i3" ; (m,n)=("i3" ,"i3" ) : Ric(:,0,)="99es13.5)')cput-cpus,myid,im(imn),in(imn),Ric(0:Nvol,0,imn)
!    write(ounit,'("ih00aa ; "f10.2" : myid="i3" ; (m,n)=("i3" ,"i3" ) : Ric(:,1,)="99es13.5)')cput-cpus,myid,im(imn),in(imn),Ric(0:Nvol,1,imn)
!   enddo
!  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(ih00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine ih00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
