!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Computes current and measures error in Beltrami equation.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{construction of current} \begin{enumerate}

!latex \item The magnetic field is given as the curl of the vector potential,
!latex \be {\bf B} = \frac{\partial_\t A_\z - \partial_\z A_\t}{\sqrt g}{\bf e}_\s
!latex             - \frac{                   \partial_\s A_\z}{\sqrt g}{\bf e}_\t
!latex             + \frac{\partial_\s A_\t                   }{\sqrt g}{\bf e}_\z
!latex             = B^\s {\bf e}_\s + B^\t {\bf e}_\t + B^\z {\bf e}_\z.
!latex \ee

!latex To take the curl of this, it is convenient to `lower' the metric elements
!latex \be B_\s&=&B^\s g_{\s\s}+B^\t g_{\s\t}+B^\z g_{\s\z},\\
!latex     B_\t&=&B^\s g_{\s\t}+B^\t g_{\s\t}+B^\z g_{\s\t},\\
!latex     B_\z&=&B^\s g_{\s\z}+B^\t g_{\s\z}+B^\z g_{\s\z}.
!latex \ee

!latex The curl is then 
!latex \be \nabla \times {\bf B} = \frac{\partial_\t B_\z - \partial_\z B_\t}{\sqrt g}{\bf e}_\s
!latex                           + \frac{\partial_\z B_\s - \partial_\s B_\z}{\sqrt g}{\bf e}_\t
!latex                           + \frac{\partial_\s B_\t - \partial_\t B_\s}{\sqrt g}{\bf e}_\z.
!latex \ee

!latex \item The interpolated vector potential harmonics and their derivatives \verb+doAtmn(0:2,1:mn)+ and \verb+doAzmn(0:2,1:mn)+,
!latex are calculated in \verb+sa00aa+.

!latex The derivatives of the metric elements \verb+gij(1:6,0:3,1:Ntz)+ and Jacobian \verb+sg(0:3,1:Ntz)+
!latex are calculated in \verb+co01aa+.

!latex \end{enumerate} \subsubsection{volume integrals} \begin{enumerate}
!latex \item Define 
!latex \be ||\left( \nabla \times {\bf B}-\mu {\bf B}\right)\cdot\nabla \s || & \equiv & 
!latex   \int ds \ooint \sqrt g \left| \left( \nabla \times {\bf B}-\mu {\bf B}\right)\cdot\nabla \s \right|
!latex = \int ds \ooint \left[(\partial_\t B_\z - \partial_\z B_\t) - \mu (\partial_\t A_\z - \partial_\z A_\t)\right], \nonumber \\
!latex     ||\left( \nabla \times {\bf B}-\mu {\bf B}\right)\cdot\nabla \t || & \equiv & \int ds \ooint \sqrt g \left( \nabla \times {\bf B}-\mu {\bf B}\right)\cdot\nabla \t
!latex =\int ds \ooint \left[(\partial_\z B_\s - \partial_\s B_\z) - \mu (\;\;\;\;\;\;\;\; - \partial_\s A_\z)\right], \nonumber \\
!latex     ||\left( \nabla \times {\bf B}-\mu {\bf B}\right)\cdot\nabla \z || & \equiv & \int ds \ooint \sqrt g \left( \nabla \times {\bf B}-\mu {\bf B}\right)\cdot\nabla \s
!latex =\int ds \ooint \left[(\partial_\s B_\t - \partial_\t B_\s) - \mu (\partial_\s A_\t   \;\;\;\;\;\;\;\;)\right], \nonumber
!latex \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine jo00aa( lvol, Ntz )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, half

  use fileunits, only : ounit, interpolatedfieldsunit

  use inputlist, only : Wjo00aa, Nvol, Ni, mu, ext

  use cputiming, only : Tjo00aa

  use allglobal, only : myid, cpus, interfacelabel, mn, im, in, &
                        iBns, & 
                        trigwk, trigm, trign, isr, Nt, Nz, efmn, ofmn, cfmn, sfmn, &
                        sg, gij, Rij, Zij, doAtmn, doAzmn, ijreal, jireal, soNtz, svol, &
                        Lcoordinatesingularity ! 11 Oct 12; 
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in) :: lvol, Ntz ! these are really global, but are included in argument list to remove allocations;

  INTEGER             :: ii, ij, ik, il, Lcurv, ig, lNi, Nen = 2**3, ifail, Ldo, iilow, nii

  REAL                :: lss, dBu(1:3,0:3,1:Ntz), dBl(1:3,0:3,1:Ntz), ju(1:3,1:Ntz), jerror(1:3), nerror(1:3) ! error in Fourier space;
  
  BEGIN(jo00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATALMESS(jo00aa,lvol.lt.1 .or. lvol.gt.Nvol,invalid interface label)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  lNi = Ni(lvol) * Nen ! enhanced resolution;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  dBu(1:3,0:3,1:Ntz) = zero ! initialize summation quantities; contravariant components of magnetic field;
  dBl(1:3,0:3,1:Ntz) = zero ! initialize summation quantities; co    variant components of magnetic field;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  jerror(1:3) = zero ! measure of error, (curl B - mu B) . \grad u_i
  nerror(1:3) = zero ! measure of error, (curl B - mu B) . \grad u_i ; perhaps this is normalized -- can check construction below;

  ju(1:3,1:Ntz) = zero ! initialize summation quantities; error in real space;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  write(svol,'(i4.4)')lvol ! 11 Oct 12; IS THIS STILL REQUIRED;
  if( Wjo00aa ) then
   open(interpolatedfieldsunit+myid,file="."//trim(ext)//".interpolatedfields:"//svol,status="unknown",form="unformatted") ! this will contain Harmonic plot data; 
   write(interpolatedfieldsunit+myid) lNi, mn, Nt, Nz, Ntz
   write(interpolatedfieldsunit+myid) im(1:mn), in(1:mn)
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Lcoordinatesingularity ) then ; iilow = 1 ! 11 Oct 12; avoid coordinate singularity;
!  if( lvol.eq.1 ) then ; iilow = 1 !  ! 11 Oct 12; 
  else                              ; iilow = 0 ! co01aa no longer uses finite-differences to compute metric elements; can go exactly to edge;
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! loop over radial sub-grid;

  do ii = iilow, lNi
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \item The error is computed in real space on a grid.
   
   lss = interfacelabel(lvol-1) + ii * ( interfacelabel(lvol)-interfacelabel(lvol-1) ) / lNi
   
   if( Wjo00aa ) write(interpolatedfieldsunit+myid) lss
   
   Ldo = 0
   WCALL(jo00aa,sa00aa,(lvol, lss, Ldo)) ! returns interpolated doAtmn(0,0:2,1:mn), doAzmn(0,0:2,1:mn) ;
   
   Lcurv = 2 ; WCALL(jo00aa,co01aa(lvol, lss, Lcurv, Ntz)) ! returns interpolated Rij(0:9,1:Ntz), Zij(0:9,1:Ntz), sg(0:3,1:Ntz), gij(1:6,0:3,1:Ntz)
   
   if( Wjo00aa ) then
    write(interpolatedfieldsunit+myid) doAtmn(0,0:2,1:mn), doAzmn(0,0:2,1:mn)
    write(interpolatedfieldsunit+myid) Rij(0:9,1:Ntz), Zij(0:9,1:Ntz),gij(1:6,0:3,1:Ntz),sg(0:3,1:Ntz)
   endif
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   ofmn(1:mn) = -          im(1:mn)*doAzmn(0,0,1:mn) -          in(1:mn)*doAtmn(0,0,1:mn) ! harmonics of \sqrt g B^s;
   sfmn(1:mn) = -          im(1:mn)*doAzmn(0,1,1:mn) -          in(1:mn)*doAtmn(0,1,1:mn) ! harmonics of \sqrt g B^s; radial derivative;

   efmn(1:mn)=zero ; cfmn(1:mn)=zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, dBu(1,0,:), dBu(1,1,:), isr, trigm, trign, trigwk )

   efmn(1:mn) = - im(1:mn)*im(1:mn)*doAzmn(0,0,1:mn) - im(1:mn)*in(1:mn)*doAtmn(0,0,1:mn) ! harmonics of \sqrt g B^s; poloidal derivative;
   cfmn(1:mn) = + in(1:mn)*im(1:mn)*doAzmn(0,0,1:mn) + in(1:mn)*in(1:mn)*doAtmn(0,0,1:mn) ! harmonics of \sqrt g B^s; toroidal derivative;

   ofmn(1:mn)=zero ; sfmn(1:mn)=zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, dBu(1,2,:), dBu(1,3,:), isr, trigm, trign, trigwk )
   
! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

   efmn(1:mn) =                                      -                   doAzmn(0,1,1:mn) ! harmonics of \sqrt g B^t;
   cfmn(1:mn) =                                      -                   doAzmn(0,2,1:mn) ! harmonics of \sqrt g B^t; radial derivative;

   ofmn(1:mn)=zero ; sfmn(1:mn)=zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, dBu(2,0,:), dBu(2,1,:), isr, trigm, trign, trigwk )

   ofmn(1:mn) =                                      +          im(1:mn)*doAzmn(0,1,1:mn) ! harmonics of \sqrt g B^t; poloidal derivative;
   sfmn(1:mn) =                                      -          in(1:mn)*doAzmn(0,1,1:mn) ! harmonics of \sqrt g B^t; toroidal derivative;

   efmn(1:mn)=zero ; cfmn(1:mn)=zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, dBu(2,2,:), dBu(2,3,:), isr, trigm, trign, trigwk )
   
! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

   efmn(1:mn) = +                   doAtmn(0,1,1:mn)                                      ! harmonics of \sqrt g B^z; 
   cfmn(1:mn) = +                   doAtmn(0,2,1:mn)                                      ! harmonics of \sqrt g B^z; radial derivative;

   ofmn(1:mn)=zero ; sfmn(1:mn)=zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, dBu(3,0,:), dBu(3,1,:), isr, trigm, trign, trigwk )

   ofmn(1:mn) = -          im(1:mn)*doAtmn(0,1,1:mn)                                      ! harmonics of \sqrt g B^z; poloidal derivative;
   sfmn(1:mn) = +          in(1:mn)*doAtmn(0,1,1:mn)                                      ! harmonics of \sqrt g B^z; toroidal derivative;

   efmn(1:mn)=zero ; cfmn(1:mn)=zero
   call invfft( mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), Nt, Nz, dBu(3,2,:), dBu(3,3,:), isr, trigm, trign, trigwk )
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  if( Wjo00aa ) write(interpolatedfieldsunit+myid) dBu(1:3, 0:3, 1:Ntz) ! write out the upper components of the magnetic field and its radial derivatives;
 
!latex \item To calculate $\nabla \times {\bf B}$ use the expression
!latex \be \partial_k B_i = \sum_j \left( \frac{\partial_k (\sqrt g B^j)}{\sqrt g}g_{ij} 
!latex                                  - \frac{\sqrt g B^j}{\sqrt g}\frac{\partial_k \sqrt g}{\sqrt g}g_{ij} 
!latex                                  + \frac{\sqrt g B^j}{\sqrt g}\partial_k g_{ij} 
!latex                             \right).
!latex \ee
   
   dBl(1:3,1:3,1:Ntz) = zero ! initialize summation;
   
   do ik = 1,3
    do il = 1,3
     
     do ij = 1,3

      call gi00aa(il,ij,ig) ! ig is intent out; see numrec.h;
      
      dBl(il,ik,:)  =  dBl(il,ik,:) + ( ( dBu(ij,ik,:) - dBu(ij,0,:) * sg(ik,:) / sg(0,:) ) * gij(ig,0,:) + dBu(ij,0,:) * gij(ig,ik,:) ) / sg(0,:)
      
     enddo

    enddo
   enddo
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   ijreal = dBl(3,2,:) - dBl(2,3,:) ! sqrt g . (curl B)^s; real space;
   jireal = dBl(1,3,:) - dBl(3,1,:) ! sqrt g . (curl B)^t; real space;

   ju(1,1:Ntz) = dBl(3,2,:) - dBl(2,3,:) - mu(lvol) * dBu(1,0,1:Ntz) ! this is in real space;
   ju(2,1:Ntz) = dBl(1,3,:) - dBl(3,1,:) - mu(lvol) * dBu(2,0,1:Ntz) ! this is in real space;

   call tfft( Nt, Nz, ijreal, jireal, isr, trigm, trign, trigwk, mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), ifail )
      
! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! -

!   if( Louterboundarynormal ) then ! DEBUGGING;
!
!   !ofmn(1:mn) = ofmn(1:mn) + iBns(1:mn) * half * mu(lvol) ! WHERE ON EARTH DID THIS COME FROM;
!
!    write(ounit,'("jo00aa : "10x" : lvol="i3" ; ii="i6" ;  j^s = "99es12.4)')lvol,ii,         (              ofmn(1:mn)                                 )
!    write(ounit,'("jo00aa : "10x" : lvol="i3" ; ii="i6" ; uB^s = "99es12.4)')lvol,ii,mu(lvol)*( - im(1:mn)*doAzmn(0,0,1:mn) - in(1:mn)*doAtmn(0,0,1:mn) )
!
!   endif

! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! - ! -

   jerror(1) = jerror(1) + sum( abs( ofmn(1:mn) - mu(lvol)*( - im(1:mn)*doAzmn(0,0,1:mn) - in(1:mn)*doAtmn(0,0,1:mn) ) ) ) ! err in Fourier; (sqrt g . j^s)_mn - (sqrt g . B^s)_mn
   
   jerror(2) = jerror(2) + sum( abs( cfmn(1:mn) - mu(lvol)*(                             -          doAzmn(0,1,1:mn) ) ) ) ! err in Fourier; B^t;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   ijreal = dBl(2,1,:) - dBl(1,2,:) ! sqrt g . (curl B)^z
   jireal = zero

   ju(3,1:Ntz) = dBl(2,1,:) - dBl(1,2,:) - mu(lvol) * dBu(3,0,1:Ntz) 

   call tfft( Nt,Nz,ijreal,jireal,isr,trigm,trign,trigwk,mn,im,in,efmn(1:mn),ofmn(1:mn),cfmn(1:mn),sfmn(1:mn),ifail )

   jerror(3) = jerror(3) + sum( abs( efmn(1:mn) - mu(lvol)*( +          doAtmn(0,1,1:mn)                             ) ) ) ! err in Fourier; B^z;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   nerror(1) = nerror(1) + sum( abs( ju(1,1:Ntz) * ( ju(1,1:Ntz) * gij(1,0,1:Ntz) + ju(2,1:Ntz) * gij(2,0,1:Ntz) + ju(3,1:Ntz) * gij(3,0,1:Ntz) ) ) )
   nerror(2) = nerror(2) + sum( abs( ju(2,1:Ntz) * ( ju(1,1:Ntz) * gij(2,0,1:Ntz) + ju(2,1:Ntz) * gij(4,0,1:Ntz) + ju(3,1:Ntz) * gij(5,0,1:Ntz) ) ) )
   nerror(3) = nerror(3) + sum( abs( ju(3,1:Ntz) * ( ju(1,1:Ntz) * gij(3,0,1:Ntz) + ju(2,1:Ntz) * gij(5,0,1:Ntz) + ju(3,1:Ntz) * gij(6,0,1:Ntz) ) ) )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  enddo ! end of do ii = iilow, lNi;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! jerror(1:3) = jerror(1:3) / ( (lNi-1) * mn  ) ! normalize error;
! nerror(1:3) = nerror(1:3) / ( (lNi-1) * Ntz ) ! normalize error;

  if( lvol.eq.1 ) then ; nii = lNi
  else                 ; nii = lNi + 1
  endif

  jerror(1:3) = jerror(1:3) / ( nii * mn  ) ! normalize error;
  nerror(1:3) = nerror(1:3) / ( nii * Ntz ) ! normalize error;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  cput = MPI_WTIME() ; write(ounit,1000)cput-cpus,myid,lvol,Ni(lvol),jerror(1:3),nerror(1:3),Nen,cput-cpui ! write error to screen;

1000 format("jo00aa : "f10.2" : myid="i3" ; lvol="i3" ; Ni="i4" ; curl error "6es13.5 " ; Nen="i3" ; time="f8.2"s ;")
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wjo00aa ) close(interpolatedfieldsunit+myid) ! 11 Oct 12; I would prefer to eliminate this file;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(jo00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine jo00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{what is the best way to define the error in $\nabla \times {\bf B}=\mu {\bf B}$ ?} \begin{enumerate}

!latex \item It may be better to compute the error according to
!latex \be \frac{\int_V | j^\s j_\s | dv}{\int_V dv},  \;\;\; \frac{\int_V | j^\t j_\t | dv}{\int_V dv}, \;\;\; \frac{\int_V | j^\z j_\z | dv}{\int_V dv},
!latex \ee
!latex where ${\bf j}=\nabla \times {\bf B} - \mu {\bf B}$.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

