!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Calculates volume integrals using Gaussian quadrature over radial coordinate.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ma00aa( Iquad, lvol )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, half, one

  use numerical, only : vsmall

  use fileunits, only : ounit

  use inputlist, only : Wma00aa, Lgeometry, Nvol, Ni, Nofe

  use cputiming, only : Tma00aa

  use allglobal, only : myid, ncpu, cpus,                                       & !
                        mn, im, in,                                             & ! Fourier resolution, volume index;
                        felr, lelr, ss, dss,                                    & ! finite element basis functions, radial subgrid;
                        dAd,                                                    &
                          agss,   agst,   agsz,   agtt,   agtz,   agzz,   agoo, & ! averaged metric quantities;
                        dxagss, dxagst, dxagsz, dxagtt, dxagtz, dxagzz, dxagoo, &
                          igss,   igst,   igsz,   igtt,   igtz,   igzz,   igoo, & ! geometric information;
                        dxigss, dxigst, dxigsz, dxigtt, dxigtz, dxigzz, dxigoo, &
                        Lcoordinatesingularity
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in) :: Iquad, lvol

!loop control;
  INTEGER             :: ii, il, ip, ir, iq, ij, ik, jj, jk, imn

! required for Gaussian integration routine;
  INTEGER             :: itype, id01bcf
  REAL                :: aa, bb, cc, dd, weight(1:Iquad), abscis(1:Iquad)

! shorthand;
  REAL                :: lss, factor(1:3), gactor(1:7), smj(-1:0), smk(-1:0), rmj, rmk
  
  BEGIN(ma00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! FATALMESS(ma00aa,lvol.lt.1.or.lvol.gt.Nvol,illegal volume label)
  
  do ip = 0, Nofe ; lelr(0:1,ip,0,1:Iquad) = felr(0:1,ip,0,1:Iquad) * dss(lvol,ip  )
                    lelr(0:1,ip,1,1:Iquad) = felr(0:1,ip,1,1:Iquad) * dss(lvol,ip-1)
  enddo
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \end{enumerate} \subsubsection{geometric information required in annular volumes} \begin{enumerate}
!latex \item The geometric information is defined
!latex \be \mbox{\type{igss(l,p,r,q,jk)\%s(i)}} & \equiv & \intdsl \varphi_{l,p}  \varphi_{r,q}  \braket{s_j}{\bar g_{ss}}{s_k},\\
!latex     \mbox{\type{igst(l,p,r,q,jk)\%s(i)}} & \equiv & \intdsl \varphi_{l,p}  \varphi_{r,q}' \braket{s_j}{\bar g_{st}}{c_k},\\
!latex     \mbox{\type{igsz(l,p,r,q,jk)\%s(i)}} & \equiv & \intdsl \varphi_{l,p}  \varphi_{r,q}' \braket{s_j}{\bar g_{sz}}{c_k},\\
!latex     \mbox{\type{igtt(l,p,r,q,jk)\%s(i)}} & \equiv & \intdsl \varphi_{l,p}' \varphi_{r,q}' \braket{c_j}{\bar g_{tt}}{c_k},\\
!latex     \mbox{\type{igtz(l,p,r,q,jk)\%s(i)}} & \equiv & \intdsl \varphi_{l,p}' \varphi_{r,q}' \braket{c_j}{\bar g_{tz}}{c_k},\\
!latex     \mbox{\type{igzz(l,p,r,q,jk)\%s(i)}} & \equiv & \intdsl \varphi_{l,p}' \varphi_{r,q}' \braket{c_j}{\bar g_{zz}}{c_k},\\
!latex     \mbox{\type{igoo(l,p,r,q,jk)\%s(i)}} & \equiv & \intdsl \varphi_{l,p}  \varphi_{r,q}' \braket{c_j}{     1     }{c_k},\\
!latex \ee
!latex where $l=0,1$, $p=0,\dots,$\verb+Nofe+, $r=0,1$, $q=0,\dots,$\verb+Nofe+, for $j,k=1,\dots,$\verb+mn+.
!latex Note that the \verb+j,k+ dependence has been compressed into a single index, \verb+jk=1,mn**2+.

!latex \item In the innermost volume, the required quantities are

!latex \be \mbox{\type{igss(l,p,r,q,jk)\%s(i)}} & \equiv &
!latex \intdsl \left(s^{m_j}\varphi_{l,p}\right)  \left(s^{m_k}\varphi_{r,q}\right)  \braket{s_j}{\bar g_{ss}}{s_k},\\
!latex     \mbox{\type{igst(l,p,r,q,jk)\%s(i)}} & \equiv &
!latex \intdsl \left(s^{m_j}\varphi_{l,p}\right)  \left(s^{m_k}\varphi_{r,q}\right)' \braket{s_j}{\bar g_{st}}{c_k},\\
!latex     \mbox{\type{igsz(l,p,r,q,jk)\%s(i)}} & \equiv &
!latex \intdsl \left(s^{m_j}\varphi_{l,p}\right)  \left(s^{m_k}\varphi_{r,q}\right)' \braket{s_j}{\bar g_{sz}}{c_k},\\
!latex     \mbox{\type{igtt(l,p,r,q,jk)\%s(i)}} & \equiv &
!latex \intdsl \left(s^{m_j}\varphi_{l,p}\right)' \left(s^{m_k}\varphi_{r,q}\right)' \braket{c_j}{\bar g_{tt}}{c_k},\\
!latex     \mbox{\type{igtz(l,p,r,q,jk)\%s(i)}} & \equiv &
!latex \intdsl \left(s^{m_j}\varphi_{l,p}\right)' \left(s^{m_k}\varphi_{r,q}\right)' \braket{c_j}{\bar g_{tz}}{c_k},\\
!latex     \mbox{\type{igzz(l,p,r,q,jk)\%s(i)}} & \equiv &
!latex \intdsl \left(s^{m_j}\varphi_{l,p}\right)' \left(s^{m_k}\varphi_{r,q}\right)' \braket{c_j}{\bar g_{zz}}{c_k},\\
!latex     \mbox{\type{igoo(l,p,r,q,jk)\%s(i)}} & \equiv &
!latex \intdsl \left(s^{m_j}\varphi_{l,p}\right)  \left(s^{m_k}\varphi_{r,q}\right)' \braket{c_j}{     1     }{c_k},\\
!latex \ee
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do ii = 1, Ni(lvol) ! loop over radial sub-grid;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!  if( Lgradient.ge.2 .and. dAd%L .and. dAd%innout.eq.0 .and. ii.gt. 1       ) cycle ! boundary perturbation only affects boundary;
!  if( Lgradient.ge.2 .and. dAd%L .and. dAd%innout.eq.1 .and. ii.lt.Ni(lvol) ) cycle ! boundary perturbation only affects boundary;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!latex \item Within each sub-grid region, the NAG routine \verb+D01CBF+ is called to determine the Gaussian integration weights, $w_i$, and abscissae, $x_i$.
!latex The integrals are approximated $\int_a^b f dx \approx \sum_i w_i f(x_i)$.
   
   itype = 0 ; aa = ss(lvol)%s(ii-1) ; bb = ss(lvol)%s(ii) ; cc = zero ; dd = zero
   
   id01bcf = 0
   call D01BCF( itype, aa, bb, cc, dd, Iquad, weight(1:Iquad), abscis(1:Iquad), id01bcf) ! sets gaussian weights & abscis;
   
   FATALMESS(ma00aa,id01bcf.ne.0,failed to construct Gaussian integration abscisae and weights)
   
   if( Wma00aa ) then ; cput= MPI_WTIME() ; write(ounit,'("ma00aa : "f10.2" : myid="i3" ; lvol="i3" ; ii="i3" ; abs="99f10.6)')cput-cpus,myid,lvol,ii,abscis(1:Iquad)
   endif
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   do jj = 1, Iquad ! loop over radial sub-sub-grid (numerical quadrature);
    
    lss = abscis(jj) ! radial sub-sub-grid = Gassian integration;
    
    WCALL(ma00aa,me00ab,( lvol, lss, ii )) 
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    do ip = 0, Nofe
     do iq = 0, Nofe
      
      do il = 0, 1 ! note that igaa, igab, igba and igbb do not depend on il, ir;
       do ir = 0, 1
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
        factor(1) = weight(jj) * lelr(il,ip,0,jj) * lelr(ir,iq,0,jj) ! note that neither    arguments are the differentiated basis function;
        factor(2) = weight(jj) * lelr(il,ip,0,jj) * lelr(ir,iq,1,jj) ! note that the second argument  is  the differentiated basis function;
        factor(3) = weight(jj) * lelr(il,ip,1,jj) * lelr(ir,iq,1,jj) ! note that both       arguments are the differentiated basis function;
        
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
        
        do ij = 1, mn
         do ik = 1, mn ; jk = ik + (ij-1) * mn
          
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
          
          if( jj.eq.1 ) then ! initialize summation quantities;
           
           if( dAd%L ) then
           dxigss(il,ip,ir,iq,jk)%s(ii) = zero
           dxigst(il,ip,ir,iq,jk)%s(ii) = zero
           dxigsz(il,ip,ir,iq,jk)%s(ii) = zero
           dxigtt(il,ip,ir,iq,jk)%s(ii) = zero
           dxigtz(il,ip,ir,iq,jk)%s(ii) = zero
           dxigzz(il,ip,ir,iq,jk)%s(ii) = zero
           dxigoo(il,ip,ir,iq,jk)%s(ii) = zero 
           else
             igss(il,ip,ir,iq,jk)%s(ii) = zero
             igst(il,ip,ir,iq,jk)%s(ii) = zero
             igsz(il,ip,ir,iq,jk)%s(ii) = zero
             igtt(il,ip,ir,iq,jk)%s(ii) = zero
             igtz(il,ip,ir,iq,jk)%s(ii) = zero
             igzz(il,ip,ir,iq,jk)%s(ii) = zero
             igoo(il,ip,ir,iq,jk)%s(ii) = zero
           endif
           
          endif ! end of if( jj.eq.1 );
          
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
 
          if( .not. Lcoordinatesingularity ) then ! ss**(mm/two) regularity factor is NOT required; either Cartesian or annular region;
!         if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ! ss**(mm/two) regularity factor is NOT required; either Cartesian or annular region;
           
           if( dAd%L ) then
           dxigss(il,ip,ir,iq,jk)%s(ii) = dxigss(il,ip,ir,iq,jk)%s(ii) + factor(1) * dxagss(jk)
           dxigst(il,ip,ir,iq,jk)%s(ii) = dxigst(il,ip,ir,iq,jk)%s(ii) + factor(2) * dxagst(jk)
           dxigsz(il,ip,ir,iq,jk)%s(ii) = dxigsz(il,ip,ir,iq,jk)%s(ii) + factor(2) * dxagsz(jk)
           dxigtt(il,ip,ir,iq,jk)%s(ii) = dxigtt(il,ip,ir,iq,jk)%s(ii) + factor(3) * dxagtt(jk)
           dxigtz(il,ip,ir,iq,jk)%s(ii) = dxigtz(il,ip,ir,iq,jk)%s(ii) + factor(3) * dxagtz(jk)
           dxigzz(il,ip,ir,iq,jk)%s(ii) = dxigzz(il,ip,ir,iq,jk)%s(ii) + factor(3) * dxagzz(jk)
           dxigoo(il,ip,ir,iq,jk)%s(ii) = dxigoo(il,ip,ir,iq,jk)%s(ii) + factor(2) * dxagoo(jk)
           else
             igss(il,ip,ir,iq,jk)%s(ii) =   igss(il,ip,ir,iq,jk)%s(ii) + factor(1) *   agss(jk)
             igst(il,ip,ir,iq,jk)%s(ii) =   igst(il,ip,ir,iq,jk)%s(ii) + factor(2) *   agst(jk)
             igsz(il,ip,ir,iq,jk)%s(ii) =   igsz(il,ip,ir,iq,jk)%s(ii) + factor(2) *   agsz(jk)
             igtt(il,ip,ir,iq,jk)%s(ii) =   igtt(il,ip,ir,iq,jk)%s(ii) + factor(3) *   agtt(jk)
             igtz(il,ip,ir,iq,jk)%s(ii) =   igtz(il,ip,ir,iq,jk)%s(ii) + factor(3) *   agtz(jk)
             igzz(il,ip,ir,iq,jk)%s(ii) =   igzz(il,ip,ir,iq,jk)%s(ii) + factor(3) *   agzz(jk)
             igoo(il,ip,ir,iq,jk)%s(ii) =   igoo(il,ip,ir,iq,jk)%s(ii) + factor(2) *   agoo(jk)
           endif ! end of if( dAd%L ) ;
           
          else ! need to accomodate the regularity conditions at the coordinate singularity;
           
           rmj = im(ij) * half ; smj(-1:0) = (/ lss**(rmj-1), lss**(rmj) /)
           rmk = im(ik) * half ; smk(-1:0) = (/ lss**(rmk-1), lss**(rmk) /)
           
           gactor(1) = weight(jj) * (       smj( 0) * lelr(il,ip,0,jj)                              ) * (       smk( 0) * lelr(ir,iq,0,jj)                              )
           gactor(2) = weight(jj) * (       smj( 0) * lelr(il,ip,0,jj)                              ) * ( rmk * smk(-1) * lelr(ir,iq,0,jj) + smk( 0) * lelr(ir,iq,1,jj) )
           gactor(3) = weight(jj) * (       smj( 0) * lelr(il,ip,0,jj)                              ) * ( rmk * smk(-1) * lelr(ir,iq,0,jj) + smk( 0) * lelr(ir,iq,1,jj) )
           gactor(4) = weight(jj) * ( rmj * smj(-1) * lelr(il,ip,0,jj) + smj( 0) * lelr(il,ip,1,jj) ) * ( rmk * smk(-1) * lelr(ir,iq,0,jj) + smk( 0) * lelr(ir,iq,1,jj) ) 
           gactor(5) = weight(jj) * ( rmj * smj(-1) * lelr(il,ip,0,jj) + smj( 0) * lelr(il,ip,1,jj) ) * ( rmk * smk(-1) * lelr(ir,iq,0,jj) + smk( 0) * lelr(ir,iq,1,jj) ) 
           gactor(6) = weight(jj) * ( rmj * smj(-1) * lelr(il,ip,0,jj) + smj( 0) * lelr(il,ip,1,jj) ) * ( rmk * smk(-1) * lelr(ir,iq,0,jj) + smk( 0) * lelr(ir,iq,1,jj) ) 
           gactor(7) = weight(jj) * (       smj( 0) * lelr(il,ip,0,jj)                              ) * ( rmk * smk(-1) * lelr(ir,iq,0,jj) + smk( 0) * lelr(ir,iq,1,jj) ) 
           
           if( dAd%L ) then
           dxigss(il,ip,ir,iq,jk)%s(ii) = dxigss(il,ip,ir,iq,jk)%s(ii) + gactor(1) * dxagss(jk)
           dxigst(il,ip,ir,iq,jk)%s(ii) = dxigst(il,ip,ir,iq,jk)%s(ii) + gactor(2) * dxagst(jk)
           dxigsz(il,ip,ir,iq,jk)%s(ii) = dxigsz(il,ip,ir,iq,jk)%s(ii) + gactor(3) * dxagsz(jk)
           dxigtt(il,ip,ir,iq,jk)%s(ii) = dxigtt(il,ip,ir,iq,jk)%s(ii) + gactor(4) * dxagtt(jk)
           dxigtz(il,ip,ir,iq,jk)%s(ii) = dxigtz(il,ip,ir,iq,jk)%s(ii) + gactor(5) * dxagtz(jk)
           dxigzz(il,ip,ir,iq,jk)%s(ii) = dxigzz(il,ip,ir,iq,jk)%s(ii) + gactor(6) * dxagzz(jk)
           dxigoo(il,ip,ir,iq,jk)%s(ii) = dxigoo(il,ip,ir,iq,jk)%s(ii) + gactor(7) * dxagoo(jk)
           else
             igss(il,ip,ir,iq,jk)%s(ii) =   igss(il,ip,ir,iq,jk)%s(ii) + gactor(1) *   agss(jk)
             igst(il,ip,ir,iq,jk)%s(ii) =   igst(il,ip,ir,iq,jk)%s(ii) + gactor(2) *   agst(jk)
             igsz(il,ip,ir,iq,jk)%s(ii) =   igsz(il,ip,ir,iq,jk)%s(ii) + gactor(3) *   agsz(jk)
             igtt(il,ip,ir,iq,jk)%s(ii) =   igtt(il,ip,ir,iq,jk)%s(ii) + gactor(4) *   agtt(jk)
             igtz(il,ip,ir,iq,jk)%s(ii) =   igtz(il,ip,ir,iq,jk)%s(ii) + gactor(5) *   agtz(jk)
             igzz(il,ip,ir,iq,jk)%s(ii) =   igzz(il,ip,ir,iq,jk)%s(ii) + gactor(6) *   agzz(jk)
             igoo(il,ip,ir,iq,jk)%s(ii) =   igoo(il,ip,ir,iq,jk)%s(ii) + gactor(7) *   agoo(jk)
           endif ! end of if( dAd%L ) ;
           
          endif ! end of if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) ;
          
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
          
         enddo ! end of do ik;
        enddo ! end of do ij;
        
       enddo ! end of do iq;
      enddo ! end of do ir;
     enddo ! end of do ip;
    enddo ! end of do il;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
   enddo ! end of do jj; loop over radial sub-sub-grid; this is the Gaussian quadrature summation loop;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  enddo ! end of do ii; loop over radial sub-grid;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(ma00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine ma00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
