!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Allocates, and deallocates, geometric information.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ma00ab( AD, lvol )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero

  use numerical, only :

  use fileunits, only : ounit

  use inputlist, only : Wma00ab, Nofe, Ni, Lgeometry

  use cputiming, only : Tma00ab

  use allglobal, only : myid, cpus, mn, dAd, &
                          igss,   igst,   igsz,   igtt,   igtz,   igzz,   igoo, &
                        dxigss, dxigst, dxigsz, dxigtt, dxigtz, dxigzz, dxigoo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  CHARACTER, intent(in) :: AD
  INTEGER  , intent(in) :: lvol

  INTEGER               :: il, ip, ir, iq, ij, ik, jk, imn

  BEGIN(ma00ab)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do il = 0, 1 ! left, right basis function;
   do ip = 0, Nofe ! basis function; derivative;
    
    do ir = 0, 1 ! left, right basis function;
     do iq = 0, Nofe ! basis function; derivative;
      
      jk = 0 ! shorthand;
      
      do ij = 1, mn
       do ik = 1, mn ; jk = jk + 1
        
!latex \item The metric volume integrals are stored in \verb$igss(0:1,0:Nofe,0:1,0:Nofe,0:mn*mn)%s(0:Ni(lvol))$, etc.
        
        select case( AD )
         
        case( 'A' )
         
          RALLOCATE(  igss(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(  igst(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(  igsz(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(  igtt(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(  igtz(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(  igzz(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(  igoo(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
         
         if( dAd%L ) then
          RALLOCATE(dxigss(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(dxigst(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(dxigsz(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(dxigtt(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(dxigtz(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(dxigzz(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
          RALLOCATE(dxigoo(il,ip,ir,iq,jk)%s,(1:Ni(lvol)))
         endif ! end of if( Lanalytic ) ;
         
        case( 'D' )
         
          DEALLOCATE(  igss(il,ip,ir,iq,jk)%s) ! note that these are not required if dAd%L;
          DEALLOCATE(  igst(il,ip,ir,iq,jk)%s)
          DEALLOCATE(  igsz(il,ip,ir,iq,jk)%s)
          DEALLOCATE(  igtt(il,ip,ir,iq,jk)%s)
          DEALLOCATE(  igtz(il,ip,ir,iq,jk)%s)
          DEALLOCATE(  igzz(il,ip,ir,iq,jk)%s)
          DEALLOCATE(  igoo(il,ip,ir,iq,jk)%s) 
         
         if( dAd%L ) then
          DEALLOCATE(dxigss(il,ip,ir,iq,jk)%s)
          DEALLOCATE(dxigst(il,ip,ir,iq,jk)%s)
          DEALLOCATE(dxigsz(il,ip,ir,iq,jk)%s)
          DEALLOCATE(dxigtt(il,ip,ir,iq,jk)%s)
          DEALLOCATE(dxigtz(il,ip,ir,iq,jk)%s)
          DEALLOCATE(dxigzz(il,ip,ir,iq,jk)%s)
          DEALLOCATE(dxigoo(il,ip,ir,iq,jk)%s)
         endif ! end of if( dAd%L ) ;
         
        case default
         
         FATALMESS(ma00ab,.true.,invalid allocate or deallocate flag)
         
        end select
        
       enddo ! end of do ik;
      enddo ! end of do ij;
      
!     FATALMESS(ma00ab,jk.ne.mn*mn,need to check loops)
      
     enddo ! end of do iq;
    enddo ! end of do ir;
    
   enddo ! end of do ip;
  enddo ! end of do il;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(ma00ab)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine ma00ab

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


