!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs matrix, and the perturbed matrix, that represents the Beltrami linear system.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{gauge and coordinates: preliminary} \begin{enumerate}

!latex \item The helicity integrals, $\int_{{\cal V}_l} {\bf A}\cdot{\bf B}\, dv$, depends explicity on the vector potential.
!latex       The gauge must be constrained and appropriate boundary conditions enforced.

!latex \item The coordinates, $(\s,\t,\z)$, are adapted to the interfaces, so that the $l$-th interface coincides with the coordinate surface $s=s_l$,
!latex       and $\t$,$\z$ are poloidal and toroidal angles.
!latex       Here, the angles remaing arbitrary.

!latex \item In each volume, $l=1,$\verb+Nvol+, bounded by the $l-1$ and $l$-th interfaces,
!latex       a regular, radial-sub-grid, $s_{l,i} \equiv$ \verb+ss(l)%s(i)+, for $i=0,$ \verb+Ni(l)+, is established,
!latex       so that \verb+ss(l)%s(0)+$=s_{l-1}$ and \verb+ss(l)%s(Ni(l))+$=s_{l}$.

!latex \end{enumerate} \subsubsection{gauge} \begin{enumerate}

!latex \item In the \mbox{$l$}-th annulus, bounded by the \mbox{$(l-1)$}-th and \mbox{$l$}-th interfaces,
!latex       a general covariant representation of the magnetic vector-potential is written
!latex       \be {\bf \bar A}=\bar A_{s} \nabla s + \bar A_{\t} \nabla \t + \bar A_{\z} \nabla \z. \ee
!latex \item To this add \mbox{$\nabla g(s,\t,\z)$}, where $g$ satisfies
!latex       \be \partial_\s g(\s      ,\t,\z) & = & - \bar A_{\s}(\s      ,\t,\z)              , \\
!latex           \partial_\t g(\s_{l-1},\t,\z) & = & - \bar A_{\t}(\s_{l-1},\t,\z)+\psi_{t,l-1} , \\
!latex           \partial_\z g(\s_{l-1}, 0,\z) & = & - \bar A_{\z}(\s_{l-1}, 0,\z)+\psi_{p,l-1} , \ee
!latex       for arbitrary constants \mbox{$\psi_{t,l-1}$}, \mbox{$\psi_{p,l-1}$}, which can be identified as the toroidal and poloidal fluxes by using
!latex       \be \int_S {\bf B}\cdot{\bf ds}=\int_{\partial S}{\bf A}\cdot {\bf dl}.\ee
!latex \item Then \mbox{${\bf A}={\bf \bar A}+\nabla g$} is given by \mbox{${\bf A}=A_{\s}\nabla\s+A_{\t}\nabla\t+A_{\z}\nabla\z$} with
!latex       \be \begin{array}{ccc}
!latex        A_{\s}(\s      ,\t,\z) &=& 0,           \\
!latex        A_{\t}(\s_{l-1},\t,\z) &=& \psi_{t,l-1},\\
!latex        A_{\z}(\s_{l-1}, 0,\z) &=& \psi_{p,l-1}. \end{array} \label{eq:gauge} \ee
!latex \item This specifies the gauge: to see this, notice that no gauge term can be added without violating the conditions in \Eqn{gauge}.
!latex \item Note that the gauge employed in each volume is distinct.

!latex \end{enumerate} \subsubsection{Fourier representation} \begin{enumerate}

!latex \item For stellarator symmetric equilibria, \mbox{$A_{\t}$} and \mbox{$A_{\z}$} may be represented by cosine series
!latex       \be A_{\t}(s,\t,\z) &=& \sum_{j}A_{\t,j}(s)\cos(m_j\t-n_j\z),\\
!latex           A_{\z}(s,\t,\z) &=& \sum_{j}A_{\z,j}(s)\cos(m_j\t-n_j\z),\ee
!latex       where \mbox{$A_{\t,j}(s)$} and \mbox{$A_{\z,j}(s)$} are represented using finite-elements, as described below.

!latex \item The magnetic field is
!latex       \be \sqrt g {\bf B} = (\partial_\t A_\z - \partial_\z A_\t){\bf e}_\s - \partial_\s A_\z {\bf e}_\t + \partial_\s A_\t {\bf e}_\z.
!latex       \ee
!latex       \be  B^2 = B^\s B^\s g_{\s\s} + 2 B^\s B^\t g_{\s\t} + 2 B^\s B^\z g_{\s\z} + B^\t B^\t g_{\t\t} + 2 B^\t B^\z g_{\t\z} + B^\z B^\z g_{\z\z}
!latex       \ee
!latex       \be \sqrt g {\bf A} \cdot {\bf B} = -A_\t \partial_s A_\z + A_\z \partial_s A_\t.
!latex       \ee

!latex \end{enumerate} \subsubsection{interface boundary conditions: annular volumes} \begin{enumerate}

!latex \item In the annular volumes, the condition that the field is tangential to the inner interface is
!latex       \be \sqrt g B^s \equiv \partial_\t A_\z - \partial_\z A_\t = 0.\label{eq:innersurfaceconstraint} \ee
!latex       With the above gauge condition on $A_\t$ given in \Eqn{gauge}, this entails that $\partial_\t A_\z=0$, which with \Eqn{gauge} entails that
!latex       $A_\z(s_{l-1},\t,\z)=const$.
!latex \item Alternatively, in terms of the Fourier harmonics we may write
!latex       \be -m_jA_{\z,j}(s_{l-1})-n_jA_{\t,j}(s_{l-1})=0. \ee
!latex \item Combing the gauge constraints and the flux surface condition we have
!latex       \be A_{\t,j}(s_{l-1}) = \left\{ \begin{array}{c@{\;\;,\;\;}c}\psi_{t,l-1} & j=1, \\ 0 & j>1, \end{array} \right. \;\;\; \mbox{\rm and} \;\;\;\;
!latex           A_{\z,j}(s_{l-1}) = \left\{ \begin{array}{c@{\;\;,\;\;}c}\psi_{p,l-1} & j=1, \\ 0 & j>1, \end{array} \right. \label{eq:innergauge}\ee

!latex \item In the annular volumes, the condition that the field is tangential to the outer interface is idential to \Eqn{innersurfaceconstraint};
!latex       however, the representations for $A_\t$ and $A_\z$ cannot be simplified to the same extent
!latex       (all of the gauge freedom was exploited to simplify $A_\t$ and $A_\z$ at the inner interface).
!latex       At the outer interface we must constrain the vector potential to be of the form
!latex       \be A_{\t}(s_l,\t,\z) &=& \partial_\t f(\t,\z), \\
!latex           A_{\z}(s_l,\t,\z) &=& \partial_\z f(\t,\z), \label{eq:outersurfaceconstraint} \ee
!latex       for arbitrary \mbox{$f$} of the form
!latex       \be \label{eq:surfacepotential} f = \psi_{t,l} \, \t + \psi_{p,l} \, \z + \sum_j f_{j}\sin(m_j \t - n_j \z).
!latex       \ee
!latex \item In terms of the Fourier representation, we have
!latex       \be A_{\t,j}(s_{l}) = \left\{ \begin{array}{c@{\;\;,\;\;}c}\psi_{t,l} & j=1, \\  m_j  f_{l,j} & j>1, \end{array} \right. \;\;\;\; \mbox{\rm and} \;\;\;\;
!latex           A_{\z,j}(s_{l}) = \left\{ \begin{array}{c@{\;\;,\;\;}c}\psi_{p,l} & j=1, \\ -n_j  f_{l,j} & j>1, \end{array} \right. \label{eq:outerboundary} \ee

!latex \end{enumerate} \subsubsection{finite element radial basis functions} \begin{enumerate}
!latex \item To describe the radial dependence of the Fourier harmonics of the vector potential, namely the $A_{\t,j}$, $A_{\z,j}$, we use a finite-element description.
!latex \item In the region $ s \in [ s_{l,i-1} , s_{l,i} ] $, the vector potential is ${\bf A}=A_\t \nabla \t + A_\z \nabla \z$ where
!latex       \be A_{\t,j}&=& \sum_{r=0}^{1} \sum_{p=0}^{No} \, A_{\t,j,i-1+r,p} \,\, \varphi_{r,p}(s) , \label{eq:finiteelementAtannular} \\
!latex           A_{\z,j}&=& \sum_{r=0}^{1} \sum_{p=0}^{No} \, A_{\z,j,i-1+r,p} \,\, \varphi_{r,p}(s) , \label{eq:finiteelementAzannular} \ee
!latex       where $r$ and $p$ identify the radial basis functions, $\varphi_{r,p}(s)$, and $No\equiv$\verb+Nofe+ controls the order of the basis functions;
!latex
!latex       \verb+Nofe=1+ for cubic,
!latex
!latex       \verb+Nofe=2+ for quintic,
!latex
!latex       \verb+Nofe=3+ for septemtic.
!latex \item By suitably defining the radial basis functions, we have
!latex       \be A_{\t,j,i,p} & \equiv & \frac{d^p}{d s^p}A_{\t,j}(s_i),\\
!latex           A_{\z,j,i,p} & \equiv & \frac{d^p}{d s^p}A_{\z,j}(s_i).
!latex       \ee
!latex \item This completes the mixed Fourier, finite-element description of the vector potential.
!latex       This representation is inserted into the energy functional, \Eqn{energyfunctional} below,
!latex       and the Beltrami linear system is constructed by taking derivatives of the energy functional with respect to the $A_{\t,j,i,p}$ and $A_{\z,j,i,p}$.

!latex \end{enumerate} \subsubsection{metric information} \begin{enumerate}

!latex \item The geometric information required to evaluate the volume integrals in the following is given by 
!latex       \be \bar g_{\s\s} \equiv g_{\s\s} / \sqrt g = \sum_i \bar g_{\s\s,i}(s)\cos(m_i\t-n_i\z), \\
!latex           \bar g_{\s\t} \equiv g_{\s\t} / \sqrt g = \sum_i \bar g_{\s\t,i}(s)\sin(m_i\t-n_i\z), \\
!latex           \bar g_{\s\z} \equiv g_{\s\z} / \sqrt g = \sum_i \bar g_{\s\z,i}(s)\sin(m_i\t-n_i\z), \\
!latex           \bar g_{\t\t} \equiv g_{\t\t} / \sqrt g = \sum_i \bar g_{\t\t,i}(s)\cos(m_i\t-n_i\z), \\
!latex           \bar g_{\t\z} \equiv g_{\t\z} / \sqrt g = \sum_i \bar g_{\t\z,i}(s)\cos(m_i\t-n_i\z), \\
!latex           \bar g_{\z\z} \equiv g_{\z\z} / \sqrt g = \sum_i \bar g_{\z\z,i}(s)\cos(m_i\t-n_i\z). \ee

!latex \item For any function \mbox{$f(\s,\t,\z)$}, in particular the metrics, we introduce the ``shorthand'' notation
!latex       \be \braket{s_j}{f}{s_k} \! & \! = \! & \ooint \sin(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \sin(m_k\t-n_k\z) \nonumber \\
!latex           \braket{s_j}{f}{c_k} \! & \! = \! & \ooint \sin(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \cos(m_k\t-n_k\z) \nonumber \\
!latex           \braket{c_j}{f}{c_k} \! & \! = \! & \ooint \cos(m_j\t-n_j\z)  \, f(\s,\t,\z) \, \cos(m_k\t-n_k\z) \nonumber \ee
!latex       Note that the second of these is {\bf \em not} symmetric with respect to $j$ and $k$.

!latex \end{enumerate} \subsubsection{energy integral} \begin{enumerate}

!latex \item Consider the integral
!latex       \be F = \sum_{i=1}^{N_i} F_i = \sum_{i=1}^{N_i} \int_{{\cal V}_i} \left( \frac{B^2}{2} - \frac{\mu}{2} {\bf A}\cdot{\bf B} \right),\label{eq:energyfunctional}
!latex       \ee
!latex       where ${\cal V}_i$ identifies each radial sub-grid volume, i.e. the volume between $s_{l,i-1}$ and $s_{l,i}$.
!latex       \be \begin{array}{ccccrrrr}
!latex       F_i & = \\
!latex           &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\t A_{\z} & \bar g_{\s\s} \\
!latex           &   & - & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!latex           &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\z A_{\t} & \bar g_{\s\s} \\
!latex           &   & - & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!latex           &   & + & \ds               & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\s A_{\z} & \bar g_{\s\t} \\
!latex           &   & + & \ds               & \ds \intdsl \ooint & \partial_\t A_{\z} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!latex           &   & - & \ds               & \ds \intdsl \ooint & \partial_\z A_{\t} & \partial_\s A_{\t} & \bar g_{\s\z} \\
!latex           &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\s A_{\z} & \partial_\s A_{\z} & \bar g_{\t\t} \\
!latex           &   & - & \ds               & \ds \intdsl \ooint & \partial_\s A_{\z} & \partial_\s A_{\t} & \bar g_{\t\z} \\
!latex           &   & + & \ds \frac{ 1 }{2} & \ds \intdsl \ooint & \partial_\s A_{\t} & \partial_\s A_{\t} & \bar g_{\z\z} \\
!latex           &   & + & \ds \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\t} & \partial_\s A_{\z} &               \\
!latex           &   & - & \ds \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\z} & \partial_\s A_{\t} & .
!latex       \end{array} \ee

!latex \end{enumerate} \subsubsection{derivatives of volume integral: annular regions} \begin{enumerate}

!latex \item The first derivatives are as follows:
!latex       \be \begin{array}{cccccrccccccccccc}
!latex       \ds \frac{\partial}{\partial A_{\t,j,i-1+l,p}} F_i & = \\
!latex           &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex           &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex           &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\t} \\
!latex           &   & + &               & \ds \intdsl \ooint & \partial_\t A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\z} \\
!latex           &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} & n_j & \varphi_{l,p}   & s_j & \bar g_{\s\z} \\
!latex           &   & - &               & \ds \intdsl \ooint & \partial_\z A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\z} \\
!latex           &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\z} \\
!latex           &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\z\z} \\
!latex           &   & + & \frac{\mu}{2} & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}   & c_j &               \\
!latex           &   & - & \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\z} &     & \varphi_{l,p}'  & c_j & 
!latex       \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,j,i-1+l,p}} F_i & = \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\s} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\t} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\t A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\t} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\z A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\s\t} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} & m_j & \varphi_{l,p}   & s_j & \bar g_{\s\z} \\
!latex     &   & + &               & \ds \intdsl \ooint & \partial_\s A_{\z} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\t} \\
!latex     &   & - &               & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}'  & c_j & \bar g_{\t\z} \\
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl \ooint &             A_{\t} &     & \varphi_{l,p}'  & c_j &               \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl \ooint & \partial_\s A_{\t} &     & \varphi_{l,p}   & c_j & 
!latex \end{array} \ee

!latex \item The second derivatives are required for construction of the Beltrami matrix, which are given

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} F_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & n_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & n_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl & n_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\z\z}}{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} F_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & n_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & n_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}  & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} F_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & m_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl & n_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & m_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}  & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} F_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & m_j & \varphi_{r,q}  & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & m_j & \varphi_{r,q}' & \varphi_{l,p}  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & \varphi_{r,q}  & \varphi_{l,p}' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & \varphi_{r,q}' & \varphi_{l,p}' & \braket{c_j}{\bar g_{\t\t}}{c_k}
!latex \end{array} \ee

!latex \end{enumerate} \subsubsection{matrix elements: annular regions} \begin{enumerate}

!latex \item The required matrix elements take the form, where $\a=\t,\z$ and $\b=\t,\z$,
!latex       \be \begin{array}{ccccccccccccccccccccccccccccc}
!latex       \ds \frac{\partial }{\partial A_{\b,k,i-1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & F       &=&
!latex       \ds \frac{\partial }{\partial A_{\b,k,i-1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & F_{i  } \\
!latex       \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & F       &=&
!latex       \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & F_{i  } &+&
!latex       \ds \frac{\partial }{\partial A_{\b,k,i  ,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & F_{i+1} \\
!latex       \ds \frac{\partial }{\partial A_{\b,k,i+1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & F       &=&
!latex                                                     &                                             &         & &
!latex       \ds \frac{\partial }{\partial A_{\b,k,i+1,q}} & \ds \frac{\partial }{\partial A_{\a,j,i,p}} & F_{i+1} \\
!latex       \end{array} \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{innermost volume: the simple torus} \begin{enumerate}

!latex \item There are several important differences between the innermost ``simple'' torus and the annular regions.
!latex       The gauge freedom and the condition that the field be tangential to the inner interface
!latex       are replaced by the condtion that the vector potential is analytic at the coordinate origin and,
!latex       while gauge freedom can still be used to simplify the representation for the vector potential,
!latex       the radial dependence of the vector potential near the coordinate origin takes a more complicated form.
!latex \item In the innermost volume, assuming $s\sim r^2$, we may write
!latex \be A_{\t}(s,\t,\z) = \sum_{j}\sum_{r=0}^{1}\sum_{p=0}^{No} s^{m_j/2} \, A_{\t,j,i-1+l,p} \,\, \varphi_{r,p}(s) \, \cos(m_j\t-n_j\z) , \label{eq:finiteelementAttorus} \\
!latex     A_{\z}(s,\t,\z) = \sum_{j}\sum_{r=0}^{1}\sum_{p=0}^{No} s^{m_j/2} \, A_{\z,j,i-1+l,p} \,\, \varphi_{r,p}(s) \, \cos(m_j\t-n_j\z) , \label{eq:finiteelementAztorus} \ee
!latex with the coordinate origin boundary condition
!latex \be A_{\t,j,0,0} & = & 0 \;\;\; \mbox{\rm for all $j$,} \\
!latex     A_{\z,j,0,0} & = & 0 \;\;\; \mbox{\rm for $m_j=0$.} \ee

!latex \item The outer interface boundary condition, $\sqrt g B^s \equiv \partial_\t A_{\z}-\partial_\z A_\t=0$,
!latex is again satisfied by writing $A_{\t}(s_l,\t,\z) \equiv \partial_\t f(\t,\z)$ and $A_{\z}(s_l,\t,\z) \equiv \partial_\z f(\t,\z)$,
!latex but it is now convenient to write \mbox{$f(\t,\z)$} in the form
!latex \be f = \psi_{t,1} \t + \psi_{p,1} \z + \sum_j s_1^{m_j/2} f_{j}\sin(m_j \t - n_j \z), \ee
!latex so we have the following
!latex \be A_{\t,j,N,0} &=& +m_j f_j, \\
!latex     A_{\z,j,N,0} &=& -n_j f_j.\ee

!latex \item The second derivatives required are then

!latex \be \begin{array}{cccccrccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} F_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & n_j & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & n_j & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl & n_k &     & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{\bar g_{\z\z}}{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\t,j,i-1+l,p}} F_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & n_j & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & n_j & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{\bar g_{\s\z}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})  & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\t,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} F_i & = \\
!latex     &   & + &               & \ds \intdsl & n_k & m_j & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl & n_k &     & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & - &               & \ds \intdsl &     & m_j & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\z}}{c_k} \\
!latex     &   & - &               & \ds \intdsl &     &     & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{\bar g_{\t\z}}{c_k} \\ 
!latex     &   & + & \frac{\mu}{2} & \ds \intdsl &     &     & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{     1       }{c_k} \\
!latex     &   & - & \frac{\mu}{2} & \ds \intdsl &     &     & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})  & \braket{c_j}{     1       }{c_k} 
!latex \end{array} \ee

!latex \be \begin{array}{cccccrccccccccccccccccccccccccccccccccccccccc}
!latex \ds \frac{\partial}{\partial A_{\z,k,i-1+r,q}} \frac{\partial}{\partial A_{\z,j,i-1+l,p}} F_i & = \\
!latex     &   & + &               & \ds \intdsl & m_k & m_j & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\s}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     & m_j & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})  & \braket{s_j}{\bar g_{\s\t}}{c_k} \\
!latex     &   & + &               & \ds \intdsl & m_k &     & (s^{m_k} \varphi_{r,q})  & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{\bar g_{\s\t}}{s_k} \\
!latex     &   & + &               & \ds \intdsl &     &     & (s^{m_k} \varphi_{r,q})' & (s^{m_j} \varphi_{l,p})' & \braket{c_j}{\bar g_{\t\t}}{c_k}
!latex \end{array} \ee

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{matrix perturbation theory} \begin{enumerate}

!latex \item The Beltrami fields are given as the solution, ${\bf X}$, to a matrix equation:
!latex       e.g. ${\bf A}\cdot{\bf X}={\bf B}$, for a given matrix, ${\bf A}$, and a given ``right-hand-side'' vector, ${\bf B}$.
!latex       For the construction of the Beltrami fields, ${\bf A}$ and ${\bf B}$ are determined completely by the geometry of the adjacent interfaces;
!latex       the enclosed toroidal, $\delta \psi_t \equiv \psi_{t,l}-\psi_{t,l-1}$, and poloidal, $\delta \psi_p \equiv \psi_{p,l}-\psi_{p,l-1}$, fluxes;
!latex       and the helicity multiplier, $\mu$.
!latex \item A small change in any of these will induce a small change, ${\bf a}$, in ${\bf A}$ and a small change, ${\bf b}$, in ${\bf B}$.
!latex       The new solution satisfies $\left({\bf A}+{\bf a}\right)\cdot\left({\bf X}+{\bf x}\right)=\left({\bf B}+{\bf b}\right)$, so that to lowest order
!latex       \be {\bf A}\cdot {\bf x} = {\bf b} - {\bf a}\cdot {\bf X}.
!latex       \ee
!latex \item Ultimately, it is intended that this method will be used to determine how the Beltrami fields in each volume change
!latex       with changes in geometry, and $\delta \psi_t$, $\delta \psi_p$ and $\mu$.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ma01ag(  lvol, mn, Nofe, lmu, dpf )
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  use constants, only : zero, half, one

  use numerical, only : 

  use fileunits, only : ounit

  use inputlist, only : Wma01ag, Nvol, Ni

  use cputiming, only : Tma01ag

  use allglobal, only : myid, cpus,                                             &
                        im, in, doAt, doAz,                                     & ! Fourier resolution, field variables = degrees of freedom;
                        dtflux,                                                 & ! inhomogeneous boundary conditions = enclosed fluxes; 
                        iBns, iBnc,                                             & ! inhomogeneous boundary conditions = non-zero normal field at outer boundary;
!                       imask,                                                  &
                        NBdof, iMB, MB, MR, duMB, duMR, dxMB, dxMR, ijk,        & ! Beltrami matrix and `right-hand-side' vector;
                        dAd,                                                    &
                          igss,   igst,   igsz,   igtt,   igtz,   igzz,   igoo, & ! metric integrals;
                        dxigss, dxigst, dxigsz, dxigtt, dxigtz, dxigzz, dxigoo, & ! metric integrals; differentiated;
                        Louterboundarynormal
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER, intent(in)  :: lvol, mn, Nofe ! this is really global, but included in argument list to simplify allocation of dtkqdtjp, etc.

  REAL,    intent(in)  :: lmu, dpf ! helicity multipler and enclosed poloidal flux;

  INTEGER              :: ij, ik, ip, iq, il, ir, ii, ix, jx ! loop control; matrix element identification;

  INTEGER              :: NN, jk, kj, mj, mk, nj, nk, njnk, njmk, mjnk, mjmk ! shorthand;

  INTEGER              :: ltj, lzj, ltk, lzk ! integer mode harmonic factors used to accomodate that the doAt & doAz at outer boundary are not independent d.o.f.

  REAL                 :: hmul, dtf ! shorthand; error checking;

  REAL                 :: dtkqdtjpFi(0:1,0:Nofe,0:1,0:Nofe), dzkqdtjpFi(0:1,0:Nofe,0:1,0:Nofe), dtkqdzjpFi(0:1,0:Nofe,0:1,0:Nofe), dzkqdzjpFi(0:1,0:Nofe,0:1,0:Nofe)
  REAL                 ::                                    lzkqdtjpFi(0:1,0:Nofe,0:1,0:Nofe), ltkqdzjpFi(0:1,0:Nofe,0:1,0:Nofe)
  REAL                 :: dtkqdtjpDi(0:1,0:Nofe,0:1,0:Nofe), dzkqdtjpDi(0:1,0:Nofe,0:1,0:Nofe), dtkqdzjpDi(0:1,0:Nofe,0:1,0:Nofe), dzkqdzjpDi(0:1,0:Nofe,0:1,0:Nofe)

  REAL                 :: ck, dk, cj, dj

  BEGIN(ma01ag)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  NN = NBdof(lvol)

  if( dAd%L ) then              ! compute derivatives of Beltrami matrix & r.h.s. wrt interface Fourier harmonic;
  dxMB(    0:NN,0:NN) = zero
  dxMR(         0:NN) = zero
  else                          ! compute                Beltrami matrix & r.h.s.                               ;
   iMB(    0:NN,0:NN) = .false. ! this is a counter used elsewehere to construct sparse representation of matrix; this is rather crude;
    MB(    0:NN,0:NN) = zero
    MR(         0:NN) = zero
  duMB(1:2,0:NN,0:NN) = zero    ! compute derivatives of Beltrami matrix & r.h.s. wrt helicity multiplier & poloidal flux; really only needed if Ldmupf.eq.2;
  duMR(1:2,     0:NN) = zero
  endif

  dtf = dtflux(lvol) ; hmul = half * lmu ! shorthand;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do ij = 1, mn ! loop over Fourier modes; first derivative;
   
  !if( imask(ij).le.0 ) cycle
   
   do ik = 1, mn ! loop over Fourier modes; second derivative;
    
   !if( imask(ik).le.0 ) cycle

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    jk = ijk(ij,ik) ; kj = ijk(ik,ij) ! shorthand;
    
    mj = im(ij) ; mk = im(ik) ; nj = in(ij) ; nk = in(ik) ; njnk = nj*nk ; njmk = nj*mk ; mjnk = mj*nk ; mjmk = mj*mk ! shorthand;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
    do ii = 1, Ni(lvol) ! loop over radial sub-grid;
     
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
     
     do ip = 0, Nofe ! loop over finite-element basis functions; first derivative;
      do iq = 0, Nofe ! loop over finite-element basis functions; second derivative;
       
       do il = 0, 1 ! loop over left and right derivatives; first derivative;
        do ir = 0, 1 ! loop over left and right derivatives; second derivative;
         
         if( dAd%L ) then ! derivative wrt geometrical Fourier harmonic is required;
         dtkqdtjpDi(il,ip,ir,iq) = njnk * dxigss(il,ip,ir,iq,jk)%s(ii) & ! note that the dxig** and the ig** contain the mode multiplication factors arising
                                 - nj   * dxigsz(il,ip,ir,iq,jk)%s(ii) & ! from the poloidal, d_\t, and toroidal ,d_\z, differentiation;
                                 -   nk * dxigsz(ir,iq,il,ip,kj)%s(ii) &
                                 +        dxigzz(il,ip,ir,iq,jk)%s(ii)
          
         dzkqdtjpDi(il,ip,ir,iq) = njmk * dxigss(il,ip,ir,iq,jk)%s(ii) &
                                 + nj   * dxigst(il,ip,ir,iq,jk)%s(ii) &
                                 -   mk * dxigsz(ir,iq,il,ip,kj)%s(ii) &
                                 -        dxigtz(il,ip,ir,iq,jk)%s(ii) &
                                 + hmul * dxigoo(il,ip,ir,iq,jk)%s(ii) &
                                 - hmul * dxigoo(ir,iq,il,ip,kj)%s(ii)
           
         dtkqdzjpDi(il,ip,ir,iq) = mjnk * dxigss(il,ip,ir,iq,jk)%s(ii) &
                                 +   nk * dxigst(ir,iq,il,ip,kj)%s(ii) &
                                 - mj   * dxigsz(il,ip,ir,iq,jk)%s(ii) &
                                 -        dxigtz(il,ip,ir,iq,jk)%s(ii) &
                                 + hmul * dxigoo(ir,iq,il,ip,kj)%s(ii) &
                                 - hmul * dxigoo(il,ip,ir,iq,jk)%s(ii)
         
         dzkqdzjpDi(il,ip,ir,iq) = mjmk * dxigss(il,ip,ir,iq,jk)%s(ii) &
                                 + mj   * dxigst(il,ip,ir,iq,jk)%s(ii) &
                                 +   mk * dxigst(ir,iq,il,ip,kj)%s(ii) &
                                 +        dxigtt(il,ip,ir,iq,jk)%s(ii)
         else ! matches if( dAd%L ) ;
         dtkqdtjpFi(il,ip,ir,iq) = njnk *   igss(il,ip,ir,iq,jk)%s(ii) & ! note that the dxig** and the ig** contain the mode multiplication factors arising
                                 - nj   *   igsz(il,ip,ir,iq,jk)%s(ii) & ! from the poloidal, d_\t, and toroidal ,d_\z, differentiation;
                                 -   nk *   igsz(ir,iq,il,ip,kj)%s(ii) &
                                 +          igzz(il,ip,ir,iq,jk)%s(ii)
         
         dzkqdtjpFi(il,ip,ir,iq) = njmk *   igss(il,ip,ir,iq,jk)%s(ii) &
                                 + nj   *   igst(il,ip,ir,iq,jk)%s(ii) &
                                 -   mk *   igsz(ir,iq,il,ip,kj)%s(ii) &
                                 -          igtz(il,ip,ir,iq,jk)%s(ii) &
                                 + hmul *   igoo(il,ip,ir,iq,jk)%s(ii) &
                                 - hmul *   igoo(ir,iq,il,ip,kj)%s(ii)
         
         dtkqdzjpFi(il,ip,ir,iq) = mjnk *   igss(il,ip,ir,iq,jk)%s(ii) &
                                 +   nk *   igst(ir,iq,il,ip,kj)%s(ii) &
                                 - mj   *   igsz(il,ip,ir,iq,jk)%s(ii) &
                                 -          igtz(il,ip,ir,iq,jk)%s(ii) &
                                 + hmul *   igoo(ir,iq,il,ip,kj)%s(ii) &
                                 - hmul *   igoo(il,ip,ir,iq,jk)%s(ii)
         
         dzkqdzjpFi(il,ip,ir,iq) = mjmk *   igss(il,ip,ir,iq,jk)%s(ii) &
                                 + mj   *   igst(il,ip,ir,iq,jk)%s(ii) &
                                 +   mk *   igst(ir,iq,il,ip,kj)%s(ii) &
                                 +          igtt(il,ip,ir,iq,jk)%s(ii)
        !if( Ldmupf.eq.2 ) then
         lzkqdtjpFi(il,ip,ir,iq) = half *   igoo(il,ip,ir,iq,jk)%s(ii) &
                                 - half *   igoo(ir,iq,il,ip,kj)%s(ii)
         ltkqdzjpFi(il,ip,ir,iq) = half *   igoo(ir,iq,il,ip,kj)%s(ii) &
                                 - half *   igoo(il,ip,ir,iq,jk)%s(ii)
        !endif ! end of if( Ldmupf.eq.2 ) ;
         endif ! end of if( dAd%L ) ;
         
        enddo ! end of do ir;
       enddo ! end of do il;
       
      enddo ! end of do iq; 
     enddo ! end of do ip; still inside do ii = 1, Ni(lvol) loop; still inside do ik = 1, mn loop; still inside do ij = 1, mn loop;
     
     
     do ip = 0, Nofe ! still inside do ii = 1, Ni(lvol) loop; still inside do ik = 1, mn loop; still inside do ij = 1, mn loop;
      do iq = 0, Nofe ! still inside do ii = 1, Ni(lvol) loop; still inside do ik = 1, mn loop; still inside do ij = 1, mn loop;
       
      !if( imask(ij).le.0 .or. imask(ik).le.0 ) then ! this must come after the ii, ip, iq loops;
      ! ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii-1)
      ! MB(ix,jx) = ?? ; dxMB(ix,jx) = ?? ; duMB(1,ix,jx) = ?? ; MR(  ix) = ?? ; dxMR(  ix) = ?? ; duMR(1,ix) = ??
      ! cycle
      !endif
       
       ltj = 1 ; lzj = 1 ! default mode multiplication factors; these are required to correctly include `surface potential' constraints at outer interface;
       ltk = 1 ; lzk = 1 ! default mode multiplication factors; that is: these multiply the f_j; note: they DO NOT multiply the c_j and d_j;
       
       if( ii.eq.Ni(lvol) ) then ! need to consider boundary constraints;
        
        if( ij.gt.1 .and. ip.eq.0 ) then ; ltj =  im(ij) ; lzj = -in(ij) ! not independent degrees of freedom; A_{t,j}  = m_j f_j + c_j , A_{z,j} = -n_j f_j + d_j;
        endif
        if( ik.gt.1 .and. iq.eq.0 ) then ; ltk =  im(ik) ; lzk = -in(ik) ! not independent degrees of freedom; A_{t,j}  = m_j f_j + c_j , A_{z,j} = -n_j f_j + d_j;
        endif
        
       endif ! end of if( ii.eq.Ni(lvol) ); mode multiplication factors have been calculated;

       if( dAd%L ) then ! derivatives of Beltrami field wrt interface geometry are to be computed;

       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dtkqdtjpDi(1,ip,0,iq) * ltj      
       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dtkqdtjpDi(1,ip,1,iq) * ltj * ltk
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dtkqdtjpDi(0,ip,0,iq)            
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dtkqdtjpDi(0,ip,1,iq)       * ltk
         
       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dzkqdtjpDi(1,ip,0,iq) * ltj      
       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dzkqdtjpDi(1,ip,1,iq) * ltj * lzk
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dzkqdtjpDi(0,ip,0,iq)            
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dzkqdtjpDi(0,ip,1,iq)       * lzk
       
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dtkqdzjpDi(1,ip,0,iq) * lzj      
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dtkqdzjpDi(1,ip,1,iq) * lzj * ltk
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dtkqdzjpDi(0,ip,0,iq)            
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dtkqdzjpDi(0,ip,1,iq)       * ltk
       
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dzkqdzjpDi(1,ip,0,iq) * lzj      
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dzkqdzjpDi(1,ip,1,iq) * lzj * lzk
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dzkqdzjpDi(0,ip,0,iq)            
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; dxMB(  ix,jx) = dxMB(  ix,jx) + dzkqdzjpDi(0,ip,1,iq)       * lzk
       
       else ! matches if( dAd%L ) ;

       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; MB(    ix,jx) = MB(    ix,jx) + dtkqdtjpFi(1,ip,0,iq) * ltj       ; iMB(ix,jx) = .true.
       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; MB(    ix,jx) = MB(    ix,jx) + dtkqdtjpFi(1,ip,1,iq) * ltj * ltk ; iMB(ix,jx) = .true.
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; MB(    ix,jx) = MB(    ix,jx) + dtkqdtjpFi(0,ip,0,iq)             ; iMB(ix,jx) = .true.
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; MB(    ix,jx) = MB(    ix,jx) + dtkqdtjpFi(0,ip,1,iq)       * ltk ; iMB(ix,jx) = .true.
       
       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; MB(    ix,jx) = MB(    ix,jx) + dzkqdtjpFi(1,ip,0,iq) * ltj       ; iMB(ix,jx) = .true.
       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; MB(    ix,jx) = MB(    ix,jx) + dzkqdtjpFi(1,ip,1,iq) * ltj * lzk ; iMB(ix,jx) = .true.
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; MB(    ix,jx) = MB(    ix,jx) + dzkqdtjpFi(0,ip,0,iq)             ; iMB(ix,jx) = .true.
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; MB(    ix,jx) = MB(    ix,jx) + dzkqdtjpFi(0,ip,1,iq)       * lzk ; iMB(ix,jx) = .true.
       
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; MB(    ix,jx) = MB(    ix,jx) + dtkqdzjpFi(1,ip,0,iq) * lzj       ; iMB(ix,jx) = .true.
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; MB(    ix,jx) = MB(    ix,jx) + dtkqdzjpFi(1,ip,1,iq) * lzj * ltk ; iMB(ix,jx) = .true.
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; MB(    ix,jx) = MB(    ix,jx) + dtkqdzjpFi(0,ip,0,iq)             ; iMB(ix,jx) = .true.
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; MB(    ix,jx) = MB(    ix,jx) + dtkqdzjpFi(0,ip,1,iq)       * ltk ; iMB(ix,jx) = .true.
       
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; MB(    ix,jx) = MB(    ix,jx) + dzkqdzjpFi(1,ip,0,iq) * lzj       ; iMB(ix,jx) = .true.
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; MB(    ix,jx) = MB(    ix,jx) + dzkqdzjpFi(1,ip,1,iq) * lzj * lzk ; iMB(ix,jx) = .true.
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; MB(    ix,jx) = MB(    ix,jx) + dzkqdzjpFi(0,ip,0,iq)             ; iMB(ix,jx) = .true.
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; MB(    ix,jx) = MB(    ix,jx) + dzkqdzjpFi(0,ip,1,iq)       * lzk ; iMB(ix,jx) = .true.

      !if( Ldmupf.eq.2 ) then ! compute derivatives of MB wrt helicity multiplier and poloidal flux; note that derivative of MB wrt poloidal flux is trivial;
       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; duMB(1,ix,jx) = duMB(1,ix,jx) + lzkqdtjpFi(1,ip,0,iq) * ltj      
       ix = doAt(0,lvol,ij,ip)%i(ii  ) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; duMB(1,ix,jx) = duMB(1,ix,jx) + lzkqdtjpFi(1,ip,1,iq) * ltj * lzk
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii-1) ; duMB(1,ix,jx) = duMB(1,ix,jx) + lzkqdtjpFi(0,ip,0,iq)            
       ix = doAt(0,lvol,ij,ip)%i(ii-1) ; jx = doAz(0,lvol,ik,iq)%i(ii  ) ; duMB(1,ix,jx) = duMB(1,ix,jx) + lzkqdtjpFi(0,ip,1,iq)       * lzk
       
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; duMB(1,ix,jx) = duMB(1,ix,jx) + ltkqdzjpFi(1,ip,0,iq) * lzj      
       ix = doAz(0,lvol,ij,ip)%i(ii  ) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; duMB(1,ix,jx) = duMB(1,ix,jx) + ltkqdzjpFi(1,ip,1,iq) * lzj * ltk
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii-1) ; duMB(1,ix,jx) = duMB(1,ix,jx) + ltkqdzjpFi(0,ip,0,iq)            
       ix = doAz(0,lvol,ij,ip)%i(ii-1) ; jx = doAt(0,lvol,ik,iq)%i(ii  ) ; duMB(1,ix,jx) = duMB(1,ix,jx) + ltkqdzjpFi(0,ip,1,iq)       * ltk
      !endif ! end of if( Ldmupf.eq.2 )
       endif ! end of if( dAd%L ) ;

!latex \end{enumerate} \subsubsection{generalized boundary condition: non-zero normal field at outer interface} \begin{enumerate}

!latex \item A non-zero normal field, $\sqrt g B^s = \partial_\t A_\z - \partial_\z A_\t$, at the outermost interface may be included by writing
!latex \be A_\t &=& \partial_\t f + c, \\ 
!latex     A_\z &=& \partial_\z f + d,
!latex \ee
!latex where $f$ is described in \Eqn{surfacepotential}.
!latex \item The term $b \equiv \sqrt g B^s = \sum_j b_j \sin(m_j \t - n_j \z)$ is considered to be a given, user supplied input quantity.
!latex We then must satisfy $\partial_\t d - \partial_\z c = b$.
!latex Using a Fourier representation for $c$ and $d$, we have $-m_j d_j - n_j c_j = b_j$.
!latex \item We can construct a solution as 
!latex \be \label{eq:nonzeronormalfield} \begin{array}{lcclcccccccccccccc}
!latex c_j = &     0     &,& d_j = &      0    &,& {\rm for } \,\, m_j =   0&,& n_j  =  0, \\
!latex c_j = &-b_j / n_j &,& d_j = &      0    &,& {\rm for } \,\, m_j =   0&,& n_j \ne 0, \\
!latex c_j = &     0     &,& d_j = &-b_j / m_j &,& {\rm for } \,\, m_j \ne 0&,& n_j  = 0 , \\
!latex c_j = &     0     &,& d_j = &-b_j / m_j &,& {\rm for } \,\, m_j \ne 0&,& n_j \ne 0. \\
!latex \end{array}
!latex \ee
!latex \item There is some arbitrariness in the last of these: for example, we  may choose $c_j = -b_j / n_j$ and $d_j = 0$ for $m_j \ne 0$, $n_j \ne 0$.
!latex In \Eqn{nonzeronormalfield}, we have chosen to include the normal field term into the toroidal covariant component of the vector potential,
!latex as this term corresponds to the field-line Hamiltonian . . 
!latex \item The $c_j$ and $d_j$ constitute inhomogeneous terms that contribute to the `right-hand-side' in a manner similar to the $\psi_{t,l}$ and $\psi_{p,l}$.
       
       if( ii.eq.Ni(lvol) .and. iq.eq.0 ) then ! outermost sub-grid = outer interface; the second derivatives include inhomogeneous boundary term;
        

        ck = zero ; dk = zero
        

        if( ik.eq.1 ) then ; ck = dtf ; dk = dpf ! inhomogeneous terms arising from enclosed toroidal and poloidal flux; always present;
        endif
        
        if( Louterboundarynormal .and. ik.gt.1 ) then ! include inhomogeneous terms arising from non-zero normal field at outer boundary;
         if( in(ik).ne.0 .and. im(ik).eq.0 ) ck = -iBns(ik) / in(ik) ! poloidal component;
         if( im(ik).ne.0                   ) dk = -iBns(ik) / im(ik) ! toroidal component;
        endif
        
        if( dAd%L ) then
         ix = doAt(0,lvol,ij,ip)%i(ii-1) ; dxMR(  ix) = dxMR(  ix) - dtkqdtjpDi(0,ip,1,iq) * ck
         ix = doAt(0,lvol,ij,ip)%i(ii  ) ; dxMR(  ix) = dxMR(  ix) - dtkqdtjpDi(1,ip,1,iq) * ck * ltj
         ix = doAt(0,lvol,ij,ip)%i(ii-1) ; dxMR(  ix) = dxMR(  ix) - dzkqdtjpDi(0,ip,1,iq) * dk      
         ix = doAt(0,lvol,ij,ip)%i(ii  ) ; dxMR(  ix) = dxMR(  ix) - dzkqdtjpDi(1,ip,1,iq) * dk * ltj
         ix = doAz(0,lvol,ij,ip)%i(ii-1) ; dxMR(  ix) = dxMR(  ix) - dtkqdzjpDi(0,ip,1,iq) * ck      
         ix = doAz(0,lvol,ij,ip)%i(ii  ) ; dxMR(  ix) = dxMR(  ix) - dtkqdzjpDi(1,ip,1,iq) * ck * lzj          
         ix = doAz(0,lvol,ij,ip)%i(ii-1) ; dxMR(  ix) = dxMR(  ix) - dzkqdzjpDi(0,ip,1,iq) * dk      
         ix = doAz(0,lvol,ij,ip)%i(ii  ) ; dxMR(  ix) = dxMR(  ix) - dzkqdzjpDi(1,ip,1,iq) * dk * lzj 
        else ! matches if( dAd%L ) then ;
         ix = doAt(0,lvol,ij,ip)%i(ii-1) ;   MR(  ix) =   MR(  ix) - dtkqdtjpFi(0,ip,1,iq) * ck         
         ix = doAt(0,lvol,ij,ip)%i(ii  ) ;   MR(  ix) =   MR(  ix) - dtkqdtjpFi(1,ip,1,iq) * ck * ltj 
         ix = doAt(0,lvol,ij,ip)%i(ii-1) ;   MR(  ix) =   MR(  ix) - dzkqdtjpFi(0,ip,1,iq) * dk        
         ix = doAt(0,lvol,ij,ip)%i(ii  ) ;   MR(  ix) =   MR(  ix) - dzkqdtjpFi(1,ip,1,iq) * dk * ltj
         ix = doAz(0,lvol,ij,ip)%i(ii-1) ;   MR(  ix) =   MR(  ix) - dtkqdzjpFi(0,ip,1,iq) * ck         
         ix = doAz(0,lvol,ij,ip)%i(ii  ) ;   MR(  ix) =   MR(  ix) - dtkqdzjpFi(1,ip,1,iq) * ck * lzj
         ix = doAz(0,lvol,ij,ip)%i(ii-1) ;   MR(  ix) =   MR(  ix) - dzkqdzjpFi(0,ip,1,iq) * dk      
         ix = doAz(0,lvol,ij,ip)%i(ii  ) ;   MR(  ix) =   MR(  ix) - dzkqdzjpFi(1,ip,1,iq) * dk * lzj 
!        if( Ldmupf.eq.2 ) then ! compute derivatives of MR wrt helicity multiplier and poloidal flux;
         ix = doAt(0,lvol,ij,ip)%i(ii-1) ; duMR(1,ix) = duMR(1,ix) - lzkqdtjpFi(0,ip,1,iq) * dk        
         ix = doAt(0,lvol,ij,ip)%i(ii  ) ; duMR(1,ix) = duMR(1,ix) - lzkqdtjpFi(1,ip,1,iq) * dk * ltj
         ix = doAz(0,lvol,ij,ip)%i(ii-1) ; duMR(1,ix) = duMR(1,ix) - ltkqdzjpFi(0,ip,1,iq) * ck         
         ix = doAz(0,lvol,ij,ip)%i(ii  ) ; duMR(1,ix) = duMR(1,ix) - ltkqdzjpFi(1,ip,1,iq) * ck * lzj
         if( ik.eq.1 ) then ! the non-zero normal field does not depend on poloidal flux;
         ix = doAt(0,lvol,ij,ip)%i(ii-1) ; duMR(2,ix) = duMR(2,ix) - dzkqdtjpFi(0,ip,1,iq)                              ! this is not zero if *o*oidalboundaryterm = zero;
         ix = doAt(0,lvol,ij,ip)%i(ii  ) ; duMR(2,ix) = duMR(2,ix) - dzkqdtjpFi(1,ip,1,iq)                        * ltj ! this is not zero if *o*oidalboundaryterm = zero;
         ix = doAz(0,lvol,ij,ip)%i(ii-1) ; duMR(2,ix) = duMR(2,ix) - dzkqdzjpFi(0,ip,1,iq)                              ! this is not zero if *o*oidalboundaryterm = zero;
         ix = doAz(0,lvol,ij,ip)%i(ii  ) ; duMR(2,ix) = duMR(2,ix) - dzkqdzjpFi(1,ip,1,iq)                        * lzj ! this is not zero if *o*oidalboundaryterm = zero;
         endif
!        endif
        endif ! end of if( dAd%L );
         
       endif ! end of if( ii.eq.Ni(lvol) .and. iq.eq.0 ) ;
       
      enddo ! end of do iq;
     enddo ! end of do ip;
     
    enddo ! end of do ii;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   enddo ! end of do ik;
  enddo ! end of do ij;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(ma01ag)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine ma01ag

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
