!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Returns the energy functional, and its derivatives with respect to geometry, in a format suitable for NAG routine E04DGF.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \subsubheading{Energy functional}

!latex \item The energy functional is
!latex       \be F \equiv \sum_{l=1}^{N} \int_{\cal V} \left( \frac{p}{\gamma-1} + \frac{B^2}{2} \right) dv,
!latex       \label{eq:energyfunctional}
!latex       \ee
!latex       where $N \equiv$\verb+Nvol+ is the number of interfaces.

!latex \item Assuming that the toroidal and poloidal fluxes, $\psi_t$ and $\psi_p$, the helicity, ${\cal K}$, the helicity multiplier, $\mu$,
!latex       and/or the interface rotational-transforms, $\iotabar$, are appropriately constrained,
!latex       the Beltrami fields in each volume depend only the geometry of the adjacent interfaces.
!latex       So, the energy functional is assumed to be a function of ``position'', i.e. $F = F(R_{l,j},Z_{l,j})$.

!latex \item Introducing a ficitious time, $t$, the position may be advanced according to 
!latex       \be \begin{array}{cccccccccccccccccccccccc}
!latex           \ds \frac{\partial R_j}{\partial t} & \equiv & \ds - \frac{\partial }{\partial R_j} \sum_{l=1}^{N} \int \left( \frac{p}{\gamma-1} + \frac{B^2}{2} \right) dv,\\
!latex           \ds \frac{\partial Z_j}{\partial t} & \equiv & \ds - \frac{\partial }{\partial Z_j} \sum_{l=1}^{N} \int \left( \frac{p}{\gamma-1} + \frac{B^2}{2} \right) dv.
!latex       \end{array} \label{eq:descent} \ee

!latex \item There remain degrees of freedom in the angle representation of the interfaces.

!latex \subsubheading{Spectral energy minimization}

!latex \item Consider variations which do not affect the geometry of the surfaces,
!latex       \be \delta R &=& R_\t \; u,\\
!latex           \delta Z &=& Z_\t \; u,
!latex       \ee
!latex       where $u$ is a angle variation.
!latex \item The corresponding variation in each of the Fourier harmonics is
!latex       \be \delta R_j &\equiv& \ooint R_\t \; u \; \cos \alpha_j,\\
!latex           \delta Z_j &\equiv& \ooint Z_\t \; u \; \sin \alpha_j,
!latex       \ee
!latex \item Following Hirshman et al., introducing the normalized spectral width
!latex       \be M \equiv \frac{\sum_j ( m_j^p + n_j^q ) ( R_{l,j}^2+Z_{l,j}^2 )}{\sum_j ( R_{l,j}^2+Z_{l,j}^2 )},
!latex       \ee
!latex \item Using the notation
!latex       \be N &\equiv& \sum_j \lambda_j ( R_{l,j}^2+Z_{l,j}^2 ), \\
!latex           D &\equiv& \sum_j           ( R_{l,j}^2+Z_{l,j}^2 ),
!latex       \ee
!latex       where $\lambda_j \equiv m_j^p + n_j^q$,
!latex       the variation in the normalized spectral width is 
!latex       \be \delta M = (\delta N - M \delta D)/D.
!latex       \ee
!latex \item For tangential variations, 
!latex       \be \delta N &=& 2 \ooint d\t d\z \; u \left(R_\t \sum_j \lambda_j R_j \cos \alpha_j + Z_\t \sum_j \lambda_j Z_j \sin \alpha_j \right),\\
!latex           \delta D &=& 2 \ooint d\t d\z \; u \left(R_\t \sum_j           R_j \cos \alpha_j + Z_\t \sum_j           Z_j \sin \alpha_j \right).
!latex       \ee

!latex \item The ``tangential spectral-width descent direction'' is thus 
!latex       \be \frac{\partial u}{\partial t} &=& -\left[ R_\t \sum_j(\lambda_j - M) R_j \cos \alpha_j / D + Z_\t \sum_j(\lambda_j - M)Z_j \sin \alpha_j / D \right].
!latex       \ee

!latex \item This suggests that position should be advanced according to
!latex       \be \frac{\partial R_j}{\partial t} & \equiv &
!latex       - \frac{\partial }{\partial R_j} \sum_{l=1}^{N} \int \left( \frac{p}{\gamma-1} + \frac{B^2}{2} \right) dv - [R_\t (R_\t X + Z_\t Y)]_j,\\
!latex           \frac{\partial Z_j}{\partial t} & \equiv &
!latex       - \frac{\partial }{\partial Z_j} \sum_{l=1}^{N} \int \left( \frac{p}{\gamma-1} + \frac{B^2}{2} \right) dv - [Z_\t (R_\t X + Z_\t Y)]_j,
!latex       \ee
!latex       where $X \equiv \sum_j (\lambda_j - M)R_j \cos\alpha_j / D$ and $Y \equiv \sum_j (\lambda_j - M)Z_j \sin\alpha_j / D$.

!latex \subsubheading{numerical implementation}

!latex \item The spectral condensation terms,
!latex \be R_\t (R_\t X + Z_\t Y) &=& \sum_{j,k,l} m_j m_k (\lambda_l-M) R_j ( + R_k R_l \sin\alpha_j\sin\alpha_k\cos\alpha_l - Z_k Z_l \sin\alpha_j\cos\alpha_k\sin\alpha_l)/D,\\
!latex     Z_\t (R_\t X + Z_\t Y) &=& \sum_{j,k,l} m_j m_k (\lambda_l-M) Z_j ( - R_k R_l \cos\alpha_j\sin\alpha_k\cos\alpha_l + Z_k Z_l \cos\alpha_j\cos\alpha_k\sin\alpha_l)/D,
!latex \ee
!latex are calculated using triple angle expressions:
!latex IT IS VERY LIKELY THAT FFTs WOULD BE FASTER!!!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine pc00ab( mode, Ngdof, position, lEnergy, Gradient, nstate, Iuser, Ruser ) ! argument fixed by NAG; see pc00aa;
  
  use constants, only : zero, half, one

  use numerical, only :

  use fileunits, only : ounit

  use inputlist, only : Wpc00ab, Lgeometry, epsilon, maxiter, forceerr, Energy, forcetol

  use cputiming, only : Tpc00ab

  use allglobal, only : writin, myid, cpus, iRbc, iZbs, im, in, mpnq, lBBintegral, DanalyticDrz, nflux, Lcoordinatesingularity, Louterboundarynormal
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER :: mode, Ngdof, nstate, Iuser(1:4)
  REAL    :: position(1:Ngdof), lEnergy, Gradient(1:Ngdof), Ruser(0:2)
  
  REAL    :: force(1:Ngdof)
  
  LOGICAL :: Lderiv
  INTEGER :: mn, Nvol, lvol, idof, imn, irz, totaldof, ilocaldof, jj, kk, ll, mi, ni, mj, nj, mk, nk, ml, nl, mjmk, wflag, iflag
  REAL    :: psifactor, dEnergyPhysical(1:Ngdof), dEnergySpectral, mjmkmpnqXj, Rj, Zj, Rk, Zk, Rl, Zl, RkRl, ZkZl, RmnsqdplusZmnsqd, gradienterror, rflag
  REAL    :: SpectralWidth, SpectralWidthNum, SpectralWidthDen ! spectral-width, numerator and denominator;

  REAL    :: Iomn(1:Iuser(1))
  
  BEGIN(pc00ab)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  mn = Iuser(1) ; Nvol = Iuser(2) ! shorthand;

  Iuser(3) = Iuser(3) + 1 ! iteration counter;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  Lderiv = .false.
  WCALL(pc00ab,fc02aa,( Ngdof, position(1:Ngdof), force(1:Ngdof), Lderiv ))
    
  if( nstate.eq.1 ) then ! this is the first call to pc00ab;
   Ruser(0) = Energy ! NORMALIZATION OF ENERGY NEEDS TO BE REVISED IF THIS ROUTINE IS TO BE CALLED BY pc02aa;
  endif
  
  lEnergy = sum( lBBintegral(1:Nvol) ) / Ruser(0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  select case( mode ) 
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  case( 0 ) ! need to assign Energy;
   
   Gradient(1:Ngdof) = zero
   dEnergyPhysical(1:Ngdof) = zero
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  case( 2 ) ! need to assign Energy & Gradient;
   
   Iuser(4) = Iuser(4) + 1 ! iteration counter;

   
   totaldof = 0 ! total degree-of-freedom counter;
   

   do lvol = 1, Nvol-1
    
    if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ; Lcoordinatesingularity = .false. ! either Cartesian geometry or annular volume; used elsewhere;
    else                                                         ; Lcoordinatesingularity = .true.
    endif
    
    ilocaldof = 0 ! local (to interface) degree-of-freedom counter;
    
    SpectralWidthNum = zero
    SpectralWidthDen = zero
    
    if( Lgeometry.ge.4 ) then
     
     do imn = 1, mn
      
!    if( imask(imn).le.0 ) cycle ! comment this out to include all terms in summation of spectral width;
      
      RmnsqdplusZmnsqd = iRbc(lvol,imn)**2 + iZbs(lvol,imn)**2
      
      SpectralWidthNum = SpectralWidthNum + mpnq(imn) * RmnsqdplusZmnsqd
      SpectralWidthDen = SpectralWidthDen +             RmnsqdplusZmnsqd
     enddo
     
     SpectralWidth    = SpectralWidthNum / SpectralWidthDen
     
    endif

    do imn = 1, mn
     
     do irz = 0, 1
      
      if( imn.eq.1 .and. irz.eq.1 ) cycle ! no dependence on Z_{m,n} \sin( m\t - n\z ) for m=0, n=0;
      
      if( irz.eq.1 .and. Lgeometry.le.3 ) cycle ! no dependence on Z;
      
      ilocaldof = ilocaldof + 1
      
!     if( imask(imn).le.0 ) cycle
      
      totaldof = totaldof + 1
      
      dEnergyPhysical(totaldof) = ( DanalyticDrz(lvol,1,ilocaldof) + DanalyticDrz(lvol+1,0,ilocaldof) ) / Ruser(0)
      
      dEnergySpectral = zero
      
      if( Lgeometry.ge.4 ) then ! include spectral constraints;
       
       mi = im(imn) ; ni = in(imn)
       
       do jj = 1, mn  ; mj = im(jj) ; nj = in(jj)                  ; Rj = iRbc(lvol,jj) ; Zj = iZbs(lvol,jj)
        do kk = 1, mn  ; mk = im(kk) ; nk = in(kk) ; mjmk = mj * mk ; Rk = iRbc(lvol,kk) ; Zk = iZbs(lvol,kk)
         do ll = 1, mn  ;  ml = im(ll) ; nl = in(ll)                 ; Rl = iRbc(lvol,ll) ; Zl = iZbs(lvol,ll) ; RkRl = Rk * Rl ; ZkZl = Zk * Zl
          
          if( irz.eq.0 ) mjmkmpnqXj =   mjmk * ( mpnq(ll) - SpectralWidth ) * Rj
          if( irz.eq.1 ) mjmkmpnqXj =   mjmk * ( mpnq(ll) - SpectralWidth ) * Zj
          
          if(  mi .eq. mj+mk+ml .and.  ni.eq. nj+nk+nl ) dEnergySpectral = dEnergySpectral + mjmkmpnqXj * ( - RkRl + ZkZl )
          if(  mi .eq. mj+mk-ml .and.  ni.eq. nj+nk-nl ) dEnergySpectral = dEnergySpectral + mjmkmpnqXj * ( - RkRl - ZkZl )
          if(  mi .eq. mj-mk+ml .and.  ni.eq. nj-nk+nl ) dEnergySpectral = dEnergySpectral + mjmkmpnqXj * ( + RkRl + ZkZl )
          if(  mi .eq. mj-mk-ml .and.  ni.eq. nj-nk-nl ) dEnergySpectral = dEnergySpectral + mjmkmpnqXj * ( + RkRl - ZkZl )
          
          if( mi.lt.0 ) then ! need to include Fourier terms \cos( -m \t + n \z ) = \cos(  m \t - n \z ), \sin( -m \t + n \z ) = - \sin(  m \t - n \z );
           
          if( irz.eq.0 ) mjmkmpnqXj =   mjmk * ( mpnq(ll)- SpectralWidth ) * Rj
          if( irz.eq.1 ) mjmkmpnqXj = - mjmk * ( mpnq(ll)- SpectralWidth ) * Zj

          if( -mi .eq. mj+mk+ml .and. -ni.eq. nj+nk+nl ) dEnergySpectral = dEnergySpectral + mjmkmpnqXj * ( - RkRl + ZkZl )
          if( -mi .eq. mj+mk-ml .and. -ni.eq. nj+nk-nl ) dEnergySpectral = dEnergySpectral + mjmkmpnqXj * ( - RkRl - ZkZl )
          if( -mi .eq. mj-mk+ml .and. -ni.eq. nj-nk+nl ) dEnergySpectral = dEnergySpectral + mjmkmpnqXj * ( + RkRl + ZkZl )
          if( -mi .eq. mj-mk-ml .and. -ni.eq. nj-nk-nl ) dEnergySpectral = dEnergySpectral + mjmkmpnqXj * ( + RkRl - ZkZl )
          
          endif ! end of if( mi.lt.0 ) ;
         
         enddo ! end of do ll ;
        enddo ! end of do kk ;
       enddo ! end of do jj ;
       
       dEnergySpectral = dEnergySpectral * half * nflux(lvol)**(im(imn)*half) / SpectralWidthDen
       
      endif ! end of if( Lgeometry.ge.4 ) ;
      
      Gradient(totaldof) = dEnergyPhysical(totaldof) + epsilon * dEnergySpectral
      
     enddo ! end of do irz;
     
    enddo ! end of do imn;
    
   enddo ! end of do lvol;
   
   FATALMESS(pc00ab,totaldof.ne.Ngdof,counting error)
   
   gradienterror = sum( abs( Gradient(1:Ngdof )) ) / Ngdof / Energy
   
   wflag=1 ; iflag=0 ; rflag=gradienterror
   WCALL(pc00ab,writin,(wflag,iflag,rflag)) ! write restart file etc.;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  case( 3 ) ! second derivatives; required for E04LYF, which is called by pc02aa;

   FATALMESS(pc00ab,.true.,have not yet computed second derivatives)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  case default
   
   FATALMESS(pc00ab,.true.,invalid mode)
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  end select

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( myid.eq.0 ) then
   cput = MPI_WTIME() ; write(ounit,1000)cput-cpus,myid,Iuser(3:4),mode,Energy,sum(abs(Gradient(1:Ngdof)))/Ngdof/Energy,sum(abs(dEnergyPhysical(1:Ngdof)))/Ngdof/Energy,forceerr
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Iuser(4).ge.maxiter .and. maxiter.gt.0 ) mode = -1 ! iteration limit reached; E04DGF will terminate with ifail=mode;
  if( forceerr.lt.forcetol                   ) mode = -2 ! force balance satisfied; E04DGF will terminate with ifail=mode;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(pc00ab)

1000 format("pc00ab : "f10.2" : myid="i3" ; iterations="2i8" ; mode="i3" ; Energy="es23.15" ; |DF|="2es13.5" ; forceerr="es13.5" ;")
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine pc00ab

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
