!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Performs radial interpolation of vector potential harmonics.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine sa00aa( lvol, lss, Ldo )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, half, one

  use numerical, only : vsmall

  use fileunits, only : ounit

  use inputlist, only : Wsa00aa, Lgeometry, Nvol, Ni, Nofe

  use cputiming, only : Tsa00aa

  use allglobal, only : cpus, myid, mn, im, in, ss, interfacelabel, dss, doAt, doAz, doAtmn, doAzmn

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in) :: lvol, Ldo
  REAL,    intent(in) :: lss

  INTEGER             :: ii, ij, il, ip, id, imn, mm, itz

  REAL                :: xx, vphi(0:1,0:3,0:2), smvp(0:2), expmm

  BEGIN(sa00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATALMESS(sa00aa,lvol.lt.1 .or. lvol.gt.Nvol,invalid lvol)

  FATALMESS(sa00aa,Nofe.gt.3,need to change dimensions of vphi if higher order finite-element basis functions are employed)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wsa00aa ) then
   cput = MPI_WTIME()
   write(ounit,'("sa00aa : "f10.2" : lvol="i3" ; [s_{l-1},lss,s_{l}]="3es23.15" ;")')cput-cpus,lvol,ss(lvol)%s(0),lss,ss(lvol)%s(Ni(lvol))
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! FATALMESS(sa00aa,lss.lt.vsmall,radial coordinate outside local bounds)

  FATALMESS(sa00aa,lss.lt.interfacelabel(lvol-1)-vsmall .or. lss.gt.interfacelabel(lvol)+vsmall,radial coordinate outside local bounds)

  xx = min( max(lss,interfacelabel(lvol-1)), interfacelabel(lvol) ) ! dummy radial; guaranteed to lie within radial bounds;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  ii = ( xx - interfacelabel(lvol-1) ) / dss(lvol,1) ! left grid point;

  if( Wsa00aa ) write(ounit,'("sa00aa : "f10.2" : lvol="i3" ; ii="i3" ; [s_{l,i},lss,s_{l,i+1}]="3es23.15" ;")')cput-cpus,lvol,ii,ss(lvol)%s(ii),xx,ss(lvol)%s(ii+1)

  FATALMESS(sa00aa,ii.lt.0,local interpolation variable outside bounds)
  
  if( ii.eq.Ni(lvol) ) ii = ii-1 ! keep off outer boundary; see ii+il logic below;

  FATALMESS(sa00aa,ii.ge.Ni(lvol),local interpolation variable outside bounds)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  xx = ( xx - ss(lvol)%s(ii) ) / dss(lvol,1) ! local interpolation; lss varies between interfacelabel(lvol-1) and interfacelabel(lvol); xx varies between zero and one;

  if( Wsa00aa ) write(ounit,'("sa00aa : "f10.2" : lvol="i3" ; ii="i3" ; xx="es23.15" ;")')cput-cpus,lvol,ii,xx

! FATALMESS(sa00aa,xx.lt.zero-vsmall.or.xx.gt.one+vsmall,local interpolation variable outside bounds)

  xx = min( max(xx,zero), one ) ! this appears to be irrelevant;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  doAtmn(Ldo,0:2,0:mn) = zero ! initialize summation; poloidal covariant component;
  doAzmn(Ldo,0:2,0:mn) = zero ! initialize summation; toroidal covariant component;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The routine \verb+fe00ab+ is called to perform the basis function interpolation.

  WCALL(sa00aa,fe00ab,( lvol, xx, Nofe, vphi(0:1,0:3,0:2) )) ! xx is the local interpolation coordinate; 

  do ip = 0, Nofe
   do id = 0, 2
    vphi(0:1,ip,id) = vphi(0:1,ip,id) * dss(lvol,ip-id) ! include radial scaling factor;
   enddo
  enddo
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The interpolated harmonics and the first and second radial derivatives are returned through the global arrays \verb+doAtmn(0,0:2,1:mn)+ and \verb+doAzmn(0,0:2,1:mn)+.

  FATALMESS(sa00aa,.not.allocated(doAt),allocation error)
  FATALMESS(sa00aa,.not.allocated(doAz),allocation error)

  do imn = 1, mn ; ij = imn ; mm = im(ij) ! loop over Fourier harmonics;
   do ip = 0, Nofe ! order of derivative;
    do il = 0, 1 ! left/right;
     
     FATALMESS(sa00aa,ii+il.gt.Ni(lvol),sub-grid indexing error on At and Az)
     
     if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ! Cartesian or annulus; no additional radial factor is included; should use Lcoordinatesingularity flag;
      
      smvp(0) = vphi(il,ip,0)
      smvp(1) = vphi(il,ip,1)
      smvp(2) = vphi(il,ip,2)
      
     else ! contains coordinate singularity; need to include radial "regularity" factor, and take it's derivative;
      
      expmm = mm * half
      
!     FATALMESS(sa00aa,Lsinterp.ne.5,needs attention)
      
      FATALMESS(sa00aa,lss.lt.vsmall .and. expmm-2.lt.zero)

      smvp(0) = vphi(il,ip,0) * lss**(expmm  )
      smvp(1) = vphi(il,ip,1) * lss**(expmm  ) + vphi(il,ip,0) * lss**(expmm-1) * (expmm  )
      smvp(2) = vphi(il,ip,2) * lss**(expmm  ) + vphi(il,ip,1) * lss**(expmm-1) * (expmm  ) * 2 + vphi(il,ip,0) * lss**(expmm-2) * (expmm  ) * (expmm-1)
      
     endif ! end of if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then;

     
     doAtmn(Ldo,0:2,imn) = doAtmn(Ldo,0:2,imn) + doAt(Ldo,lvol,ij,ip)%s(ii+il) * smvp(0:2)
     doAzmn(Ldo,0:2,imn) = doAzmn(Ldo,0:2,imn) + doAz(Ldo,lvol,ij,ip)%s(ii+il) * smvp(0:2)
     

    enddo ! do il = 0, 1 ;
   enddo ! end of do ip = 0, Nofe;
  enddo ! end of do imn = 1, mn;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(sa00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine sa00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
