!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Writes vector potential harmonics to file.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine tz00aa( lvol , nilss , mn )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero
  use numerical, only : vsmall
  use fileunits, only : ounit, aunit
  use inputlist, only : Wtz00aa, Nvol, Ni, ext
  use cputiming, only : Ttz00aa
  use allglobal, only : cpus, myid, interfacelabel, ss, im, in, doAtmn, doAzmn

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS
  
  INTEGER, intent(in) :: lvol, nilss, mn 

  INTEGER             :: ilss, Ldo                                                        ! loop control and radial resolution;
  REAL                :: lss                                                              ! radial dummy;
  REAL                :: ass(1:nilss), aoAtmn(1:nilss,0:2,1:mn), aoAzmn(1:nilss,0:2,1:mn) ! used to save vector potential harmonics; 
  CHARACTER           :: suf*4

  BEGIN(tz00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATALMESS(tz00aa,lvol-1.lt.0.or.lvol.gt.Nvol,invalid interface label)

  do ilss = 1,nilss
   
   lss = interfacelabel(lvol-1) + ilss * ( interfacelabel(lvol)-interfacelabel(lvol-1) ) / (nilss+1)
   
   ass(ilss) = lss
   
   Ldo = 0
   CALL(sa00aa,(lvol, lss, Ldo))
   
   aoAtmn(ilss,0:2,1:mn) = doAtmn(0,0:2,1:mn)
   aoAzmn(ilss,0:2,1:mn) = doAzmn(0,0:2,1:mn)
   
  enddo ! end of do ilss;
  
  write(suf,'(i4.4)')lvol
  open(aunit+myid,file="."//trim(ext)//".atazmn:"//suf,status="unknown",form="unformatted") ! this will contain Harmonic plot data; 
  write(aunit+myid)mn,Ni(lvol),nilss
  write(aunit+myid)ss(lvol)%s(0:Ni(lvol))
  write(aunit+myid)im
  write(aunit+myid)in
  write(aunit+myid)ass
  write(aunit+myid)aoAtmn
  write(aunit+myid)aoAzmn
  close(aunit+myid)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(tz00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine tz00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
