!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs smooth approximation to wall.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{solution of Laplace's equation in two-dimensions} \begin{enumerate}

!latex \item The wall is given by a discrete set of points.
!latex \item The points must go anti-clockwise.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine wa00aa( iwa00aa )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, half, one, ten, pi2

  use numerical, only : vsmall

  use fileunits, only : ounit, gunit

  use inputlist, only : Wwa00aa, Nvol, Mpol, Ntor, Lwall, phiwall, odetol

  use cputiming, only : Twa00aa
  
  use allglobal, only : ncpu, myid, cpus, mn, im, in, Ntz, Rij, Zij, iRbc, iZbs, iRbs, iZbc, &
                        trigwk, trigm, trign, isr, Nt, Nz, efmn, ofmn, cfmn, sfmn, &
                        Rij, Zij, interfacelabel, iexvol, Lcoordinatesingularity, Nt
  
  use laplaces

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER              :: iwa00aa

  INTEGER              :: ifail, ii, ij, mm, nn, imn, iwall, Nwall, Lcurv, iintegrate

  INTEGER, parameter   :: Nconstraints = 1, lengthwork = Nconstraints * ( 3*Nconstraints + 13 ) / 2 ! required for C05NBF;

  REAL                 :: dmid, hmid, rho(1:Nconstraints), fvec(1:Nconstraints), xtol, realwork(1:lengthwork), Rmin, Rmax, Zmin, Zmax, lRZ(1:2), px, py, dR, dZ

  REAL                 :: lss
  REAL, allocatable    :: RZwall(:,:)

  INTEGER              :: Node
  REAL                 :: length, lengthend, xy(1:2), dxy(1:2), tol, isocurvetermination, workreal(1:40)
  CHARACTER            :: relabs
  external             :: isocurveequalarc, isocurveequalarcoutput, isocurvetermination

  external             :: VacuumPhi
  
  BEGIN(wa00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  FATALMESS(wa00aa,myid.ne.0,error)
  
  FATALMESS(wa00aa,Ntor.gt.0,presently axisymmetry is assumed but this can easily be generalized)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Lwall.eq.-2 ) then ! Lwall.eq.-2 will eventually become the default; 24 Oct 12;
   
   lss = interfacelabel(Nvol-iexvol) ; Lcurv = 0 ; Lcoordinatesingularity = .false. ! shall use next-to-last interface as `plasma' boundary; 24 Oct 12;
   
   WCALL(wa00aa,co01aa,( Nvol, lss, Lcurv, Ntz )) ! 23 Oct 12;
   
!   Nwall = Ntz + 1 ! 24 Oct 12;
!   RALLOCATE(RZwall,(1:2,1:Nwall)) ! 24 Oct 12;
!   RZwall(1,1:Ntz) = Rij(0,1:Ntz) ; RZwall(1,Nwall) = Rij(0,1) ! 24 Oct 12;
!   RZwall(2,1:Ntz) = Zij(0,1:Ntz) ; RZwall(2,Nwall) = Zij(0,1) ! 24 Oct 12;
! ! 24 Oct 12;
!   FATALMESS(wa00aa,RZwall(2,2).lt.RZwall(2,1),wall is not anti-clockwise) ! 24 Oct 12;
   
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  open(gunit,file="wall.dat",status='old',action='read',iostat=ios)
  FATALMESS(wa00aa,ios.ne.0,error opening wall.dat)
  
  Nwall = 0
  do
   read(gunit,*,iostat=ios)lRZ(1:2)
   if( ios.ne.0 ) exit
   Nwall = Nwall + 1
  enddo
  close(gunit)
  
  RALLOCATE(RZwall,(1:2,1:Nwall))
  
  open(gunit,file="wall.dat",status='old',action='read',iostat=ios)
  FATALMESS(wa00aa,ios.ne.0,error opening wall.dat)   

  read(gunit,*,iostat=ios) RZwall(1:2,1:Nwall) ! MUST GO ANTI-CLOCKWISE; LAST-POINT = FIRST POINT;
  FATALMESS(wa00aa,ios.ne.0,error reading RZwall from wall.dat)
  
  close(gunit)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
 ! need to establish polar coordinate origin; 24 Oct 12;

  Rmin = minval( RZwall(1,1:Nwall) ) ! these will be redundant eventually; 24 Oct 12;
  Rmax = maxval( RZwall(1,1:Nwall) )
  Zmin = minval( RZwall(2,1:Nwall) )
  Zmax = maxval( RZwall(2,1:Nwall) )
  
  Rmid = half * ( Rmin + Rmax ) ! these will be redundant eventually; 24 Oct 12;
  Zmid = half * ( Zmin + Zmax )

  dR = ( Rmax - Rmid ) * 2.0
  dZ = ( Zmax - Zmid ) * 2.0
  
  dmid = minval( sqrt( (RZwall(1,1:Nwall)-Rmid)**2 + (RZwall(2,1:Nwall)-Zmid)**2 ) ) / 2**4 ; hmid = dmid* half
   
  write(ounit,1000) Nwall, Rmin, Rmax, Zmin, Zmax, Rmid, Zmid, dmid, phiwall

1000 format("wa00aa : " 10x " : Nwall="i9" ; Rmin="f9.4" ; Rmax="f9.4" ; Zmin="f9.4" ; Zmax="f9.4" ; Rmid="f9.4" ; Zmid="f9.4" ; dmid="f9.4" ; phiwall="f9.6" ;")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!                                                                   boundary points +    nodes  + repeated point + inner boundary + inner nodes  
  if( Lwall.eq.-2 ) then ; Nintervals = Nwall-1 + Ntz ; Nsegments =       Nwall     + (Nwall-1) +         1      +    (Ntz+1)     +     Ntz
  else                   ; Nintervals = Nwall-1 + 4   ; Nsegments =       Nwall     + (Nwall-1) +         1      +     5          +     4
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RALLOCATE(xpoly,(1:Nsegments))
  RALLOCATE(ypoly,(1:Nsegments))
  
  RALLOCATE(phi,(1:Nintervals)) ! must set to boundary value of phi;
  RALLOCATE(phid,(1:Nintervals)) ! can leave this as zero;
  
  IC = Nintervals + 1
  
  NP4 = Nintervals + 4
  NP1 = Nintervals + 1
  
  RALLOCATE(CC,(1:IC,1:NP4))
  
  RALLOCATE(ICINT,(1:NP1))
  
  iwall = 0
  
  select case( Lwall )

  case( -2 )  ! this will eventually become the default; 24 Oct 12;
   
! outer boundary must go anti-clockwise; 24 Oct 12;

   do ii = 1, Nwall-1
    iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii)                    ! vertices; 24 Oct 12;
    iwall = iwall + 1 ; xpoly(iwall) = half * ( RZwall(1,ii) + RZwall(1,ii+1) ) ; ypoly(iwall) = half * ( RZwall(2,ii) + RZwall(2,ii+1) ) ! nodes   ; 24 Oct 12;
   enddo
      ii =    Nwall
    iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii)                    ! last point=first; 24 Oct 12;
   
! repeated point indicates end of outer boundary; 24 Oct 12;

    iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii)

! inner boundary must go clockwise; 24 Oct 12;

    iwall = iwall + 1 ; xpoly(iwall) =          Rij(0, 1)               ; ypoly(iwall) =          Zij(0, 1)               ! vertices; 24 Oct 12;
    iwall = iwall + 1 ; xpoly(iwall) = half * ( Rij(0, 1)+Rij(0,Ntz ) ) ; ypoly(iwall) = half * ( Zij(0, 1)+Zij(0,Ntz ) ) ! nodes   ;
   do ii = Ntz-1, 2, -1
    iwall = iwall + 1 ; xpoly(iwall) =          Rij(0,ii)               ; ypoly(iwall) =          Zij(0,ii)               ! vertices; 24 Oct 12;
    iwall = iwall + 1 ; xpoly(iwall) = half * ( Rij(0,ii)+Rij(0,ii-1) ) ; ypoly(iwall) = half * ( Zij(0,ii)+Zij(0,ii-1) ) ! nodes   ;
   enddo
    iwall = iwall + 1 ; xpoly(iwall) =          Rij(0, 1)               ; ypoly(iwall) =          Zij(0, 1)               ! last point=first; 24 Oct 12;
    

    phi(      1:Nwall-1   ) = zero ! scalar potential on outer boundary; 24 Oct 12;
    phi(Nwall  :Nintervals) = one  ! scalar potential on inner boundary; 24 Oct 12;

  case( -1 ) ! shall construct surface outside given; 23 Oct 12;
   
   iwall = iwall + 1 ; xpoly(iwall) = Rmid + dR ; ypoly(iwall) = Zmid + dZ
   iwall = iwall + 1 ; xpoly(iwall) = Rmid      ; ypoly(iwall) = Zmid + dZ ! node;
   iwall = iwall + 1 ; xpoly(iwall) = Rmid - dR ; ypoly(iwall) = Zmid + dZ
   iwall = iwall + 1 ; xpoly(iwall) = Rmid - dR ; ypoly(iwall) = Zmid      ! node;
   iwall = iwall + 1 ; xpoly(iwall) = Rmid - dR ; ypoly(iwall) = Zmid - dZ
   iwall = iwall + 1 ; xpoly(iwall) = Rmid      ; ypoly(iwall) = Zmid - dZ ! node;
   iwall = iwall + 1 ; xpoly(iwall) = Rmid + dR ; ypoly(iwall) = Zmid - dZ
   iwall = iwall + 1 ; xpoly(iwall) = Rmid + dR ; ypoly(iwall) = Zmid      ! node;
   iwall = iwall + 1 ; xpoly(iwall) = Rmid + dR ; ypoly(iwall) = Zmid + dZ ! last point = first point;

   iwall = iwall + 1 ; xpoly(iwall) = Rmid + dR ; ypoly(iwall) = Zmid + dZ ! repeated point;
   
   do ii = Nwall, 2, -1
    iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii)
    iwall = iwall + 1 ; xpoly(iwall) = half * ( RZwall(1,ii) + RZwall(1,ii-1) ) ; ypoly(iwall) = half * ( RZwall(2,ii) + RZwall(2,ii-1) ) ! nodes;
   enddo
      ii = 1
    iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii) ! last point must coincide with first;

    phi(1:      4) = zero ! scalar potential on outer boundary;
    phi(5:Nwall+3) = one  ! scalar potential on inner boundary;

  case(  1 ) ! shall construct surface inside given; 23 Oct 12;
   
   do ii = 1, Nwall-1
    iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii)
    iwall = iwall + 1 ; xpoly(iwall) = half * ( RZwall(1,ii) + RZwall(1,ii+1) ) ; ypoly(iwall) = half * ( RZwall(2,ii) + RZwall(2,ii+1) ) ! nodes;
   enddo
      ii =    Nwall
    iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii) ! last point must coincide with first;
   
    iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii) ! repeated point; indicates end of outer boundary;
   
    iwall = iwall + 1 ; xpoly(iwall) = Rmid + dmid ; ypoly(iwall) = Zmid
    iwall = iwall + 1 ; xpoly(iwall) = Rmid + hmid ; ypoly(iwall) = Zmid - hmid ! node;
    iwall = iwall + 1 ; xpoly(iwall) = Rmid        ; ypoly(iwall) = Zmid - dmid
    iwall = iwall + 1 ; xpoly(iwall) = Rmid - hmid ; ypoly(iwall) = Zmid - hmid ! node;
    iwall = iwall + 1 ; xpoly(iwall) = Rmid - dmid ; ypoly(iwall) = Zmid
    iwall = iwall + 1 ; xpoly(iwall) = Rmid - hmid ; ypoly(iwall) = Zmid + hmid ! node;
    iwall = iwall + 1 ; xpoly(iwall) = Rmid        ; ypoly(iwall) = Zmid + dmid
    iwall = iwall + 1 ; xpoly(iwall) = Rmid + hmid ; ypoly(iwall) = Zmid + hmid ! node;
    iwall = iwall + 1 ; xpoly(iwall) = Rmid + dmid ; ypoly(iwall) = Zmid
    
    phi(      1:Nwall-1) = one  ! scalar potential on outer boundary;
    phi(Nwall  :Nwall+3) = zero ! scalar potential on inner boundary;
    
   case default
    
    FATALMESS(wa00aa,.true.,invalid Lwall)

   end select

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
 !DEALLOCATE( RZwall ) ! comes later; 24 Oct 12;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wwa00aa ) then
   cput = MPI_WTIME()
   do ii = 1, iwall ; write(ounit,'("wa00aa : "f10.2" : Nsegments="i9" ; ii="i9" ; R="f15.9" ; Z="f15.9" ;")')cput-cpus, Nsegments, ii, xpoly(ii), ypoly(ii)
   enddo
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  stage1   = .true.  ! preparation;
  exterior = .true.  ! unbounded domain;
  exterior = .false. ! interior  domain;
  dorm     = .true.  ! Dirichlet or mixed boundary value problem;
  
  px = xpoly(1)      ! only required for stage two
  py = ypoly(1)      ! only required for stage two
  
  alpha = zero       ! alpha need not be set if dorm = .true. ;
  
  ifail = 1

  call D03EAF( stage1, exterior, dorm, Nintervals, px, py, xpoly, ypoly, Nsegments, phi, phid, alpha, CC, IC, NP4, ICINT, NP1, ifail )
  
  cput = MPI_WTIME()
  select case( ifail )
  case( 0 ) ; write(ounit,'("wa00aa : "f10.2" : prepared vacuum calculation; stage1="L2" ; ifail="i3" ; success ;          ")')cput-cpus, stage1, ifail
  case( 1 ) ; write(ounit,'("wa00aa : "f10.2" : prepared vacuum calculation; stage1="L2" ; ifail="i3" ; invalid tolerance ;")')cput-cpus, stage1, ifail
  case( 2 ) ; write(ounit,'("wa00aa : "f10.2" : prepared vacuum calculation; stage1="L2" ; ifail="i3" ; incorrect rank ;   ")')cput-cpus, stage1, ifail
  case default
   FATALMESS(wa00aa,.true.,invalid ifail returned by D03EAF)
  end select
  
  stage1 = .false. ; originalalpha = alpha

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the intialization of Laplaces solution is complete; 24 Oct 12;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
#ifdef TESTING
  
! INTEGRATE ALONG EQUAL-ARC ISOCURVE;
  
  totallength = -one ; lengthend = ten * pi2 * iRbc(Nvol-iexvol,1) ! 26 Oct 12;
  
  Node = 2 ; tol = odetol ; relabs = 'D'
  
  do iintegrate = 0, 1 ! first, compute total length of curve; second, return equally spaced; 26 Oct 12;
   
   ilength = 0 ; length = zero
   
   xy(1:2) = (/ ( Rij(0,1)+RZwall(1,1) ) * half , vsmall /) ! starting point midway between plasma boundary and wall; 24 Oct 12;
   
   call isocurveequalarc( length, xy(1:2), dxy(1:2) ) ! 24 Oct 12;
   
   xy(1:2) = xy(1:2) + vsmall * dxy(1:2) ! step off y=0; note that y=0 is termination criterion; 24 Oct 12;
   
   length = length + vsmall
   
   ifail = 1
   call D02BJF( length, lengthend, Node, xy(1:2), isocurveequalarc, tol, relabs, isocurveequalarcoutput, isocurvetermination, workreal(1:40), ifail )
   
   cput = MPI_WTIME()
   select case( ifail )
   case( 0 ) ; write(ounit,'("wa00aa : "f10.2" : called D02BJF ; ii="i2" ; ifail="i2" ; success         ;":" length=",es23.15" ;")')cput-cpus, iintegrate, ifail, length
   case( 1 ) ; write(ounit,'("wa00aa : "f10.2" : called D02BJF ; ii="i2" ; ifail="i2" ; input error     ;":" length=",es23.15" ;")')cput-cpus, iintegrate, ifail
   case( 2 ) ; write(ounit,'("wa00aa : "f10.2" : called D02BJF ; ii="i2" ; ifail="i2" ; no more progress;":" length=",es23.15" ;")')cput-cpus, iintegrate, ifail, length
   case( 3 ) ; write(ounit,'("wa00aa : "f10.2" : called D02BJF ; ii="i2" ; ifail="i2" ; tol too small   ;":" length=",es23.15" ;")')cput-cpus, iintegrate, ifail
   case( 4 ) ; write(ounit,'("wa00aa : "f10.2" : called D02BJF ; ii="i2" ; ifail="i2" ; invalid xsol    ;":" length=",es23.15" ;")')cput-cpus, iintegrate, ifail
   case( 5 ) ; write(ounit,'("wa00aa : "f10.2" : called D02BJF ; ii="i2" ; ifail="i2" ; invalid xsol    ;":" length=",es23.15" ;")')cput-cpus, iintegrate, ifail
   case( 6 ) ; write(ounit,'("wa00aa : "f10.2" : called D02BJF ; ii="i2" ; ifail="i2" ; no sign change  ;":" length=",es23.15" ;")')cput-cpus, iintegrate, ifail, length
   case( 7 ) ; write(ounit,'("wa00aa : "f10.2" : called D02BJF ; ii="i2" ; ifail="i2" ; serious error   ;":" length=",es23.15" ;")')cput-cpus, iintegrate, ifail
   end select
   
   totallength = length ; lengthend = totallength + totallength / Nt
   
  enddo ! end of do iintegrate loop; 26 Oct 12;

#endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  DEALLOCATE( RZwall ) ! comes later; 24 Oct 12;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  select case( Lwall )

  case( -2 )

   rho(1) = (Rmax + Rij(0,1)) * half - Rmid
   
  case( -1 )
   
   rho(1) = ( Rmax + Rmid+dR) * half - Rmid
   FATALMESS(wa00aa,Rmid+rho(1).lt.Rmax .or. Rmid+rho(1).gt.Rmid+dR,illegal position)
   
  case(  1 )

   rho(1) = phiwall**2 * ( Rmax-Rmid )

   case default
    
    FATALMESS(wa00aa,.true.,invalid Lwall)

  end select


  do iangle = 1, Ntz

   niterations = 0 ; xtol = odetol
   
   ifail = 1
   
   call C05NBF( VacuumPhi, Nconstraints, rho(1:Nconstraints), fvec(1:Nconstraints), xtol, realwork(1:lengthwork), lengthwork, ifail )
   
   cput = MPI_WTIME()
   select case( ifail )
   case( :-1 ) ;               write(ounit,'("wa00aa : "f10.2" : iangle="i6" ; ifail="i3" ; outside domain ; FAIL ;   ")')cput-cpus, iangle, ifail
   case(   0 ) ; if( Wwa00aa ) write(ounit,'("wa00aa : "f10.2" : iangle="i6" ; ifail="i3" ; success ;                 ")')cput-cpus, iangle, ifail
   case(   1 ) ;               write(ounit,'("wa00aa : "f10.2" : iangle="i6" ; ifail="i3" ; input error ; FAIL ;      ")')cput-cpus, iangle, ifail
   case(   2 ) ;               write(ounit,'("wa00aa : "f10.2" : iangle="i6" ; ifail="i3" ; consider restart ; FAIL ; ")')cput-cpus, iangle, ifail
   case(   3 ) ;               write(ounit,'("wa00aa : "f10.2" : iangle="i6" ; ifail="i3" ; xtol is too small ; FAIL ;")')cput-cpus, iangle, ifail
   case(   4 ) ;               write(ounit,'("wa00aa : "f10.2" : iangle="i6" ; ifail="i3" ; bad progress ; FAIL ;     ")')cput-cpus, iangle, ifail
   case default
    FATALMESS(wa00aa,.true.,invalid ifail returned by C05NBF)
   end select

   if( ifail.ne.0 ) exit

  enddo ! end of do iangle = 1, Ntz loop;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  DEALLOCATE(xpoly)
  DEALLOCATE(ypoly)
  DEALLOCATE(phi)
  DEALLOCATE(phid)
  DEALLOCATE(CC)
  DEALLOCATE(ICINT)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  iwa00aa = ifail

  cput = MPI_WTIME()
  write(ounit,'("wa00aa : "f10.2" : constructed outer boundary; Lwall="i3" ; phiwall="es13.5" ; iwa00aa="i3" ;")')cput-cpus, Lwall, phiwall, iwa00aa ! 24 Oct 12;

  if( ifail.ne.0 ) goto 9999
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

 !open(gunit,file="wall.new",status='unknown') ! 24 Oct 12;
 !write(gunit,'(2es23.15)') ( Rij(0,ij), Zij(0,ij), ij = 1,Ntz ) ! 24 Oct 12;
 !write(gunit,'(2es23.15)')   Rij(0, 1), Zij(0, 1) ! 24 Oct 12;
 !close(gunit) ! 24 Oct 12;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  call tfft( Nt, Nz, Rij(0,1:Ntz), Zij(0,1:Ntz), isr, trigm, trign, trigwk, mn, im, in, efmn(1:mn), ofmn(1:mn), cfmn(1:mn), sfmn(1:mn), ifail ) ! Fourier decompose normal field;

  iRbc(Nvol,1:mn) = efmn(1:mn) ; iZbs(Nvol,1:mn) = sfmn(1:mn)
  iRbs(Nvol,1:mn) = ofmn(1:mn) ; iZbc(Nvol,1:mn) = cfmn(1:mn)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(wa00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine wa00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine VacuumPhi( Nconstraints, rho, fvec, iflag )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, one, pi2
  
  use inputlist, only : Wwa00aa, phiwall

  use fileunits, only : ounit
  
  use allglobal, only : ncpu, myid, cpus, Ntz, Rij, Zij
  
  use laplaces

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS
  
  INTEGER :: Nconstraints, iflag
  REAL    :: rho(1:Nconstraints), fvec(1:Nconstraints), angle, px, py

  INTEGER :: ifail

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  niterations = niterations + 1

  alpha = originalalpha ! this needs to be reset before every call to D03EAF; 24 Oct 12;
  
  angle = (iangle-1) * pi2 / Ntz ; px = Rmid + rho(1) * cos( angle )
  ;                                py =        rho(1) * sin( angle )
  
  Rij(0,iangle) = px 
  Zij(0,iangle) = py ! global information; passed back to wa00aa; used in FFT to construct new boundary;
  
  ifail = 1
  
  call D03EAF( stage1, exterior, dorm, Nintervals, px, py, xpoly, ypoly, Nsegments, phi, phid, alpha, CC, IC, NP4, ICINT, NP1, ifail )
  
  cput = MPI_WTIME()

  select case( ifail )
  case( 0 ) ; if( Wwa00aa ) write(ounit,'("wa00aa : "f10.2" : stage1="L2" ; ifail="i3" ; success ;          ")')cput-cpus, stage1, ifail
  case( 1 ) ;               write(ounit,'("wa00aa : "f10.2" : stage1="L2" ; ifail="i3" ; invalid tolerance ;")')cput-cpus, stage1, ifail
  case( 2 ) ;               write(ounit,'("wa00aa : "f10.2" : stage1="L2" ; ifail="i3" ; incorrect rank ;   ")')cput-cpus, stage1, ifail
  case default
   FATALMESS(wa00aa,.true.,invalid ifail returned by D03EAF)
  end select
  
  if( rho(1).lt.zero ) iflag = -1 ! could also check that R, Z are within domain;

  fvec(1) = alpha - phiwall

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
 
  if( Wwa00aa ) then
   write(ounit,1000)iangle, niterations, rho(1), px, py, alpha, fvec(1)
  endif

1000 format("wa00aa : " 10x " : iangle="i6" ; nits="i3" ; rho="es13.5" ; R,Z="2es23.15" ; alpha="es13.5" ; F="es13.5" ;")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  return

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine VacuumPhi

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine isocurveequalarc( length, xy, dxy )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : quarter, one

  use numerical, only : sqrtmachprec

  use inputlist, only : Wwa00aa

  use fileunits, only : ounit
  
  use allglobal, only : myid, cpus
  
  use laplaces

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  REAL   , intent(in)  :: length, xy(1:2)
  REAL   , intent(out) :: dxy(1:2)

  INTEGER              :: ii, jj, ifail
  REAL                 :: pxy(-1:1,-1:1), px, py, dphidxy(0:2), dfinitediff, normalization
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  dfinitediff = sqrtmachprec
  
  do ii = -1, 1, 2

   do jj = -1, 1, 2
    
    px = xy(1) + ii*dfinitediff ; py = xy(2) + jj*dfinitediff

    ifail = 1 ; alpha = originalalpha ! this needs to be reset before each call to D03EAF; 24 Oct 12;

    call D03EAF( stage1, exterior, dorm, Nintervals, px, py, xpoly, ypoly, Nsegments, phi, phid, alpha, CC, IC, NP4, ICINT, NP1, ifail ) ! alpha is returned; 24 Oct 12;
    
    cput = MPI_WTIME()
    
    select case( ifail )
    case( 0 ) ; if( Wwa00aa ) write(ounit,'("wa00aa : "f10.2" : stage1="L2" ; ifail="i3" ; success ;          ")')cput-cpus, stage1, ifail
    case( 1 ) ;               write(ounit,'("wa00aa : "f10.2" : stage1="L2" ; ifail="i3" ; invalid tolerance ;")')cput-cpus, stage1, ifail
    case( 2 ) ;               write(ounit,'("wa00aa : "f10.2" : stage1="L2" ; ifail="i3" ; incorrect rank ;   ")')cput-cpus, stage1, ifail
    case default
     FATALMESS(wa00aa,.true.,invalid ifail returned by D03EAF)
    end select
    
    pxy(ii,jj) = alpha

   !write(ounit,'("wa00aa : " 10x " : ii="i3" ; jj="i3" ; phi="es23.15" ;")')ii, jj, pxy(ii,jj) ! 24 Oct 12;

   enddo
   
  enddo

! dphidxy(0) = ( pxy(+1,+1) + pxy(-1,+1) + pxy(+1,-1) + pxy(-1,-1) ) * quarter
  dphidxy(1) = ( pxy(+1,+1) - pxy(-1,+1) + pxy(+1,-1) - pxy(-1,-1) ) * quarter / dfinitediff ! 24 Oct 12;
  dphidxy(2) = ( pxy(+1,+1) + pxy(-1,+1) - pxy(+1,-1) - pxy(-1,-1) ) * quarter / dfinitediff ! 24 Oct 12;
  
  normalization = one / sqrt( dphidxy(1)**2 + dphidxy(2)**2 )! equal-arc normalization; 24 Oct 12;

  dxy(1) = + dphidxy(2) * normalization
  dxy(2) = - dphidxy(1) * normalization

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  return

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine isocurveequalarc

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine isocurveequalarcoutput( length, xy )

  use constants, only : zero, quarter, two, ten, pi2

 !use numerical, only : sqrtmachprec ! 26 Oct 12;

 !use inputlist, only : Wwa00aa ! 26 Oct 12;

  use fileunits, only : ounit
  
  use allglobal, only : myid, cpus, Nt
  
  use laplaces

  LOCALS

  REAL :: length, xy(1:2)

  ilength = ilength + 1

  if( totallength.gt.zero ) then ; length = ilength *     totallength  / Nt ; write(ounit,1000) length, xy(1:2)
  else                           ; length =  length + abs(totallength) / Nt
  endif

1000 format("wa00aa : " 10x " : length="es23.15" ; xy = ["es13.5" ,"es13.5" ] ;")
   
  return

end subroutine isocurveequalarcoutput

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

real function isocurvetermination( length, xy )

  use constants, only : quarter, one, pi2

 !use numerical, only : sqrtmachprec, vsmall ! 26 Oct 12;

 !use inputlist, only : Wwa00aa ! 26 Oct 12;

 !use fileunits, only : ounit ! 26 Oct 12;
  
 !use allglobal, only : myid, cpus ! 26 Oct 12;
  
 !use laplaces ! 26 Oct 12;

  LOCALS

  REAL :: length, xy(1:2)

  isocurvetermination = xy(2) ! this will get `upper' half of curve; only works if up-down symmetric; 26 Oct 12;

  return

end function isocurvetermination
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
