!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Constructs smooth approximation to wall.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{solution of Laplace's equation in two-dimensions} \begin{enumerate}

!latex \item The wall is given by a discrete set of points.
!latex \item The points must go anti-clockwise.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine wa01aa( iwa01aa )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, half, one, pi2, ten

  use numerical, only : 

  use fileunits, only : ounit, gunit

  use inputlist, only : Wwa01aa, Nvol, phiwall, Nfp, Rbc, Zbs, Rbs, Zbc, Lwall

  use cputiming, only : Twa01aa
  
  use allglobal, only : ncpu, myid, cpus, interfacelabel, Ntz, Rij, Zij, iRbc, iZbs, iRbs, iZbc, mn
  
  use laplaces

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  INTEGER              :: iwa01aa

  INTEGER              :: ifail, ii, ij, mm, nn, imn, iwall, Nwall, Mconstraints, Ndegreefreedom, lengthintegerwork, lengthrealwork

  INTEGER, allocatable :: integerwork(:)

  REAL                 :: dmid, hmid, Rmin, Rmax, Zmin, Zmax, lRZ(1:2), px, py, sumsq

  REAL, allocatable    :: RZwall(:,:), RZmn(:), realwork(:)

  BEGIN(wa01aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  FATALMESS(wa01aa,myid.ne.0,error)
  
  open(gunit,file="wall.dat",status='old',action='read',iostat=ios)
  FATALMESS(wa01aa,ios.ne.0,error opening wall.dat)
  
  Nwall = 0
  do
   read(gunit,*,iostat=ios)lRZ(1:2)
   if( ios.ne.0 ) exit
   Nwall = Nwall + 1
  enddo
  
  close(gunit)
  
  RALLOCATE(RZwall,(1:2,1:Nwall))

  open(gunit,file="wall.dat",status='old',action='read',iostat=ios)
  FATALMESS(wa01aa,ios.ne.0,error opening wall.dat)
  
  read(gunit,*,iostat=ios) RZwall(1:2,1:Nwall) ! MUST GO ANTI-CLOCKWISE; LAST-POINT = FIRST POINT;
  FATALMESS(wa01aa,ios.ne.0,error reading RZwall from wall.dat)
  
  close(gunit)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  Rmin = minval( RZwall(1,1:Nwall) )
  Rmax = maxval( RZwall(1,1:Nwall) )
  Zmin = minval( RZwall(2,1:Nwall) )
  Zmax = maxval( RZwall(2,1:Nwall) )

  Rmid = half * ( Rmin + Rmax )
  Zmid = half * ( Zmin + Zmax )

  dmid = minval( sqrt( (RZwall(1,1:Nwall)-Rmid)**2 + (RZwall(2,1:Nwall)-Zmid)**2 ) ) / 2**4 ; hmid = dmid* half
  
  write(ounit,1000) myid, Nwall, Rmin, Rmax, Zmin, Zmax, Rmid, Zmid, dmid, phiwall

1000 format("wa01aa : " 10x " : myid="i3" ; Nwall="i9" ; Rmin="f9.4" ; Rmax="f9.4" ; Zmin="f9.4" ; Zmax="f9.4" ; Rmid="f9.4" ; Zmid="f9.4" ; dmid="f9.4" ; phiwall="f9.6" ;")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  Nintervals = Nwall-1 + 4
  
!             boundary points  +   nodes   + repeated point + inner boundary + inner nodes
  Nsegments =      Nwall       + (Nwall-1) +         1      +      5         +      4
  
  RALLOCATE(xpoly,(1:Nsegments))
  RALLOCATE(ypoly,(1:Nsegments))

  RALLOCATE(phi,(1:Nintervals)) ! must set to boundary value of phi;
  RALLOCATE(phid,(1:Nintervals)) ! can leave this as zero;
  
  IC = Nintervals + 1

  NP4 = Nintervals + 4
  NP1 = Nintervals + 1

  RALLOCATE(CC,(1:IC,1:NP4))

  RALLOCATE(ICINT,(1:NP1))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  iwall = 0
  
  do ii = 1, Nwall-1
   iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii)
   iwall = iwall + 1 ; xpoly(iwall) = half * ( RZwall(1,ii) + RZwall(1,ii+1) ) ; ypoly(iwall) = half * ( RZwall(2,ii) + RZwall(2,ii+1) ) ! nodes;
  enddo
     ii =    Nwall
   iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii) ! last point must coincide with first;
   iwall = iwall + 1 ; xpoly(iwall) =          RZwall(1,ii)                    ; ypoly(iwall) =          RZwall(2,ii) ! repeated point; indicates end of outer boundary;

  iwall = iwall + 1 ; xpoly(iwall) = Rmid + dmid ; ypoly(iwall) = Zmid
  iwall = iwall + 1 ; xpoly(iwall) = Rmid + hmid ; ypoly(iwall) = Zmid - hmid ! node;
  iwall = iwall + 1 ; xpoly(iwall) = Rmid        ; ypoly(iwall) = Zmid - dmid
  iwall = iwall + 1 ; xpoly(iwall) = Rmid - hmid ; ypoly(iwall) = Zmid - hmid ! node;
  iwall = iwall + 1 ; xpoly(iwall) = Rmid - dmid ; ypoly(iwall) = Zmid
  iwall = iwall + 1 ; xpoly(iwall) = Rmid - hmid ; ypoly(iwall) = Zmid + hmid ! node;
  iwall = iwall + 1 ; xpoly(iwall) = Rmid        ; ypoly(iwall) = Zmid + dmid
  iwall = iwall + 1 ; xpoly(iwall) = Rmid + hmid ; ypoly(iwall) = Zmid + hmid ! node;
  iwall = iwall + 1 ; xpoly(iwall) = Rmid + dmid ; ypoly(iwall) = Zmid

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  DEALLOCATE( RZwall )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wwa01aa ) then
   cput = MPI_WTIME()
   do ii = 1, iwall ; write(ounit,'("wa01aa : "f10.2" : myid="i3" : Nsegments="i9" ; ii="i9" ; R="f15.9" ; Z="f15.9" ;")')cput-cpus, myid, Nsegments, ii, xpoly(ii), ypoly(ii)
   enddo
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  stage1   = .true.  ! preparation;
  exterior = .false. ! interior domain;
  dorm     = .true.  ! Dirichlet;
  px = xpoly(1)      ! only required for stage two
  py = ypoly(1)      ! only required for stage two
  alpha = zero

  phi(      1:Nwall-1) = one  ! outer boundary;
  phi(Nwall  :Nwall+3) = zero ! inner boundary;

  ifail = 0

  call D03EAF( stage1, exterior, dorm, Nintervals, px, py, xpoly, ypoly, Nsegments, phi, phid, alpha, CC, IC, NP4, ICINT, NP1, ifail )
  
  cput = MPI_WTIME()
  select case( ifail )
  case( 0 ) ; if( Wwa01aa ) write(ounit,'("wa01aa : "f10.2" : myid="i3" : stage1="L2" ; ifail="i3" ; success ;          ")')cput-cpus, myid, stage1, ifail
  case( 1 ) ;               write(ounit,'("wa01aa : "f10.2" : myid="i3" : stage1="L2" ; ifail="i3" ; invalid tolerance ;")')cput-cpus, myid, stage1, ifail
  case( 2 ) ;               write(ounit,'("wa01aa : "f10.2" : myid="i3" : stage1="L2" ; ifail="i3" ; incorrect rank ;   ")')cput-cpus, myid, stage1, ifail
  case default
   FATALMESS(wa01aa,.true.,invalid ifail returned by D03EAF)
  end select
  

  stage1 = .false. ; originalalpha = alpha

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  Mconstraints   = Ntz + mn-1
  Ndegreefreedom = mn  + mn-1
  
  RALLOCATE(RZmn,(1:Ndegreefreedom))

  RZmn(   1:mn     ) = iRbc(Nvol,1:mn) ! set initial guess;
  RZmn(mn+1:mn+mn-1) = iZbs(Nvol,2:mn)

  lengthintegerwork = 1
  IALLOCATE(integerwork,(1:lengthintegerwork))
  
  lengthrealwork = 7 * Ndegreefreedom + Ndegreefreedom * Ndegreefreedom + 2 * Mconstraints * Ndegreefreedom + 3 * Mconstraints + Ndegreefreedom * (Ndegreefreedom-1) / 2
  RALLOCATE(realwork,(1:lengthrealwork))
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  niterations = 0
  
  ifail = 1
  
  call E04FDF( Mconstraints, Ndegreefreedom, RZmn(1:Ndegreefreedom), sumsq, integerwork(1:lengthintegerwork), lengthintegerwork, realwork(1:lengthrealwork), lengthrealwork, ifail)

  cput = MPI_WTIME()
  select case( ifail ) !                                                        1234567890123456789012
  case(   0 ) ;               write(ounit,1001)cput-cpus,myid,niterations,sumsq,ifail,"success ;             "
  case(   1 ) ;               write(ounit,1001)cput-cpus,myid,niterations,sumsq,ifail,"input error ;         "
  case(   2 ) ;               write(ounit,1001)cput-cpus,myid,niterations,sumsq,ifail,"try restart ;         "
  case(   3 ) ;               write(ounit,1001)cput-cpus,myid,niterations,sumsq,ifail,"could not find lower ;"
  case(   4 ) ;               write(ounit,1001)cput-cpus,myid,niterations,sumsq,ifail,"internal SVD failed ; "
  case( 5:8 ) ;               write(ounit,1001)cput-cpus,myid,niterations,sumsq,ifail,"some doubt ;          "
  case default
   FATALMESS(wa01aa,.true.,invalid ifail returned by C05NBF)
  end select
  
1001 format("wa01aa : "f10.2" : myid="i3" : niterations="i9" ; sumsq="es13.5" ; E04FDF ; ifail="i3" ; "a22)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  DEALLOCATE(xpoly)
  DEALLOCATE(ypoly)
  DEALLOCATE(phi)
  DEALLOCATE(phid)
  DEALLOCATE(CC)
  DEALLOCATE(ICINT)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  iwa01aa = ifail ! return error flag;

  if( ifail.ne.0 ) goto 9999 ! iRbc, iZbs are unchanged;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  open(gunit,file="wall.new",status='unknown')
  write(gunit,'(2es23.15)') ( Rij(0,ij), Zij(0,ij), ij = 1,Ntz )
  write(gunit,'(2es23.15)')   Rij(0, 1), Zij(0, 1)
  close(gunit)
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  iRbc(Nvol,1:mn) = RZmn(1:mn) ; iZbs(Nvol,2:mn) = RZmn(mn+1:mn+mn-1)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  DEALLOCATE(RZmn)

  DEALLOCATE(integerwork)
  DEALLOCATE(realwork)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(wa01aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine wa01aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine lsfun1( Mconstraints, Ndegreefreedom, RZmn, FVECC )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, one, pi2
  
  use inputlist, only : Wwa01aa, phiwall, Nvol

  use fileunits, only : ounit

  use cputiming, only : Twa01aa
  
  use allglobal, only : ncpu, myid, cpus, Ntz, Rij, Zij, iRbc, iZbs, mn, interfacelabel, ofmn
  
  use laplaces

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS
  
  INTEGER :: Mconstraints, Ndegreefreedom, ij, Lcurv, lvol
  REAL    :: RZmn(1:Ndegreefreedom), fvecc(1:Mconstraints), px, py, lss

  INTEGER :: ifail

  BEGIN(wa01aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  niterations = niterations + 1 

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! construct array of points; probably need to include more constraints that degrees of freedom; will need another NAG routine;
  
  iRbc(Nvol,1:mn) = RZmn(1:mn) ; iZbs(Nvol,2:mn) = RZmn(mn+1:mn+mn-1)

  lvol = Nvol ; lss = interfacelabel(Nvol) ; Lcurv = 0 ! return geometry of outer boundary; will need metric elements to compute normal;
  
  WCALL(wa01aa,co01aa,( lvol, lss, Lcurv, Ntz )) ! will need Rij(0:3,:) & Zij(0:3), sg(0,:) and gij(1:6,0,:);

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do ij = 1, Ntz
   
   alpha = originalalpha ; px = Rij(0,ij) ; py = Zij(0,ij) ! these are returned by co01aa;
   
   ifail = 1
   
   call D03EAF( stage1, exterior, dorm, Nintervals, px, py, xpoly, ypoly, Nsegments, phi, phid, alpha, CC, IC, NP4, ICINT, NP1, ifail )
   
   cput = MPI_WTIME()
   select case( ifail )
   case( 0 ) ; if( Wwa01aa ) write(ounit,'("wa01aa : "f10.2" : myid="i3" : stage1="L2" ; ifail="i3" ; success ;          ")')cput-cpus, myid, stage1, ifail
   case( 1 ) ;               write(ounit,'("wa01aa : "f10.2" : myid="i3" : stage1="L2" ; ifail="i3" ; invalid tolerance ;")')cput-cpus, myid, stage1, ifail
   case( 2 ) ;               write(ounit,'("wa01aa : "f10.2" : myid="i3" : stage1="L2" ; ifail="i3" ; incorrect rank ;   ")')cput-cpus, myid, stage1, ifail
   case default
    FATALMESS(wa01aa,.true.,invalid ifail returned by D03EAF)
   end select
   
   fvecc(ij) = alpha - phiwall
  
  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! construct spectral condensation constraints;
  
  WCALL(wa01aa,sw03aa,( mn, iRbc(Nvol,1:mn), iZbs(Nvol,1:mn), ofmn(1:mn) ))
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  fvecc(Ntz+1:Ntz+mn-1) = ofmn(2:mn)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! if( Wwa01aa ) then

   cput = MPI_WTIME()
   write(ounit,'("lsfun1 : "f10.2" : myid="i3" ; niterations="i9" ; sumsq="es13.5" ;")')cput-cpus,myid,niterations,sum(fvecc(1:Mconstraints)**2) 

! endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  return

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine lsfun1

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
