!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Main program.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! uppercase generally indicates macros;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

program xspech

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, one, two, half, ten, pi2

  use numerical, only : vsmall, sqrtmachprec

  use fileunits, only : ounit, aunit, zunit

  use inputlist, only : Wxspech, ext, &
                        compilationdate,                                                   &
                        Lgeometry, Nvol,                                                   & !
                        Mpol, Ntor, Nofe, Ni,                                              & ! numerical resolution, . . .
                        Lconstraint, helicity,                                             & !
                        pressure, pscale, Ladiabatic, adiabatic, gamma,                    & ! for initializing adiabatic constants;
                        Lvacuum, maxfbits, Lwall, phiwall, Linitialize,                    & ! 
                        Lminimize, Lfindzero,                                              & ! selection of non-linear solver;
                        beta, forceerr, normalerr,                                         & ! these are output;
                        nPpts, nPtrj, Nunstable, dunstable, Munstable,                     & ! controls resolution of Poincare plot; 
                        pqs, pqt,                                                          & ! if nPpts gt 0 then will construct Poincare plot;
                        Nghd, Mpqits, npq,                                                 & ! if Mpqits gt 0 then periodic orbits (and ghost-surfaces) will be constructed;
                        Lwrpj, Lcurlerr,                                                   & !
                        absreq, relreq,                                                    &
                        LHessian, LHevalues, LHevectors,                                   &
                        Lvacuum, Rbc, Zbs, Rbs, Zbc, Nfp

  use cputiming, only : Txspech

  use allglobal, only : readin, writin,                                                    & 
                        ncpu, myid, cpus,                                                  &
                        LCondenseSpectrum,                                                 &
                        mn, im, in, Ntz, Ngdof,                                            &
                        Iquad,                                                             &
                        iRbc, iZbs, iRbs, iZbc, mIomn, mBomn,                              &
                        Iwrpj, iqfmin,                                                     &
                        lBBintegral, lABintegral, lvolume, iexvol,                         &
                        Rmin, Rmax, Zmin, Zmax,                                            &
                        Lcoordinatesingularity, Louterboundarynormal, Bnserror,            &
                        dpflux, Lmgridexist, nFreeIterations, Lcontinueiterations,         & ! 18 Oct 12;
                        looperr,                                                           & ! 21 Oct 12;
                        nflux, interfacelabel

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  LOGICAL              :: Lderiv

  INTEGER              :: lvol, llmodnp, ifail, wflag, iflag, mm, nn, imn, iwa00aa, Lcurv
  REAL                 :: rflag, lcpu, lss
  REAL,    allocatable :: position(:), gradient(:)

  CHARACTER            :: packorunpack

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  MPISTART
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! COMPILATION ! this line is replaced during compilation with a write statement identifying date, time, compilation flags, etc.; see Makefile;
  
! if(myid.eq.0) call A00AAF() ! check NAG version; ! 23 Oct 12;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  cpus = MPI_WTIME() ; cpuo = cpus
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
#ifdef DEBUG
  if( myid.eq.0 ) then
   write(ounit,'("xspech : " 10x " : ")')
   write(ounit,'("xspech : "f10.2" : compilation flag -D DEBUG recognized ;")')cpus-cpus
  endif
#endif
  
#ifdef TESTING
  if( myid.eq.0 ) then
   write(ounit,'("xspech : " 10x " : ")')
   write(ounit,'("xspech : "f10.2" : compilation flag -D TESTING recognized ;")')cpus-cpus
  endif
#endif
  
  if( myid.eq.0 ) then
   write(ounit,'("xspech : " 10x " : ")')
   write(ounit,'("xspech : "f10.2" : begin execution ; ncpu="i3" ; calling readin ;")')cpus-cpus,ncpu
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \subsubsection{workflow}

!latex \item The input namelists and geometry are read in via a call to \verb+readin+. A full description of the required input is given in \verb+globals+.
  
  WCALL(xspech,readin)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The global memory is allocated in \verb+al00aa+.

  WCALL(xspech,al00aa)
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  looperr = one ! perhaps it is better to initialize this in al00aa; 23 Oct 12;

  if( myid.eq.0 ) then ! prepare ``convergence evolution'' output; save restart file;

   open(zunit,file="."//trim(ext)//".convergence",status="unknown",form="unformatted")
   write(zunit)mn, Nvol
   write(zunit)im(1:mn)
   write(zunit)in(1:mn)
   call flush(zunit)

   wflag=0 ; iflag=0 ; rflag=zero
   WCALL(xspech,writin,(wflag,iflag,rflag)) ! write restart file; save initial input; if wflag.gt.0 information is written to zunit = .ext.convergence

  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item The boundary is adapted to the wall, if \verb+Lwall.eq.1+.
  
  if( Lwall.ne.0 ) then
   
   FATALMESS(xspech,Lvacuum.eq.0,should not change outer boundary in fixed boundary case)
   
   if( myid.eq.0 ) then
    
    WCALL(xspech,wa00aa,(iwa00aa)) ! construct surface between plasma boundary and wall; 24 Oct 12;
    
   !select case( Lwall ) ! 24 Oct 12;
   !case( -2 ) ; WCALL(xspech,wa00aa,(iwa00aa)) ! construct surface between plasma boundary and wall; 24 Oct 12; ! 24 Oct 12;
   !case( -1 ) ; WCALL(xspech,wa00aa,(iwa00aa)) ! construct surface outside                     wall; 24 Oct 12; ! 24 Oct 12;
   !case(  1 ) ; WCALL(xspech,wa00aa,(iwa00aa)) ! construct surface  inside                     wall; 24 Oct 12; ! 24 Oct 12;
   !case default ! 24 Oct 12;
   ! FATALMESS(xspech,.true.,invalid Lwall) ! 24 Oct 12;
   !end select ! 24 Oct 12;
    
   !cput = MPI_WTIME()
   !write(ounit,'("xspech : "f10.2" : myid="i3" : constructed outer boundary; Lwall="i3" ; phiwall="es13.5" ; iwa00aa="i3" ;")')cput-cpus,myid,Lwall,phiwall,iwa00aa
    
   endif ! end of if( myid.eq.0 );
   
   IlBCAST(iwa00aa,1,0)

   FATALMESS(xspech,iwa00aa.ne.0,failed to construct computational boundary)
   
   if( iwa00aa.eq.0 ) then
    RlBCAST(iRbc(Nvol,1:mn),mn,0) ! this was updated in wa00aa/wa01aa/. . .
    RlBCAST(iZbs(Nvol,1:mn),mn,0) ! this was updated in wa00aa/wa01aa/. . .
    RlBCAST(iRbs(Nvol,1:mn),mn,0) ! this was updated in wa00aa/wa01aa/. . .
    RlBCAST(iZbc(Nvol,1:mn),mn,0) ! this was updated in wa00aa/wa01aa/. . .
    do imn = 1, mn ; mm = im(imn) ; nn = in(imn) / Nfp ; Rbc(nn,mm) = iRbc(Nvol,imn) ; Zbs(nn,mm) = iZbs(Nvol,imn) ! update boundary;
     ;                                                   Rbs(nn,mm) = iRbs(Nvol,imn) ; Zbc(nn,mm) = iZbc(Nvol,imn)
    enddo
   endif ! end of if( iwa00aa.eq.0 );
   
  !Lwall = 0 !latex \item The input parameter, \verb+Lwall+, is set \verb+Lwall=0+. This is so that the `restart' file will not re-compute the wall.
      
  endif ! end of if( Lwall.ne.0 );

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  select case( Linitialize ) ! NOTE THAT THIS COMES AFTER CONSTRUCTION OF OUTERMOST INTERFACE IF LWALL.NE.0; 24 Oct 12;
   
  case( 0 ) ! initial guess for geometry of the interior surfaces is given in the input file;
  case( 1 ) ! initialize internal geometry using regular extrapolation; the Fourier harmonics of the interior interfaces are not required;
   
   do lvol = 1, Nvol-1
    iRbc(lvol,1:mn) = iRbc(Nvol,1:mn) * nflux(lvol)**(im(1:mn)*half) ! nflux = normalized toroidal flux;
    iZbs(lvol,2:mn) = iZbs(Nvol,2:mn) * nflux(lvol)**(im(2:mn)*half) ! nflux = normalized toroidal flux;
    iRbs(lvol,2:mn) = iRbs(Nvol,2:mn) * nflux(lvol)**(im(2:mn)*half) ! nflux = normalized toroidal flux;
    iZbc(lvol,1:mn) = iZbc(Nvol,1:mn) * nflux(lvol)**(im(1:mn)*half) ! nflux = normalized toroidal flux;
   enddo
   
  case default
   
   FATALMESS(readin,.true.,invalid Linitialize)
   
  end select

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( myid.eq.0 ) then ! prepare ``convergence evolution'' output; save restart file;

   wflag=0 ; iflag=0 ; rflag=zero
   WCALL(xspech,writin,(wflag,iflag,rflag))

  endif
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Lvacuum.ne.0 ) then ! 10 Oct 12; will always require mgrid interpolation;

   WCALL(xspech,mg00aa) ! read in mgrid data and interpolate using ezspline; this will set Lmgridexist = .true. is successful; otherwise Lmgridexist = .false. is default;

  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
    
!latex \item The basis functions on radial sub-sub-grid, arrays \verb+fel(0:Nofe,1:Nj)+, \verb+fer(0:Nofe,1:Nj)+, are evaluated via a call to \verb+fe00aa+.

  WCALL(xspech,fe00aa,( Iquad ))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item If \verb+Lgeometry.ge.4 .and. lswmin(1)+, then the interface harmonics are converted to spectrally condensed angle via a call to \verb+sw00ac+.
!latex       Recall that the logical array \verb+lsmin(1:3)+ is determined by \verb+Iswmin+ given as input.
  
  if( Lgeometry.ge.4 .and. LCondenseSpectrum ) then 
   
   do lvol = 1, Nvol
    
    if( myid.ne.modulo(lvol-1,ncpu) ) cycle
    
    WCALL(xspech,sw00ac,( mn, Ntz, iRbc(lvol,1:mn), iZbs(lvol,1:mn) ))
    
   enddo
   
   do lvol = 1, Nvol
    
    llmodnp = modulo(lvol-1,ncpu)
    
    RlBCAST(iRbc(lvol,1:mn),mn,llmodnp)
    RlBCAST(iZbs(lvol,1:mn),mn,llmodnp)
    
   enddo
   
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RALLOCATE(position,(1:Ngdof)) ! position ; Ngdof was computed in readin; this assumes the outer boundary is fixed;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! FREE BOUNDARY ITERATION LOOP;

  nFreeIterations = -1

9000 nFreeIterations = nFreeIterations + 1

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Ngdof.gt.0 ) then    
   packorunpack = 'P' ; WCALL(xspech,gf00aa,( Ngdof, position(1:Ngdof), Nvol, mn, iRbc(1:Nvol-1,1:mn), iZbs(1:Nvol-1,1:mn), packorunpack )) ! pack geometry into vector;
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Initialize adiabatic constants.
  
  do lvol = 1, Nvol
   
   WCALL(xspech,vo00aa,( lvol )) ! compute volume;
   
   if( Ladiabatic.eq.0 ) adiabatic(lvol) = pressure(lvol) * lvolume(lvol)**gamma ! initialize adiabatic constants using supplied pressure profile;
   
  enddo ! end of do lvol = 1, Nvol;
  
  if( Wxspech .and. myid.eq.0 ) then ; cput = MPI_WTIME() ; write(ounit,'("xspech : "f10.2" : adiabatic constants = "99es13.5)')cput-cpus,adiabatic(1:Nvol)
  endif
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Ngdof .gt. 0 ) then !latex \item The following routines are called only if geometrical degrees of freedom exist; \begin{itemize}
   
   Iwrpj = .false.
   
!latex \item if \verb+Lminimize.eq.1+, call \verb+pc00aa+ to find minimum of energy functional using quasi-Newton, preconditioned conjugate gradient method, \verb+E04DGF+;
   if( Lminimize.eq.1 ) then
    WCALL(xspech,pc00aa,( Nvol, mn, Ngdof, position(1:Ngdof), ifail ))
   endif
   
!latex \item if \verb+Lminimize.eq.2+, call \verb+pc01aa+ to find minimum of energy functional using ``home-spun'' non-linear conjugate gradient method;
   if( Lminimize.eq.2 ) then
    WCALL(xspech,pc01aa,( Nvol, mn, Ngdof, position(1:Ngdof) )) ! SHOULD INCLUDE IFAIL ARGUMENT FOR CONSISTENCY;
   endif
   
!latex \item if \verb+Lminimize.eq.4+, call \verb+pc02aa+ to find minimum of energy functional using using modified Newton method, \verb+E04LYF+; under construction;
   if( Lminimize.eq.4 ) then
    WCALL(xspech,pc02aa,( Nvol, mn, Ngdof, position(1:Ngdof), ifail ))
   endif
   
!latex \item If \verb+Lfindzero.gt.0+, call \verb+jk03aa+ to find extremum of energy function using a Newton method, \verb+C05PDF+;
   if( Lfindzero.gt.0 ) then
    ifail = 1
    WCALL(xspech,jk03aa,( Ngdof, position(1:Ngdof), ifail ))
   endif
   
   packorunpack = 'U' ; WCALL(xspech,gf00aa,( Ngdof, position(1:Ngdof), Nvol, mn, iRbc(1:Nvol-1,1:mn), iZbs(1:Nvol-1,1:mn), packorunpack )) ! unpack;
   
  endif !latex \end{itemize}

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set/reset input variables;
  
  if( Lconstraint.lt.2 ) helicity(1:Nvol) = lABintegral(1:Nvol) ! updated ``input'' quantity;

  pressure(1:Nvol) = adiabatic(1:Nvol) / lvolume(1:Nvol)**gamma ! this matches construction of adiabatic above;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following are diagnostics; set appropriate flags;
  
  Iwrpj = Lwrpj ! cb00aa (which is called by fc02aa, which is called by jk03aa) will write the pressure-jump files, depending on input flag Lwrpj;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item The Beltrami fields in each annulus are calculated by a call to \verb+fc02aa+.
  
  RALLOCATE(gradient,(1:Ngdof))
  
  Lderiv = .false.
  WCALL(xspech,fc02aa,( Ngdof, position(1:Ngdof), gradient(1:Ngdof), Lderiv )) ! re-calculate Beltrami fields;
  
  DEALLOCATE(gradient)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  do lvol = 1, Nvol

   if( myid.ne.modulo(lvol-1,ncpu) ) cycle ! the construction of the vector potential is distributed over cpus;

   WCALL(xspech,ra00aa,(lvol,'W')) ! this writes doAt,doAz to file;

  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( myid.eq.0 ) then
   
   cput = MPI_WTIME()
   
   if( Nvol.gt.2 ) then
    ;                    write(ounit,'("xspech : "f10.2" : "8x " |f|="es12.5" : |B|="999f6.2)')cput-cpus,forceerr,mBomn(1:Nvol-1)
    if( Lgeometry.ge.4 ) write(ounit,'("xspech : " 10x " : "8x "     "  12x " : |I|="999f6.2)')                   mIomn(1:Nvol-1)
   endif
   
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Various diagnostic routines are then called: \begin{enumerate}
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item If \verb+Mpqits.gt.0 .and. npq(lvol).gt.0+ then the periodic orbits in the $l$-th annulus are located via a call to \verb+pq01aa+.
!latex \item If also \verb+Nghd.gt.0+ then the quadratic-flux minimizing surfaces are constructed via a call to \verb+pq02aa+.
  
  if( Mpqits.gt.0 ) then

   do lvol = 1, Nvol
    
    if( myid.ne.modulo(lvol-1,ncpu) ) cycle ! diagnostic calculations are performed in parallel;
    
    if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ; Lcoordinatesingularity = .false. ! either Cartesian geometry or annular volume; used elsewhere;
    else                                                         ; Lcoordinatesingularity = .true.
    endif
    
    if( Lvacuum.ne.0 .and. lvol.eq.Nvol                   ) then ; Louterboundarynormal   = .true.
    else                                                         ; Louterboundarynormal   = .false.
    endif
    
    if( npq(lvol).gt.0 ) then
                            iqfmin=0 ; WCALL(xspech,pq01aa,( lvol )) ! construct periodic orbits;
     if( Nghd.gt.0 ) then ; iqfmin=1 ; WCALL(xspech,pq02aa,( lvol )) ! construct QFMin surfaces;
     endif
    endif

   enddo
   
  endif
  
  do lvol = 1, Nvol ! broadcast periodic orbits;

   llmodnp = modulo(lvol-1,ncpu) ! identify which node contains data; this must be consistent with above looping / parallelization;

   RlBCAST(pqs(lvol),1,llmodnp)
   RlBCAST(pqt(lvol),1,llmodnp)

  enddo
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  WCALL(xspech,fb00aa) ! 10 Oct 12; compute tangential field on interfaces; required for virtual casing; includes do-lvol-parallization loop; includes do innout = 0, 1 loop;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  Lcontinueiterations = .false. ! this may be set in bn00aa; 18 Oct 12;

  looperr = one ! this is probably redundant; 23 Oct 12;
  
!#ifdef DEBUG ! 23 Oct 12;
!  write(ounit,'("xspech : " 10x " : Rbc=",99es13.5)')iRbc(Nvol,1:mn) ! 23 Oct 12;
!  write(ounit,'("xspech : " 10x " : Zbs=",99es13.5)')iZbs(Nvol,1:mn) ! 23 Oct 12;
!  lss = interfacelabel(Nvol) ; Lcurv = 1 ; Lcoordinatesingularity = .false. ! 23 Oct 12; ! 23 Oct 12;
!  WCALL(xspech,co01aa,( Nvol, lss, Lcurv, Ntz )) ! 23 Oct 12; ! 23 Oct 12;
!#endif ! 23 Oct 12;
  
  if( Lvacuum.ge.2 .and. Lmgridexist ) then ! 23 Oct 12;
   
   WCALL(xspech,bn00aa,( mn, Ntz )) ! compute normal field etc. on computational boundary;
      
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( myid.eq.0 ) then ! WRITE RESTART FILE;

   wflag=0 ; iflag=0 ; rflag=zero
   WCALL(xspech,writin,(wflag,iflag,rflag)) ! write restart file; save initial input;

  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Lcontinueiterations ) goto 9000 ! this may be set in bn00aa; 18 Oct 12;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( myid.eq.0 ) then
   
   close(zunit)
   
   cput = MPI_WTIME()
   write(ounit,'("xspech : " 10x " :")')
   write(ounit,'("xspech : "f10.2" : myid="i3" : restart file closed ;")')cput-cpus,myid
   
  endif


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! volume, beta & FF are calculated by vo00aa, which is called by fc02aa, which is called above in xspech;

  if( myid.eq.0 ) then ! 16 Oct 12;
   
   cput = MPI_WTIME() ! 16 Oct 12;
   write(ounit,'("xspech : " 10x " : ")')
   write(ounit,'("xspech : "f10.2" : myid="i3" ; sum volumes="es12.5" ; beta="es12.5" ;")')cput-cpus,myid,sum(lvolume(1:Nvol-iexvol)),beta ! 16 Oct 12;
   
   if( Wxspech .and. myid.eq.0 ) then
    write(ounit,'("xspech : "f10.2" : myid="i3" ; V _l="99es23.15" ;")')cput-cpus,myid,   lvolume(  1:Nvol)
    write(ounit,'("xspech : "f10.2" : myid="i3" ; BB_l="99es23.15" ;")')cput-cpus,myid,lBBintegral(1:Nvol)
    write(ounit,'("xspech : "f10.2" : myid="i3" ; AB_l="99es23.15" ;")')cput-cpus,myid,lABintegral(1:Nvol)
   endif

  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item If \verb+LHessian+ then the parallel construction of the force-derivative matrix is compared with a series construction in \verb+he01aa+.
!latex       If \verb+LHevalues+ then the eigenvalues of the force-derivative matrix (quasi-Hessian) are computed via a call to \verb+he01aa+.
!latex       If \verb+LHevectors+ then the eigenvalues and eigenvectors of the force-derivative matrix (quasi-Hessian) are computed via a call to \verb+he01aa+.
  
  if( LHessian .or. LHevalues .or. LHevectors ) then

   if( myid.eq.0 ) write(ounit,'("xspech : "10x" : myid="i3" ; calling he01aa ;")')myid

   WCALL(xspech,he01aa,( Ngdof, position(1:Ngdof) ))

  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item if \verb+Lcurlerr+ then call \verb+jo00aa+ : computes ${\bf j} = \nabla \times {\bf B}$ and measures error in ${\bf j} = \mu {\bf B}$;
  
  if( Lcurlerr ) then
   
   do lvol = 1, Nvol
    
    if( myid.ne.modulo(lvol-1,ncpu) ) cycle
    
    WCALL(xspech,jo00aa,( lvol, Ntz )) ! depends on Rij(0:9,1:Ntz), Zij(0:9,1:Ntz), sg(0:3,1:Ntz), gij(1:6,0:3,1:Ntz);
    
   enddo ! end of do lvol = 1, Nvol;
   
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item If \verb+nPpts.gt.0+ then the \Poincare plot in each annulus is constructed via a call to \verb+pp00aa+.
  
  if( nPpts.gt.0 .or. Munstable.gt.0 ) then
   
   if( myid.eq.0 ) then
    cput = MPI_WTIME()
    write(ounit,'("xspech : " 10x " :")')
    write(ounit,1001)cput-cpus,myid,Nunstable,dunstable,Munstable,nPpts!,nPtrj(1:Nvol)
   endif
   
1001 format("xspech : "f10.2" : myid="i3" ; Poincare plot ; BEWARE CHANGED FORMAT Sep 2012 ; Nunstable="i6"; dunstable="es8.1"; Munstable="i4"; nPpts="i6";":" nPtrj="99(i5","))
   
   do lvol = 1, Nvol
    
    if( myid.ne.modulo(lvol-1,ncpu) ) cycle ! diagnostic calculations are performed in parallel;
    
    if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ; Lcoordinatesingularity = .false. ! either Cartesian geometry or annular volume; used elsewhere;
    else                                                         ; Lcoordinatesingularity = .true.
    endif
    
    if( Lvacuum.ne.0 .and. lvol.eq.Nvol                   ) then ; Louterboundarynormal   = .true.
    else                                                         ; Louterboundarynormal   = .false.
    endif
    
    iqfmin = 0 ; WCALL(xspech,pp00aa,( lvol )) ! Poincare plots in each volume
    
   enddo ! end of do lvol = 1, Nvol;
   
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \item If \verb+Lwrpj+ then force balance across the interfaces is confirmed using \verb+ph01aa+.
!latex       If \verb+nPpts.gt.0+, \verb+ph01aa+ will also construct the \Poincare plots for pressure-jump Hamiltonian at each interface.
  
  if( Lwrpj ) then
   
   do lvol = 1, Nvol
    
    if( myid.ne.modulo(lvol-1,ncpu) ) cycle ! diagnostic calculations are performed in parallel;
    
    if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ; Lcoordinatesingularity = .false. ! either Cartesian geometry or annular volume; used elsewhere;
    else                                                         ; Lcoordinatesingularity = .true.
    endif
    
    if( Lvacuum.ne.0 .and. lvol.eq.Nvol                  ) then ; Louterboundarynormal   = .true.
    else                                                         ; Louterboundarynormal   = .false.
    endif
    
    WCALL(xspech,ph01aa,( lvol ))
    
   enddo ! end of do lvol = 1, Nvol;
   
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \end{enumerate} % \item Various diagnostic routines are then called: \begin{enumerate}
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
9999 continue

  WCALL(xspech,finished)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  stop
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end program xspech

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Print timing, close mpi, finish.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine finished
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero

  use fileunits, only : ounit

  use inputlist, only : ext, Ltiming, Lconstraint

  use cputiming

  use allglobal, only : myid, cpus

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS
  
  REAL      :: Ttotal
  CHARACTER :: date*8, time*10
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  cput = MPI_WTIME()
  
! SUMTIME !  this is expanded by Makefile, and then again by macros; do not remove;

  cput = MPI_WTIME()
  
  if( Ltiming .and. myid.eq.0 ) then

   Ttotal = zero
   
   if( Lconstraint.gt.0                      ) then
   ma02aaT = ma02aaT - mp00acT - ma01agT - tr00abT ! ma02aa may call  ma02aa via the NAG routine C05PBF; and ma02aa calls ma01ag, tr00ab,
   endif
   ma02aaT = ma02aaT - df00aaT                     ! ma02aa may call  df00aa via the NAG routine C05PBF;
   pp00aaT = pp00aaT - bf00aaT                     ! pp00aa     calls bf00aa via the NAG routine D02BJF;

! PRTTIME ! this is expanded by Makefile, and then again by macros; do not remove;
   write(ounit,'("finish : "f10.2" : time spent in writin ="f10.2" ;")')cput-cpus,Twritin ; Ttotal = Ttotal + Twritin
   write(ounit,'("finish : "f10.2" : time spent in readin ="f10.2" ;")')cput-cpus,Treadin ; Ttotal = Ttotal + Treadin

   write(ounit,'("finish : "f10.2" : Ttotal ="f10.2" s = "f8.2" m = "f6.2" h ;")')cput-cpus, Ttotal / (/ 1, 60, 3600 /)

  endif
  
  if( myid.eq.0 ) then 
   call date_and_time(date,time)
   write(ounit,'("finish : " 10x " : ")')
   write(ounit,1000)cput-cpus,myid,(cput-cpus)/(/1,60,3600/),date(1:4),date(5:6),date(7:8),time(1:2),time(3:4),time(5:6),ext
   write(ounit,'("finish : " 10x " : ")')
  endif

  MPIFINALIZE
  
1000 format("finish : "f10.2" : myid="i3" ; completion ; time="f10.2" s = "f8.1" m = "f7.2" h ; date="a4"/"a2"/"a2" , "a2":"a2":"a2" ; ext = "a60)

  stop

end subroutine finished

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
