!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
!2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
!        1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Defines input, global variables and output files.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! to set keyboard shortcut in emacs                                        

! (1) define macro         , e.g. \C-x \C-( . . . \C-x \C-)              
! (2) name macro           , e.g. Esc-x name-last-kbd-macro arbitraryname ! 11 Oct 12; 
! (3) set keyboard shortcut, e.g. Esc-x global-set-key F12 arbitraryname 

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module constants
  implicit none

  REAL, parameter :: zero     =   0.0
  REAL, parameter :: one      =   1.0
  REAL, parameter :: two      =   2.0
  REAL, parameter :: three    =   3.0
  REAL, parameter :: four     =   4.0
  REAL, parameter :: five     =   5.0
  REAL, parameter :: six      =   6.0
  REAL, parameter :: seven    =   7.0
  REAL, parameter :: eight    =   8.0
  REAL, parameter :: nine     =   9.0
  REAL, parameter :: ten      =  10.0
  REAL, parameter :: eleven   =  11.0
  REAL, parameter :: twelve   =  12.0

  REAL, parameter :: half     =  one / two
  REAL, parameter :: third    =  one / three 
  REAL, parameter :: quarter  =  one / four
  REAL, parameter :: fifth    =  one / five
  REAL, parameter :: sixth    =  one / six

  REAL, parameter :: pi2      =  6.28318530717958623
  REAL, parameter :: pi       =  pi2 / two
  REAL, parameter :: mu0      =  2.0E-07 * pi2
  REAL, parameter :: goldmean =  1.618033988749895 ! golden mean = ( one + sqrt(five) ) / two ;

end module constants

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module numerical
  implicit none
  INTEGER         :: largestint
  REAL            :: machprec, vsmall, small, sqrtmachprec ! these are assigned below in readin via a call to NAG routine;
  REAL            :: logtolerance = 1.0e-32 
end module numerical

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module fileunits
  implicit none
  INTEGER :: ounit =  0 ! output;
  INTEGER :: iunit = 10 ! input;
  INTEGER :: punit = 11 ! Poincare;
  INTEGER :: hunit = 12 ! Hessian;
  INTEGER :: qunit = 13 ! quadratic-flux minimizing surfaces;
  INTEGER :: munit = 14 ! periodic orbits;
  INTEGER :: wunit = 15 ! irrational surfaces;
  INTEGER :: funit = 16 ! force iterations;
  INTEGER :: dunit = 17 ! derivative matrix;
  INTEGER :: aunit = 18 ! vector potential;
  INTEGER :: interpolatedfieldsunit = 19 ! vector potential, coordinates, magnetic field all interpolated on a high-resolution grid
  INTEGER :: gunit = 20 ! mgrid file unit;
  INTEGER :: eunit = 21 ! for comparison with extender;
  INTEGER :: vunit = 22 ! for examination of adaptive quadrature;
  INTEGER :: bunit = 23 ! for boundary harmonics;
  INTEGER :: zunit = 24 ! for convergence;
end module fileunits

module cputiming
! CPUVARIABLE ! this is expanded by Makefile; do not remove;
  REAL :: Treadin=0.0
  REAL :: Twritin=0.0
end module cputiming

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module typedefns
  
  type subgrid
     REAL,    allocatable :: s(:)
     INTEGER, allocatable :: i(:)
  end type subgrid

end module typedefns

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module inputlist !latex \end{enumerate} \subsection{Input namelists} \begin{enumerate}
  implicit none

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  REAL               :: version = 1.00
  CHARACTER          :: compilationdate*30

!latex \item The input file, \verb+ext.spec+, where \verb+ext*100+ is given as command line input, contains the following namelists and interface geometry.
!latex       Note: if the command line input \verb+-autoin+ is given, then \verb+ext.spec+ is not required; see below for more information on command line inputs.

!SET RESOLUTION;

  CHARACTER          :: ext*100

  INTEGER, parameter :: MNvol     = 257 !latex \item The maximum value of \verb+Nvol+ is \verb+MNvol=257+.
  INTEGER, parameter :: MMpol     =  32 !latex \item The maximum value of \verb+Mpol+ is \verb+MNpol= 32+.
  INTEGER, parameter :: MNtor     =  16 !latex \item The maximum value of \verb+Ntor+ is \verb+MNtor= 16+.
! INTEGER, parameter :: Mmn       = MNtor+1 + MMpol*(2*MNtor+1)
  INTEGER, parameter :: maxgroups = 100 !latex \item The maximum number of independent coil currents is given by \verb+maxgroups=100+.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/physicslist/; note that all variables in namelist need to be broadcasted in readin;

  INTEGER :: Lgeometry                  =  6
  INTEGER :: Lstellsym                  =  1
  INTEGER :: Ltoroidal                  = -9 ! redundant; ! 10 Oct 12;
  INTEGER :: Itoroidal                  = -1 
  INTEGER :: Lfreebound                 =  0
  INTEGER :: Lvacuum                    =  0 
  INTEGER :: LVns                       =  0  ! redundant; 23 Oct 12;
  REAL    :: phiedge                    =  1.0
  REAL    :: curtor                     =  0.0
  REAL    :: extcur(maxgroups)
  REAL    :: gamma                      =  5.0 / 3.0
  INTEGER :: Nfp                        =  1
  INTEGER :: Nvol                       =  1
  INTEGER :: Mpol                       =  1
  INTEGER :: Ntor                       =  0
  INTEGER :: Ni(MNvol)                  =  2
  INTEGER :: Lconstraint                =  2
  REAL    ::     tflux(0:MNvol)         =  0.0
  REAL    ::     pflux(0:MNvol)         =  0.0
  REAL    ::  helicity(0:MNvol)         =  0.0
  REAL    :: pscale                     =  0.0
  REAL    :: pres(1:MNvol)              =  0.0 ! redundant; ! 10 Oct 12;
  REAL    ::  pressure(1:MNvol)         =  0.0
  INTEGER :: Ladiabatic                 =  0 
  REAL    :: adiab(1:MNvol)             =  0.0
  REAL    :: adiabatic(1:MNvol)         =  0.0
  REAL    :: beta                       =  0.0 ! redundant; 24 Oct 12;
  REAL    ::        mu(1:MNvol)
  INTEGER ::        pl(0:MNvol)         =  0
  INTEGER ::        ql(0:MNvol)         =  0
  INTEGER ::        pr(0:MNvol)         =  0
  INTEGER ::        qr(0:MNvol)         =  0
  REAL    ::      iota(0:MNvol)
  REAL    ::  Rbc(-MNtor:MNtor,0:MMpol) =  0.0 !     stellarator symmetric boundary components;
  REAL    ::  Zbs(-MNtor:MNtor,0:MMpol) =  0.0 !     stellarator symmetric boundary components;
  REAL    ::  Rbs(-MNtor:MNtor,0:MMpol) =  0.0 ! non-stellarator symmetric boundary components;
  REAL    ::  Zbc(-MNtor:MNtor,0:MMpol) =  0.0 ! non-stellarator symmetric boundary components;
  REAL    ::  Bns(-MNtor:MNtor,0:MMpol) =  0.0 !     stellarator symmetric normal field at boundary;
  REAL    ::  Bnc(-MNtor:MNtor,0:MMpol) =  0.0 ! non-stellarator symmetric normal field at boundary;
  REAL    ::  Vns(-MNtor:MNtor,0:MMpol) =  0.0 !     stellarator symmetric normal field at boundary; vacuum component;
  REAL    ::  Vnc(-MNtor:MNtor,0:MMpol) =  0.0 ! non-stellarator symmetric normal field at boundary; vacuum component;
  INTEGER :: Lmask                      =  1   ! under-construction;
  INTEGER :: mask(-MNtor:MNtor,0:MMpol) = -9   ! under-construction;
  REAL    :: mupftol                    =  1.0e-07
  INTEGER :: mupfits                    =  16

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/numericlist/; note that all variables in namelist need to be broadcasted in readin;

  INTEGER :: Linitialize =  0 
  INTEGER :: Lwall       =  0 
  REAL    :: phiwall     =  0.9
  INTEGER :: iextrap     =  4
  INTEGER :: Ndiscrete   =  2
  INTEGER :: Lslabel     = -9 ! redundant; ! 10 Oct 12;
  INTEGER :: Lsinterp    = -9 ! redundant; ! 10 Oct 12;
  INTEGER :: Nofe        =  2
  INTEGER :: Nquad       = -1
  INTEGER :: iMpol       = -1
  INTEGER :: iNtor       = -1
  INTEGER :: Ldmupf      = -1
  INTEGER :: Iswmin      =  0
  LOGICAL :: Lsymagl     = .false. ! redundant; ! 10 Oct 12;
  INTEGER :: Lperturb    = 0 
  REAL    :: dperturb    = 1.0e-04

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/linearlist/; note that all variables in namelist need to be broadcasted in readin;

  INTEGER :: Lbeltrami  =  1
  INTEGER :: Linitgues  =  1
  INTEGER :: Ldense     =  1
  LOGICAL :: Lposdef    = .true.
  INTEGER :: Nmaxexp    =  0
  INTEGER :: Lprecon    =  1
  INTEGER :: sparseits  = -1
  REAL    :: ssoromega  =  1.0
  REAL    :: sparsetol  = -1.0
  INTEGER :: Liotasolv  =  1

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/nonlinearlist/; note that all variables in namelist need to be broadcasted in readin;

! LOGICAL   :: Lvacuum    = .false.
  LOGICAL   :: Lc05ndf    = .false. ! redundant; ! 10 Oct 12;
  LOGICAL   :: Le04dgf    = .false. ! redundant; ! 10 Oct 12;
  INTEGER   :: Lminimize  =  0
  INTEGER   :: Lfindzero  =  0
  INTEGER   :: pwidth     =  4
  INTEGER   :: qwidth     =  4
  REAL      :: forcetol   =  1.0e-09
  REAL      :: normalerr  =  1.0e-06
  REAL      :: norblend   =  0.0
  INTEGER   :: maxfbits   = 20
  REAL      :: forceerr   =  0.0 ! redundant; 02 Nov 12;
  REAL      :: energy     =  0.0 ! redundant; 02 Nov 12;
  LOGICAL   :: Lc05pdf    = .false. ! redundant; ! 10 Oct 12;
  LOGICAL   :: Le04lyf    = .false. ! redundant; ! 10 Oct 12;
  REAL      :: xftol      = -9.0    ! redundant; ! 10 Oct 12;
  REAL      :: c05xtol    =  1.0e-09
  REAL      :: factor     = -9.0
  REAL      :: c05factor  =  1.0e-04
  INTEGER   :: ifinited   = -9 ! redundant; ! 10 Oct 12;
  INTEGER   :: Lgradient  = -9 ! redundant; ! 10 Oct 12;
  LOGICAL   :: LreadGF    = .true.
  INTEGER   :: GFsuff     =  0 ! redundant; ! 10 Oct 12;
  INTEGER   :: verify     = -1
  REAL      :: maxstep    =  1.0e-03
  REAL      :: epsilon    =  1.0e-00
  INTEGER   :: maxiter    = -1
  INTEGER   :: normalize  =  1 ! redundant; ! 10 Oct 12;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/diagnosticslist/; note that all variables in namelist need to be broadcasted in readin;

  REAL    :: odetol           =     1.0e-07
  REAL    :: absreq           =     1.0e-08
  REAL    :: relreq           =     1.0e-08
  REAL    :: absacc           =     1.0e-08
  REAL    :: divertorR        =    -1.0 ! redundant; ! 10 Oct 12;
  REAL    :: divertorZ        =     1.0 ! redundant; ! 10 Oct 12;
  INTEGER :: Lpoincare        =     0 
  INTEGER :: nPpts            =     0
  INTEGER :: nPtrj(1:MNvol+1) =    -1
  INTEGER :: Mpqits           =    10
  INTEGER :: Lpqsym           =     1
  INTEGER :: p1(1:MNvol)      =     0
  INTEGER :: q1(1:MNvol)      =     0
  INTEGER :: p2(1:MNvol)      =     0
  INTEGER :: q2(1:MNvol)      =     0
  REAL    :: pqs(1:MNvol)     =    -1.0
  REAL    :: pqt(1:MNvol)     =     0.0
  REAL    :: pqR(1:MNvol)     =    -1.0
  REAL    :: pqZ(1:MNvol)     =    -1.0
  INTEGER :: Npl              =     1
  INTEGER :: Munstable        =    10  
  REAL    :: dunstable        =     1.0e-05
  INTEGER :: Nunstable        =  1000
  INTEGER :: npq(1:MNvol)     =     0
  INTEGER :: Mirrits          =     0
  INTEGER :: irrMpol          =    50
  INTEGER :: irrNtor          =    25
  REAL    :: irrsvdcut        =     1.0e-12
  REAL    :: irrtol           =     1.0e-08
  LOGICAL :: Lwrpj            =  .false.
  INTEGER :: Nghd             =     0
  LOGICAL :: LHessian         =  .false.
  LOGICAL :: LHevalues        =  .false.
  LOGICAL :: LHevectors       =  .false.
  LOGICAL :: Lcurlerr         =  .false.
  INTEGER :: Lcheck           =     0
  LOGICAL :: Lexamine         =  .false.
  LOGICAL :: Ltiming          =  .false.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/screenlist/; note that all variables in namelist need to be broadcasted in readin;
  
! DSCREENLIST ! define screenlist; this is expanded by Makefile; DO NOT REMOVE; each file compiled by Makefile has its own write flag;
  LOGICAL :: Wreadin = .false.
  LOGICAL :: Wwritin = .false.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The (very loose) convention in naming input variables is
!latex       \begin{itemize}
!latex       \item Variables that begin with \verb+L+ serve as logical flags. These are usually integers, as integers allow more choices that simply \verb+T+ or \verb+F+.
!latex       \item Variables that begin with \verb+N+ or \verb+M+ serve as integer resolution flags.
!latex       \end{itemize}

!latex \item In the following, all default settings are shown.

!latex \end{enumerate} \subsubsection{physicslist} \begin{enumerate}

!latex \item The namelist \verb+physicslist+ controls the geometry, profiles, and numerical resolution.
!latex       \begin{itemize}
!latex       \verb+namelist/physicslist/+

  namelist/physicslist/&
 Lgeometry   ,& !latex \item \verb+Lgeometry=6 : integer+ : selects Cartesian, cylindrical or toroidal geometry;
                !latex \begin{itemize}
                !l!tex \item if \verb+Lgeometry.eq.-6+, toroidal geometry: ${\bf x}=R \; \hat {\bf R}(\z) + Z \; \hat {\bf k}$, but $R$ is considered to be a function of $Z$;
                !l!tex       this option is presently under construction;
                !latex \item if \verb+Lgeometry.eq. 1+, Cartesian geometry: ${\bf x} = \t \; \hat {\bf i} + \z \; \hat {\bf j}+ R \; \hat {\bf k}$;
                !latex \item if \verb+Lgeometry.eq. 2+, cylindrical geometry: ${\bf x} = R \; \hat {\bf r} + \z \; \hat {\bf k}$;
                !latex \item if \verb+Lgeometry.eq. 3+, toroidal geometry: ${\bf x} = (R_0 + R\cos\t) \; \hat {\bf R}(-\z) + R\sin\t \; \hat {\bf k}$;
                !latex \item if \verb+Lgeometry.eq. 4+, Cartesian geometry: under construction;
                !latex \item if \verb+Lgeometry.eq. 5+, cylindrical geometry: ${\bf x} = R \; \hat {\bf i} + Z \; \hat {\bf j} + \z \; \hat {\bf k}$;
                !latex \item if \verb+Lgeometry.eq. 6+, toroidal geometry: ${\bf x}=R \; \hat {\bf R}(\z) + Z \; \hat {\bf k}$,
                !latex \end{itemize}
                !latex where $\phi = \lambda \zeta$ is the standard cylindrical angle and $\lambda = \pm 1$,
                !latex $\hat {\bf i}$, $\hat {\bf j}$ and $\hat {\bf k}$ are the standard Cartesian basis vectors;
                !latex $\hat {\bf r} \equiv \cos \t \;\hat {\bf i} + \sin\t \; \hat {\bf j}$;
                !latex $\hat {\bf R}(\z) \equiv \cos \zeta \;\hat {\bf i} + \sin \zeta \;\hat {\bf j}$;
                !latex and $R=R(\s,\t,\z)$ and $Z=Z(\s,\t,\z)$.

 Lstellsym   ,& !latex \item \verb+Lstellsym =  1 : integer+ : enforces stellarator symmetry; under construction;
 Ltoroidal   ,& !latex \item \verb+Ltoroidal = -1 : integer+ : redundant; ! 10 Oct 12;
 Itoroidal   ,& !latex \item \verb+Itoroidal = -1 : integer+ : selects toroidal angle;
                !latex \begin{itemize}
                !latex \item the computational toroidal angle, $\zeta$, is defined as $\phi = \lambda \zeta$, where $\phi$ is the standard cylindrical angle,
                !latex and $\lambda\equiv$\verb+Itoroidal+;
                !latex \item constraint : \verb+Itoroidal = -1+ or \verb!Itoroidal = +1!;
                !latex \end{itemize}
 Lvacuum     ,& !latex \item \verb+Lvacuum = 0 : integer+ : allows for non-zero normal field at boundary;
 LVns        ,& !latex \item \verb+LVns = 0 : integer+ : indicates whether external field supplied as Fourier series; ! redundant; 23 Oct 12;
 phiedge     ,& !latex \item \verb+phiedge = 1.0 : real+ : total enclosed flux; at present, only affects the virtual casing construction of the external field;
 curtor      ,& !latex \item \verb+curtor = 0.0 : real+ : total enclosed current; presently irrelevant;
 extcur      ,& !latex \item \verb+extcur : real(1:maxgroups)+ : coil currents;
 gamma       ,& !latex \item \verb+gamma = 5.0/3.0 : real+ : adiabatic index; cannot set $|\gamma|=1$;
 Nfp         ,& !latex \item \verb+Nfp = 1 : integer+ : field periodicity;
                !latex \begin{itemize}
                !latex \item all Fourier representations are of the form $\cos(m\t-nN\z)$, where $N\equiv$\verb+Nfp+;
                !latex \item constraint : \verb+Nfp.ge.1+;
                !latex \end{itemize}
 Nvol        ,& !latex \item \verb+Nvol = 1 : integer+ : number of volumes;
                !latex \begin{itemize}
                !latex \item each volume ${\cal V}_l$ is bounded by the ${\cal I}_{l-1}$ and ${\cal I}_{l}$ interfaces;
                !latex \item note that in cylindrical or toroidal geometry, ${\cal I}_{0}$ is the degenerate coordinate axis;
                !latex \item constraint : \verb+Nvol.le.MNvol+;
                !latex \end{itemize}
 Mpol        ,& !latex \item \verb+Mpol = 1 : integer+ : poloidal resolution;
 Ntor        ,& !latex \item \verb+Ntor = 0 : integer+ : toroidal resolution;
                !latex \begin{itemize}
                !latex \item all Fourier representations of doubly-periodic functions are of the form 
                !latex \be f(\t,\z)=\sum_{n=0}^{Ntor} f_{0,n}\cos(-nN\z) + \sum_{m=1}^{Mpol}\sum_{n=-Ntor}^{Ntor} f_{m,n}\cos(m\t-nN\z),\ee
                !latex where $N\equiv$\verb+Nfp+;
                !latex \end{itemize}
 Ni          ,& !latex \item \verb+Ni=2 : integer(MNvol)+ : sub-grid resolution in each volume;
                !latex \begin{itemize}
                !latex \item constraint : \verb+Ni(1:Nvol).ge.2+; why is this?;
                !latex \end{itemize}
 Lconstraint ,& !latex \item \verb+Lconstraint=2 : integer+ : selects constraints; only relevant if \verb+Lbeltrami.eq.1, 3, 5, or 7+;
                !latex \begin{itemize}
                !latex \item if \verb+Lconstraint.eq.0+, then $\mu$ and $\psi_p$ are {\em not} varied;
                !latex in this case \verb+helicity+ and the transform (either \verb+pl+, \verb+ql+, \verb+pr+ and \verb+qr+ or \verb+iota+) are irrelevant;
                !latex \item if \verb+Lconstraint.eq.1+, then $\mu$ and $\psi_p$ are adjusted in order to satisfy the inner and outer interface transform constraints;
                !latex (except in the simple torus, where the enclosed poloidal flux is irrelevant, and only $\mu$ is varied to satisfy the outer interface transform constraint);
                !latex in this case \verb+helicity+ is irrelevant;
                !latex \item if \verb+Lconstraint.eq.2+, then $\mu$ is adjusted in order to satisfy the helicity constraint, and $\psi_p$ is held constant;
                !latex in this case the  transform (either \verb+pl+, \verb+ql+, \verb+pr+ and \verb+qr+ or \verb+iota+) is irrelevant;
                !latex \item an exeption: if SQP is used to construct the Beltrami fields, then \verb+Lconstraint+ is irrelevant
                !latex and $\mu$ will be adjusted to constrain the helicity;
                !latex \end{itemize}
 tflux       ,& !latex \item \verb+tflux : real(0:MNvol)+ : toroidal flux, $\psi_t$, enclosed by each interface;
                !latex \begin{itemize}
                !latex \item this is a constraint: \verb+tflux+ is not varied; 
                !latex \item note that \verb+tflux+ will be normalized so that \verb+tflux(l)=1+, where $l$ labels the plasma edge;
                !latex \end{itemize}
 pflux       ,& !latex \item \verb+pflux : real(0:MNvol)+ : poloidal flux, $\psi_p$, enclosed by each interface;
                !latex \begin{itemize}
                !latex \item if \verb+Lconstraint.eq.0+, then \verb+pflux+ is not varied;
                !latex \item if \verb+Lconstraint.eq.1+, then \verb+pflux+ is adjusted to satisfy interface rotational-transform constraint
                !latex (except in the innermost volume if the geometry is cylindrical or toroidal);
                !latex on entry \verb+pflux+ serves as an initial guess and is changed on output;
                !latex \item if \verb+Lconstraint.eq.2+, then \verb+pflux+ is not varied;
                !latex \end{itemize}
 helicity    ,& !latex \item \verb+helicity : real(0:MNvol)+ : helicity, ${\cal K}$, in each volume;
                !latex \begin{itemize}
                !latex \item on exit, \verb+helicity+ is set to the computed values of ${\cal K} \equiv \int {\bf A}\cdot{\bf B}\;dv$;
                !latex \end{itemize}
 pscale      ,& !latex \item \verb+pscale=0.0 : real+ : pressure scale factor;
                !latex \begin{itemize}
                !latex \item the initial pressure profile is given by \verb+pscale * press+;
                !latex \end{itemize}
 pres        ,& !latex \item \verb+pres : real(1:MNvol)+ : redundant; ! 10 Oct 12;
 pressure    ,& !latex \item \verb+pressure : real(1:MNvol)+ : pressure in each volume;
                !latex \begin{itemize}
                !latex \item the pressure is {\em not} held constant, but $p_l V_l^\gamma = P_l$ {\em is} held constant, 
                !latex where $P_l$ is determined by the initial pressures and the initial volumes, $V_l$;
                !latex \item on output, the pressure is given by $p_l= P_l/V_l^\gamma$, where $V_l$ is the final volume;
                !latex \item \verb+pressure+ is only used in calculation of interface force-balance;
                !latex \end{itemize}
 Ladiabatic  ,& !latex \item \verb+Ladiabatic=0 : integer+ : logical flag;
                !latex \begin{itemize}
                !latex \item if \verb+Ladiabatic=0+, the adiabatic constants are determined by the initial pressure and volume;
                !latex \item if \verb+Ladiabatic=1+, the adiabatic constants are determined by the given input \verb+adiabatic+;
                !latex \end{itemize}
 adiab       ,& !latex \item \verb+adiab : real(1:MNvol)+ : redundant; ! 10 Oct 12;
 adiabatic   ,& !latex \item \verb+adiabatic : real(1:MNvol)+ : adiabatic constants in each volume;
                !latex \begin{itemize}
                !latex \item the pressure is {\em not} held constant, but $p_l V_l^\gamma = P_l \equiv$\verb+adiabatic+ is constant, 
                !latex \item note that if \verb+gamma=0+, then \verb+pressure=adiabatic+;
                !latex \item \verb+pressure+ is only used in calculation of interface force-balance;
                !latex \end{itemize}
 beta        ,& !latex \item \verb+beta=0.0 : real+ : on exit, plasma beta; redundant; ! 24 Oct 12;
 mu          ,& !latex \item \verb+mu : real(1:MNvol)+ : helicity-multiplier, $\mu$, in each volume;
                !latex \begin{itemize}
                !latex \item if \verb+Lconstraint.eq.0+, then \verb+mu+ is not varied;
                !latex \item if \verb+Lconstraint.eq.1+, then \verb+mu+ is adjusted to satisfy interface rotational-transform constraint;
                !latex in this case \verb+mu+ serves as an initial guess;
                !latex \item if \verb+Lconstraint.eq.2+, then \verb+mu+ is adjusted to satisfy helicity constraint;
                !latex \end{itemize}
 pl          ,& !latex \item \verb+pl=0 : integer(0:MNvol)+ :
 ql          ,& !latex \item \verb+ql=0 : integer(0:MNvol)+ :
 pr          ,& !latex \item \verb+pr=0 : integer(0:MNvol)+ :
 qr          ,& !latex \item \verb+qr=0 : integer(0:MNvol)+ :
                !latex \begin{itemize}
                !latex \item interface rotational-transform is $\iotabar=(p_l+\gamma p_r)/(q_l+\gamma q_r)$, where $\gamma$ is the golden mean, $\gamma=(1 + \sqrt 5 ) / 2 $;
                !latex \item if both $q_l=0$ {\em and} $q_r=0$, then the interface rotational-transform is defined by \verb+iota+;
                !latex \item if \verb+Lconstraint.ne.1+ then \verb+pl+, \verb+ql+, \verb+pr+ and \verb+qr+ are irrelevant;
                !latex \end{itemize}
 iota        ,& !latex \item \verb+iota : real(0:MNvol)+ : rotational-transform, $\iotabar$, on each interface;
                !latex \begin{itemize}
                !latex \item only relevant if illogical input for \verb+ql+ and \verb+qr+ are provided;
                !latex \end{itemize}
 mupftol     ,& !latex \item \verb+mupftol=1.0e-07 : real+ : accuracy to which $\mu$ and $\psi_p$ are required;
                !latex \begin{itemize}
                !latex \item only relevant if \verb+Lconstraint.gt.0+;
                !latex \end{itemize}
 mupfits     ,& !latex \item \verb+mupfits=16 : integer+ : an upper limit on the transform/helicity constraint iterations;
                !latex \begin{itemize}
                !latex \item constraint: \verb+mupfits > 0+;
                !latex \end{itemize}
 Rbc         ,& !latex \item \verb+Rbc : real(-MNtor:MNtor,0:MMpol)+ : Fourier harmonics of boundary;     stellarator symmetric;
 Zbs         ,& !latex \item \verb+Zbs : real(-MNtor:MNtor,0:MMpol)+ : Fourier harmonics of boundary;     stellarator symmetric;
 Rbs         ,& !latex \item \verb+Rbs : real(-MNtor:MNtor,0:MMpol)+ : Fourier harmonics of boundary; non-stellarator symmetric;
 Zbc         ,& !latex \item \verb+Zbc : real(-MNtor:MNtor,0:MMpol)+ : Fourier harmonics of boundary; non-stellarator symmetric;
                !latex \begin{itemize}
                !latex \item The boundary, ${\bf x}=R(\t,\z) \hat {\bf R} + Z(\t,\z) \hat {\bf Z}$, is described by
                !latex \be R & = & \sum_{n=0}^{Ntor}R_{n,0}\cos(-n\z)+\sum_{m=0}^{Mpol}\sum_{n=-Ntor}^{Ntor}R_{n,m}\cos(m\t-nN\z), \\
                !latex     Z & = & \sum_{n=0}^{Ntor}Z_{n,0}\sin(-n\z)+\sum_{m=0}^{Mpol}\sum_{n=-Ntor}^{Ntor}Z_{n,m}\sin(m\t-nN\z), \ee
                !latex where $N\equiv$\verb+Nfp+ and $R_{n,m}\equiv$\verb+Rbc(n,m)+, $Z_{n,m}\equiv$\verb+Zbs(n,m)+.
                !latex \end{itemize}
 Bns         ,& !latex \item \verb+Bns : real(-MNtor:MNtor,0:MMpol)+ : Fourier harmonics of normal field at boundary;     stellarator symmetric;
 Bnc         ,& !latex \item \verb+Bnc : real(-MNtor:MNtor,0:MMpol)+ : Fourier harmonics of normal field at boundary; non-stellarator symmetric;
 Vns         ,& !latex \item \verb+Vns : real(-MNtor:MNtor,0:MMpol)+ : Fourier harmonics of normal field at boundary;     stellarator symmetric; vacuum;
 Vnc         ,& !latex \item \verb+Vnc : real(-MNtor:MNtor,0:MMpol)+ : Fourier harmonics of normal field at boundary; non-stellarator symmetric; vacuum;
 mask        ,& !latex \item \verb+mask : integer(-MNtor:MNtor,0:MMpol)=Lmask+ : inclusion flag; under-construction;
                !latex \begin{itemize}
                !latex \item Set \verb+mask(n,m)=0+ to exclude the $(m\t-n\z)$ harmonics in the computation of the Beltrami fields and geometry.
                !latex \item Set \verb+mask(n,m)=1+ to include the $(m\t-n\z)$ harmonics in the computation of the Beltrami fields and geometry.
                !latex \end{itemize}
 Lmask          !latex \item \verb+Lmask=1+ : sets default value for mask; under-construction;

!latex \end{itemize}

!latex \item Comments:
!latex \begin{enumerate}
!latex \item The helicity multipler, $\mu$, is related to the parallel current.
!latex \item The choice \verb+Lconstraint=1+ will suitably adjust $\mu$ to enforce the rotational-transform constraint.
!latex       This is analogous to setting \verb+NCURR=0+ in \verb+VMEC+.
!latex \item The choice \verb+Lconstraint=0+ will not adjust $\mu$. 
!latex       This is analogous to setting \verb+NCURR=1+ in \verb+VMEC+.
!latex \item The input parameter \verb+Itoroidal+ needs to be examined.
!latex       It seems that \verb+Itoroidal+ needs to be selected to give a right-handed coordinate system; 
!latex       i.e. it depends on the choice of the poloidal angle.
!latex       (Note that the Fourier representation of the boundary implicity defines the poloidal angle.)
!latex \item For \verb+Lgeometry=4,5,6+ : two functions are used to specify the coordinate transformation, namely $R(\s,\t,\z)$ and $Z(\s,\t,\z)$.
!latex       In this case additional angle constraints must be included in order to obtain a unique solution for force-balance across the interfaces.
!latex \item For \verb+Lgeometry=1,2,3+ : only one function is used to specify the coordinate transformation, namely $R(\s,\t,\z)$.
!latex       In this case, no additional angle constraints are required.
!latex \end{enumerate}

!latex \end{enumerate} \subsubsection{numericlist} \begin{enumerate}
!latex \item The namelist \verb+numericlist+ controls internal resolution parameters that the user rarely needs to consider.
!latex \begin{itemize}
!latex \verb+namelist/numericlist/+

  namelist/numericlist/&
 Linitialize ,& !latex \item \verb+Linitialize=0 : integer+ : to initialize geometry using a regularization / extrapolation method;
                !latex \begin{itemize}
                !latex \item if \verb+Linitialize=0+, the geometry of the interior surfaces is provided after the namelists in the input file;
                !latex \item if \verb+Linitialize=1+, the interior surfaces will be intialized as $R_{l,m,n}=R_{N,m,n} \psi_{t,l}^{m/2}$, where $R_{N,m,n}$ is the boundary
                !latex       and $\psi_{t,l}$ is the given toroidal flux enclosed by the $l$-th interface, normalized to the total enclosed toroidal flux;
                !latex       a similar extrapolation is used for $Z_{l,m,n}$;
                !latex \item note that the Fourier harmonics of the boundary is {\em always} given by the \verb+Rbc+ and \verb+Zbs+ given in \verb+physicslist+;
                !latex \item if \verb+Linitialize=1+, it is not required to provide the geometry of the interfaces after the namelists;
                !latex \end{itemize}
 Lwall       ,& !latex \item \verb+Lwall=0 : integer+ wall is given as a set of data points; smooth approximation will be constructed;
 phiwall     ,& !latex \item \verb+phiwall=0.9 : real+ value of vacuum potential at wall;
 iextrap     ,& !latex \item \verb+iextrap= 4 : integer+ : extrapolation of magnetic axis;
 Ndiscrete   ,& !latex \item \verb+Ndiscrete=2 : integer+ :
                !latex \begin{itemize}
                !latex \item resolution of the real space grid on which fast Fourier transforms are performed is given by \verb+Ndiscrete*Mpol*4+;
                !latex \item constraint \verb+Ndiscrete>0+;
                !latex \end{itemize}
 Lslabel     ,& !latex \item \verb+Lslabel=-9 : integer+ : redundant;  ! 10 Oct 12;
                !latex Warning: the regularity conditions at the origin imposed on the vector potential assume that the radial coordinate is similar to $r^2$.
 Lsinterp    ,& !latex \item \verb+Lsinterp=-9 : integer+ : redundant; ! 10 Oct 12;
 Nofe        ,& !latex \item \verb+Nofe=2 : integer+ : controls order of finite-element basis functions used to discretize vector potential;
                !latex \begin{itemize}
                !latex \item if \verb+Nofe=1+, cubic     basis functions are used;
                !latex \item if \verb+Nofe=2+, quintic   basis functions are used;
                !latex \item if \verb+Nofe=3+, septemtic basis functions are used;
                !latex \end{itemize}
 Nquad       ,& !latex \item \verb+Nquad=-1 : integer+ : the resolution of the Gaussian quadrature, i.e. the radial sub-sub-grid;
                !latex \begin{itemize}
                !latex \item if \verb+Nquad.le.0+, then \verb!Nquad=2*Nofe+3-Nquad!;
                !latex \item In the innermost volume, we should use if \verb!Nquad=Mpol/2+2*Nofe+3-Nquad!;
                !latex \end{itemize}
                !latex 
 iMpol       ,& !latex \item \verb+iMpol=-1 : integer+ : Fourier resolution of straight-field-line angle on interfaces;
                !latex \begin{itemize}
                !latex \item the rotational-transform on the interfaces is determined by a transformation to the straight-field-line angle,
                !latex with poloidal resolution given by \verb+iMpol+;
                !latex \item if \verb+iMpol.lt.0+, then \verb+iMpol = 4 * max(1,Mpol) * abs(iMpol)+;
                !latex \end{itemize}
 iNtor       ,& !latex \item \verb+iNtor=-1 : integer+ : Fourier resolution of straight-field-line angle on interfaces;
                !latex \begin{itemize}
                !latex \item the rotational-transform on the interfaces is determined by a transformation to the straight-field-line angle,
                !latex with toroidal resolution given by \verb+iNtor+;
                !latex \item if \verb+iNtor.lt.0+, then \verb+iNtor = 4 * Ntor * abs(iNtor)+;
                !latex \end{itemize}
 Ldmupf      ,& !latex \item \verb+Ldmupf=-1 : integer+ : redundant;  ! 10 Oct 12;
 Iswmin      ,& !latex \item \verb+Iswmin=0 : integer+ : construct spectrally condensed angle as a pre-processing step;
                !latex \begin{itemize}
                !latex \item if \verb+Iswmin=0+, the Fourier representation of all interfaces (incl. outer boundary) {\em is not} converted to spectrally condensed representation;
                !latex \item if \verb+Iswmin=1+, the Fourier representation of all interfaces (incl. outer boundary) {\em is    } converted to spectrally condensed representation;
                !latex \item if \verb+Iswmin=2+, the spectrally condensed representation of the outer boundary is written to the restart file, \verb+ext.end+, on completion,
                !latex otherwise the original Fourier representation of the outer boundary is written to \verb+ext.end+;
                !latex \end{itemize}
 Lsymagl     ,& !latex \item \verb+Lsymagl=F : logical+ : redundant; ! 10 Oct 12;
 Lperturb    ,& !latex \item \verb+Lperturb=0 : integer+ : add random perturbation to input geometry;
                !latex \begin{itemize}
                !latex \item if \verb+Lperturb.eq.1+ a random deformation is added to all Fourier harmonics of all internal interfaces;
                !latex \item used for debugging, testing domain of convergence;
                !latex \end{itemize}
 dperturb       !latex \item \verb+dperturb=1.0e-04 : real+ : magnitude of random perturbation added to each Fourier harmonic;
                !latex \begin{itemize}
                !latex \item only relevant if \verb+Lperturb.eq.1+;
                !latex \end{itemize}

!latex \end{itemize}

!latex \item Comments:
!latex \begin{enumerate}
!latex \item The metric elements are constructed at enhanced resolution, \verb+lMpol=2*Mpol+; so \verb+Ndiscrete+ should be set carefully;
!latex \end{enumerate}

!latex \end{enumerate} \subsubsection{linearlist} \begin{enumerate}
!latex \item The namelist \verb+linearlist+ controls the construction of the Beltrami fields in each volume.
!latex \begin{itemize}
!latex \verb+namelist/linearlist/+

  namelist/linearlist/&
 Lbeltrami,&    !latex \item\verb+Lbeltrami=1  integer+
                !latex \begin{itemize}
                !latex \item if \verb+Lbeltrami=4,5,6 or 7+, (SQP) then the Beltrami field in each volume is constructed
                !latex by minimizing the magnetic energy with the constraint of fixed helicity; 
                !latex this is achieved by using sequential quadratic programming as provided by the NAG routine \verb+E04UFF+; 
                !latex this approach has the benefit (in theory) of robustly constructing minimum energy solutions when multiple, i.e. bifurcated, solutions exist.
                !latex \item if \verb+Lbeltrami=1,3,5 or 7+, (linear) it is assumed that the Beltrami fields are parameterized by $\mu$;
                !latex in this case, it is only required to solve $\nabla \times {\bf B}=\mu {\bf B}$ which reduces to a system of linear equations;
                !latex $\mu$ may or may not be adjusted iteratively, depending on \verb+Lconstraint+, to satisfy either rotational-transform or helicity constraints;
                !latex \item if \verb+Lbeltrami=2,3,6 or 7+, (Newton) then the Beltrami fields are constructed by employing a standard Newton method for locating an extremum of
                !latex $F\equiv \int B^2 dv - \mu (\int {\bf A}\cdot{\bf B}dv-{\cal K})$,
                !latex where $\mu$ is treated as an independent degree of freedom similar to the parameters describing the vector potential
                !latex and ${\cal K}$ is the required value of the helicity; 
                !latex this is the standard Lagrange multipler approach for locating the constrained minimum; 
                !latex this method cannot distinguish saddle-type extrema from minima, and the solution obtained depends on the initial guess;
                !latex \item for flexibility and comparison, each of the above methods can be employed; for example:
                !latex \begin{itemize}
                !latex \item if \verb+Lbeltrami=1+, only the linear method will be employed; 
                !latex \item if \verb+Lbeltrami=2+, only the Newton method will be employed; 
                !latex \item if \verb+Lbeltrami=4+, only the SQP    method will be employed; 
                !latex \item if \verb+Lbeltrami=3+, first the linear method will be employed to construct the Beltrami field and then, 
                !latex using this solution as the initial guess, the Newton method will be employed;
                !latex \item if \verb+Lbeltrami=6+, first the SQP method will construct the Beltrami field and then, 
                !latex using this solution as the initial guess, the Newton method will be employed 
                !latex (this should ensure that the Newton method constructs the minimum energy solution);
                !latex \item if \verb+Lbeltrami=7+, all three methods will be employed;
                !latex \end{itemize}
                !latex \end{itemize}
 Linitgues,&    !latex \item\verb+Linitgues=1  integer+ controls how initial guess for Beltrami field is constructed;
                !latex \begin{itemize}
                !latex \item only relevant for routines that require an initial guess for the Beltrami fields, such as the SQP and Newton methods, or the sparse linear solver;
                !latex \item if \verb+Linitgues=0+, the initial guess for the Beltrami field is trivial;
                !latex \item if \verb+Linitgues=1+, the initial guess for the Beltrami field is an integrable approximation;
                !latex \item if \verb+Linitgues=2+, the initial guess for the Beltrami field is read from file; 
                !latex \end{itemize}
 Ldense   ,&    !latex \item\verb+Ldense=1 : integer+ : controls whether the Beltrami linear system is assumed to be dense or sparse;
                !latex \begin{itemize}
                !latex \item if \verb+Ldense=0+, the Beltrami linear matrix is assumed to be sparse;
                !latex \item if \verb+Ldense=1+, the Beltrami linear matrix is assumed to be dense;
                !latex \item if \verb+Ldense=2+, the methods will be compared;
                !latex \end{itemize}
 Lposdef  ,&    !latex \item\verb+Lposdef=T : logical+ : indicates whether the Beltrami linear system is positive definite;
                !latex \begin{itemize}
                !latex \item if \verb+Lposdef=T+, the Beltrami linear system is assumed to be positive definite;
                !latex \item if \verb+Lposdef=F+, the Beltrami linear system is assumed not   positive definite;
                !latex \item only relevant for the linear method of constructing the Beltrami fields, i.e. if \verb+Lbeltrami=1,3,5 or 7+;
                !latex \end{itemize}
 Nmaxexp  ,&    !latex \item\verb+Nmaxexp=0 : integer+ : indicates maximum exponent used to precondition Beltrami linear system near coordinate singularity; under construction;
                !latex \begin{itemize}
                !latex \item a factor of $s^{\bar m_j/2}$ is extracted, where $\bar m \equiv $\verb+min(Nmaxexp,m_j)+;
                !latex \item the default value, \verb+Nmaxexp=0+, indicates no preconditioning;
                !latex \end{itemize}
 Lprecon ,&     !latex \item\verb+Lprecon=1 : integer+ : choice of preconditioner used in sparse linear solver, \verb+F11JEF+; 
                !latex \begin{itemize}
                !latex \item if \verb+Lprecon=0+, no preconditioner is used;
                !latex \item if \verb+Lprecon=1+, the Jacobi preconditioner is used;
                !latex \item if \verb+Lprecon=2+, successive over relaxation preconditioner is used;
                !latex \item only used if \verb+Ldense.eq.0+ (or \verb+Ldense.eq.2+);
                !latex \end{itemize}
 sparseits,&    !latex \item\verb+sparseits=-1 : integer+ : maximum iterations allowed in sparse method of solving Beltrami linear system;
                !latex \begin{itemize}
                !latex \item if \verb+sparseits.le.0+, maximum allowed iterations defaults to \verb+abs(sparseits)*+$N$, where $N$ is the size of the matrix;
                !latex \item only used if \verb+Ldense.eq.0+ (or \verb+Ldense.eq.2+);
                !latex \end{itemize}
 ssoromega,&    !latex \item\verb+ssoromega=1.0 : real+ : successive over-relaxation parameter, $\omega$;
                !latex \begin{itemize}
                !latex \item constraint $0.0 \le \omega \le 2.0$;
                !latex \item only required if \verb+Ldense.eq.0+ (or \verb+Ldense.eq.2+) and \verb+Lprecon.eq.2+;
                !latex \end{itemize}
 sparsetol,&    !latex \item\verb+sparsetol=-1.0 : real+ : accuracy requested in sparse solution to Beltrami linear system;
                !latex \begin{itemize}
                !latex \item if \verb+sparsetol.le.zero+, required accuracy defaults to machine precision;
                !latex \item only used if \verb+Ldense.eq.0+ (or \verb+Ldense.eq.2+);
                !latex \end{itemize}
 Liotasolv      !latex \item\verb+Liotasolv=1 : integer+ : choice of solving for straight-field line coordinates on the interfaces; 
                !latex \begin{itemize}
                !latex \item if \verb+Liotasolv=1,3,5,7+, the linear transformation is solved using sparse LU decomposition;
                !latex \item if \verb+Liotasolv=2,3,6,7+, the linear transformation is solved using standard, iterative linear solver;
                !latex \item if \verb+Liotasolv=4,5,6,7+, the linear transformation is solved using singular value decomposition (SVD) methods;
                !latex \end{itemize}

!latex \end{itemize}

!latex \item Comments:
!latex \begin{enumerate}
!latex \item The transformation to straight-field-line coordinates is singular when the rotational-transform of the interfaces is rational;
!latex       however, the rotational-transform is still well defined.
!latex       In this case, the SVD method (\verb+Liotasolv=4,5,6,7+) must be used.
!latex \end{enumerate}

!latex \end{enumerate} \subsubsection{nonlinearlist} \begin{enumerate}
!latex \item The namelist \verb+nonlinearlist+ controls the search for global-force balance, i.e. the search for the interface geometry so that $[[p+B^2/2]]=0$.
!latex \begin{itemize}
!latex \verb+ namelist/nonlinearlist/+

  namelist/nonlinearlist/& 
 Lc05ndf     ,& !latex \item \verb+Lc05ndf=F : logical+ : redundant; ! 10 Oct 12;
 Le04dgf     ,& !latex \item \verb+Le04dgf=F : logical+ : redundant; ! 10 Oct 12;
 Lminimize   ,& !latex \item \verb+Lminimize=0 : integer+ : use minimization methods to construct equilibrium solutions;
                !latex \begin{itemize}
                !latex \item if \verb+Lminimize=1+, then use the preconditioned conjugate gradient method, provided by \verb+E04DGF+;
                !latex \item if \verb+Lminimize=2+, then use the homespun non-linear conjugate gradient method, described in \verb+pc01aa+;
                !latex \item if \verb+Lminimize=4+, then use the modified Newton method, employing first and second derivatives, provided by \verb+E04LYF+; under construction;
                !latex \end{itemize}
 Lfindzero   ,& !latex \item \verb+Lfindzero=0 : integer+ : use Newton methods to find zero of force balance;
                !latex \begin{itemize}
                !latex \item if \verb+Lfindzero=1+, then use NAG routine \verb+C05NDF+, which uses function values only;
                !latex \item if \verb+Lfindzero=2+, then use NAG routine \verb+C05PDF+, which uses derivative information;
                !latex \end{itemize}
 pwidth      ,& !latex \item \verb+pwidth=4 : integer+ :
 qwidth      ,& !latex \item \verb+qwidth=4 : integer+ : spectral condensation parameter;
                !latex \begin{itemize}
                !latex \item the angle freedom is exploited to minimize $\sum_{m,n}(m^p+n^q)(R_{m,n}^2+Z_{m,n}^2)$ with respect to tangential variations;
                !latex \item Only relevant if \verb+Lgeometry.ge.4+;
                !latex \end{itemize}
 forcetol    ,& !latex \item \verb+forcetol = 1.0e-09 : real+ : required tolerance in force balance error;
 normalerr   ,& !latex \item \verb+normalerr = 1.0e-06 : real+ : required tolerance in free-boundary iterations;
 norblend    ,& !latex \item \verb+norblend  = 0.0     : real+ : normal blendin;
 maxfbits    ,& !latex \item \verb+maxfbits = 20 : integer+ : maximum allowed free-boundary iterations;
 forceerr    ,& !latex \item \verb+forceerr = 0.0 : real+ : on exit, force balance error; redundant; 02 Nov 12;
 energy      ,& !latex \item \verb+energy   = 0.0 : real+ : on exit, total energy; redundant; 02 Nov 12;
 Lc05pdf     ,& !latex \item \verb+Lc05pdf=F : logical+ : redundant; ! 10 Oct 12;
 Le04lyf     ,& !latex \item \verb+Le04lyf=F : logical+ : redundant; ! 10 Oct 12;
 xftol       ,& !latex \item \verb+xftol : real+ : redundant; ! 10 Oct 12;
 c05xtol     ,& !latex \item \verb+c05xtol=1.0e-09 : real+ : required tolerance in position, {\bf x};
                !latex \begin{itemize}
                !latex \item used by both \verb+C05NDF+ and \verb+C05PDF+; see the NAG documents for further details on how the error is defined;
                !latex \item this parameter doubles as a ``force'' tolerance: if initially $|{\bf F}|<$\verb+xftol+, then the solution is accepted as an equilibrium;
                !latex \item constraint \verb+xftol.gt.0.0+;
                !latex \end{itemize}
 factor      ,& !latex \item \verb+factor : real+ : redundant; this has been replaced by \verb+c05factor+; ! 10 Oct 12;
 c05factor   ,& !latex \item \verb+c05factor=1.0e-04 : real+ : used to control initial step size; provided to NAG routines \verb+C05NDF+, \verb+C05PDF+
                !latex \begin{itemize}
                !latex \item constraint \verb+c05factor.gt.0.0+;
                !latex \item only relevant if \verb+Lfindzero.gt.0+;
                !latex \item used by both \verb+C05NDF+ and \verb+C05PDF+;
                !latex \end{itemize}
 ifinited    ,& !latex \item \verb+ifinited=-9 : integer+ : redundant; ! 10 Oct 12;
 Lgradient   ,& !latex \item \verb+Lgradient=-9 : integer+ : redundant; ! 10 Oct 12;
 LreadGF     ,& !latex \item \verb+LreadGF=T : logical+ : read $\nabla {\bf F}$ from file \verb+.GF+;
 GFsuff      ,& !latex \item \verb+GFsuff=0 : integer+ : redundant; ! 10 Oct 12;
 verify      ,& !latex \item \verb+verify=-1 : integer+ : instruct \verb+E04DGF+ to ``verify'' user supplied gradients are correct; only relevant if \verb+Le04gdf=T+;
                !latex \begin{itemize}
                !latex \item if \verb+verify=-1+, no checks on user supplied gradients are requested;
                !latex \item if \verb+verify= 0+, simple checks on user supplied gradients are requested;
                !latex \item if \verb+verify= 1+, extensive checks on user supplied gradients are requested;
                !latex \end{itemize}
 maxstep     ,& !latex \item \verb+maxstep=1.0e-03 : real+ : provided to \verb+E04DGF+; only relevant if \verb+Le04gdf=T+;
 epsilon     ,& !latex \item \verb+epsilon=1.0e-00 : real+ : weighting of spectral width; only relevant if \verb+Le04gdf=T+;
 maxiter     ,& !latex \item \verb+maxiter=-1 : integer+ : maximum iterations allowed in \verb++E04DGF;
 normalize      !latex \item \verb+normalize=1 : integer+ : redundant; ! 10 Oct 12;
!latex \end{itemize}

!latex \item Comments:
!latex \begin{enumerate}
!latex \item An equilibrium is obtained when ${\bf F}({\bf x})=0$.
!latex \item The ``force'' vector, ${\bf F}$, is a combination of pressure-imbalance Fourier harmonics, i.e. $[[p+B^2/2]]_{m,n}$ and spectral-condensation constraints.
!latex \item The vector ${\bf x}$ represents the internal interface geometry harmonics.
!latex \end{enumerate}

!latex \end{enumerate} \subsubsection{diagnosticslist} \begin{enumerate}
!latex \item The namelist \verb+diagnosticslist+ controls post-processor diagnostics, such as \Poincare plot resolution, $\dots$,
!latex \begin{itemize}
!latex \verb+namelist/diagnosticslist/+

  namelist/diagnosticslist/&
 odetol     ,&  !latex \item \verb+odetol=1.0e-07 : real+ : o.d.e. integration tolerance for all field line tracing routines;
 absreq     ,&  !latex \item \verb+absreq=1.0e-06 : real+ : absolute accuracy on virtual casing integral for external field;
 relreq     ,&  !latex \item \verb+relreq=1.0e-06 : real+ : relative accuracy on virtual casing integral for external field;
 absacc     ,&  !latex \item \verb+absacc=1.0e-06 : real+ : absolute accuracy required for integration of toroidal flux;
 divertorR  ,&  !latex \item \verb+divertorR=-1.0 : real+ : redundant; ! 10 Oct 12;
 divertorZ  ,&  !latex \item \verb+divertorZ= 1.0 : real+ : redundant; ! 10 Oct 12;
 Lpoincare  ,&  !latex \item \verb+Lpoincare=0 : integer+ : controls whether toroidal angle or poloidal angle parameterizes field line;
                !latex \begin{itemize}
                !latex \item if \verb+Lpoincare=0+, the \Poincare section is taken as $\z=const.$ and distance along a field line is parameterized by the toroidal angle;
                !latex the toroidal field must be nowhere zero; the o.d.e.s to be integrated are $\dot \s = B^\s / B^\z$ and $\dot \t = B^\t / B^\z$.
                !latex \item if \verb+Lpoincare=1+, the \Poincare section is taken as $\t=const.$ and distance along a field line is parameterized by the poloidal angle;
                !latex the poloidal field must be nowhere zero; the o.d.e.s to be integrated are $\dot \s = B^\s / B^\t$ and $\dot \z = B^\z / B^\t$.
                !latex \item if \verb+Lpoincare=2+, the \Poincare section is taken as $\z=const.$, but distance along a field line is not parameterized by the toroidal angle;
                !latex the o.d.e.s to be integrated are $\dot \s = B^\s$, $\dot \t = B^\t$ and $\dot \z = B^\z$.
                !latex \end{itemize}
 nPpts      ,&  !latex \item \verb+nPpts=0 : integer+ : number of toroidal transits used (per trajectory) in following field lines for constructing \Poincare plots;
                !latex if \verb+nPpts<1+, no \Poincare plot is constructed;
 nPtrj      ,&  !latex \item \verb+nPtrj=-1 : integer(1:MNvol+1)+ : number of trajectories in each annulus following in constructing \Poincare plot;
                !latex if \verb+nPtrj(l)<0+, then \verb+nPtrj(l)=Ni(l)+, where \verb+Ni(l)+ is the grid resolution used to construct the Beltrami field in volume $l$;
 Mpqits     ,&  !latex \item \verb+Mpqits=10 : integer+ : maximum allowed iterations in finding periodic orbits; see \verb+pq00aa,pq02aa+;
 Lpqsym     ,&  !latex \item \verb+Lpqsym=1 : integer+ : indicates whether periodic orbits lie on symmetry line; see \verb+pq00aa,pq02aa+;
                !latex \begin{itemize}
                !latex \item if \verb+Lpqsym=1+, the periodic orbits are assumed to lie on the `symmetry line', $\theta=0$.
                !latex \item constraint; \verb+Lpqsym=0+ or \verb+Lpqsym=1+;
                !latex \end{itemize}
 p1         ,&  !latex \item \verb+p1=0 : integer(1:MNvol)+ : selection of periodic orbits and noble irrational surface; see \verb+pq01aa+;
 q1         ,&  !latex \item \verb+q1=0 : integer(1:MNvol)+ : selection of periodic orbits and noble irrational surface; see \verb+pq01aa+;
 p2         ,&  !latex \item \verb+p2=0 : integer(1:MNvol)+ : selection of periodic orbits and noble irrational surface; see \verb+pq01aa+;
 q2         ,&  !latex \item \verb+q2=0 : integer(1:MNvol)+ : selection of periodic orbits and noble irrational surface; see \verb+pq01aa+;
 pqs        ,&  !latex \item \verb+pqs=-1.0 : real(1:MNvol)+ : initial radial guess for location of periodic orbit;
 pqt        ,&  !latex \item \verb+pqt= 0.0 : real(1:MNvol)+ : initial angle  guess for location of periodic orbit;
 pqR        ,&  !latex \item \verb+pqR= 0.0 : real(1:MNvol)+ : output cylindrical; redundant; ! 10 Oct 12;
 pqZ        ,&  !latex \item \verb+pqZ= 0.0 : real(1:MNvol)+ : output cylindrical; redundant; ! 10 Oct 12;
 Npl        ,&  !latex \item \verb+Npl= 1 : integer+ piecewise linear resolution for Lagrangian integration;
 Nunstable  ,&  !latex \item \verb+Nunstable=1000    : integer+ : unstable manifold; resolution of line segment emanating from unstable periodic orbit;
 dunstable  ,&  !latex \item \verb+dunstable=1.0e-05 : real   + : unstable manifold; length     of line segment emanating from unstable periodic orbit;
 Munstable  ,&  !latex \item \verb+Nunstable=20      : integer+ : unstable manifold; iterations of \Poincare map;
 npq        ,&  !latex \item \verb+npq=0 : integer(1:MNvol)+ : number of required additional periodic orbits as defined by Fibonacci series
                !latex beginning from \verb+p1/q1+ and \verb+p2/q2+;
 Mirrits    ,&  !latex \item \verb+Mirrits=0 : integer+ : maximum allowed iterations in finding irrational surface; if \verb+Mirrits<1+, irrational surfaces are not located;
 irrMpol    ,&  !latex \item \verb+irrMpol=50 : integer+ : poloidal resolution of irrational surface; only required if \verb+Mirrits>0+; see \verb+pq01aa,ir00aa+;
 irrNtor    ,&  !latex \item \verb+irrNtor=25 : integer+ : toroidal resolution of irrational surface; only required if \verb+Mirrits>0+; see \verb+pq01aa,ir00aa+;
 irrsvdcut  ,&  !latex \item \verb+irrsvdcut=1.0e-12 : real+ : SVD inversion singular cutoff used to locate irrational surfaces; only required if \verb+Mirrits>0+;
                !latex see \verb+ir00aa+;
 irrtol     ,&  !latex \item \verb+irrtol=1.0e-08 : real+ : irrational surface tolerance; only required if \verb+Mirrits>0+;see \verb+ir00aa+;
 Lwrpj      ,&  !latex \item \verb+Lwrpj=F : logical+ : the pressure-jump Hamiltonian input files are written;
 Nghd       ,&  !latex \item \verb+Nghd=0 : integer+ : poloidal resolution of ghost-surfaces $\equiv$ quadratic-flux minimizing surfaces;
 LHessian   ,&  !latex \item \verb+LHessian=F : logical+ : to compare $\nabla {\bf F}$ constructed in parallel to series construction;
 LHevalues  ,&  !latex \item \verb+LHevalues=F : logical+ : to compute eigenvalues of $\nabla {\bf F}$;
 LHevectors ,&  !latex \item \verb+LHevectors=F : logical+ : to compute eigenvectors (and also eigenvalues) of $\nabla {\bf F}$;
 Lcurlerr   ,&  !latex \item \verb+Lcurlerr=F : logical+ : check Beltrami field error, $\nabla \times {\bf B}-\mu {\bf B}$; see \verb+jo00aa+;
 Lcheck     ,&  !latex \item \verb+Lcheck=0 : integer+ : check derivative of transform wrt $\mu$ and $\delta \psi_p$; see \verb+ma02aa+
 Lexamine   ,&  !latex \item \verb+Lexamine=F : logical+ : to perform additional checks on accuracy;
 Ltiming        !latex \item \verb+Ltiming=F : logical+ : to check timing;

!latex \end{itemize}

!latex Comments:
!latex \begin{enumerate}
!latex \item No comments yet.
!latex \end{enumerate}

!latex \end{enumerate} \subsubsection{screenlist} \begin{enumerate}
!latex \item The namelist \verb+screenlist+ controls screen output.
!latex \begin{itemize}
!latex \verb+namelist/screenlist/+

  namelist/screenlist/&
! NSCREENLIST ! namelist screenlist; this is expanded by Makefile; do not remove;
 Wreadin , &  !latex \item Every subroutine, e.g. \verb+xy00aa.h+, has its own write flag, \verb+Wxy00aa+.
 Wwritin

!latex \end{itemize}

!latex \end{enumerate} \subsection{Input geometry} \begin{enumerate}
!latex \item The geometry of the $l$-th interface, for $l=0,N$ where $N\equiv$ \verb+Nvol+, is described by a set of Fourier harmonics, using an arbitrary poloidal angle,
!latex \be R_l(\t,\z)&=&\sum_{j}R_{j,l}\cos(m_j\t-n_j\z), \\ Z_l(\t,\z)&=&\sum_{j}Z_{j,l}\sin(m_j\t-n_j\z). \ee
!latex \item These harmonics are read from the \verb+ext.spec+ file and come directly after the namelists described above.
!latex The required format is as follows:
!latex \be \begin{array}{ccccccccc}
!latex m_1 & n_1 & R_{1,0} & Z_{1,0} & R_{1,1} & Z_{1,1} & \dots & R_{1,N} & Z_{1,N} \\
!latex m_2 & n_2 & R_{2,0} & Z_{2,0} & R_{2,1} & Z_{2,1} & \dots & R_{2,N} & Z_{2,N} \\
!latex \dots \\
!latex m_j & n_j & R_{j,0} & Z_{j,0} & R_{j,1} & Z_{j,1} & \dots & R_{j,N} & Z_{j,N} \\
!latex \dots
!latex \end{array}
!latex \ee
!latex
!latex \item The coordinate axis corresponds to $j=0$ and the outermost boundary corresponds to $j=$\verb+Nvol+.
!latex \item An arbitrary selection of harmonics may be inluded in any order, but only those within the range specified by \verb+Mpol+ and \verb+Ntor+ will be used.
!latex \item The geometry of {\em all} the interfaces, i.e. $l=0,N$, including the degenerate `coordinate-axis' interface, must be given.

! note that all variables in namelist need to be broadcasted in readin;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end module inputlist

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module ezmgrid

  use ezspline_obj
  use ezspline

  implicit none

  INTEGER            :: mgridnfp
  REAL               :: pi2mgridnfp

  type(ezspline3_r8) :: sTBr, sTBz, sTBp ! spline objects for total field in mgrid file;

end module ezmgrid

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module allglobal

  use constants
  use typedefns

  implicit none

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  INTEGER              :: myid, ncpu       ! mpi variables;
  REAL                 :: cpus             ! initial time;

  REAL                 :: pi2nfp           !       pi2/nfp     ; assigned in readin;
  REAL                 :: pi2pi2nfpquarter ! pi2 * pi2/nfp / 4 ; assigned in readin; used in me00ab;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOGICAL, allocatable :: Lmp00ac(:)       ! used to indicate if Beltrami fields have been correctly constructed;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate}
!latex \subsection{Internal variables}
!latex \subsubsection{Fourier representation}
!latex \begin{enumerate} 

!latex \item The Fourier description of stellarator-symmetric (even) periodic functions is 
!latex \be f(\t,\z) = \sum_{n=0}^{N} f_{0,n} \cos(-n\z) + \sum_{m=1}^{M}\sum_{n=-N}^{N} f_{m,n} \cos(m\t-n\z),
!latex \ee
!latex where the resolution is given on input, $M\equiv$\verb+ Mpol+ and $N\equiv$\verb+ Ntor+.
!latex \item For convenience, the Fourier summations are written as
!latex \be f(\s,\t,\z) &=& \sum_j f_j(s) \cos( m_j \t - n_j \z ),\\
!latex     f(\s,\t,\z) &=& \sum_j f_j(s) \sin( m_j \t - n_j \z ),
!latex \ee
!latex for $j=1,$ \verb+mn+, where 
!latex \verb+mn+$ = N + 1 +  M  ( 2 N + 1 )$.
!latex \item The arrays \verb+im+ and \verb+in+ contain the $m_j$ and $n_j$.

  INTEGER              :: mn  ! total number of Fourier harmonics for coordinates/fields; calculated from Mpol,Ntor in readin;
  INTEGER, allocatable :: im(:), in(:) ! Fourier modes; set in readin;

  INTEGER, allocatable :: mpnq(:) ! spectral condensation factors;

!latex \item Enhanced resolution is required for the metric elements, $g_{ij}/\sqrt g$, which is given by \verb+mne+, \verb+ime+., and \verb+ine+.
!latex The Fourier resolution here is determined by \verb+lMpol=2*Mpol+ and \verb+lNtor=2*Ntor+.
  INTEGER              :: mne ! enhanced resolution for metric elements;
  INTEGER, allocatable :: ime(:), ine(:)

!latex \item Enhanced resolution is required for the transformation to straight-field line angle on the interfaces, which is given by \verb+mns+, \verb+ims+., and \verb+ins+.
!latex The Fourier resolution here is determined by \verb+iMpol+ and \verb+iNtor+.

  INTEGER              :: mns ! enhanced resolution for straight field line transformation;
  INTEGER, allocatable :: ims(:), ins(:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  REAL                 :: xoffset = 1.0 ! used to normalize NAG routines;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{Interface geometry} \begin{enumerate}

!latex \item The Fourier harmonics of the interfaces are contained in \verb+iRbc(0:Nvol,1:mn)+ and \verb+iZbs(0:Nvol,1:mn)+, where
!latex \verb+iRbc(l,j)+, \verb+iZbs(l,j)+ contains the Fourier harmonics, $R_j$, $Z_j$, of the $l$-th interface.

  REAL,    allocatable :: iRbc(:,:) , iZbs(:,:)   ! interface surface geometry;
  REAL,    allocatable :: iRbs(:,:) , iZbc(:,:)   ! interface surface geometry;
! INTEGER, allocatable :: imask(  :)              ! interface surface geometry;

  REAL,    allocatable :: iBns(:)                 ! non-zero normal field;
  REAL,    allocatable :: iBnc(:)                 ! non-zero normal field;

  REAL,    allocatable :: iVns(:)                 ! non-zero normal field;
  REAL,    allocatable :: iVnc(:)                 ! non-zero normal field;

  REAL                 :: Bnserror                ! used to terminate free-boundary iterations; computed in bn00aa;
  REAL                 :: looperr                 ! used to measure free-boundary consistency; 21 Oct 12;

  REAL,    allocatable :: lRbc(:)   , lZbs(:)     ! local workspace;
  REAL,    allocatable :: lRbs(:)   , lZbc(:)     ! local workspace;

!latex \item The total radial resolution is \verb+SumNi=sum(Ni(1:Nvol))+.
!latex       The arrays, \verb+Rmn(0:SumNi,0:2,1:mn)+ and \verb+Zmn(0:SumNi,0:2,1:mn)+, are used to interpolate the interface geometry.
!latex       The \verb+Rmn(0:SumNi,1:2,j)+ and \verb+Zmn(0:SumNi,1:2,j)+ contain the first and second radial partial derivatives.

  INTEGER              :: SumNi
  REAL,    allocatable :: Rmn(:,:,:)
  REAL,    allocatable :: Zmn(:,:,:)

  REAL,    allocatable :: nflux(:) ! normalized toroidal flux; allows for geometrical regularization factor;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{Fourier Transforms} \begin{enumerate}

!latex \item The coordinate geometry and fields are mapped to/from Fourier space and real space using the NAG routine \verb+C06FUF+.
!latex \item The resolution of the real space grid is given by \verb+Nt=Ndiscrete*4*Mpol+ and \verb+Nz=Ndiscrete*4*Ntor+.
!latex \item Trigonometric information required for the fast Fourier transform's is saved in \verb+trigm(1:2*Nt)+, \verb+trign(1:2*Nz)+, and \verb+trigwk(1:2*Ntz)+,
!latex where \verb+Ntz=Nt*Nz+.

  INTEGER              :: Nt, Nz, Ntz ! discrete resolution; Ntz=Nt*Nz shorthand;
  REAL                 :: soNtz ! one / sqrt (one*Ntz); shorthand;

  CHARACTER            :: isr ! required for C06FUF;
  REAL   , allocatable :: trigm(:), trign(:), trigwk(:) ! these are set in readin and contain trigonometric factors; cannot be changed;

!latex \item Various workspace arrays are allocated. 
!latex These include \verb+Rij(0:9,Ntz)+ and \verb+Zij(0:9,Ntz)+, which contain the coordinates in real space and their derivatives;
!latex \verb+sg(0:3,Ntz)+, which contains the Jacobian and its derivatives;
!latex and \verb+gij(1:6,0:3,1:Ntz)+, which contains the metric elements and their derivatives.
!latex The array \verb+sgmn(1:mn)+ contains the Fourier harmonics of the inverse jacobian.

  REAL   , allocatable :: Rij(:,:), Zij(:,:), sg(:,:), gij(:,:,:), glmn(:,:), sgmn(:) ! dummy arrays;

  REAL,    allocatable :: ofmn(:), efmn(:), sfmn(:), cfmn(:) ! Fourier harmonics; dummy workspace;

  REAL,    allocatable :: ijreal(:), ijimag(:), jireal(:), jiimag(:) ! real grid; dummy workspace;

  REAL,    allocatable :: Bsupumn(:,:,:), Bsupvmn(:,:,:) ! 11 Oct 12; tangential field on interfaces; required for virtual casing construction of field;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{Metric information} \begin{enumerate}

!latex \item The angle averaged metric coefficients required are 
!latex  
  REAL,    allocatable :: agss(:) !latex \verb+agss(1:mn*mn)+ $\equiv \ooint \sin \alpha_j (g_{\s\s}/\sqrt g) \sin \alpha_k$
!latex  
  REAL,    allocatable :: agst(:) !latex \verb+agst(1:mn*mn)+ $\equiv \ooint \sin \alpha_j (g_{\s\t}/\sqrt g) \cos \alpha_k$
!latex  
  REAL,    allocatable :: agsz(:) !latex \verb+agsz(1:mn*mn)+ $\equiv \ooint \sin \alpha_j (g_{\s\z}/\sqrt g) \cos \alpha_k$
!latex  
  REAL,    allocatable :: agtt(:) !latex \verb+agtt(1:mn*mn)+ $\equiv \ooint \cos \alpha_j (g_{\t\t}/\sqrt g) \cos \alpha_k$
!latex  
  REAL,    allocatable :: agtz(:) !latex \verb+agtz(1:mn*mn)+ $\equiv \ooint \cos \alpha_j (g_{\t\z}/\sqrt g) \cos \alpha_k$
!latex  
  REAL,    allocatable :: agzz(:) !latex \verb+agzz(1:mn*mn)+ $\equiv \ooint \cos \alpha_j (g_{\z\z}/\sqrt g) \cos \alpha_k$
!latex  
  REAL,    allocatable :: agoo(:) !latex \verb+agoo(1:mn*mn)+ $\equiv \ooint \cos \alpha_j \cos \alpha_k$.
!latex
!latex These quantities, which are functions of $s$, are computed by performing an FFT of the $(g_{\s\s}/\sqrt g)$ etc. and by using triple angle formulae.

!latex \item The volume integrals required involve products of these quantities with the finite-element basis functions,
!latex $\varphi_{l,p}(s)$ and $\varphi_{r,q}(s)$ where $l=0,1$, $p=0,\dots,N$ and $r=0,1$, $q=0,\dots,N$ for $N\equiv$ \verb+Nofe+,
!latex used to describe the vector potential.
!latex
!latex \verb+igss(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)%s(0:Ni(lvol))+ $\equiv \int ds\;\varphi_{l,p} \varphi_{r,q}$ \verb+agss(1:mn*mn)+
  type(subgrid), allocatable ::   igss(:,:,:,:,:)
!latex  
  type(subgrid), allocatable ::   igst(:,:,:,:,:) !latex \verb+igst(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)%s(0:Ni(lvol))+
!latex  
  type(subgrid), allocatable ::   igsz(:,:,:,:,:) !latex \verb+igsz(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)%s(0:Ni(lvol))+
!latex  
  type(subgrid), allocatable ::   igtt(:,:,:,:,:) !latex \verb+igtt(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)%s(0:Ni(lvol))+
!latex  
  type(subgrid), allocatable ::   igtz(:,:,:,:,:) !latex \verb+igtz(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)%s(0:Ni(lvol))+
!latex  
  type(subgrid), allocatable ::   igzz(:,:,:,:,:) !latex \verb+igzz(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)%s(0:Ni(lvol))+
!latex  
  type(subgrid), allocatable ::   igoo(:,:,:,:,:) !latex \verb+igoo(0:1,0:Nofe,0:1,0:Nofe,1:mn*mn)%s(0:Ni(lvol))+
!latex
!latex The volume integrals are constructed by Gaussian integration over the radial coordinate.

  REAL         , allocatable :: dxagss(:), dxagst(:), dxagsz(:), dxagtt(:), dxagtz(:), dxagzz(:), dxagoo(:)

  type(subgrid), allocatable :: dxigss(:,:,:,:,:) ! these can be renamed after reduction;
  type(subgrid), allocatable :: dxigst(:,:,:,:,:)
  type(subgrid), allocatable :: dxigsz(:,:,:,:,:)
  type(subgrid), allocatable :: dxigtt(:,:,:,:,:)
  type(subgrid), allocatable :: dxigtz(:,:,:,:,:)
  type(subgrid), allocatable :: dxigzz(:,:,:,:,:)
  type(subgrid), allocatable :: dxigoo(:,:,:,:,:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  REAL   , allocatable :: felr(:,:,:,:) ! left & right finite element functions on radial sub-sub-grid; assigned in fe00aa;
  REAL   , allocatable :: lelr(:,:,:,:) ! left & right finite element functions on radial sub-sub-grid; assigned in fe00aa; local to ll-th volume;

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \end{enumerate} \subsubsection{Enclosed fluxes} \begin{enumerate}

!latex \item The input variables are the toroidal and poloidal fluxes, given in \verb+tflux(0:Nvol)+ and \verb+pflux(0:Nvol)+.
!latex \item However, the Beltrami fields in each volume depend only on the enclosed fluxes, \verb+dtflux(1:Nvol)+ and \verb+dpflux(1:Nvol)+,
!latex which are the independent degrees of freedom required to satisfy the rotational transform constraints, see \verb+ma02aa+.

  REAL,    allocatable :: dtflux(:), dpflux(:) ! \delta \psi_{toroidal} and \delta \psi_{poloidal} in each annulus;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{The vector potential, and Beltrami linear system} \begin{enumerate}
  
!latex \item The basic quantities are the covariant components of the vector potential at the radial sub-grid:
!latex 
!latex $A_{\t,l,j,p,i}\equiv$\verb+doAt(0,l,j,p)%s(i)+,
!latex 
!latex $A_{\z,l,j,p,i}\equiv$\verb+doAz(0,l,j,p)%s(i)+.
!latex
!latex For all annuli, $l=2,$\verb+Nvol+, the degrees of freedom in the vector potential include $j=1,$\verb+mn+, $p=0,$\verb+Nofe+ and $i=0,$\verb+Ni(l)+,
!latex except the $A_{\t,l,j,0,0}$ and $A_{\z,l,j,0,0}$, which are constrained by the gauge and interface conditions at the inner interface,
!latex and the $A_{\t,l,j,0,Ni}=m_j f_j$ and $A_{\z,l,j,0,Ni}=-n_j f_j$, which are constrained by the interface conditions at the outer interface.

!latex \item The innermost volume is a little different (see \verb+ma01af+), as the $A_{\t,l,j,0,p}$ and $A_{\z,l,j,0,p}$ are constrained by regularity and gauge and
!latex are not degrees of freedom.

!latex \item In volume $l$, for $s\in[s_{l,i-1},s_{l,i}]$, the $j$-th harmonic of each component is given by
!latex \be A_{\t,l,j}(s)=\sum_{p=0}^{Nofe}\left[A_{\t,l,j,p,i-1} \varphi_{L,p}(s) + A_{\t,l,j,p,i} \varphi_{R,p}(s)  \right], \ee
!latex where the $\varphi(s)_{L,p}$ are the finite-element basis functions.

  type(subgrid), allocatable :: doAt(:,:,:,:), doAz(:,:,:,:) ! covariant components of vector potential; description below;
 
!latex \item In each volume, the total degrees of freedom in the Beltrami linear system, \verb+NBdof(1:Nvol)+, is determined.
!latex This depends on \verb+Mpol+, \verb+Ntor+, \verb+Nofe+ and \verb+Ni(lvol)+.
   
!latex \item To employ standard `canned' routines for solving linear systems, the vector potential degrees-of-freedom in each annulus 
!latex need to be written as a single `column' vector.
!latex The location of $A_{\t,l,j,i,p}$ in this vector is given by \verb+doAt(0,l,j,p)%i(i)+ and $A_{\z,l,j,i,p}$ by \verb+doAz(0,l,j,p)%i(i)+.
!latex Note that better ways of packing this vector may exist, particularly so given that the Beltrami linear system is sparse, and
!latex sparse linear solvers could be employed.

  INTEGER, allocatable :: NBdof(:) ! degrees of freedom in Beltrami fields in each annulus;

  LOGICAL              :: Lcoordinatesingularity = .false.
  LOGICAL              :: Louterboundarynormal   = .false.

  LOGICAL              :: Lpreconditioner        = .false. ! under construction;

  LOGICAL, allocatable ::  iMB(  :,:)              ! keep track of non-zero elements in Belrami matrix in each volume;
  REAL   , allocatable ::   MB(  :,:),   MR(  :) ! linear matrix in each volume and driving rhs; constructed in ma01af;
  REAL   , allocatable :: duMB(:,:,:), duMR(:,:) ! linear matrix in each volume and driving rhs; constructed in ma01af;
  REAL   , allocatable :: dxMB(  :,:), dxMR(  :) ! linear matrix in each volume and driving rhs; constructed in ma01af;

!latex \item The matrix representing the Beltrami linear system, \verb+doMB(0,1:NBdof,1:NBdof)+, 
!latex and the Beltrami `right-hand-side' \verb+doMR(0,1:NBdof)+, arising from the inhomogeneous boundary conditions associated with non-zero toroidal and poloidal fluxes,
!latex are allocated/deallocated in \verb+ma02aa+ and assigned values in \verb+ma01ab+.
!latex \item The routine \verb+ma01ab+ contains more documentation on the construction of the Beltrami linear system.
!latex The solution to the linear system, i.e. the Beltrami field itself, is constructed in \verb+mp00aa+.

!latex \item The \verb+doAtmn(0:Ldmupf,0:2,1:mn)+, \verb+doAzmn(0:Ldmupf,0:2,1:mn)+ are workspace arrays used for interpolation.

  REAL,    allocatable :: doAtmn(:,:,:), doAzmn(:,:,:)

  CHARACTER            :: svol*4, AtAzsuffix*15

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{Transformation to straight-field-line angle} \begin{enumerate}

!latex \item Given the Beltrami fields in any volume, the rotational-transform on the adjacent interfaces 
!latex may be determined by constructing the straight-field line angle on the interfaces.
!latex \item This is performed in \verb+tr00ab+.
!latex \item The angle transformation is stored in the array \verb+dsflangle(0:2,1:Nvol,0:1,1:mns)+, 
!latex 
!latex where \verb+dsflangle(0,l,0,1:mn)+ and \verb+dsflangle(0,l,1,1:mn)+ are the straight-field line angle transformations
!latex on the inner and outer interfaces of the $l$-th volume.
!latex \item This is written to the file \verb+.ext.lambda+ for diagnostics.

  REAL,    allocatable :: dsflangle(:,:,:,:)

!latex \item The rotational-transform on the inner and outer interfaces of each volume is stored in \verb+diota(1:Nvol,0:2,0:1)+. 
!latex This is assigned values in \verb+mp00aa+ after calling \verb+tr00ab+.

  REAL   , allocatable :: diota(:,:,:) ! measured rotational transform on inner/outer interfaces for each volume;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{Radial interpolation, radial sub-grid} \begin{enumerate}

!latex \item The interfaces are labelled with \verb+interfacelabel(1:Nvol)+.

  REAL,    allocatable :: interfacelabel(:)

!latex \item The radial sub-grid is given in \verb+ss(1:Nvol)%s(0:Ni)+, where \verb+Ni+ is the resolution of the radial sub-grid which is volume dependent.

  type(subgrid), allocatable :: ss(:)

!latex \item The array \verb&dss(1:Nvol,-2:Nofe+Nofe)& contains powers of the radial sub-grid size, \verb+dss(l,n)+ $\equiv h^n$, where \mbox{$h\equiv (s_{l}-s_{l-1})/N$}.

  REAL,    allocatable :: dss(:,:)

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \end{enumerate} \subsubsection{Construction of `force'} \begin{enumerate}

!latex \item The force vector is comprised of \verb+Bomn+ and \verb+Iomn+.

  REAL,    allocatable ::  Bomn(:,:,:),  Iomn(:,:)
  REAL,    allocatable :: mBomn(:)    , mIomn(:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{Parallel construction of derivative matrix} \begin{enumerate}

!latex \item The derivatives of force balance, $[[p+B^2/2]]$, and the spectral constraints (see \verb+sw03aa+), with respect to the interface geometry
!latex is constructed in parallel by \verb+fc02aa+.

!latex \item Force balance across the $l$-th interface depends on the fields in the adjacent interfaces.

  INTEGER              :: Ngdof ! geometrical degrees of freedom;
  INTEGER              :: nlocaldof, mlocaldof

  REAL,    allocatable ::   DenergyDrz(:,:,:    ) ! derivatives of \int B^2 dv            wrt interface geometry;
  REAL,    allocatable :: DanalyticDrz(:,:,:    ) ! derivatives of \int B^2 dv            wrt interface geometry;
  REAL,    allocatable :: DanalyDrzDrz(:,:,:,:,:) ! derivatives of \int B^2 dv            wrt interface geometry; wrt interface geometry

  REAL,    allocatable :: DforcebalDrz(:,:,:,:,:) ! derivatives of [[p+B^2]]              wrt interface geometry;
  REAL,    allocatable :: DspectralDrz(:  ,:  ,:) ! derivatives of I \equiv R_t X + Z_t Y wrt interface geometry;
  LOGICAL, allocatable :: LforcebalDrz(:  ,:    ) ! indicates if derivative information has been previously constructed and saved in file;

!latex \item The geometrical degrees of freedom is given by \verb&Ngdof=(Nvol-1)*(mn+mn-1)&.
!latex NOTE: this is under construction: the \verb+mask+ imask is now included so that the user may select modes.
!latex This is assuming fixed boundary, so the outermost inteface is not free to move.

  LOGICAL              :: Lhessianallocated
  REAL,    allocatable :: hessian(:,:)

 !REAL,    allocatable :: naisseh(:,:) ! inverse-hessian? backward-hessian?

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \end{enumerate} \subsubsection{Trigonometric factors} \begin{enumerate}

!latex \item To facilitate construction of the metric integrals, various trigonometric identities are exploited.
!latex \item The required information is saved in
!latex
!latex \verb+ijk(1:mn,1:mn)+

  REAL   , allocatable :: coszeta(:), sinzeta(:), costeta(:), sinteta(:)

  REAL   , allocatable :: cosj(:,:), sinj(:,:)

  REAL   , allocatable :: dxsg(:), dxgij(:,:)

  REAL   , allocatable :: dxglmn(:,:) ! these are only used in me00ab; seems wasteful on memory;

  INTEGER, allocatable :: ijk(:,:) ! symmetry identification;

  LOGICAL, allocatable :: doubleex(:,:)
  INTEGER, allocatable :: doubleie(:,:), doubleip(:,:), doubleim(:,:), doublein(:,:)

  INTEGER, allocatable :: tripleipp(:,:), tripleipm(:,:), tripleimp(:,:), tripleimm(:,:)

!latex \item The following are used for volume integrals (see \verb+vo00aa+)
!latex \be a_{i,j,k} &=& 4 \; m_k \ooint \cos(\alpha_i)\cos(\alpha_j)\cos(\alpha_k) /(2\pi)^2 , \\
!latex     b_{i,j,k} &=& 4 \; m_j \ooint \cos(\alpha_i)\sin(\alpha_j)\sin(\alpha_k) /(2\pi)^2 ,
!latex \ee 

!latex 
!latex \item The curious factor of $4/(2\pi)^2$ is included so that \verb+aijk+ and \verb+bijk+ are strictly integer.
!latex
!latex \item These quantities are stored in \verb+aijk(1:mn,1:mn,1:mn)+ and \verb+bijk(1:mn,1:mn,1:mn)+.

  INTEGER, allocatable :: aijk(:,:,:), bijk(:,:,:) ! trigonometric coefficients used to calculate volume integrals;

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \end{enumerate} \subsubsection{Volume integrals} \begin{enumerate}

!latex \item The energy functional, $F \equiv \sum_l F_l$, where
!latex \be F_l \equiv \left( \int_{{\cal V}_l} \frac{p_l}{\gamma-1} + \frac{B_l^2}{2} dv \right)
!latex            = \frac{P_l}{\gamma-1}V_l^{1-\gamma}+\int_{{\cal V}_l} \frac{B_l^2}{2} dv, \label{eq:energy}
!latex \ee
!latex where the second expression is derived using $p_l V_l^\gamma=P_l$, where $P_l$ is the adiabatic-constant.
!latex In \Eqn{energy}, it is implicit that ${\bf B}$ satisfies (i) the toroidal and poloidal flux constraints; (ii) the interface constraint, ${\bf B}\cdot\nabla s=0$;
!latex and (iii) the helicity constraint (or the transform constraint)
!latex \item The derivatives of $F_l$ with respect to the inner and outer adjacent interface geometry are stored in
!latex
!latex \verb&dFF(1:Nvol,0:1,0:mn+mn-1)&, where
!latex
!latex $         F_l                      \equiv$ \verb&dFF(l,0,    0)&
!latex
!latex $\partial F_l / \partial R_{l-1,j} \equiv$ \verb&dFF(ll,0,   j)& 
!latex
!latex $\partial F_l / \partial Z_{l-1,j} \equiv$ \verb&dFF(ll,0,mn+j)& 
!latex
!latex $\partial F_l / \partial R_{l  ,j} \equiv$ \verb&dFF(ll,1,   j)& 
!latex
!latex $\partial F_l / \partial Z_{l  ,j} \equiv$ \verb&dFF(ll,1,mn+j)&
!latex

!latex \item The volume integrals $\int dv$, $\int B^2 \; dv$ and $\int {\bf A}\cdot{\bf B} \; dv$ in each volume are computed and saved in \verb+volume(0:2,1:Nvol)+.

  REAL   , allocatable :: lBBintegral(:) ! B.B      integral;
  REAL                 :: dBBintegral    ! B.B      integral; derivative wrt R, Z;

  REAL   , allocatable :: oBBintegral(:) ! B.B      integral; original; used to normalize; perhaps irrelevant;

  REAL   , allocatable :: lABintegral(:) ! A.B      integral;
  REAL                 :: dABintegral    ! A.B      integral; derivative wrt R, Z;

  REAL   , allocatable :: lvolume(:) ! volume integral of \sqrt g; computed in vo00aa;
  REAL                 :: dvolume    ! derivative of volume wrt interface geometry;

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

  LOGICAL              :: Lmgridexist = .false.
  LOGICAL              :: Lmgridhasbeensplined = .false.
  INTEGER              :: nextcur = 1            ! default given in readin; re-set in mg00aa; ! 11 Oct 12; 
  REAL                 :: Rmin, Rmax, Zmin, Zmax ! set in mg00aa;
  
! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

  INTEGER              :: nFreeIterations ! this counts the number of free-boundary iterations; only relevant if Lvacuum.ge.3; iterations terminated by maxfbits; 18 Oct 12;
  LOGICAL              :: Lcontinueiterations ! a logical flag used for convenience; indicates whether free-boundary iterations should continue; 18 Oct 12;

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
  
!latex \end{enumerate} \subsubsection{Diagnostics : periodic orbits} \begin{enumerate}

!latex \item Periodic orbits may be constructed. This information is contained in a \verb+periodicorbit+ structure called 
!latex
!latex \verb+pqorbit(1:Nvol,maxval(npq))+.

  type periodicorbit
     INTEGER              :: pq(2)            ! integers defining periodcity; \t(\z+2pi q) = \t(\z) + 2pi p;
     INTEGER              :: ok               ! flag indicating whether periodic orbit has been successfully located;
     REAL                 :: to, so           ! location of periodic orbit on \z=0; poloidal angle, \t, and radial coordinate, \s;
     REAL                 :: Ro, Zo           ! location of periodic orbit on \z=0; cylindrical   ,  R, and cylindrical      ,  Z;
     REAL                 :: residue          ! residue;
     REAL                 :: error            ! error;
     INTEGER              :: its              ! required iterations
     REAL                 :: wr(2)  , wi(2)   ! eigenvalues  of tangent map at periodic orbit;
     REAL                 :: vr(2,2), vi(2,2) ! eigenvectors of tangent map at periodic orbit;
     REAL,    allocatable :: s(:), t(:)       ! location of periodic orbit on all \z=const. planes;
     REAL,    allocatable :: a(:)             ! 
     REAL,    allocatable :: tt(:), ss(:)
     REAL,    allocatable :: dt(:)
  end type periodicorbit
  
  type(periodicorbit), allocatable :: pqorbit(:,:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  REAL                 :: Dzeta ! will be used for Lagrangian integration; 14 Nov 12;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{Diagnostics : quadratic-flux minimizing surfaces} \begin{enumerate}

!latex \item Quadratic-flux minimizing surfaces may be constructed.
!latex All the information is contained in a \verb+QFmin+ structure called \verb+qfms(1:Nvol,mnpq)+.

  type QFmin
     INTEGER              :: i ! flag;
     INTEGER              :: pq(2) ! periodicity;
     REAL,    allocatable :: trvs(:,:,:) ! theta, radial, action-gradient;
  end type QFmin

  type(QFmin),allocatable :: qfms(:,:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \end{enumerate} \subsubsection{Diagnostics : irrational surfaces} \begin{enumerate}

!latex \item Irrational, invariant flux surfaces may be constructed.
!latex The Fourier harmonics are described by \verb+irrmn+, \verb+irrim+ and \verb+irrin+.

  INTEGER              :: irrmn ! total number of Fourier harmonics for irrational surfaces; calculated from MNirr in readin;
  INTEGER, allocatable :: irrim(:), irrin(:) ! Fourier modes for irrational surfaces; set in readin;

  type irrational
     REAL              :: iota ! prescribed irrational transform
     REAL              :: Itor, Gpol ! secular parts;
     INTEGER           :: its ! iterations required to locate surface; screen diagnostics only I think;
     REAL              :: err ! accuracy;
     INTEGER           :: Npts ! resolution of discrete curve;
     REAL, allocatable :: sm(:), tm(:) ! radial and poloidal angle Fourier harmonics of irrational, invariant curve in toroidal coordinates;
     REAL              :: tflux ! enclosed toroidal flux;
     REAL, allocatable :: si(:), ti(:), di(:) ! invariant curve in discrete; interpolation coefficients;
     REAL, allocatable :: Rbc(:), Zbs(:) ! cylindrical Fourier harmonics of irrational/invariant surface in toroidal coordinates;
     REAL, allocatable :: Rbs(:), Zbc(:) ! cylindrical Fourier harmonics of irrational/invariant surface in toroidal coordinates;
     REAL, allocatable :: fmn(:) ! covariant field derived from surface potential;
  end type irrational

!latex The irrational surface Fourier harmonics, etc. are contained in a \verb+irrational+ structure called \verb+irrsurf+.

  type(irrational) :: irrsurf ! Fourier harmonics etc. of irrational surfaces ! shall construct one irrational surface per annulus;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! internal global variables; internal logical variables; default values are provided here; these may be changed according to input values;

  INTEGER              :: ivol ! labels volume; some subroutines (called by NAG) are fixed argument list but require the volume label;

  INTEGER              :: Ltangent = 1 ! indicates whether tangent field needs to be calculated by bf00aa, vc00aa;

  INTEGER              :: Lfb      = 1 ! indicates whether field lines are followed or backwards;

  INTEGER              :: oiMpol, oiNtor ! save original iMpol and iNtor, which may be changed internally; THIS IS POOR PROGRAMMING; BETTER TO DECLARE INTERNAL VARIABLES;

  REAL                 :: Bzeta ! toroidal (contravariant) field; calculated in bf00aa; required to convert \dot \t to B^\t, \dot s to B^s;

  INTEGER              :: iqfmin, jgd, kgd ! I don't know if all these are required to be global; see bf00aa_out and bf00aa_end;

  REAL                 :: actiongradient ! used to construct QFmin surfaces; probably not required to be global;

 !INTEGER              :: lextrap ! internal value of iextrap; set below in readin; used in fc00aa/fc01aa; given to ex00aa; probably redundant; ! 10 Oct 12;

  LOGICAL              :: Iwrpj ! internal copy of Lwrpj;

  INTEGER              :: Iquad ! internal copy of Nquad;

  LOGICAL              :: LCondenseSpectrum ! depends on input Iswmin;

  LOGICAL              :: LbeltramiLinear, LbeltramiNewton, LbeltramiSeQuad ! controls selection of Beltrami field solver; depends on Lbeltrami;

  LOGICAL              :: Lsparsematrix, Ldensematrix

  REAL                 :: oRZp(1:3) ! used in mg00aa to determine (\s,\t,\z) given (R,Z,p);

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOGICAL              :: Lautoin ! command line options;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  type derivative
     LOGICAL :: L
     INTEGER :: innout
     INTEGER :: irz
     INTEGER :: imn
  end type derivative
  
  type(derivative)  :: dAd
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following are required for the sparse solution to the straight-field-line coordinate on the interfaces;

  LOGICAL              :: Liotasparse, Liotastandard, LiotaSVD

  LOGICAL, allocatable :: AngleLogical(:,:)
  INTEGER              :: AngleNZ, AngleLIRN, AngleLICN, AngleIDISP(1:10)
  INTEGER, allocatable :: AngleIRN(:), AngleICN(:), AngleIKEEP(:), AngleIVECT(:), AngleJVECT(:)
  REAL   , allocatable :: AngleSparseMatrix(:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  INTEGER, allocatable :: NNZ(:) ! used to count non-zero elements of Beltrami linear system;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following are miscellaneous flags required for the virtual casing field, external (vacuum) field integration,  . . .
  
! INTEGER              :: odeintegrationerror ! 10 Oct 12; to be deleted;

  REAL                 :: xyz(1:3) ! point at which external field is required; NAG routines employed are fixed argument list, but require position;

! REAL                 :: residual(1:3) ! 10 Oct 12; to be deleted;

  REAL                 :: virtualcasingfactor = one / ( four*pi * pi2 )

  INTEGER              :: iexvol ! this must be set early; 24 Oct 12;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
contains

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine readin !latex \end{enumerate} \subsection{Subroutine readin} \begin{enumerate}

!latex \item The master node reads the input namelist and sets various secondary variables; variables are then broadcast;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item \verb+readin+ : Reads (and broadcasts) the input file.
!latex Various checks on input consistency are performed.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants

  use numerical

  use fileunits

  use inputlist

  use cputiming

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  LOGICAL              :: inputfileexist
  INTEGER              :: lvol, mm, nn, imn, ix, ii, ij, ip, lMpol, lNtor, X02BBF, iargc, iarg, numargs
  REAL                 :: X02AJF, X01AAF, machpi, xx, G05CAF
  REAL,    allocatable :: RZ(:,:) ! local array used for reading interface Fourier harmonics from file;
  
  CHARACTER            :: date*8, time*10, arg*100

  external             :: X02BBF

  BEGIN(readin)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  cput = MPI_WTIME()

  machprec = X02AJF() ; vsmall = 100*machprec ; small = 100*vsmall ; sqrtmachprec = sqrt(machprec) ! returns machine precision;

  largestint = X02BBF(0.0)
  
  machpi = X01AAF(0.0)

  FATALMESS(globals,abs(machpi-pi).gt.vsmall,incorrect value for pi)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( myid.eq.0 ) then ! only the master node reads input file and sets secondary variables;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
!  call A00AAF() ! check NAG version;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   call date_and_time(date,time)

   write(ounit,'("readin : " 10x " : ")')
   write(ounit,1000)cput-cpus,date(1:4),date(5:6),date(7:8),time(1:2),time(3:4),time(5:6),machprec,vsmall,small,largestint
   
1000 format("readin : "f10.2" : date="a4"/"a2"/"a2" , "a2":"a2":"a2" ; machine precision="es9.2" ; vsmall="es9.2" ; small="es9.2" ; largestint="i12" ; ")

   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : reading ext from command line ;")')cput-cpus
   endif
   
!latex \end{enumerate}\subsubsection{command line inputs} \begin{enumerate}

   call getarg(1,ext) !latex \item The input file name, \verb!ext!, is given as the first command line input, and the input file itself is \verb!ext.spec!.
   
   if( ext .eq. "-h" .or. ext .eq. "-help" ) then
    write(ounit,'("readin : "f10.2" : myid="i3" : command line options = -readin -autoin ;")')cput-cpus,myid
    call finished
   endif

   write(ounit,'("readin : " 10x " : ")')
   write(ounit,'("readin : "f10.2" : ext = "a100)')cput-cpus,ext

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Additional command line inputs recognized are:
!latex \begin{enumerate}

   Lautoin = .false. ! these are set on command line input;

   write(ounit,'("readin : " 10x " : ")')

   numargs = iargc()

   if( numargs.gt.1 ) then
    iarg = 1
    do while ( iarg < numargs )
     iarg = iarg + 1 ; call getarg( iarg, arg )
     select case( arg )
!latex \item \verb+-help, -h+ ; will give help information to user; under construction;
     case("-help","-h") ; write(ounit,'("readin : "f10.2" : myid="i3" : command line options = -readin -autoin ;")')cput-cpus,myid
!latex \item \verb+-readin+ ; will immediately set \verb+Wreadin=T+; this may be over-ruled when \verb+namelist/screenlist/+ is read;
     case("-readin"   ) ; Wreadin = .true.
!latex \item \verb+-autoin+ ; will NOT read namelists and geometry from \verb+ext.spec+; input information will be assigned in \verb+st00aa+;
     case("-autoin"   ) ; Lautoin = .true.
     case("-p4pg"     ) ; iarg = iarg + 1 ; call getarg( iarg, arg )
     case("-p4wd"     ) ; iarg = iarg + 1 ; call getarg( iarg, arg )
     case default       ; write(ounit,'("readin : "f10.2" : myid="i3" : argument not recognized ; arg = "a100)')cput-cpus,myid,arg
     end select
    enddo
   endif
   write(ounit,'("readin : "f10.2" : myid="i3" : Lautoin="L2" ; ")')cput-cpus,myid,Lautoin

!latex \end{enumerate}
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

   if( Lautoin ) then
    WCALL(readin,st00aa,('N'))
    goto 1099
   endif
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   inquire(file=trim(ext)//".spec",exist=inputfileexist) ! check if file exists;
   FATALMESS(readin,.not.inputfileexist,the input file does not exist) ! if not, abort;
      
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   open(iunit,file=trim(ext)//".spec",status="old")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/physicslist/ ; recall this is inside the if( myid.eq.0 );
   
   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : reading physicslist     from ext.spec ;")')cput-cpus
   endif

   read(iunit,physicslist)!,iostat=ios)
!  FATAL(readin : error reading physicslist,ios.ne.0)

   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : read    physicslist     from ext.spec ;")')cput-cpus
   endif
   
   FATAL(readin,Nfp.le.0)
   FATAL(readin,Lgeometry.lt.1 .or. Lgeometry.gt.6)
   FATAL(readin,Lgeometry.eq.5 .and. Mpol.lt.1)
   FATAL(readin,Lgeometry.eq.6 .and. Mpol.lt.1)
   FATAL(readin,Ntor.lt.0)
   FATALMESS(readin,Nvol.lt.1 .or. Nvol.gt.MNvol,need to recompile SPEC with increased MNvol)
   FATAL(readin,mupftol.le.zero)
   FATALMESS(readin,abs(one+gamma).lt.vsmall,1+gamma appears in denominator in fc02aa)
   FATALMESS(readin,abs(one-gamma).lt.vsmall,1-gamma appears in denominator in fu00aa)

   do lvol = 2, Nvol
    FATALMESS(readin,tflux(lvol)-tflux(lvol-1).lt.small,toroidal flux is not monotonic)
   enddo

   if( Lvacuum.eq.0 ) then ; tflux(1:Nvol) = tflux(1:Nvol) / tflux(Nvol  )
   else                    ; tflux(1:Nvol) = tflux(1:Nvol) / tflux(Nvol-1) ! normalize toroidal flux; phiedge and pi2 factors included when required; 24 Oct 12;
   endif

   FATALMESS(readin,Lvacuum.ne.0 .and. abs(mu(Nvol)).gt.vsmall,outermost volume is not vacuum)
  !FATALMESS(readin,LVns.ne.0 .and. LVns.ne.1,invalid) ! 23 Oct 12;

   FATALMESS(readin,abs(Itoroidal).ne.1,must set Itoroidal = -1 or Itoroidal = +1)

!  FATALMESS(readin,Lmask.ne.0 .and. Lmask.ne.1,Lmask must be equal to 0 or 1)

   do nn = -Ntor, Ntor
    do mm = 0, Mpol
     FATALMESS(readin,mm.eq.0 .and. nn.lt.0 .and. abs(Rbc(nn,mm)).gt.vsmall,illegal)
    enddo
   enddo

   mask(-MNtor:MNtor,0:MMpol) = 1 ! under construction;

   do nextcur = maxgroups, 1, -1
    if( abs(extcur(nextcur)).gt.vsmall ) exit ! this will provide default value for nextcur; this may be over-written in mg00aa;
   enddo

!  do lvol = 1, Nvol
!   FATAL(readin,Ni(lvol).lt.2) ! radial sub-grid resolution; why is this; what sets lower limit on radial resolution?;
!  enddo

   if( sum(pres(1:Nvol)).gt.vsmall ) write(ounit,'("readin : " 10x " : PRES IS REDUNDANT; please remove from namelist/physicslist/; pres -> pressure;")')
   if( sum(adiab(1:Nvol)).gt.vsmall ) write(ounit,'("readin : " 10x " : ADIAB IS REDUNDANT; please remove from namelist/physicslist/; adiab -> adiabatic;")')
   if( Ltoroidal.ne.-9 ) write(ounit,'("readin : " 10x " : LTOROIDAL IS REDUNDANT; please remove from namelist/physicslist/; see documentation for Itoroidal ;")')

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/numericlist/ ; recall this is inside the if( myid.eq.0 );
   
   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : reading numericlist     from ext.spec ;")')cput-cpus
   endif

   read(iunit,numericlist)!,iostat=ios)
!  FATAL(readin : error reading numericlist,ios.ne.0)

   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : read    numericlist     from ext.spec ;")')cput-cpus
   endif
   
!  FATAL(readin,iextrap.eq.0 .or. iextrap.gt.Nvol)
   FATAL(readin,Ndiscrete.le.0)
   FATAL(readin,Nofe.lt.1 .or. Nofe.gt.3)
   FATAL(readin,Iswmin.lt.0 .or. Iswmin.gt.3)

   if( Lsymagl        ) write(ounit,'("readin : " 10x " : LSYMAGL IS REDUNDANT; please remove from namelist/numericlist/;")')
   if( Lslabel .ne.-9 ) write(ounit,'("readin : " 10x " : LSLABEL IS REDUNDANT; please remove from namelist/numericlist/;")')
   if( Lsinterp.ne.-9 ) write(ounit,'("readin : " 10x " : LSINTERP IS REDUNDANT; please remove from namelist/numericlist/;")')
   if( Ldmupf  .ne.-1 ) write(ounit,'("readin : " 10x " : LDMUPF IS REDUNDANT; please remove from namelist/numericlist/;")')

   oiMpol = iMpol ! save original input ; these "input" values may be changed internally;
   oiNtor = iNtor ! save original input ; these "input" values may be changed internally;

   if( Ntor.eq.0 ) iNtor=0

   FATAL(readin,iMpol.eq.0)
   FATAL(readin,Ntor.gt.0 .and. iNtor.eq.0)
   
   if( iMpol.lt.0 ) then ; iMpol = 4 * max(1,Mpol) * abs(iMpol) ! allow user input default;
   endif
   if( iNtor.lt.0 ) then ; iNtor = 4 *       Ntor  * abs(iNtor) ! allow user input default;
   endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/linearlist/
   
   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : reading linearlist      from ext.spec ;")')cput-cpus
   endif

   read(iunit,linearlist)!,iostat=ios)
!  FATAL(readin : error reading linearlist,ios.ne.0)
   
   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : read    linearlist      from ext.spec ;")')cput-cpus
   endif

   FATAL(readin,Lbeltrami.lt.0 .or. Lbeltrami.gt.7)
   FATAL(readin,sparsetol.gt.one)
   FATAL(readin,Lprecon.lt.0 .or. Lprecon.gt.2)
   FATAL(readin,ssoromega.lt.zero .or. ssoromega.gt.two)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/nonlinearlist/

   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : reading nonlinearlist   from ext.spec ;")')cput-cpus
   endif
   
   read(iunit,nonlinearlist)!,iostat=ios)
!  FATAL(readin : error reading nonlinearlist,ios.ne.0)

   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : read    nonlinearlist   from ext.spec ;")')cput-cpus
   endif

   FATAL(readin,normalerr.le.zero)
   FATAL(readin,maxfbits.lt.zero)

   FATAL(readin,c05xtol.le.zero)
   FATAL(readin,c05factor.le.zero)

  !forceerr = -1.0 ! 02 Nov 12;
  !energy = -1.0 ! 02 Nov 12;

   if( Le04lyf           ) write(ounit,'("readin : " 10x " : LE04LYF IS REDUNDANT  ; please remove from namelist/nonlinearlist/;")')
   if( Lgradient.ne. -9  ) write(ounit,'("readin : " 10x " : LGRADIENT IS REDUNDANT; please remove from namelist/nonlinearlist/;")')
   if( ifinited .ne. -9  ) write(ounit,'("readin : " 10x " : IFINITED IS REDUNDANT ; please remove from namelist/nonlinearlist/;")')
   if( factor   .ge. zero) write(ounit,'("readin : " 10x " : FACTOR   IS REDUNDANT ; please remove from namelist/nonlinearlist/;")')
   if( xftol    .ge. zero) write(ounit,'("readin : " 10x " : XFTOL    IS REDUNDANT ; please remove from namelist/nonlinearlist/;")')

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/diagnosticslist/

   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : reading diagnosticslist from ext.spec ;")')cput-cpus
   endif
   
   read(iunit,diagnosticslist)!,iostat=ios)
!  FATAL(readin : error reading diagnosticslist,ios.ne.0)

   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : read    diagnosticslist from ext.spec ;")')cput-cpus
   endif

   FATAL(readin,odetol.le.zero)
   FATAL(readin,absreq.le.zero)
   FATAL(readin,relreq.le.zero)
   FATAL(readin,absacc.le.zero)
   FATAL(readin,Lpoincare.ne.0 .and. Lpoincare.ne.1 .and. Lpoincare.ne.2)
   FATAL(readin,nPpts.lt.0)   
   FATAL(readin,Mpqits.lt.0)
   FATAL(readin,Lpqsym.lt.0.or.Lpqsym.gt.1)
   FATAL(readin,irrMpol.le.0)
   FATAL(readin,irrNtor.lt.0)
   FATAL(readin,Mirrits.lt.0)
   FATAL(readin,irrsvdcut.lt.zero)
   FATAL(readin,irrtol.lt.zero)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/screenlist

   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : reading screenlist      from ext.spec ;")')cput-cpus
   endif
   
   read(iunit,screenlist)!,iostat=ios)
!  FATAL(readin : error reading screenlist,ios.ne.0)

   if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : read    screenlist      from ext.spec ;")')cput-cpus
   endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! additional checks on input logic;

   FATALMESS(readin,Lvacuum.ge.3 .and. ( Lminimize.eq.0 .and. Lfindzero.eq.0 ),free-boundary iterations require force-balance) ! 26 Oct 12;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

1099 continue ! end of Lautoin;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! screen output of namelist/physicslist/

   write(ounit,'("readin : " 10x " : ")')

   write(ounit,1010) cput-cpus, Lgeometry, Lstellsym, Itoroidal
   write(ounit,1011)            Lvacuum, nextcur, phiedge, curtor, gamma
   write(ounit,1012)            Nfp, Nvol, Mpol, Ntor
   write(ounit,1013)            pscale, Lconstraint, mupftol, mupfits

1010 format("readin : "f10.2" : Lgeometry="i3" ; Lstellsym="i3" ; Itoroidal="i3" ;")
1011 format("readin : " 10x " : Lvacuum="i3" ; nextcur="i4" ; phiedge="es23.15" ; curtor="es23.15" ; gamma="es23.15" ;")
1012 format("readin : " 10x " : Nfp="i3" ; Nvol="i3" ; Mpol="i3" ; Ntor="i3" ;")
1013 format("readin : " 10x " : pscale="es13.5" ; Lconstraint="i2" ; mupf: tol,its="es13.5," ,"i4" ;")
   
!  if( ) write(ounit,'("readin : "f10.2" : Ni       ="11x"  "1000(i7"     ,":))')cput-cpus,(Ni(lvol),lvol=1,Nvol)
!  if( ) write(ounit,'("readin : "f10.2" : tflux    ="1000(es11.3" ,":))')cput-cpus,( tflux(lvol),lvol=0,Nvol)
!  if( ) write(ounit,'("readin : "f10.2" : pflux    ="1000(es11.3" ,":))')cput-cpus,( pflux(lvol),lvol=0,Nvol)
!  if( ) write(ounit,'("readin : "f10.2" : helicity ="1000(es11.3" ,":))')cput-cpus,( pflux(lvol),lvol=0,Nvol)
!  if( ) write(ounit,'("readin : "f10.2" : pressure ="11x"  "1000(es11.3" ,":))')cput-cpus,(pressure(lvol),lvol=1,Nvol)
!  if( ) write(ounit,'("readin : "f10.2" : mu       ="11x"  "1000(es11.3" ,":))')cput-cpus,(mu(lvol),lvol=1,Nvol)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! screen output of namelist/numericlist/

   write(ounit,'("readin : " 10x " : ")')

   write(ounit,1020) cput-cpus, Linitialize, Lwall, phiwall, Ndiscrete, iextrap
   write(ounit,1021)            Nofe, Nquad, oiMpol, iMpol, oiNtor, iNtor
   write(ounit,1022)            Iswmin, Lperturb, dperturb

1020 format("readin : "f10.2" : Linitialize="i3" ; Lwall="i3" ; phiwall="es13.5" ; Ndiscrete="i2" ; iextrap="i3" ;")
1021 format("readin : " 10x " : Nofe="i2" ; Nquad="i4" ; iMpol="i4" ->"i4" ; iNtor="i4" ->"i4" ;")
1022 format("readin : " 10x " : Iswmin="i2" ; Lperturb="i2" ; dperturb="es13.5" ;")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! screen output of namelist/linearlist/

   write(ounit,'("readin : " 10x " : ")')

   write(ounit,1030) cput-cpus, Lbeltrami, Linitgues, Ldense, Lposdef, Nmaxexp
   write(ounit,1031)            Lprecon, sparseits, ssoromega, sparsetol
   write(ounit,1032)            Liotasolv

1030 format("readin : "f10.2" : Lbeltrami="i2" ; Linitgues="i2" ; Ldense="i2" ; Lposdef="L2" ; Nmaxexp="i3" ;")
1031 format("readin : " 10x " : Lprecon="i2" ; sparseits="i4" ; ssoromega="f6.3" ; sparsetol="es13.5" ;")
1032 format("readin : " 10x " : Liotasolv="i2" ;")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! screen output of namelist/nonlinearlist/

   write(ounit,'("readin : " 10x " : ")')

   write(ounit,1040) cput-cpus, Lminimize, Lfindzero
   write(ounit,1041)            pwidth, qwidth
   write(ounit,1042)            forcetol, normalerr, norblend, maxfbits, c05xtol, c05factor
   write(ounit,1043)            LreadGF, verify, maxstep, epsilon, maxiter

1040 format("readin : "f10.2" : Lminimize="i2" ; Lfindzero="i2" ;")
1041 format("readin : " 10x " : pwidth="i3" ; qwidth="i3" ;")
1042 format("readin : " 10x " : forcetol="es13.5" ; normalerr="es13.5" ; norblend="es13.5" ; maxfbits="i4" ; c05xtol="es13.5" ; c05factor="es13.5" ;")
1043 format("readin : " 10x " : LreadGF="L2" ; verify="i3" ; maxstep="es13.5" ; epsilon="es13.5" ; maxiter="i9" ;")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! screen output of namelist/diagnosticslist/
   
   write(ounit,'("readin : " 10x " : ")')

   write(ounit,1050) cput-cpus, odetol, absreq, relreq, absacc
   write(ounit,1051)            Lpoincare
   write(ounit,1052)            nPpts, Mpqits, Npl, Lpqsym, Nunstable, dunstable, Munstable
   write(ounit,1053)            Mirrits, irrMpol, irrNtor, irrsvdcut, irrtol, Lwrpj
   write(ounit,1054)            Nghd, LHessian, LHevalues, LHevectors, Lcurlerr, Lcheck, Lexamine, Ltiming

1050 format("readin : "f10.2" : odetol="es13.5" ; absreq="es13.5" ; relreq="es13.5" ; absacc="es13.5" ;")
1051 format("readin : " 10x " : Lpoincare="i2" ;")
1052 format("readin : " 10x " : nPpts="i6" ; Mpqits="i3" ; Npl="i3" ; Lpqsym="i2" ; Nunstable="i6" ; dunstable="es8.1" ; Munstable="i3" ;")
1053 format("readin : " 10x " : Mirrits="i3" ; irrMpol="i4" ; irrNtor="i4" ; irrsvdcut="es13.5" ; irrtol="es13.5" ; Lwrpj="L2" ;")
1054 format("readin : " 10x " : Nghd="i3" ; LHessian="L2" ; LHevalues="L2" ; LHevectors="L2" ; Lcurlerr="L2" ; Lcheck="i2" ; Lexamine="L2" ; Ltiming="L2" ;")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! screen output of namelist/screenlist/; no screen output;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   write(ounit,'("readin : " 10x " : ")')

  endif ! end of if myid eq 0 loop;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! broadcast command line input
  
  ClBCAST(ext,100,0)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/physicslist/
  
  if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : broadcasting physicslist     from ext.spec ;")')cput-cpus
  endif
  
  IlBCAST(Lgeometry,1,0)
  IlBCAST(Lstellsym,1,0)
  IlBCAST(Itoroidal,1,0)
! IlBCAST(Lfreebound,1,0) ! 10 Oct 12; 
  IlBCAST(Lvacuum,1,0)
 !IlBCAST(LVns,1,0) ! 23 Oct 12;
  RlBCAST(phiedge,1,0)
  RlBCAST(curtor,1,0)
  RlBCAST(extcur,maxgroups,0)
  RlBCAST(gamma,1,0)
  IlBCAST(Nfp,1,0)
  IlBCAST(Nvol,1,0)
  IlBCAST(Mpol,1,0)
  IlBCAST(Ntor,1,0)
  IlBCAST(Ni,MNvol,0)
  RlBCAST(tflux,MNvol+1,0)
  RlBCAST(pflux,MNvol+1,0)
  RlBCAST(helicity,MNvol+1,0)
  RlBCAST(pscale,1,0)
  RlBCAST(pressure,MNvol,0)
  IlBCAST(Ladiabatic,1,0)
  RlBCAST(adiabatic,MNvol,0)
 !RlBCAST(beta,1,0)
  RlBCAST(mu,MNvol,0)
  IlBCAST(Lconstraint,1,0)
  IlBCAST(pl,MNvol+1,0)
  IlBCAST(ql,MNvol+1,0)
  IlBCAST(pr,MNvol+1,0)
  IlBCAST(qr,MNvol+1,0)
  RlBCAST(iota,MNvol+1,0)
! IlBCAST(Lmask,1,0)
  RlBCAST(mupftol,1,0)
  IlBCAST(mupfits,1,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/numericlist/
  
  if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : broadcasting numericlist     from ext.spec ;")')cput-cpus
  endif
  
  IlBCAST(Linitialize,1,0)
  IlBCAST(Lwall,1,0)
  RlBCAST(phiwall,1,0)
  IlBCAST(iextrap,1,0)
  IlBCAST(Ndiscrete,1,0)
  IlBCAST(Nofe,1,0)
  IlBCAST(Nquad,1,0)
  IlBCAST(iMpol,1,0)
  IlBCAST(iNtor,1,0)
! IlBCAST(Ldmupf,1,0)
  IlBCAST(Iswmin,1,0)
! LlBCAST(Lsymagl,1,0)
  IlBCAST(Lperturb,1,0)
  RlBCAST(dperturb,1,0)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! broadcast namelist/nonlinearlist/
  
  if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : broadcasting nonlinearlist   from ext.spec ;")')cput-cpus
  endif
  
  IlBCAST(Lminimize,1,0)
  IlBCAST(Lfindzero,1,0)
  IlBCAST(pwidth,1,0)
  IlBCAST(qwidth,1,0)
  RlBCAST(forcetol,1,0)
  RlBCAST(normalerr,1,0)
  RlBCAST(norblend,1,0)
  IlBCAST(maxfbits,1,0)
 !RlBCAST(forceerr,1,0) ! this is an ``output'' quantity;
 !RlBCAST(energy,1,0)   ! this is an ``output'' quantity;
  RlBCAST(c05xtol,1,0)
  RlBCAST(c05factor,1,0)
 !IlBCAST(ifinited,1,0)
 !IlBCAST(Lgradient,1,0)
  LlBCAST(LreadGF,1,0)
  IlBCAST(verify,1,0)
  RlBCAST(maxstep,1,0)
  RlBCAST(epsilon,1,0)
  IlBCAST(maxiter,1,0)
 !IlBCAST(normalize,1,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/linearlist/

  if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : broadcasting linearlist      from ext.spec ;")')cput-cpus
  endif
  
  IlBCAST(Lbeltrami,1,0)
  IlBCAST(Linitgues,1,0)
  IlBCAST(Ldense,1,0)
  LlBCAST(Lposdef,1,0)
  IlBCAST(Nmaxexp,1,0)
  IlBCAST(Lprecon,1,0)
  IlBCAST(sparseits,1,0)
  RlBCAST(ssoromega,1,0)
  RlBCAST(sparsetol,1,0)
  IlBCAST(Liotasolv,1,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/diagnosticslist/

  if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : broadcasting diagnosticslist from ext.spec ;")')cput-cpus
  endif
  
  RlBCAST(odetol,1,0)
  RlBCAST(absreq,1,0)
  RlBCAST(relreq,1,0)
  RlBCAST(absacc,1,0)
 !RlBCAST(divertorR,1,0)
 !RlBCAST(divertorZ,1,0)
  IlBCAST(Lpoincare,1,0)
  IlBCAST(nPpts,1,0)
  IlBCAST(nPtrj,(MNvol+1),0)
  IlBCAST(Mpqits,1,0)
  IlBCAST(Lpqsym,1,0)
  IlBCAST(p1,(MNvol),0)
  IlBCAST(q1,(MNvol),0)
  IlBCAST(p2,(MNvol),0)
  IlBCAST(q2,(MNvol),0)
  RlBCAST(pqs,(MNvol),0)
  RlBCAST(pqt,(MNvol),0)
  IlBCAST(Npl,1,0)
  IlBCAST(Nunstable,(MNvol),0)
  RlBCAST(dunstable,(MNvol),0)
  IlBCAST(Munstable,(MNvol),0)
  IlBCAST(npq,(MNvol),0)
  IlBCAST(Mirrits,1,0)
  IlBCAST(irrMpol,1,0)
  IlBCAST(irrNtor,1,0)
  RlBCAST(irrsvdcut,1,0)
  RlBCAST(irrtol,1,0)
  LlBCAST(Lwrpj,1,0)
  IlBCAST(Nghd,1,0)
  LlBCAST(LHessian,1,0)
  LlBCAST(LHevalues,1,0)
  LlBCAST(LHevectors,1,0)
  LlBCAST(Lcurlerr,1,0)
  IlBCAST(Lcheck,1,0)
  LlBCAST(Lexamine,1,0)
  LlBCAST(Ltiming,1,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/screenlist/

  if( Wreadin ) then ; cput = MPI_WTIME() ; write(ounit,'("readin : "f10.2" : broadcasting screenlist      from ext.spec ;")')cput-cpus
  endif

! BSCREENLIST ! broadcast screenlist; this is expanded by Makefile; do not remove;
  LlBCAST(Wreadin,1,0)
  LlBCAST(Wwritin,1,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on physicslist;

! pi2nfp = pi2 / Nfp ; pi2pi2nfpquarter = pi2 * pi2nfp * quarter ! numerical constants; now in al00aa; May  2 2012;

  mn  =  Ntor + 1 +  Mpol * ( 2* Ntor + 1 ) ! Fourier resolution of interface geometry & vector potential;
  IALLOCATE(im,(1:mn))
  IALLOCATE(in,(1:mn))
  CALL(gi00ab,(  Mpol,  Ntor, Nfp, mn, im, in  )) ! this sets the im and in mode identification arrays;

  lMpol = 2*Mpol ; lNtor = 2*Ntor ! enhanced resolution for metrics;

  mne = lNtor + 1 + lMpol * ( 2*lNtor + 1 ) ! resolution of metrics; enhanced resolution; see me00ab;
  IALLOCATE(ime,(1:mne))
  IALLOCATE(ine,(1:mne))
  CALL(gi00ab,( lMpol, lNtor, Nfp, mne, ime, ine ))

  mns = iNtor + 1 + iMpol * ( 2*iNtor + 1 ) ! resolution of straight-field line transformation on interfaces; see tr00ab;
  IALLOCATE(ims,(1:mns))
  IALLOCATE(ins,(1:mns))
  CALL(gi00ab,( iMpol, iNtor, Nfp, mns, ims, ins )) ! note that the field periodicity factor is included in in;
 
  RALLOCATE(nflux,(1:Nvol))
  nflux(1:Nvol) = tflux(1:Nvol) / tflux(Nvol) ! normalized toroidal flux; ! tflux is already normalized; THIS NEEDS REVISION; 24 Oct 12;

  if( Wreadin .and. myid.eq.0 ) then
   write(ounit,'("readin : " 10x " : myid="i3" : nflux(1:Nvol)="99es13.5)')myid,nflux(1:Nvol)
   write(ounit,'("readin : " 10x " : myid="i3" : nflux(1)**(m/2)="99es13.5)')myid,nflux(1)**( (/ (mm,mm=0,Mpol) /)*half )
  endif

  if( Lvacuum.gt.0 ) then ; iexvol = 1 ! 10 Oct 12; this selects which tangential field is written to file: either just inside          last interface,
  else                    ; iexvol = 0 ! 10 Oct 12;                                                         or     just outside next-to-last interface;
  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on numericlist;

!latex \item The resolution of the radial sub-sub-grid is given \verb+Nquad+.

!  if( Nquad.gt.0 ) then ; Iquad = Nquad                ! now in al00aa; May  2 2012;
!  else                  ; Iquad = 2 * Nofe + 3 - Nquad ! now in al00aa; May  2 2012;
!  endif                                                ! now in al00aa; May  2 2012;

!  if( iextrap.gt.0 .and. iextrap.le.Nvol ) then ; lextrap = iextrap ! now in al00aa; May  2 2012;
!  else                                          ; lextrap = Nvol    ! now in al00aa; May  2 2012;
!  endif                                                             ! now in al00aa; May  2 2012;

!  LCondenseSpectrum      = .false. ! now in al00aa; May  2 2012;
!  LSaveCondensedBoundary = .false. ! now in al00aa; May  2 2012;
!  LEarlyTermination      = .false. ! now in al00aa; May  2 2012;
!
!  if( Iswmin.eq.1 .or. Iswmin.eq.3 .or. Iswmin.eq.5 .or. Iswmin.eq.7 ) LCondenseSpectrum       = .true. ! initially convert interfaces to spectrally condensed angle;
!  if( Iswmin.eq.2 .or. Iswmin.eq.3 .or. Iswmin.eq.6 .or. Iswmin.eq.7 ) LSaveCondensedBoundary  = .true. ! write spectrally condensed boundary to restart file;
!  if( Iswmin.eq.4 .or. Iswmin.eq.5 .or. Iswmin.eq.6 .or. Iswmin.eq.7 ) LEarlyTermination       = .true.
!
!  if( LSaveCondensedBoundary ) Iswmin = 0 ! will not repeatedly (on restarts) condense the Fourier spectrum of the boundary; avoid accumulating truncation errors;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on linearlist;

!  LbeltramiLinear = .false.
!  LbeltramiNewton = .false.
!  LbeltramiSeQuad = .false.
!
!  if( Lbeltrami.eq.1 .or. Lbeltrami.eq.3 .or. Lbeltrami.eq.5 .or. Lbeltrami.eq.7 ) LbeltramiLinear = .true.
!  if( Lbeltrami.eq.2 .or. Lbeltrami.eq.3 .or. Lbeltrami.eq.6 .or. Lbeltrami.eq.7 ) LbeltramiNewton = .true.
!  if( Lbeltrami.eq.4 .or. Lbeltrami.eq.5 .or. Lbeltrami.eq.6 .or. Lbeltrami.eq.7 ) LbeltramiSeQuad = .true.
!
!  if( Ldense.eq.0 .or. Ldense.eq.2 ) Lsparsematrix = .true. ! will solve Beltrami linear system using sparse algorithms;
!  if( Ldense.eq.1 .or. Ldense.eq.2 ) Ldensematrix  = .true.
!
!  if( myid.eq.0 ) then
!   write(ounit,'("readin : "f10.2" : LbeltramiLinear ="L2" , LbeltramiNewton ="L2" , LbeltramiSeQuad ="L2" ;")')cput-cpus, LbeltramiLinear, LbeltramiNewton, LbeltramiSeQuad
!  endif
!
!  Liotasparse   = .false. ! relates to construction of straight-field-line angle on interfaces;
!  Liotastandard = .false. ! relates to construction of straight-field-line angle on interfaces;
!  LiotaSVD      = .false. ! relates to construction of straight-field-line angle on interfaces;
!
!  if( Liotasolv.eq.1 .or. Liotasolv.eq.3 .or. Liotasolv.eq.5 .or. Liotasolv.eq.7 ) Liotasparse   = .true.
!  if( Liotasolv.eq.2 .or. Liotasolv.eq.3 .or. Liotasolv.eq.6 .or. Liotasolv.eq.7 ) Liotastandard = .true.
!  if( Liotasolv.eq.4 .or. Liotasolv.eq.5 .or. Liotasolv.eq.6 .or. Liotasolv.eq.7 ) LiotaSVD      = .true.
!
!  if( myid.eq.0 ) then
!   write(ounit,'("readin : "f10.2" : Liotasparse     ="L2" , Liotastandard   ="L2" , LiotaSVD        ="L2" ;")')cput-cpus, Liotasparse, Liotastandard, LiotaSVD
!   write(ounit,'("readin : "f10.2" : ")')cput-cpus
!  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on nonlinearlist;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on diagnosticslist;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RALLOCATE( iRbc,(0:Nvol,1:mn)) ! interface Fourier harmonics;
  RALLOCATE( iZbs,(0:Nvol,1:mn))
  RALLOCATE( iRbs,(0:Nvol,1:mn)) ! interface Fourier harmonics;
  RALLOCATE( iZbc,(0:Nvol,1:mn))

! IALLOCATE(imask,(       1:mn))

  RALLOCATE( iBns,(1:mn)) ! non-zero normal field at outermost interface;
  RALLOCATE( iBnc,(1:mn))

  RALLOCATE( iVns,(1:mn)) ! non-zero normal field at outermost interface;
  RALLOCATE( iVnc,(1:mn))

  RALLOCATE(lRbc,(       1:mn)) ! interface Fourier harmonics;
  RALLOCATE(lZbs,(       1:mn))
  RALLOCATE(lRbs,(       1:mn)) ! interface Fourier harmonics;
  RALLOCATE(lZbc,(       1:mn))
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( myid.eq.0 ) then ! will set geometry of interfaces;
   
   if( Lautoin ) then
    
    WCALL(readin,st00aa,('G')) ! geometry will be supplied elsewhere;
    
   else
    
    do imn = 1, mn ; mm = im(imn) ; nn = in(imn) / Nfp
     
     iRbc(Nvol,imn) = Rbc(nn,mm) ! plasma boundary is ALWAYS given by namelist Rbc & Zbs;
     iZbs(Nvol,imn) = Zbs(nn,mm)
     iRbs(Nvol,imn) = Rbs(nn,mm) ! plasma boundary is ALWAYS given by namelist Rbs & Zbc;
     iZbc(Nvol,imn) = Zbc(nn,mm)
     iBns(     imn) = Bns(nn,mm) ! non-zero normal B ALWAYS given by namelist Rbs & Zbc;
     iBnc(     imn) = Bnc(nn,mm)
     iVns(     imn) = Vns(nn,mm) ! non-zero normal B ALWAYS given by namelist Rbs & Zbc;
     iVnc(     imn) = Vnc(nn,mm)

    enddo ! end of do imn = 1, mn;
    

    select case( Linitialize ) ! 24 Oct 12;
     
    case( 0 ) ! initial guess for geometry of the interior surfaces is given in the input file;
     
     RALLOCATE(RZ,(1:2,0:Nvol)) ! temp array for reading input;
     
     do ! will read in Fourier harmonics until the end of file is reached;
      
      read(iunit,*,iostat=ios) mm, nn, RZ(1:2,0:Nvol)
      if( ios.ne.0 ) exit
      do imn = 1, mn ! loop over harmonics within range;
       if( mm.eq.im(imn) .and. nn*Nfp.eq.in(imn) ) then
        iRbc(0:Nvol-1,imn) = RZ(1,0:Nvol-1) ! select relevant harmonics;
        iZbs(0:Nvol-1,imn) = RZ(2,0:Nvol-1) ! select relevant harmonics;
        FATALMESS(readin,Lstellsym.ne.1,need to include non-symmetric interface harmonics)
       endif
      enddo ! end of do imn;
      
     enddo ! end of do;
     
     DEALLOCATE(RZ)
     
    case( 1 ) ! initialize internal geometry using regular extrapolation; THIS IS REPEATED IN xspec AFTER CALL TO wa00aa; 24 Oct 12;
     
     do lvol = 1, Nvol-1
      iRbc(lvol,1:mn) = iRbc(Nvol,1:mn) * nflux(lvol)**(im(1:mn)*half) ! nflux = normalized toroidal flux;
      iZbs(lvol,2:mn) = iZbs(Nvol,2:mn) * nflux(lvol)**(im(2:mn)*half) ! nflux = normalized toroidal flux;
      iRbs(lvol,2:mn) = iRbs(Nvol,2:mn) * nflux(lvol)**(im(2:mn)*half) ! nflux = normalized toroidal flux;
      iZbc(lvol,1:mn) = iZbc(Nvol,1:mn) * nflux(lvol)**(im(1:mn)*half) ! nflux = normalized toroidal flux;
     enddo
     
     iBns(1:mn) = zero

    case default
     
     FATALMESS(readin,.true.,invalid Linitialize)
     
    end select


    close(iunit)
    
    if( Lperturb.eq.1 ) then ! add random perturbation to interior interface Fourier harmonics;
     do lvol = 1, Nvol-1
      do imn = 1, mn
       xx = G05CAF(xx) ; iRbc(lvol,imn) = iRbc(lvol,imn) + ( xx - half ) * dperturb
       xx = G05CAF(xx) ; iZbs(lvol,imn) = iZbs(lvol,imn) + ( xx - half ) * dperturb ! only required for imn > 1;
       xx = G05CAF(xx) ; iRbs(lvol,imn) = iRbs(lvol,imn) + ( xx - half ) * dperturb ! only required for imn > 1;
       xx = G05CAF(xx) ; iZbc(lvol,imn) = iZbc(lvol,imn) + ( xx - half ) * dperturb
      enddo
     enddo
    endif
    
   endif ! end of if( Lautoin );
   
  endif ! end of if myid.eq.0 loop; only the master will read the input file; all variables need to be broadcast;
  
  RlBCAST( iRbc(0:Nvol,1:mn),(Nvol+1)*mn,0)
  RlBCAST( iZbs(0:Nvol,1:mn),(Nvol+1)*mn,0) ! only required for imn > 1 ;
  RlBCAST( iRbs(0:Nvol,1:mn),(Nvol+1)*mn,0) ! only required for imn > 1 ;
  RlBCAST( iZbc(0:Nvol,1:mn),(Nvol+1)*mn,0)
! IlBCAST(imask(       1:mn),         mn,0)
  RlBCAST( iBns(       1:mn),         mn,0) ! only required for imn > 1 ;
  RlBCAST( iBnc(       1:mn),         mn,0)
  RlBCAST( iVns(       1:mn),         mn,0) ! only required for imn > 1 ;
  RlBCAST( iVnc(       1:mn),         mn,0)
 
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(readin)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine readin

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine writin( wflag, iflag, rflag ) !latex \end{enumerate} \subsubsection{writin} \begin{enumerate}

!latex \item The restart file is written.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only :

  use numerical, only : machprec

  use fileunits, only : ounit, iunit, zunit

  use cputiming, only : Twritin

  use inputlist

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER, intent(in)  :: wflag, iflag
  REAL   , intent(in)  :: rflag
  
  LOGICAL              :: Lverbose = .true. ! will eventually have this as user input; set Lverbose = .false. to have concise restart file;

  INTEGER              :: lvol, imn, ii, jj, kk, Lcurv, mm, nn, lextrap
  REAL                 :: lss
  
  BEGIN(writin)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( myid.ne.0 ) goto 9999

  FATAL(writin,myid.ne.0)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  WCALL(writin,hdfint,( mn, Nvol ))
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Wwritin ) then ; cput = MPI_WTIME() ; write(ounit,'("writin : "f10.2" : myid="i3" ; opening/writing ext.end ;")')cput-cpus,myid
  endif

  open(iunit,file=trim(ext)//".end",status="unknown") ! restart input file;
  
  ;                                     write(iunit,'("&physicslist")')
  ;                                     write(iunit,'(" Lgeometry   = "i9            )')Lgeometry
  if( Lstellsym .ne. 1  .or. Lverbose ) write(iunit,'(" Lstellsym   = "i9            )')Lstellsym
  if( Itoroidal .ne.-1  .or. Lverbose ) write(iunit,'(" Itoroidal   = "i9            )')Itoroidal
  if( Lvacuum   .ne. 0  .or. Lverbose ) write(iunit,'(" Lvacuum     = "i9            )')Lvacuum
 !if( LVns      .ne. 0  .or. Lverbose ) write(iunit,'(" LVns        = "i9            )')LVns ! 23 Oct 12;
  if(                        Lverbose ) write(iunit,'(" phiedge     = "es23.15       )')phiedge
  if(                        Lverbose ) write(iunit,'(" curtor      = "es23.15       )')curtor
  if(                        Lverbose ) write(iunit,'(" extcur      = "999es23.15    )')extcur(1:max(nextcur,1))
  ;                                     write(iunit,'(" gamma       = "es23.15       )')gamma
  ;                                     write(iunit,'(" Nfp         = "i9            )')Nfp
  ;                                     write(iunit,'(" Nvol        = "i9            )')Nvol
  ;                                     write(iunit,'(" Mpol        = "i9            )')Mpol
  ;                                     write(iunit,'(" Ntor        = "i9            )')Ntor
  ;                                     write(iunit,'(" Ni          = "23x,999i23    )')Ni(1:Nvol)
  ;                                     write(iunit,'(" tflux       = "999es23.15    )')tflux(0:Nvol)
  ;                                     write(iunit,'(" pflux       = "999es23.15    )')pflux(0:Nvol)
  ;                                     write(iunit,'(" helicity    = "999es23.15    )')helicity(0:Nvol)
  ;                                     write(iunit,'(" pscale      = "es23.15       )')pscale
  ;                                     write(iunit,'(" pressure    = "23x,999es23.15)')pressure(1:Nvol)
  ;                                     write(iunit,'(" Ladiabatic  = "i9            )')Ladiabatic
  ;                                     write(iunit,'(" adiabatic   = "23x,999es23.15)')adiabatic(1:Nvol)
 !;                                     write(iunit,'(" beta        = "es23.15       )')beta ! redundant; 24 Oct 12;
  ;                                     write(iunit,'(" mu          = "23x,999es23.15)')mu(1:Nvol)
  ;                                     write(iunit,'(" Lconstraint = "i9            )')Lconstraint
  ;                                     write(iunit,'(" pl          = "999i23        )')pl(0:Nvol)
  ;                                     write(iunit,'(" ql          = "999i23        )')ql(0:Nvol)
  ;                                     write(iunit,'(" pr          = "999i23        )')pr(0:Nvol)
  ;                                     write(iunit,'(" qr          = "999i23        )')qr(0:Nvol)
  ;                                     write(iunit,'(" iota        = "999es23.15    )')iota(0:Nvol)

  do mm = 0, Mpol
   do nn = -Ntor, Ntor
    
! do mm = 0, MMpol ! to be deleted; 13 Oct 12;
!  do nn = -MNtor, MNtor ! to be deleted; 13 Oct 12;
    
    if( mm.eq.0 .and. nn.lt.0 ) cycle ! these modes are always excluded; 13 Oct 12;
    
    do imn = 1, mn
     if( im(imn).eq.mm .and. in(imn).eq.nn ) then ! identify harmonics; 13 Oct 12;
      if( Lvacuum.ge.2 ) Vns(nn,mm) = iVns(imn) ! this was computed internally; 13 Oct 12;
      if( Lvacuum.ge.2 ) Bns(nn,mm) = iBns(imn) ! this was computed internally; 13 Oct 12;
     endif
    enddo
    
    select case( mm )
    case(   0:  9 )
     if( nn.lt.- 9 .and. nn.gt.-99 )     write(iunit,1000) nn, mm, Rbc(nn,mm), nn, mm, Zbs(nn,mm), nn, mm, Bns(nn,mm), nn, mm, Vns(nn,mm), nn, mm, mask(nn,mm)
     if( nn.lt.  0 .and. nn.gt.- 9 )     write(iunit,1001) nn, mm, Rbc(nn,mm), nn, mm, Zbs(nn,mm), nn, mm, Bns(nn,mm), nn, mm, Vns(nn,mm), nn, mm, mask(nn,mm)
     if( nn.ge.  0 .and. nn.le.  9 )     write(iunit,1002) nn, mm, Rbc(nn,mm), nn, mm, Zbs(nn,mm), nn, mm, Bns(nn,mm), nn, mm, Vns(nn,mm), nn, mm, mask(nn,mm)
     if( nn.gt.  9 .and. nn.le. 99 )     write(iunit,1001) nn, mm, Rbc(nn,mm), nn, mm, Zbs(nn,mm), nn, mm, Bns(nn,mm), nn, mm, Vns(nn,mm), nn, mm, mask(nn,mm)
!    if( nn.lt.- 9 .and. nn.gt.-99 )     write(iunit,2000) nn, mm, Rbs(nn,mm), nn, mm, Zbc(nn,mm), nn, mm, Bnc(nn,mm), nn, mm, Vnc(nn,mm), nn, mm, mask(nn,mm) ! 13 Oct 12;
!    if( nn.lt.  0 .and. nn.gt.- 9 )     write(iunit,2001) nn, mm, Rbs(nn,mm), nn, mm, Zbc(nn,mm), nn, mm, Bnc(nn,mm), nn, mm, Vnc(nn,mm), nn, mm, mask(nn,mm) ! 13 Oct 12;
!    if( nn.ge.  0 .and. nn.le.  9 )     write(iunit,2002) nn, mm, Rbs(nn,mm), nn, mm, Zbc(nn,mm), nn, mm, Bnc(nn,mm), nn, mm, Vnc(nn,mm), nn, mm, mask(nn,mm) ! 13 Oct 12;
!    if( nn.gt.  9 .and. nn.le. 99 )     write(iunit,2001) nn, mm, Rbs(nn,mm), nn, mm, Zbc(nn,mm), nn, mm, Bnc(nn,mm), nn, mm, Vnc(nn,mm), nn, mm, mask(nn,mm) ! 13 Oct 12;
    case(  10: 99 )
     if( nn.lt.- 9 .and. nn.gt.-99 )     write(iunit,1003) nn, mm, Rbc(nn,mm), nn, mm, Zbs(nn,mm), nn, mm, Bns(nn,mm), nn, mm, Vns(nn,mm), nn, mm, mask(nn,mm)
     if( nn.lt.  0 .and. nn.gt.- 9 )     write(iunit,1004) nn, mm, Rbc(nn,mm), nn, mm, Zbs(nn,mm), nn, mm, Bns(nn,mm), nn, mm, Vns(nn,mm), nn, mm, mask(nn,mm)
     if( nn.ge.  0 .and. nn.le.  9 )     write(iunit,1005) nn, mm, Rbc(nn,mm), nn, mm, Zbs(nn,mm), nn, mm, Bns(nn,mm), nn, mm, Vns(nn,mm), nn, mm, mask(nn,mm)
     if( nn.gt.  9 .and. nn.le. 99 )     write(iunit,1004) nn, mm, Rbc(nn,mm), nn, mm, Zbs(nn,mm), nn, mm, Bns(nn,mm), nn, mm, Vns(nn,mm), nn, mm, mask(nn,mm)
!    if( nn.lt.- 9 .and. nn.gt.-99 )     write(iunit,2003) nn, mm, Rbs(nn,mm), nn, mm, Zbc(nn,mm), nn, mm, Bnc(nn,mm), nn, mm, Vnc(nn,mm), nn, mm, mask(nn,mm) ! 13 Oct 12;
!    if( nn.lt.  0 .and. nn.gt.- 9 )     write(iunit,2004) nn, mm, Rbs(nn,mm), nn, mm, Zbc(nn,mm), nn, mm, Bnc(nn,mm), nn, mm, Vnc(nn,mm), nn, mm, mask(nn,mm) ! 13 Oct 12;
!    if( nn.ge.  0 .and. nn.le.  9 )     write(iunit,2005) nn, mm, Rbs(nn,mm), nn, mm, Zbc(nn,mm), nn, mm, Bnc(nn,mm), nn, mm, Vnc(nn,mm), nn, mm, mask(nn,mm) ! 13 Oct 12;
!    if( nn.gt.  9 .and. nn.le. 99 )     write(iunit,2004) nn, mm, Rbs(nn,mm), nn, mm, Zbc(nn,mm), nn, mm, Bnc(nn,mm), nn, mm, Vnc(nn,mm), nn, mm, mask(nn,mm) ! 13 Oct 12;
    end select ! end of select case( mm );
   enddo ! end of do nn;
  enddo ! end of do mm;
  
1000 format(" Rbc("i3","i1")"2x"="es23.15,3x" Zbs("i3","i1")"2x"="es23.15" Bns("i3","i1")"2x"="es23.15" Vns("i3","i1")"2x"="es23.15" mask("i3","i1")"2x"="i4)
1001 format(" Rbc("i2","i1")"3x"="es23.15,3x" Zbs("i2","i1")"3x"="es23.15" Bns("i2","i1")"3x"="es23.15" Vns("i2","i1")"3x"="es23.15" mask("i2","i1")"3x"="i4)
1002 format(" Rbc("i1","i1")"4x"="es23.15,3x" Zbs("i1","i1")"4x"="es23.15" Bns("i1","i1")"4x"="es23.15" Vns("i1","i1")"4x"="es23.15" mask("i1","i1")"4x"="i4)
1003 format(" Rbc("i3","i2")"1x"="es23.15,3x" Zbs("i3","i2")"1x"="es23.15" Bns("i3","i2")"1x"="es23.15" Vns("i3","i2")"1x"="es23.15" mask("i3","i2")"1x"="i4)
1004 format(" Rbc("i2","i2")"2x"="es23.15,3x" Zbs("i2","i2")"2x"="es23.15" Bns("i2","i2")"2x"="es23.15" Vns("i2","i2")"2x"="es23.15" mask("i2","i2")"2x"="i4)
1005 format(" Rbc("i1","i2")"3x"="es23.15,3x" Zbs("i1","i2")"3x"="es23.15" Bns("i1","i2")"3x"="es23.15" Vns("i1","i2")"3x"="es23.15" mask("i1","i2")"3x"="i4)

2000 format(" Rbs("i3","i1")"2x"="es23.15,3x" Zbc("i3","i1")"2x"="es23.15" Bnc("i3","i1")"2x"="es23.15" Vnc("i3","i1")"2x"="es23.15" mask("i3","i1")"2x"="i4)
2001 format(" Rbs("i2","i1")"3x"="es23.15,3x" Zbc("i2","i1")"3x"="es23.15" Bnc("i2","i1")"3x"="es23.15" Vnc("i2","i1")"3x"="es23.15" mask("i2","i1")"3x"="i4)
2002 format(" Rbs("i1","i1")"4x"="es23.15,3x" Zbc("i1","i1")"4x"="es23.15" Bnc("i1","i1")"4x"="es23.15" Vnc("i1","i1")"4x"="es23.15" mask("i1","i1")"4x"="i4)
2003 format(" Rbs("i3","i2")"1x"="es23.15,3x" Zbc("i3","i2")"1x"="es23.15" Bnc("i3","i2")"1x"="es23.15" Vnc("i3","i2")"1x"="es23.15" mask("i3","i2")"1x"="i4)
2004 format(" Rbs("i2","i2")"2x"="es23.15,3x" Zbc("i2","i2")"2x"="es23.15" Bnc("i2","i2")"2x"="es23.15" Vnc("i2","i2")"2x"="es23.15" mask("i2","i2")"2x"="i4)
2005 format(" Rbs("i1","i2")"3x"="es23.15,3x" Zbc("i1","i2")"3x"="es23.15" Bnc("i1","i2")"3x"="es23.15" Vnc("i1","i2")"3x"="es23.15" mask("i1","i2")"3x"="i4)
  
  if( Lconstraint.gt.0  .or. Lverbose ) write(iunit,'(" mupftol     = "es23.15       )')mupftol
  if( Lconstraint.gt.0  .or. Lverbose ) write(iunit,'(" mupfits     = "i9            )')mupfits
 !if(                        Lverbose ) write(iunit,'(" Lmask       = "i9            )')Lmask
  write(iunit,'("/")')
  
  
  write(iunit,'("&numericlist")')
  if( Linitialize.ne. 0 .or. Lverbose ) write(iunit,'(" Linitialize = "i9            )')0 ! Linitialize ! restarts will not change internal geometry;
  if( Lwall      .ne. 0 .or. Lverbose ) write(iunit,'(" Lwall       = "i9            )')Lwall
  ;                                     write(iunit,'(" phiwall     = "es23.15       )')phiwall
  if( iextrap    .ne. 4 .or. Lverbose ) write(iunit,'(" iextrap     = "i9            )')iextrap
  if( Ndiscrete  .ne. 2 .or. Lverbose ) write(iunit,'(" Ndiscrete   = "i9            )')Ndiscrete
  if( Nofe       .ne. 2 .or. Lverbose ) write(iunit,'(" Nofe        = "i9            )')Nofe
  if( Nquad      .ne.-1 .or. Lverbose ) write(iunit,'(" Nquad       = "i9            )')Nquad
  if( oiMpol     .ne.-1 .or. Lverbose ) write(iunit,'(" iMpol       = "i9            )')oiMpol
  if( oiNtor     .ne.-1 .or. Lverbose ) write(iunit,'(" iNtor       = "i9            )')oiNtor
! if( Ldmupf     .ne. 0 .or. Lverbose ) write(iunit,'(" Ldmupf      = "i9            )')Ldmupf ! redundant; ! 10 Oct 12;
  if( Iswmin     .ne. 0 .or. Lverbose ) write(iunit,'(" Iswmin      = "i9            )')Iswmin
!                                       write(iunit,'(" Lsymagl     = "L9            )')Lsymagl ! redundant; ! 10 Oct 12;
  if( Lperturb   .ne. 0 .or. Lverbose ) write(iunit,'(" Lperturb    = "i9            )')Lperturb
  if( Lperturb   .ne. 0 .or. Lverbose ) write(iunit,'(" dperturb    = "es23.15       )')dperturb
  write(iunit,'("/")')
  
  
  write(iunit,'("&linearlist")')
  if( Lbeltrami.ne. 1   .or. Lverbose ) write(iunit,'(" Lbeltrami   = "i9            )')Lbeltrami
  if( Linitgues.ne. 1   .or. Lverbose ) write(iunit,'(" Linitgues   = "i9            )')Linitgues
  if( Ldense   .ne. 1   .or. Lverbose ) write(iunit,'(" Ldense      = "i9            )')Ldense
  if( .not.Lposdef      .or. Lverbose ) write(iunit,'(" Lposdef     = "L9            )')Lposdef
  if( Nmaxexp.ne.0      .or. Lverbose ) write(iunit,'(" Nmaxexp     = "i9            )')Nmaxexp
  if( Lsparsematrix     .or. Lverbose ) write(iunit,'(" Lprecon     = "i9            )')Lprecon
  if( Lsparsematrix     .or. Lverbose ) write(iunit,'(" sparseits   = "i9            )')sparseits
  if( Lsparsematrix     .or. Lverbose ) write(iunit,'(" ssoromega   = "es23.15       )')ssoromega
  if( Lsparsematrix     .or. Lverbose ) write(iunit,'(" sparsetol   = "es23.15       )')sparsetol
  if( Liotasolv.ne.1    .or. Lverbose ) write(iunit,'(" Liotasolv   = "i9            )')Liotasolv
  write(iunit,'("/")')
  
  
  write(iunit,'("&nonlinearlist")')
  ;                                     write(iunit,'(" Lminimize   = "i9            )')Lminimize
  ;                                     write(iunit,'(" Lfindzero   = "i9            )')Lfindzero
  if( Lgeometry.ge.4    .or. Lverbose ) write(iunit,'(" pwidth      = "i9            )')pwidth
  if( Lgeometry.ge.4    .or. Lverbose ) write(iunit,'(" qwidth      = "i9            )')qwidth
  ;                                     write(iunit,'(" forcetol    = "es23.15       )')forcetol
  ;                                     write(iunit,'(" normalerr   = "es23.15       )')normalerr
  ;                                     write(iunit,'(" norblend    = "es23.15       )')norblend
  ;                                     write(iunit,'(" maxfbits    = "i9            )')maxfbits
 !;                                     write(iunit,'(" forceerr    = "es23.15       )')forceerr ! 02 Nov 12;
 !;                                     write(iunit,'(" energy      = "es23.15       )')energy ! 02 Nov 12;
 !;                                     write(iunit,'(" Lc05pdf     = "L9            )')Lc05pdf ! redundant; ! 10 Oct 12;
  ;                                     write(iunit,'(" c05xtol     = "es23.15       )')c05xtol
  ;                                     write(iunit,'(" c05factor   = "es23.15       )')c05factor
 !if( ifinited.ne.0     .or. Lverbose ) write(iunit,'(" ifinited    = "i9            )')ifinited ! redundant; ! 10 Oct 12;
 !if( Lgradient.ne.0    .or. Lverbose ) write(iunit,'(" Lgradient   = "i9            )')Lgradient ! redundant; ! 10 Oct 12;
  if( .not. LreadGF     .or. Lverbose ) write(iunit,'(" LreadGF     = "L9            )')LreadGF
  if( verify.ne.-1      .or. Lverbose ) write(iunit,'(" verify      = "i9            )')verify
  if( Lminimize.eq.1    .or. Lverbose ) write(iunit,'(" maxstep     = "es23.15       )')maxstep
  if( Lminimize.eq.1    .or. Lverbose ) write(iunit,'(" epsilon     = "es23.15       )')epsilon
  if( Lminimize.eq.1    .or. Lverbose ) write(iunit,'(" maxiter     = "i9            )')maxiter
 !if( normalize.ne.1    .or. Lverbose ) write(iunit,'(" normalize   = "i9            )')normalize ! redundant; ! 10 Oct 12;
  write(iunit,'("/")')
  

  write(iunit,'("&diagnosticslist")')
  ;                                     write(iunit,'(" odetol      = "es23.15       )')odetol
  ;                                     write(iunit,'(" absreq      = "es23.15       )')absreq
  ;                                     write(iunit,'(" relreq      = "es23.15       )')relreq
  ;                                     write(iunit,'(" absacc      = "es23.15       )')absacc
  if( Lpoincare.ne.0    .or. Lverbose ) write(iunit,'(" Lpoincare   = "i9            )')Lpoincare
  if( nPpts.ne.0        .or. Lverbose ) write(iunit,'(" nPpts       = "i9            )')nPpts
  ;                                     write(iunit,'(" Mpqits      = "i9            )')Mpqits
  if( Lpqsym.ne.0       .or. Lverbose ) write(iunit,'(" Lpqsym      = "i9            )')Lpqsym
  ;                                     write(iunit,'(" p1          = "999i6         )')p1(1:Nvol)
  ;                                     write(iunit,'(" q1          = "999i6         )')q1(1:Nvol)
  ;                                     write(iunit,'(" p2          = "999i6         )')p2(1:Nvol)
  ;                                     write(iunit,'(" q2          = "999i6         )')q2(1:Nvol)
  ;                                     write(iunit,'(" pqs         = "999es23.15    )')pqs(1:Nvol)
  ;                                     write(iunit,'(" pqt         = "999es23.15    )')pqt(1:Nvol)
  ;                                     write(iunit,'(" Npl         = "i9            )')Npl
  ;                                     write(iunit,'(" Nunstable   = "i9            )')Nunstable
  ;                                     write(iunit,'(" dunstable   = "es23.15       )')dunstable
  ;                                     write(iunit,'(" Munstable   = "i9            )')Munstable
  ;                                     write(iunit,'(" npq         = "999i6         )')npq(1:Nvol)
  ;                                     write(iunit,'(" nPtrj       = "999i6         )')nPtrj(1:Nvol+1)
  if( Mirrits.gt.0      .or. Lverbose ) write(iunit,'(" Mirrits     = "i9            )')Mirrits
  if( Mirrits.gt.0      .or. Lverbose ) write(iunit,'(" irrMpol     = "i9            )')irrMpol
  if( Mirrits.gt.0      .or. Lverbose ) write(iunit,'(" irrNtor     = "i9            )')irrNtor
  if( Mirrits.gt.0      .or. Lverbose ) write(iunit,'(" irrsvdcut   = "es23.15       )')irrsvdcut
  if( Mirrits.gt.0      .or. Lverbose ) write(iunit,'(" irrtol      = "es23.15       )')irrtol
  if( Lwrpj             .or. Lverbose ) write(iunit,'(" Lwrpj       = "L9            )')Lwrpj
  if( Nghd.ne.0         .or. Lverbose ) write(iunit,'(" Nghd        = "i9            )')Nghd
  if( LHessian          .or. Lverbose ) write(iunit,'(" LHessian    = "L9            )')LHessian
  if( LHevalues         .or. Lverbose ) write(iunit,'(" LHevalues   = "L9            )')LHevalues
  if( LHevectors        .or. Lverbose ) write(iunit,'(" LHevectors  = "L9            )')LHevectors
  if( Lcurlerr          .or. Lverbose ) write(iunit,'(" Lcurlerr    = "L9            )')Lcurlerr
  if( Lcheck.ne.0       .or. Lverbose ) write(iunit,'(" Lcheck      = "i9            )')Lcheck
  if( Lexamine          .or. Lverbose ) write(iunit,'(" Lexamine    = "L9            )')Lexamine
  if( Ltiming           .or. Lverbose ) write(iunit,'(" Ltiming     = "L9            )')Ltiming
  write(iunit,'("/")')
  
  
  write(iunit,'("&screenlist")')
! WSCREENLIST ! write screenlist; this is expanded by Makefile ; do not remove;
  if( Wreadin           ) write(iunit,'(" Wreadin = "L1                )')Wreadin
  if( Wwritin           ) write(iunit,'(" Wwritin = "L1                )')Wwritin
  write(iunit,'("/")')
  
!latex \item Note that the boundary harmonics are changed by the spectral condensation routine \verb+sw00ab+, which is called by \verb+spec+.
!latex At finite resolution, as the boundary harmonics are changed, the boundary surface itself may change. 
!latex For restarts at potentially higher resolution, the original boundary harmonics (saved in \verb+Rbm+ and \verb+Zbm+, see \verb+global/readin+) are written to file.
  
  do imn = 1, mn ; write(iunit,'(2i6,999es23.15)') im(imn), in(imn)/Nfp, ( iRbc(lvol,imn), iZbs(lvol,imn), lvol = 0, Nvol )
  enddo
  
  FATALMESS(readin,Lstellsym.ne.1,need to write non-stellarator-symmetric harmonics to restart file)
  
  close(iunit)
  
  lextrap = max( min( iextrap, Nvol ), 1)
  WCALL(writin,ex00aa,(lextrap))
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \subsubheading{iterations towards convergence}
!latex \item The file \verb+.ext.convergence+ is created.
!latex This file contains the evolution of the geometry towards convergence: i.e., the geometry of the interfaces at every iteration is saved.
!latex The format of this file is: needs revision;
!latex \begin{verbatim}
!latex open(zunit,file="."//trim(ext)//".convergence",status="unknown")!,form="unformatted")
!latex write(zunit,'(2i9)')mn, Nvol
!latex write(zunit,'(999i4)')im(1:mn)
!latex write(zunit,'(999i4)')in(1:mn)
!latex ! begin do loop over iterations;
!latex write(zunit)wflag,iflag,energy,rflag
!latex do imn = 1, mn
!latex  write(zunit,'(999es23.15)') ( iRbc(lvol,imn), iZbs(lvol,imn), lvol = 0, Nvol )
!latex enddo
!latex !  end  do loop over iterations;
!latex \end{verbatim}
!latex \item The \verb+wflag+ integer indicates algorithm: \verb+wflag=1+ indicates \verb+E04DGF+; \verb+wflag=2+ indicates \verb+C05PDF+.
!latex \item The \verb+iflag+ integer indicates number of derivative evaluations required by \verb+C05PDF+. 

  if( wflag.gt.0 ) then ! this writes to convergence file;
   write(zunit)wflag, iflag, energy, rflag
   write(zunit)iRbc(0:Nvol,1:mn)
   write(zunit)iZbs(0:Nvol,1:mn)
   FATALMESS(writin,Lstellsym.ne.1,need to write non-stellarator-symmetric harmonics to file)
   call flush(zunit)
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( Wwritin ) then ; cput = MPI_WTIME() ; write(ounit,'("writin : "f10.2" : myid="i3" ; opening/writing .ext.lambda ;")')cput-cpus,myid
  endif

  open(iunit,file="."//trim(ext)//".lambda",status="unknown",form="unformatted") ! transformation to straight-field-line angle on interfaces;
  write(iunit)mns,Nvol
  write(iunit)ims(1:mns)
  write(iunit)ins(1:mns)
  write(iunit)dsflangle(0,1:Nvol,0:1,1:mns)
  close(iunit)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( Wwritin ) then ; cput = MPI_WTIME() ; write(ounit,'("writin : "f10.2" : myid="i3" ; opening/writing .ext.grid ;")')cput-cpus,myid ! 21 Oct 12;
  endif
  
  open(iunit,file="."//trim(ext)//".grid",status="unknown") ! coordinate grid; 21 Oct 12;
  
  write(iunit,'(3i9)')Nt, Nz, Nvol
  
  do lvol = 1, Nvol ! volumes;
   
   if( Lgeometry.eq.1 .or. Lgeometry.eq.4 .or. lvol.gt.1 ) then ; Lcoordinatesingularity = .false. ! 21 Oct 12;
   else                                                         ; Lcoordinatesingularity = .true.
   endif
   
   write(iunit,'(i3)')Ni(lvol)+1 ! sub-grid radial resolution;
   
   do ii = 0, Ni(lvol) ! sub-grid;
    
    lss = ss(lvol)%s(ii)

    Lcurv = 0 ; WCALL(writin,co01aa,( lvol, lss, Lcurv, Ntz )) ! only Rij(0,:),Zij(0,:) are required; Rmn & Zmn are available;
    
    write(iunit,'(2f15.10)')((Rij(0,1+jj+kk*Nt),Zij(0,1+jj+kk*Nt),jj=0,Nt-1),kk=0,Nz-1)
    
   enddo
   
  enddo
  
  close(iunit)
  
  if( Wwritin ) then ; cput = MPI_WTIME() ; write(ounit,'("writin : "f10.2" : myid="i3" ; opened /wrote   .ext.grid ;")')cput-cpus,myid
  endif
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(writin)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine writin

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!


!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine option( intvariable, fltvariable )
  
  use constants, only :
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : ext
  use cputiming, only : 
  
  LOCALS
  
  INTEGER, intent(in), optional :: intvariable
  REAL   , intent(in), optional :: fltvariable

  cput = MPI_WTIME()

  if( present(intvariable) ) write(ounit,'("option : "f10.2" : myid="i3" ; integer = "i9" ;")')cput-cpus,myid,intvariable
  if( present(fltvariable) ) write(ounit,'("option : "f10.2" : myid="i3" ; real    = "es23.15" ;")')cput-cpus,myid,fltvariable

  return
  
end subroutine option
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end module allglobal

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module pjhamilto

  INTEGER              :: io

  REAL,    allocatable :: Itor(:,:), Gpol(:,:), spmn(:,:,:)

end module pjhamilto

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module laplaces

  LOGICAL              :: stage1, exterior, dorm
  INTEGER              :: Nintervals, Nsegments, IC, NP4, NP1
  INTEGER, allocatable :: icint(:)
  REAL                 :: originalalpha
  REAL, allocatable    :: xpoly(:), ypoly(:), phi(:), phid(:), CC(:,:)

  INTEGER              :: ilength
  REAL                 :: totallength

  INTEGER              :: niterations ! counter; ! eventually redundant; 24 Oct 12;
  
  INTEGER              :: iangle ! angle ! eventually redundant; 24 Oct 12;

  REAL                 :: Rmid, Zmid ! used to define local polar coordinate; ! eventually redundant; 24 Oct 12;

  REAL                 :: alpha ! eventually redundant; 24 Oct 12;

end module laplaces

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
